/* file-utils.c generated by valac 0.56.18, the Vala compiler
 * generated from file-utils.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (c) 2024       Arthur Demchenkov <spinal.by@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "libnotes.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

gboolean
xnp_file_utils_validate_text_file (GFile* file)
{
	gboolean _result_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 24 "../lib/file-utils.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 25 "../lib/file-utils.vala"
	_result_ = FALSE;
#line 52 "file-utils.c"
	{
		gchar* valid_end = NULL;
		guint8* content = NULL;
		guint8* _tmp0_;
		gint content_length1;
		gint _content_size_;
		const gchar* str = NULL;
		guint8* _tmp1_;
		gint _tmp1__length1;
		GFileInputStream* stream = NULL;
		GFileInputStream* _tmp2_;
		gssize length = 0L;
		GFileInputStream* _tmp3_;
		guint8* _tmp4_;
		gint _tmp4__length1;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gboolean _tmp8_;
#line 29 "../lib/file-utils.vala"
		_tmp0_ = g_new0 (guint8, 4096);
#line 29 "../lib/file-utils.vala"
		content = _tmp0_;
#line 29 "../lib/file-utils.vala"
		content_length1 = 4096;
#line 29 "../lib/file-utils.vala"
		_content_size_ = content_length1;
#line 30 "../lib/file-utils.vala"
		_tmp1_ = content;
#line 30 "../lib/file-utils.vala"
		_tmp1__length1 = content_length1;
#line 30 "../lib/file-utils.vala"
		str = (const gchar*) _tmp1_;
#line 31 "../lib/file-utils.vala"
		_tmp2_ = g_file_read (file, NULL, &_inner_error0_);
#line 31 "../lib/file-utils.vala"
		stream = _tmp2_;
#line 31 "../lib/file-utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../lib/file-utils.vala"
			content = (g_free (content), NULL);
#line 94 "file-utils.c"
			goto __catch0_g_error;
		}
#line 32 "../lib/file-utils.vala"
		_tmp3_ = stream;
#line 32 "../lib/file-utils.vala"
		_tmp4_ = content;
#line 32 "../lib/file-utils.vala"
		_tmp4__length1 = content_length1;
#line 32 "../lib/file-utils.vala"
		length = g_input_stream_read ((GInputStream*) _tmp3_, _tmp4_, (gsize) _tmp4__length1, NULL, &_inner_error0_);
#line 32 "../lib/file-utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32 "../lib/file-utils.vala"
			_g_object_unref0 (stream);
#line 32 "../lib/file-utils.vala"
			content = (g_free (content), NULL);
#line 111 "file-utils.c"
			goto __catch0_g_error;
		}
#line 33 "../lib/file-utils.vala"
		_tmp6_ = str;
#line 33 "../lib/file-utils.vala"
		_tmp8_ = g_utf8_validate (_tmp6_, length, &_tmp7_);
#line 33 "../lib/file-utils.vala"
		valid_end = _tmp7_;
#line 33 "../lib/file-utils.vala"
		if (_tmp8_) {
#line 33 "../lib/file-utils.vala"
			_tmp5_ = TRUE;
#line 124 "file-utils.c"
		} else {
			gchar* _tmp9_;
			guint8* _tmp10_;
			gint _tmp10__length1;
#line 34 "../lib/file-utils.vala"
			_tmp9_ = valid_end;
#line 34 "../lib/file-utils.vala"
			_tmp10_ = content;
#line 34 "../lib/file-utils.vala"
			_tmp10__length1 = content_length1;
#line 34 "../lib/file-utils.vala"
			_tmp5_ = (_tmp9_ - ((gchar*) _tmp10_)) > ((gsize) (length - 6));
#line 137 "file-utils.c"
		}
#line 33 "../lib/file-utils.vala"
		_result_ = _tmp5_;
#line 27 "../lib/file-utils.vala"
		_g_object_unref0 (stream);
#line 27 "../lib/file-utils.vala"
		content = (g_free (content), NULL);
#line 145 "file-utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 27 "../lib/file-utils.vala"
		g_clear_error (&_inner_error0_);
#line 152 "file-utils.c"
	}
	__finally0:
#line 27 "../lib/file-utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "file-utils.c"
		gboolean _tmp11_ = FALSE;
#line 27 "../lib/file-utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 27 "../lib/file-utils.vala"
		g_clear_error (&_inner_error0_);
#line 27 "../lib/file-utils.vala"
		return _tmp11_;
#line 165 "file-utils.c"
	}
#line 38 "../lib/file-utils.vala"
	result = _result_;
#line 38 "../lib/file-utils.vala"
	return result;
#line 171 "file-utils.c"
}

gboolean
xnp_file_utils_path_exists (const gchar* path)
{
	gboolean result;
#line 41 "../lib/file-utils.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 42 "../lib/file-utils.vala"
	result = g_file_test (path, G_FILE_TEST_EXISTS);
#line 42 "../lib/file-utils.vala"
	return result;
#line 184 "file-utils.c"
}

