/* hypertextview.c generated by valac 0.56.18, the Vala compiler
 * generated from hypertextview.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (c) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *  Copyright (c) 2009       Cornelius Hald <hald@icandy.de>
 *  Copyright (c) 2023       Arthur Demchenkov <spinal.by@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "libnotes.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gtksourceview/gtksource.h>
#include <pango/pango.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	XNP_HYPERTEXT_VIEW_0_PROPERTY,
	XNP_HYPERTEXT_VIEW_FONT_PROPERTY,
	XNP_HYPERTEXT_VIEW_NUM_PROPERTIES
};
static GParamSpec* xnp_hypertext_view_properties[XNP_HYPERTEXT_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define __vala_PangoTabArray_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoTabArray_free (var), NULL)))

struct _XnpHypertextViewPrivate {
	GSList* checkboxes;
	GdkCursor* hand_cursor;
	GdkCursor* regular_cursor;
	gboolean cursor_over_checkbox;
	gboolean cursor_over_link;
	GtkTextTag* tag_bold;
	GtkTextTag* tag_italic;
	GtkTextTag* tag_strikethrough;
	GtkTextTag* tag_underline;
	GtkTextTag* tag_link;
	GRegex* regex_link;
	gchar* _font;
};

struct _Block4Data {
	int _ref_count_;
	XnpHypertextView* self;
	gchar* tag_name;
};

struct _Block5Data {
	int _ref_count_;
	XnpHypertextView* self;
	gchar* tags_text;
};

struct _Block6Data {
	int _ref_count_;
	XnpHypertextView* self;
	GtkTextIter start;
	GtkTextIter end;
};

struct _Block7Data {
	int _ref_count_;
	XnpHypertextView* self;
	GtkTextChildAnchor* anchor;
};

static gint XnpHypertextView_private_offset;
static gpointer xnp_hypertext_view_parent_class = NULL;
static gchar* xnp_hypertext_view_tag_char;
static gchar* xnp_hypertext_view_tag_char = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void xnp_hypertext_view_style_updated_cb (XnpHypertextView* self,
                                          GtkWidget* hypertextview);
static void _xnp_hypertext_view_style_updated_cb_gtk_widget_style_updated (GtkWidget* _sender,
                                                                    gpointer self);
static void xnp_hypertext_view_populate_popup_cb (XnpHypertextView* self,
                                           GtkMenu* popup_menu);
static void _xnp_hypertext_view_populate_popup_cb_gtk_text_view_populate_popup (GtkTextView* _sender,
                                                                         GtkMenu* popup,
                                                                         gpointer self);
static gboolean xnp_hypertext_view_button_release_event_cb (XnpHypertextView* self,
                                                     GtkWidget* hypertextview,
                                                     GdkEventButton* event);
static gboolean _xnp_hypertext_view_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                      GdkEventButton* event,
                                                                                      gpointer self);
static gboolean xnp_hypertext_view_motion_notify_event_cb (XnpHypertextView* self,
                                                    GtkWidget* hypertextview,
                                                    GdkEventMotion* event);
static gboolean _xnp_hypertext_view_motion_notify_event_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                    GdkEventMotion* event,
                                                                                    gpointer self);
static void xnp_hypertext_view_state_flags_changed_cb (XnpHypertextView* self);
static void _xnp_hypertext_view_state_flags_changed_cb_gtk_widget_state_flags_changed (GtkWidget* _sender,
                                                                                GtkStateFlags previous_state_flags,
                                                                                gpointer self);
static void xnp_hypertext_view_insert_text_cb (XnpHypertextView* self,
                                        GtkTextBuffer* buffer,
                                        GtkTextIter* location,
                                        const gchar* text,
                                        gint len);
static void _xnp_hypertext_view_insert_text_cb_gtk_text_buffer_insert_text (GtkTextBuffer* _sender,
                                                                     GtkTextIter* pos,
                                                                     const gchar* new_text,
                                                                     gint new_text_length,
                                                                     gpointer self);
static void xnp_hypertext_view_delete_range_cb (XnpHypertextView* self,
                                         GtkTextBuffer* buffer,
                                         GtkTextIter* start,
                                         GtkTextIter* end);
static void _xnp_hypertext_view_delete_range_cb_gtk_text_buffer_delete_range (GtkTextBuffer* _sender,
                                                                       GtkTextIter* start,
                                                                       GtkTextIter* end,
                                                                       gpointer self);
static void xnp_hypertext_view_menu_add_text_formatting (XnpHypertextView* self,
                                                  GtkMenu* menu,
                                                  const gchar* tag_name,
                                                  const gchar* text);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda13_ (Block4Data* _data4_);
static void ___lambda13__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda7_ (XnpHypertextView* self);
static void ___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self);
static void xnp_hypertext_view_auto_highlight_urls (XnpHypertextView* self,
                                             GtkTextIter* start,
                                             GtkTextIter* end);
static gboolean _gtk_text_iter_equal (const GtkTextIter * s1,
                               const GtkTextIter * s2);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda14_ (Block5Data* _data5_,
                   GtkTextTag* tag);
static void ____lambda14__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda15_ (Block5Data* _data5_,
                   GtkTextTag* tag);
static void ____lambda15__gfunc (gconstpointer data,
                          gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ______lambda16_ (Block6Data* _data6_,
                      const gchar* tag);
static void _______lambda16__gfunc (gconstpointer data,
                             gpointer self);
static gchar** xnp_hypertext_view_split_tags (XnpHypertextView* self,
                                       const gchar* tags,
                                       gint* result_length1);
static void xnp_hypertext_view_insert_checkbox_at_iter (XnpHypertextView* self,
                                                 GtkTextIter* iter,
                                                 gboolean checked);
static void __________lambda17_ (Block6Data* _data6_,
                          const gchar* tag);
static void ___________lambda17__gfunc (gconstpointer data,
                                 gpointer self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void xnp_hypertext_view_extend_block (XnpHypertextView* self,
                                      GtkTextIter* start_iter,
                                      GtkTextIter* end_iter,
                                      gint max_len);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean __lambda8_ (XnpHypertextView* self);
static gboolean ___lambda8__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                    GdkEventCrossing* event,
                                                    gpointer self);
static gboolean __lambda9_ (XnpHypertextView* self);
static gboolean ___lambda9__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                    GdkEventCrossing* event,
                                                    gpointer self);
static void __lambda10_ (XnpHypertextView* self);
static void ___lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda11_ (Block7Data* _data7_);
static void ___lambda11__gtk_widget_destroy (GtkWidget* _sender,
                                      gpointer self);
static gint __lambda12_ (XnpHypertextView* self,
                  GtkTextChildAnchor* a,
                  GtkTextChildAnchor* b);
static gint ___lambda12__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static GObject * xnp_hypertext_view_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _vala_PangoTabArray_free (PangoTabArray* self);
static void xnp_hypertext_view_finalize (GObject * obj);
static GType xnp_hypertext_view_get_type_once (void);
static void _vala_xnp_hypertext_view_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_xnp_hypertext_view_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
xnp_hypertext_view_get_instance_private (XnpHypertextView* self)
{
	return G_STRUCT_MEMBER_P (self, XnpHypertextView_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 29 "../lib/hypertextview.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 277 "hypertextview.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 29 "../lib/hypertextview.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 285 "hypertextview.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1122 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1122 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1123 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1124 "glib-2.0.vapi"
	result = str;
#line 1124 "glib-2.0.vapi"
	return result;
#line 304 "hypertextview.c"
}

static void
_xnp_hypertext_view_style_updated_cb_gtk_widget_style_updated (GtkWidget* _sender,
                                                               gpointer self)
{
#line 73 "../lib/hypertextview.vala"
	xnp_hypertext_view_style_updated_cb ((XnpHypertextView*) self, _sender);
#line 313 "hypertextview.c"
}

static void
_xnp_hypertext_view_populate_popup_cb_gtk_text_view_populate_popup (GtkTextView* _sender,
                                                                    GtkMenu* popup,
                                                                    gpointer self)
{
#line 74 "../lib/hypertextview.vala"
	xnp_hypertext_view_populate_popup_cb ((XnpHypertextView*) self, popup);
#line 323 "hypertextview.c"
}

static gboolean
_xnp_hypertext_view_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                             GdkEventButton* event,
                                                                             gpointer self)
{
	gboolean result;
	result = xnp_hypertext_view_button_release_event_cb ((XnpHypertextView*) self, _sender, event);
#line 75 "../lib/hypertextview.vala"
	return result;
#line 335 "hypertextview.c"
}

static gboolean
_xnp_hypertext_view_motion_notify_event_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                           GdkEventMotion* event,
                                                                           gpointer self)
{
	gboolean result;
	result = xnp_hypertext_view_motion_notify_event_cb ((XnpHypertextView*) self, _sender, event);
#line 76 "../lib/hypertextview.vala"
	return result;
#line 347 "hypertextview.c"
}

static void
_xnp_hypertext_view_state_flags_changed_cb_gtk_widget_state_flags_changed (GtkWidget* _sender,
                                                                           GtkStateFlags previous_state_flags,
                                                                           gpointer self)
{
#line 77 "../lib/hypertextview.vala"
	xnp_hypertext_view_state_flags_changed_cb ((XnpHypertextView*) self);
#line 357 "hypertextview.c"
}

static void
_xnp_hypertext_view_insert_text_cb_gtk_text_buffer_insert_text (GtkTextBuffer* _sender,
                                                                GtkTextIter* pos,
                                                                const gchar* new_text,
                                                                gint new_text_length,
                                                                gpointer self)
{
#line 78 "../lib/hypertextview.vala"
	xnp_hypertext_view_insert_text_cb ((XnpHypertextView*) self, _sender, pos, new_text, new_text_length);
#line 369 "hypertextview.c"
}

static void
_xnp_hypertext_view_delete_range_cb_gtk_text_buffer_delete_range (GtkTextBuffer* _sender,
                                                                  GtkTextIter* start,
                                                                  GtkTextIter* end,
                                                                  gpointer self)
{
#line 79 "../lib/hypertextview.vala"
	xnp_hypertext_view_delete_range_cb ((XnpHypertextView*) self, _sender, start, end);
#line 380 "hypertextview.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 81 "../lib/hypertextview.vala"
	return self ? g_object_ref (self) : NULL;
#line 388 "hypertextview.c"
}

XnpHypertextView*
xnp_hypertext_view_construct (GType object_type)
{
	XnpHypertextView * self = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkSourceBuffer* source_buffer = NULL;
	GtkTextBuffer* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkSourceBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextTag* _tmp9_;
	GtkTextTag* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextTag* _tmp13_;
	GtkTextTag* _tmp14_;
	GtkTextBuffer* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GtkTextTag* _tmp17_;
	GtkTextTag* _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextBuffer* _tmp20_;
	GtkTextTag* _tmp21_;
	GtkTextTag* _tmp22_;
	GtkTextBuffer* _tmp23_;
	GtkTextBuffer* _tmp24_;
	GtkTextTag* _tmp25_;
	GtkTextTag* _tmp26_;
#line 72 "../lib/hypertextview.vala"
	self = (XnpHypertextView*) g_object_new (object_type, NULL);
#line 73 "../lib/hypertextview.vala"
	g_signal_connect_object ((GtkWidget*) self, "style-updated", (GCallback) _xnp_hypertext_view_style_updated_cb_gtk_widget_style_updated, self, 0);
#line 74 "../lib/hypertextview.vala"
	g_signal_connect_object ((GtkTextView*) self, "populate-popup", (GCallback) _xnp_hypertext_view_populate_popup_cb_gtk_text_view_populate_popup, self, 0);
#line 75 "../lib/hypertextview.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _xnp_hypertext_view_button_release_event_cb_gtk_widget_button_release_event, self, 0);
#line 76 "../lib/hypertextview.vala"
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _xnp_hypertext_view_motion_notify_event_cb_gtk_widget_motion_notify_event, self, G_CONNECT_AFTER);
#line 77 "../lib/hypertextview.vala"
	g_signal_connect_object ((GtkWidget*) self, "state-flags-changed", (GCallback) _xnp_hypertext_view_state_flags_changed_cb_gtk_widget_state_flags_changed, self, 0);
#line 78 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 78 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 78 "../lib/hypertextview.vala"
	g_signal_connect_object (_tmp1_, "insert-text", (GCallback) _xnp_hypertext_view_insert_text_cb_gtk_text_buffer_insert_text, self, G_CONNECT_AFTER);
#line 79 "../lib/hypertextview.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 79 "../lib/hypertextview.vala"
	_tmp3_ = _tmp2_;
#line 79 "../lib/hypertextview.vala"
	g_signal_connect_object (_tmp3_, "delete-range", (GCallback) _xnp_hypertext_view_delete_range_cb_gtk_text_buffer_delete_range, self, G_CONNECT_AFTER);
#line 81 "../lib/hypertextview.vala"
	_tmp4_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 81 "../lib/hypertextview.vala"
	_tmp5_ = _tmp4_;
#line 81 "../lib/hypertextview.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_source_buffer_get_type ()) ? ((GtkSourceBuffer*) _tmp5_) : NULL);
#line 81 "../lib/hypertextview.vala"
	source_buffer = _tmp6_;
#line 82 "../lib/hypertextview.vala"
	gtk_source_buffer_set_highlight_matching_brackets (source_buffer, FALSE);
#line 84 "../lib/hypertextview.vala"
	_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 84 "../lib/hypertextview.vala"
	_tmp8_ = _tmp7_;
#line 84 "../lib/hypertextview.vala"
	_tmp9_ = gtk_text_buffer_create_tag (_tmp8_, "b", "weight", PANGO_WEIGHT_BOLD, NULL, NULL);
#line 84 "../lib/hypertextview.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 84 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_bold);
#line 84 "../lib/hypertextview.vala"
	self->priv->tag_bold = _tmp10_;
#line 88 "../lib/hypertextview.vala"
	_tmp11_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 88 "../lib/hypertextview.vala"
	_tmp12_ = _tmp11_;
#line 88 "../lib/hypertextview.vala"
	_tmp13_ = gtk_text_buffer_create_tag (_tmp12_, "i", "style", PANGO_STYLE_ITALIC, NULL, NULL);
#line 88 "../lib/hypertextview.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 88 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_italic);
#line 88 "../lib/hypertextview.vala"
	self->priv->tag_italic = _tmp14_;
#line 92 "../lib/hypertextview.vala"
	_tmp15_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 92 "../lib/hypertextview.vala"
	_tmp16_ = _tmp15_;
#line 92 "../lib/hypertextview.vala"
	_tmp17_ = gtk_text_buffer_create_tag (_tmp16_, "s", "strikethrough", TRUE, NULL, NULL);
#line 92 "../lib/hypertextview.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 92 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_strikethrough);
#line 92 "../lib/hypertextview.vala"
	self->priv->tag_strikethrough = _tmp18_;
#line 96 "../lib/hypertextview.vala"
	_tmp19_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 96 "../lib/hypertextview.vala"
	_tmp20_ = _tmp19_;
#line 96 "../lib/hypertextview.vala"
	_tmp21_ = gtk_text_buffer_create_tag (_tmp20_, "u", "underline", PANGO_UNDERLINE_SINGLE, NULL, NULL);
#line 96 "../lib/hypertextview.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 96 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_underline);
#line 96 "../lib/hypertextview.vala"
	self->priv->tag_underline = _tmp22_;
#line 100 "../lib/hypertextview.vala"
	_tmp23_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 100 "../lib/hypertextview.vala"
	_tmp24_ = _tmp23_;
#line 100 "../lib/hypertextview.vala"
	_tmp25_ = gtk_text_buffer_create_tag (_tmp24_, "link", "foreground", "blue", "underline", PANGO_UNDERLINE_SINGLE, NULL, NULL);
#line 100 "../lib/hypertextview.vala"
	_tmp26_ = _g_object_ref0 (_tmp25_);
#line 100 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_link);
#line 100 "../lib/hypertextview.vala"
	self->priv->tag_link = _tmp26_;
#line 72 "../lib/hypertextview.vala"
	_g_object_unref0 (source_buffer);
#line 72 "../lib/hypertextview.vala"
	return self;
#line 521 "hypertextview.c"
}

XnpHypertextView*
xnp_hypertext_view_new (void)
{
#line 72 "../lib/hypertextview.vala"
	return xnp_hypertext_view_construct (XNP_TYPE_HYPERTEXT_VIEW);
#line 529 "hypertextview.c"
}

/**
 * style_updated_cb:
 *
 * Get the link color from the css.
 */
static void
xnp_hypertext_view_style_updated_cb (XnpHypertextView* self,
                                     GtkWidget* hypertextview)
{
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0U;
	GtkTextTag* _tmp2_;
	GdkRGBA _tmp3_ = {0};
#line 115 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 115 "../lib/hypertextview.vala"
	g_return_if_fail (hypertextview != NULL);
#line 116 "../lib/hypertextview.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 116 "../lib/hypertextview.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 116 "../lib/hypertextview.vala"
	context = _tmp1_;
#line 117 "../lib/hypertextview.vala"
	state = gtk_style_context_get_state (context);
#line 118 "../lib/hypertextview.vala"
	state &= ~GTK_STATE_FLAG_VISITED;
#line 119 "../lib/hypertextview.vala"
	state |= GTK_STATE_FLAG_LINK;
#line 120 "../lib/hypertextview.vala"
	gtk_style_context_save (context);
#line 121 "../lib/hypertextview.vala"
	gtk_style_context_set_state (context, state);
#line 123 "../lib/hypertextview.vala"
	gtk_style_context_remove_class (context, GTK_STYLE_CLASS_VIEW);
#line 124 "../lib/hypertextview.vala"
	_tmp2_ = self->priv->tag_link;
#line 124 "../lib/hypertextview.vala"
	gtk_style_context_get_color (context, state, &_tmp3_);
#line 124 "../lib/hypertextview.vala"
	g_object_set (_tmp2_, "foreground-rgba", &_tmp3_, NULL);
#line 125 "../lib/hypertextview.vala"
	gtk_style_context_restore (context);
#line 115 "../lib/hypertextview.vala"
	_g_object_unref0 (context);
#line 579 "hypertextview.c"
}

/**
 * button_release_event_cb:
 *
 * Event to open links.
 */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 611 "hypertextview.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 617 "hypertextview.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 623 "hypertextview.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 627 "hypertextview.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 635 "hypertextview.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 639 "hypertextview.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 651 "hypertextview.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 674 "hypertextview.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 683 "hypertextview.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 702 "hypertextview.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 706 "hypertextview.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 712 "hypertextview.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 722 "hypertextview.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 730 "hypertextview.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 734 "hypertextview.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 740 "hypertextview.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 750 "hypertextview.c"
}

static gboolean
xnp_hypertext_view_button_release_event_cb (XnpHypertextView* self,
                                            GtkWidget* hypertextview,
                                            GdkEventButton* event)
{
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextIter iter = {0};
	gchar* link = NULL;
	gint x = 0;
	gint y = 0;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextIter _tmp3_ = {0};
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GtkTextIter _tmp6_ = {0};
	GtkTextTag* _tmp7_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 133 "../lib/hypertextview.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 133 "../lib/hypertextview.vala"
	g_return_val_if_fail (hypertextview != NULL, FALSE);
#line 133 "../lib/hypertextview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 138 "../lib/hypertextview.vala"
	if (event->button != ((guint) GDK_BUTTON_PRIMARY)) {
#line 139 "../lib/hypertextview.vala"
		result = FALSE;
#line 139 "../lib/hypertextview.vala"
		_g_free0 (link);
#line 139 "../lib/hypertextview.vala"
		return result;
#line 788 "hypertextview.c"
	}
#line 141 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 141 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 141 "../lib/hypertextview.vala"
	gtk_text_buffer_get_selection_bounds (_tmp1_, &_tmp2_, &_tmp3_);
#line 141 "../lib/hypertextview.vala"
	start = _tmp2_;
#line 141 "../lib/hypertextview.vala"
	end = _tmp3_;
#line 142 "../lib/hypertextview.vala"
	if (gtk_text_iter_get_offset (&start) != gtk_text_iter_get_offset (&end)) {
#line 143 "../lib/hypertextview.vala"
		result = FALSE;
#line 143 "../lib/hypertextview.vala"
		_g_free0 (link);
#line 143 "../lib/hypertextview.vala"
		return result;
#line 808 "hypertextview.c"
	}
#line 145 "../lib/hypertextview.vala"
	gtk_text_view_window_to_buffer_coords ((GtkTextView*) self, GTK_TEXT_WINDOW_WIDGET, (gint) event->x, (gint) event->y, &_tmp4_, &_tmp5_);
#line 145 "../lib/hypertextview.vala"
	x = _tmp4_;
#line 145 "../lib/hypertextview.vala"
	y = _tmp5_;
#line 146 "../lib/hypertextview.vala"
	gtk_text_view_get_iter_at_location ((GtkTextView*) self, &_tmp6_, x, y);
#line 146 "../lib/hypertextview.vala"
	iter = _tmp6_;
#line 148 "../lib/hypertextview.vala"
	_tmp7_ = self->priv->tag_link;
#line 148 "../lib/hypertextview.vala"
	if (gtk_text_iter_has_tag (&iter, _tmp7_)) {
#line 824 "hypertextview.c"
		GtkTextIter _tmp8_;
		GtkTextIter _tmp9_;
		GtkTextTag* _tmp10_;
		GtkTextTag* _tmp12_;
		GtkTextIter _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gboolean _tmp18_;
#line 149 "../lib/hypertextview.vala"
		_tmp8_ = iter;
#line 149 "../lib/hypertextview.vala"
		end = _tmp8_;
#line 149 "../lib/hypertextview.vala"
		_tmp9_ = end;
#line 149 "../lib/hypertextview.vala"
		start = _tmp9_;
#line 151 "../lib/hypertextview.vala"
		_tmp10_ = self->priv->tag_link;
#line 151 "../lib/hypertextview.vala"
		if (!gtk_text_iter_starts_tag (&start, _tmp10_)) {
#line 847 "hypertextview.c"
			GtkTextTag* _tmp11_;
#line 152 "../lib/hypertextview.vala"
			_tmp11_ = self->priv->tag_link;
#line 152 "../lib/hypertextview.vala"
			gtk_text_iter_backward_to_tag_toggle (&start, _tmp11_);
#line 853 "hypertextview.c"
		}
#line 155 "../lib/hypertextview.vala"
		_tmp12_ = self->priv->tag_link;
#line 155 "../lib/hypertextview.vala"
		gtk_text_iter_forward_to_tag_toggle (&end, _tmp12_);
#line 157 "../lib/hypertextview.vala"
		_tmp13_ = end;
#line 157 "../lib/hypertextview.vala"
		_tmp14_ = gtk_text_iter_get_text (&start, &_tmp13_);
#line 157 "../lib/hypertextview.vala"
		_g_free0 (link);
#line 157 "../lib/hypertextview.vala"
		link = _tmp14_;
#line 159 "../lib/hypertextview.vala"
		_tmp15_ = link;
#line 159 "../lib/hypertextview.vala"
		_tmp16_ = string_slice (_tmp15_, (glong) 0, (glong) 2);
#line 159 "../lib/hypertextview.vala"
		_tmp17_ = _tmp16_;
#line 159 "../lib/hypertextview.vala"
		_tmp18_ = g_strcmp0 (_tmp17_, "~/") == 0;
#line 159 "../lib/hypertextview.vala"
		_g_free0 (_tmp17_);
#line 159 "../lib/hypertextview.vala"
		if (_tmp18_) {
#line 879 "hypertextview.c"
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 160 "../lib/hypertextview.vala"
			_tmp19_ = g_get_home_dir ();
#line 160 "../lib/hypertextview.vala"
			_tmp20_ = link;
#line 160 "../lib/hypertextview.vala"
			_tmp21_ = string_substring (_tmp20_, (glong) 2, (glong) -1);
#line 160 "../lib/hypertextview.vala"
			_tmp22_ = _tmp21_;
#line 160 "../lib/hypertextview.vala"
			_tmp23_ = g_strdup_printf ("%s/%s", _tmp19_, _tmp22_);
#line 160 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 160 "../lib/hypertextview.vala"
			link = _tmp23_;
#line 160 "../lib/hypertextview.vala"
			_g_free0 (_tmp22_);
#line 901 "hypertextview.c"
		}
		{
			gchar* _tmp24_;
			gchar* _tmp25_;
			gboolean _tmp26_;
#line 163 "../lib/hypertextview.vala"
			_tmp24_ = g_find_program_in_path ("xfce-open");
#line 163 "../lib/hypertextview.vala"
			_tmp25_ = _tmp24_;
#line 163 "../lib/hypertextview.vala"
			_tmp26_ = _tmp25_ != NULL;
#line 163 "../lib/hypertextview.vala"
			_g_free0 (_tmp25_);
#line 163 "../lib/hypertextview.vala"
			if (_tmp26_) {
#line 917 "hypertextview.c"
				const gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 164 "../lib/hypertextview.vala"
				_tmp27_ = link;
#line 164 "../lib/hypertextview.vala"
				_tmp28_ = g_strconcat ("xfce-open ", _tmp27_, NULL);
#line 164 "../lib/hypertextview.vala"
				_tmp29_ = _tmp28_;
#line 164 "../lib/hypertextview.vala"
				g_spawn_command_line_async (_tmp29_, &_inner_error0_);
#line 164 "../lib/hypertextview.vala"
				_g_free0 (_tmp29_);
#line 164 "../lib/hypertextview.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 933 "hypertextview.c"
					goto __catch0_g_error;
				}
			} else {
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
#line 166 "../lib/hypertextview.vala"
				_tmp30_ = link;
#line 166 "../lib/hypertextview.vala"
				_tmp31_ = g_strconcat ("exo-open ", _tmp30_, NULL);
#line 166 "../lib/hypertextview.vala"
				_tmp32_ = _tmp31_;
#line 166 "../lib/hypertextview.vala"
				g_spawn_command_line_async (_tmp32_, &_inner_error0_);
#line 166 "../lib/hypertextview.vala"
				_g_free0 (_tmp32_);
#line 166 "../lib/hypertextview.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 952 "hypertextview.c"
					goto __catch0_g_error;
				}
			}
#line 167 "../lib/hypertextview.vala"
			result = FALSE;
#line 167 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 167 "../lib/hypertextview.vala"
			return result;
#line 962 "hypertextview.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 162 "../lib/hypertextview.vala"
			g_clear_error (&_inner_error0_);
#line 969 "hypertextview.c"
		}
		__finally0:
#line 162 "../lib/hypertextview.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 974 "hypertextview.c"
			gboolean _tmp33_ = FALSE;
#line 162 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 162 "../lib/hypertextview.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "../lib/hypertextview.vala"
			g_clear_error (&_inner_error0_);
#line 162 "../lib/hypertextview.vala"
			return _tmp33_;
#line 984 "hypertextview.c"
		}
		{
			const gchar* _tmp34_;
#line 171 "../lib/hypertextview.vala"
			_tmp34_ = link;
#line 171 "../lib/hypertextview.vala"
			g_app_info_launch_default_for_uri (_tmp34_, NULL, &_inner_error0_);
#line 171 "../lib/hypertextview.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 994 "hypertextview.c"
				goto __catch1_g_error;
			}
#line 172 "../lib/hypertextview.vala"
			result = FALSE;
#line 172 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 172 "../lib/hypertextview.vala"
			return result;
#line 1003 "hypertextview.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp35_;
			const gchar* _tmp36_;
#line 170 "../lib/hypertextview.vala"
			e = _inner_error0_;
#line 170 "../lib/hypertextview.vala"
			_inner_error0_ = NULL;
#line 174 "../lib/hypertextview.vala"
			_tmp35_ = e;
#line 174 "../lib/hypertextview.vala"
			_tmp36_ = _tmp35_->message;
#line 174 "../lib/hypertextview.vala"
			g_message ("hypertextview.vala:174: Unable to open link with default handler: %s", _tmp36_);
#line 170 "../lib/hypertextview.vala"
			_g_error_free0 (e);
#line 1023 "hypertextview.c"
		}
		__finally1:
#line 170 "../lib/hypertextview.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1028 "hypertextview.c"
			gboolean _tmp37_ = FALSE;
#line 170 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 170 "../lib/hypertextview.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../lib/hypertextview.vala"
			g_clear_error (&_inner_error0_);
#line 170 "../lib/hypertextview.vala"
			return _tmp37_;
#line 1038 "hypertextview.c"
		}
		{
			const gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 177 "../lib/hypertextview.vala"
			_tmp38_ = link;
#line 177 "../lib/hypertextview.vala"
			_tmp39_ = g_strconcat ("xdg-open ", _tmp38_, NULL);
#line 177 "../lib/hypertextview.vala"
			_tmp40_ = _tmp39_;
#line 177 "../lib/hypertextview.vala"
			g_spawn_command_line_async (_tmp40_, &_inner_error0_);
#line 177 "../lib/hypertextview.vala"
			_g_free0 (_tmp40_);
#line 177 "../lib/hypertextview.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1056 "hypertextview.c"
				goto __catch2_g_error;
			}
#line 178 "../lib/hypertextview.vala"
			result = FALSE;
#line 178 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 178 "../lib/hypertextview.vala"
			return result;
#line 1065 "hypertextview.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
#line 176 "../lib/hypertextview.vala"
			g_clear_error (&_inner_error0_);
#line 1072 "hypertextview.c"
		}
		__finally2:
#line 176 "../lib/hypertextview.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1077 "hypertextview.c"
			gboolean _tmp41_ = FALSE;
#line 176 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 176 "../lib/hypertextview.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../lib/hypertextview.vala"
			g_clear_error (&_inner_error0_);
#line 176 "../lib/hypertextview.vala"
			return _tmp41_;
#line 1087 "hypertextview.c"
		}
		{
			const gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
#line 183 "../lib/hypertextview.vala"
			_tmp42_ = link;
#line 183 "../lib/hypertextview.vala"
			_tmp43_ = g_strconcat ("firefox ", _tmp42_, NULL);
#line 183 "../lib/hypertextview.vala"
			_tmp44_ = _tmp43_;
#line 183 "../lib/hypertextview.vala"
			g_spawn_command_line_async (_tmp44_, &_inner_error0_);
#line 183 "../lib/hypertextview.vala"
			_g_free0 (_tmp44_);
#line 183 "../lib/hypertextview.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1105 "hypertextview.c"
				goto __catch3_g_error;
			}
#line 184 "../lib/hypertextview.vala"
			result = FALSE;
#line 184 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 184 "../lib/hypertextview.vala"
			return result;
#line 1114 "hypertextview.c"
		}
		goto __finally3;
		__catch3_g_error:
		{
#line 182 "../lib/hypertextview.vala"
			g_clear_error (&_inner_error0_);
#line 1121 "hypertextview.c"
		}
		__finally3:
#line 182 "../lib/hypertextview.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1126 "hypertextview.c"
			gboolean _tmp45_ = FALSE;
#line 182 "../lib/hypertextview.vala"
			_g_free0 (link);
#line 182 "../lib/hypertextview.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../lib/hypertextview.vala"
			g_clear_error (&_inner_error0_);
#line 182 "../lib/hypertextview.vala"
			return _tmp45_;
#line 1136 "hypertextview.c"
		}
#line 189 "../lib/hypertextview.vala"
		g_message ("hypertextview.vala:189: Unable to find an appropriate fallback to open" \
" the link");
#line 1140 "hypertextview.c"
	}
#line 192 "../lib/hypertextview.vala"
	result = FALSE;
#line 192 "../lib/hypertextview.vala"
	_g_free0 (link);
#line 192 "../lib/hypertextview.vala"
	return result;
#line 1148 "hypertextview.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 195 "../lib/hypertextview.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 195 "../lib/hypertextview.vala"
	return _data4_;
#line 1158 "hypertextview.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 195 "../lib/hypertextview.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1168 "hypertextview.c"
		XnpHypertextView* self;
#line 195 "../lib/hypertextview.vala"
		self = _data4_->self;
#line 195 "../lib/hypertextview.vala"
		_g_free0 (_data4_->tag_name);
#line 195 "../lib/hypertextview.vala"
		_g_object_unref0 (self);
#line 195 "../lib/hypertextview.vala"
		g_slice_free (Block4Data, _data4_);
#line 1178 "hypertextview.c"
	}
}

static void
__lambda13_ (Block4Data* _data4_)
{
	XnpHypertextView* self;
#line 200 "../lib/hypertextview.vala"
	self = _data4_->self;
#line 200 "../lib/hypertextview.vala"
	xnp_hypertext_view_toggle_tag (self, _data4_->tag_name);
#line 1190 "hypertextview.c"
}

static void
___lambda13__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 200 "../lib/hypertextview.vala"
	__lambda13_ (self);
#line 1199 "hypertextview.c"
}

static void
xnp_hypertext_view_menu_add_text_formatting (XnpHypertextView* self,
                                             GtkMenu* menu,
                                             const gchar* tag_name,
                                             const gchar* text)
{
	Block4Data* _data4_;
	gchar* _tmp0_;
	GtkMenuItem* mi = NULL;
	GtkMenuItem* _tmp1_;
	GtkLabel* label = NULL;
	GtkWidget* _tmp2_;
	GtkLabel* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 195 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 195 "../lib/hypertextview.vala"
	g_return_if_fail (menu != NULL);
#line 195 "../lib/hypertextview.vala"
	g_return_if_fail (tag_name != NULL);
#line 195 "../lib/hypertextview.vala"
	g_return_if_fail (text != NULL);
#line 195 "../lib/hypertextview.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 195 "../lib/hypertextview.vala"
	_data4_->_ref_count_ = 1;
#line 195 "../lib/hypertextview.vala"
	_data4_->self = g_object_ref (self);
#line 195 "../lib/hypertextview.vala"
	_tmp0_ = g_strdup (tag_name);
#line 195 "../lib/hypertextview.vala"
	_g_free0 (_data4_->tag_name);
#line 195 "../lib/hypertextview.vala"
	_data4_->tag_name = _tmp0_;
#line 196 "../lib/hypertextview.vala"
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("");
#line 196 "../lib/hypertextview.vala"
	g_object_ref_sink (_tmp1_);
#line 196 "../lib/hypertextview.vala"
	mi = _tmp1_;
#line 197 "../lib/hypertextview.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) mi);
#line 197 "../lib/hypertextview.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp2_) : NULL);
#line 197 "../lib/hypertextview.vala"
	label = _tmp3_;
#line 198 "../lib/hypertextview.vala"
	_tmp4_ = g_strdup_printf ("<%s>%s</%s>", _data4_->tag_name, text, _data4_->tag_name);
#line 198 "../lib/hypertextview.vala"
	_tmp5_ = _tmp4_;
#line 198 "../lib/hypertextview.vala"
	gtk_label_set_markup (label, _tmp5_);
#line 198 "../lib/hypertextview.vala"
	_g_free0 (_tmp5_);
#line 199 "../lib/hypertextview.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, G_TYPE_CHECK_INSTANCE_TYPE (mi, gtk_widget_get_type ()) ? ((GtkWidget*) mi) : NULL, -1);
#line 200 "../lib/hypertextview.vala"
	g_signal_connect_data (mi, "activate", (GCallback) ___lambda13__gtk_menu_item_activate, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 195 "../lib/hypertextview.vala"
	_g_object_unref0 (label);
#line 195 "../lib/hypertextview.vala"
	_g_object_unref0 (mi);
#line 195 "../lib/hypertextview.vala"
	block4_data_unref (_data4_);
#line 195 "../lib/hypertextview.vala"
	_data4_ = NULL;
#line 1269 "hypertextview.c"
}

static void
__lambda7_ (XnpHypertextView* self)
{
#line 205 "../lib/hypertextview.vala"
	xnp_hypertext_view_insert_checkbox (self, FALSE);
#line 1277 "hypertextview.c"
}

static void
___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                    gpointer self)
{
#line 205 "../lib/hypertextview.vala"
	__lambda7_ ((XnpHypertextView*) self);
#line 1286 "hypertextview.c"
}

static void
xnp_hypertext_view_populate_popup_cb (XnpHypertextView* self,
                                      GtkMenu* popup_menu)
{
	GtkMenuItem* mi = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkSeparatorMenuItem* _tmp3_;
	GtkMenuItem* _tmp4_;
#line 203 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 203 "../lib/hypertextview.vala"
	g_return_if_fail (popup_menu != NULL);
#line 204 "../lib/hypertextview.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Insert checkbox"));
#line 204 "../lib/hypertextview.vala"
	g_object_ref_sink (_tmp0_);
#line 204 "../lib/hypertextview.vala"
	mi = _tmp0_;
#line 205 "../lib/hypertextview.vala"
	_tmp1_ = mi;
#line 205 "../lib/hypertextview.vala"
	g_signal_connect_object (_tmp1_, "activate", (GCallback) ___lambda7__gtk_menu_item_activate, self, 0);
#line 206 "../lib/hypertextview.vala"
	_tmp2_ = mi;
#line 206 "../lib/hypertextview.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) popup_menu, G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp2_) : NULL, -1);
#line 208 "../lib/hypertextview.vala"
	_tmp3_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 208 "../lib/hypertextview.vala"
	g_object_ref_sink (_tmp3_);
#line 208 "../lib/hypertextview.vala"
	_g_object_unref0 (mi);
#line 208 "../lib/hypertextview.vala"
	mi = (GtkMenuItem*) _tmp3_;
#line 209 "../lib/hypertextview.vala"
	_tmp4_ = mi;
#line 209 "../lib/hypertextview.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) popup_menu, G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp4_) : NULL, -1);
#line 211 "../lib/hypertextview.vala"
	xnp_hypertext_view_menu_add_text_formatting (self, popup_menu, "s", _ ("Strikethrough"));
#line 212 "../lib/hypertextview.vala"
	xnp_hypertext_view_menu_add_text_formatting (self, popup_menu, "u", _ ("Underline"));
#line 213 "../lib/hypertextview.vala"
	xnp_hypertext_view_menu_add_text_formatting (self, popup_menu, "i", _ ("Italic"));
#line 214 "../lib/hypertextview.vala"
	xnp_hypertext_view_menu_add_text_formatting (self, popup_menu, "b", _ ("Bold"));
#line 216 "../lib/hypertextview.vala"
	gtk_widget_show_all ((GtkWidget*) popup_menu);
#line 203 "../lib/hypertextview.vala"
	_g_object_unref0 (mi);
#line 1341 "hypertextview.c"
}

/**
 * motion_notify_event_cb:
 *
 * Event to update the cursor of the pointer.
 */
static gboolean
xnp_hypertext_view_motion_notify_event_cb (XnpHypertextView* self,
                                           GtkWidget* hypertextview,
                                           GdkEventMotion* event)
{
	GdkCursor* cursor = NULL;
	GtkTextIter iter = {0};
	GdkWindow* win = NULL;
	gint x = 0;
	gint y = 0;
	GdkWindow* _tmp8_;
	GdkWindow* _tmp9_;
	GdkWindow* _tmp10_;
	GdkCursor* _tmp11_;
	GdkCursor* _tmp12_;
	GdkCursor* _tmp13_;
	gboolean result;
#line 224 "../lib/hypertextview.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../lib/hypertextview.vala"
	g_return_val_if_fail (hypertextview != NULL, FALSE);
#line 224 "../lib/hypertextview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 225 "../lib/hypertextview.vala"
	cursor = NULL;
#line 230 "../lib/hypertextview.vala"
	if (!self->priv->cursor_over_checkbox) {
#line 1376 "hypertextview.c"
		gint _tmp0_ = 0;
		gint _tmp1_ = 0;
		GtkTextIter _tmp2_ = {0};
		GtkTextTag* _tmp3_;
		GdkCursor* _tmp4_ = NULL;
		GdkCursor* _tmp7_;
#line 231 "../lib/hypertextview.vala"
		gtk_text_view_window_to_buffer_coords ((GtkTextView*) self, GTK_TEXT_WINDOW_WIDGET, (gint) event->x, (gint) event->y, &_tmp0_, &_tmp1_);
#line 231 "../lib/hypertextview.vala"
		x = _tmp0_;
#line 231 "../lib/hypertextview.vala"
		y = _tmp1_;
#line 232 "../lib/hypertextview.vala"
		gtk_text_view_get_iter_at_location ((GtkTextView*) self, &_tmp2_, x, y);
#line 232 "../lib/hypertextview.vala"
		iter = _tmp2_;
#line 233 "../lib/hypertextview.vala"
		_tmp3_ = self->priv->tag_link;
#line 233 "../lib/hypertextview.vala"
		self->priv->cursor_over_link = gtk_text_iter_has_tag (&iter, _tmp3_);
#line 234 "../lib/hypertextview.vala"
		if (self->priv->cursor_over_link) {
#line 1399 "hypertextview.c"
			GdkCursor* _tmp5_;
#line 234 "../lib/hypertextview.vala"
			_tmp5_ = self->priv->hand_cursor;
#line 234 "../lib/hypertextview.vala"
			_tmp4_ = _tmp5_;
#line 1405 "hypertextview.c"
		} else {
			GdkCursor* _tmp6_;
#line 234 "../lib/hypertextview.vala"
			_tmp6_ = self->priv->regular_cursor;
#line 234 "../lib/hypertextview.vala"
			_tmp4_ = _tmp6_;
#line 1412 "hypertextview.c"
		}
#line 234 "../lib/hypertextview.vala"
		_tmp7_ = _g_object_ref0 (_tmp4_);
#line 234 "../lib/hypertextview.vala"
		_g_object_unref0 (cursor);
#line 234 "../lib/hypertextview.vala"
		cursor = _tmp7_;
#line 1420 "hypertextview.c"
	}
#line 237 "../lib/hypertextview.vala"
	_tmp8_ = gtk_text_view_get_window ((GtkTextView*) self, GTK_TEXT_WINDOW_TEXT);
#line 237 "../lib/hypertextview.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 237 "../lib/hypertextview.vala"
	_g_object_unref0 (win);
#line 237 "../lib/hypertextview.vala"
	win = _tmp9_;
#line 238 "../lib/hypertextview.vala"
	_tmp10_ = win;
#line 238 "../lib/hypertextview.vala"
	_tmp11_ = gdk_window_get_cursor (_tmp10_);
#line 238 "../lib/hypertextview.vala"
	_tmp12_ = _tmp11_;
#line 238 "../lib/hypertextview.vala"
	_tmp13_ = cursor;
#line 238 "../lib/hypertextview.vala"
	if (_tmp12_ != _tmp13_) {
#line 1440 "hypertextview.c"
		GdkWindow* _tmp14_;
		GdkCursor* _tmp15_;
#line 239 "../lib/hypertextview.vala"
		_tmp14_ = win;
#line 239 "../lib/hypertextview.vala"
		_tmp15_ = cursor;
#line 239 "../lib/hypertextview.vala"
		gdk_window_set_cursor (_tmp14_, _tmp15_);
#line 1449 "hypertextview.c"
	}
#line 242 "../lib/hypertextview.vala"
	result = FALSE;
#line 242 "../lib/hypertextview.vala"
	_g_object_unref0 (win);
#line 242 "../lib/hypertextview.vala"
	_g_object_unref0 (cursor);
#line 242 "../lib/hypertextview.vala"
	return result;
#line 1459 "hypertextview.c"
}

/**
 * state_flags_changed_cb:
 *
 * Fix mouse cursor behavior after clicking on a link.
 */
static void
xnp_hypertext_view_state_flags_changed_cb (XnpHypertextView* self)
{
	gboolean _tmp0_ = FALSE;
#line 250 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 251 "../lib/hypertextview.vala"
	if (gtk_widget_get_realized ((GtkWidget*) self)) {
#line 1475 "hypertextview.c"
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 251 "../lib/hypertextview.vala"
		_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) self);
#line 251 "../lib/hypertextview.vala"
		_tmp2_ = _tmp1_;
#line 251 "../lib/hypertextview.vala"
		_tmp0_ = _tmp2_;
#line 1484 "hypertextview.c"
	} else {
#line 251 "../lib/hypertextview.vala"
		_tmp0_ = FALSE;
#line 1488 "hypertextview.c"
	}
#line 251 "../lib/hypertextview.vala"
	if (_tmp0_) {
#line 1492 "hypertextview.c"
		GdkWindow* win = NULL;
		GdkWindow* _tmp3_;
		GdkWindow* _tmp4_;
		GdkCursor* _tmp5_ = NULL;
		GdkWindow* _tmp8_;
#line 252 "../lib/hypertextview.vala"
		_tmp3_ = gtk_text_view_get_window ((GtkTextView*) self, GTK_TEXT_WINDOW_TEXT);
#line 252 "../lib/hypertextview.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 252 "../lib/hypertextview.vala"
		win = _tmp4_;
#line 253 "../lib/hypertextview.vala"
		if (self->priv->cursor_over_link) {
#line 1506 "hypertextview.c"
			GdkCursor* _tmp6_;
#line 253 "../lib/hypertextview.vala"
			_tmp6_ = self->priv->hand_cursor;
#line 253 "../lib/hypertextview.vala"
			_tmp5_ = _tmp6_;
#line 1512 "hypertextview.c"
		} else {
			GdkCursor* _tmp7_;
#line 253 "../lib/hypertextview.vala"
			_tmp7_ = self->priv->regular_cursor;
#line 253 "../lib/hypertextview.vala"
			_tmp5_ = _tmp7_;
#line 1519 "hypertextview.c"
		}
#line 253 "../lib/hypertextview.vala"
		_tmp8_ = win;
#line 253 "../lib/hypertextview.vala"
		gdk_window_set_cursor (_tmp8_, _tmp5_);
#line 251 "../lib/hypertextview.vala"
		_g_object_unref0 (win);
#line 1527 "hypertextview.c"
	}
}

/**
 * insert_text_cb:
 *
 * Event to create and update existing tags within the buffer.
 */
static void
xnp_hypertext_view_insert_text_cb (XnpHypertextView* self,
                                   GtkTextBuffer* buffer,
                                   GtkTextIter* location,
                                   const gchar* text,
                                   gint len)
{
	GtkTextIter end_iter = {0};
	GtkTextIter _tmp0_;
	GtkTextIter _tmp1_;
	GtkTextIter _tmp2_;
#line 262 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 262 "../lib/hypertextview.vala"
	g_return_if_fail (buffer != NULL);
#line 262 "../lib/hypertextview.vala"
	g_return_if_fail (location != NULL);
#line 262 "../lib/hypertextview.vala"
	g_return_if_fail (text != NULL);
#line 263 "../lib/hypertextview.vala"
	_tmp0_ = *location;
#line 263 "../lib/hypertextview.vala"
	end_iter = _tmp0_;
#line 264 "../lib/hypertextview.vala"
	gtk_text_iter_forward_chars (&end_iter, g_utf8_strlen (text, (gssize) -1));
#line 265 "../lib/hypertextview.vala"
	_tmp1_ = *location;
#line 265 "../lib/hypertextview.vala"
	_tmp2_ = end_iter;
#line 265 "../lib/hypertextview.vala"
	xnp_hypertext_view_auto_highlight_urls (self, &_tmp1_, &_tmp2_);
#line 1567 "hypertextview.c"
}

/**
 * delete_range_cb:
 *
 * Event to delete and update existing tags within the buffer.
 */
static void
xnp_hypertext_view_delete_range_cb (XnpHypertextView* self,
                                    GtkTextBuffer* buffer,
                                    GtkTextIter* start,
                                    GtkTextIter* end)
{
	GtkTextIter _tmp0_;
	GtkTextIter _tmp1_;
#line 273 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 273 "../lib/hypertextview.vala"
	g_return_if_fail (buffer != NULL);
#line 273 "../lib/hypertextview.vala"
	g_return_if_fail (start != NULL);
#line 273 "../lib/hypertextview.vala"
	g_return_if_fail (end != NULL);
#line 274 "../lib/hypertextview.vala"
	_tmp0_ = *start;
#line 274 "../lib/hypertextview.vala"
	_tmp1_ = *end;
#line 274 "../lib/hypertextview.vala"
	xnp_hypertext_view_auto_highlight_urls (self, &_tmp0_, &_tmp1_);
#line 1597 "hypertextview.c"
}

void
xnp_hypertext_view_undo (XnpHypertextView* self)
{
	GtkSourceBuffer* buffer = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkSourceBuffer* _tmp2_;
	GtkSourceBuffer* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 281 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 282 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 282 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 282 "../lib/hypertextview.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_source_buffer_get_type ()) ? ((GtkSourceBuffer*) _tmp1_) : NULL);
#line 282 "../lib/hypertextview.vala"
	buffer = _tmp2_;
#line 283 "../lib/hypertextview.vala"
	_tmp3_ = buffer;
#line 283 "../lib/hypertextview.vala"
	g_object_get (_tmp3_, "can-undo", &_tmp4_, NULL);
#line 283 "../lib/hypertextview.vala"
	_tmp5_ = _tmp4_;
#line 283 "../lib/hypertextview.vala"
	if (_tmp5_) {
#line 1628 "hypertextview.c"
		GtkSourceBuffer* _tmp6_;
#line 284 "../lib/hypertextview.vala"
		_tmp6_ = buffer;
#line 284 "../lib/hypertextview.vala"
		gtk_source_buffer_undo (_tmp6_);
#line 1634 "hypertextview.c"
	}
#line 281 "../lib/hypertextview.vala"
	_g_object_unref0 (buffer);
#line 1638 "hypertextview.c"
}

void
xnp_hypertext_view_redo (XnpHypertextView* self)
{
	GtkSourceBuffer* buffer = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkSourceBuffer* _tmp2_;
	GtkSourceBuffer* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 287 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 288 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 288 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 288 "../lib/hypertextview.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_source_buffer_get_type ()) ? ((GtkSourceBuffer*) _tmp1_) : NULL);
#line 288 "../lib/hypertextview.vala"
	buffer = _tmp2_;
#line 289 "../lib/hypertextview.vala"
	_tmp3_ = buffer;
#line 289 "../lib/hypertextview.vala"
	g_object_get (_tmp3_, "can-redo", &_tmp4_, NULL);
#line 289 "../lib/hypertextview.vala"
	_tmp5_ = _tmp4_;
#line 289 "../lib/hypertextview.vala"
	if (_tmp5_) {
#line 1669 "hypertextview.c"
		GtkSourceBuffer* _tmp6_;
#line 290 "../lib/hypertextview.vala"
		_tmp6_ = buffer;
#line 290 "../lib/hypertextview.vala"
		gtk_source_buffer_redo (_tmp6_);
#line 1675 "hypertextview.c"
	}
#line 287 "../lib/hypertextview.vala"
	_g_object_unref0 (buffer);
#line 1679 "hypertextview.c"
}

/**
 * toggle_tag:
 *
 * Toggle appropriate tag on the selected text.
 */
static gboolean
_gtk_text_iter_equal (const GtkTextIter * s1,
                      const GtkTextIter * s2)
{
#line 315 "../lib/hypertextview.vala"
	if (s1 == s2) {
#line 315 "../lib/hypertextview.vala"
		return TRUE;
#line 1695 "hypertextview.c"
	}
#line 315 "../lib/hypertextview.vala"
	if (s1 == NULL) {
#line 315 "../lib/hypertextview.vala"
		return FALSE;
#line 1701 "hypertextview.c"
	}
#line 315 "../lib/hypertextview.vala"
	if (s2 == NULL) {
#line 315 "../lib/hypertextview.vala"
		return FALSE;
#line 1707 "hypertextview.c"
	}
#line 315 "../lib/hypertextview.vala"
	return FALSE;
#line 1711 "hypertextview.c"
}

void
xnp_hypertext_view_toggle_tag (XnpHypertextView* self,
                               const gchar* tag_name)
{
	GtkTextTag* tag = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextTagTable* _tmp2_;
	GtkTextTag* _tmp3_;
	GtkTextTag* _tmp4_;
	GtkTextTag* _tmp5_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextIter _tmp8_ = {0};
	GtkTextIter _tmp9_ = {0};
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	GtkTextTag* _tmp16_;
	GtkTextBuffer* _tmp27_;
	GtkTextBuffer* _tmp28_;
#line 302 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 302 "../lib/hypertextview.vala"
	g_return_if_fail (tag_name != NULL);
#line 303 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 303 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 303 "../lib/hypertextview.vala"
	_tmp2_ = gtk_text_buffer_get_tag_table (_tmp1_);
#line 303 "../lib/hypertextview.vala"
	_tmp3_ = gtk_text_tag_table_lookup (_tmp2_, tag_name);
#line 303 "../lib/hypertextview.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 303 "../lib/hypertextview.vala"
	tag = _tmp4_;
#line 304 "../lib/hypertextview.vala"
	_tmp5_ = tag;
#line 304 "../lib/hypertextview.vala"
	if (_tmp5_ == NULL) {
#line 305 "../lib/hypertextview.vala"
		g_warning ("hypertextview.vala:305: Tag not found: %s", tag_name);
#line 306 "../lib/hypertextview.vala"
		_g_object_unref0 (tag);
#line 306 "../lib/hypertextview.vala"
		return;
#line 1764 "hypertextview.c"
	}
#line 309 "../lib/hypertextview.vala"
	_tmp6_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 309 "../lib/hypertextview.vala"
	_tmp7_ = _tmp6_;
#line 309 "../lib/hypertextview.vala"
	gtk_text_buffer_get_selection_bounds (_tmp7_, &_tmp8_, &_tmp9_);
#line 309 "../lib/hypertextview.vala"
	start = _tmp8_;
#line 309 "../lib/hypertextview.vala"
	end = _tmp9_;
#line 310 "../lib/hypertextview.vala"
	_tmp10_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 310 "../lib/hypertextview.vala"
	_tmp11_ = _tmp10_;
#line 310 "../lib/hypertextview.vala"
	_tmp12_ = gtk_text_buffer_get_has_selection (_tmp11_);
#line 310 "../lib/hypertextview.vala"
	_tmp13_ = _tmp12_;
#line 310 "../lib/hypertextview.vala"
	if (!_tmp13_) {
#line 1786 "hypertextview.c"
		GtkTextIter _tmp14_;
		GtkTextIter _tmp15_;
#line 312 "../lib/hypertextview.vala"
		gtk_text_iter_set_line_offset (&start, 0);
#line 313 "../lib/hypertextview.vala"
		if (!gtk_text_iter_ends_line (&end)) {
#line 314 "../lib/hypertextview.vala"
			gtk_text_iter_forward_to_line_end (&end);
#line 1795 "hypertextview.c"
		}
#line 315 "../lib/hypertextview.vala"
		_tmp14_ = start;
#line 315 "../lib/hypertextview.vala"
		_tmp15_ = end;
#line 315 "../lib/hypertextview.vala"
		if (_gtk_text_iter_equal (&_tmp14_, &_tmp15_) == TRUE) {
#line 317 "../lib/hypertextview.vala"
			_g_object_unref0 (tag);
#line 317 "../lib/hypertextview.vala"
			return;
#line 1807 "hypertextview.c"
		}
	}
#line 319 "../lib/hypertextview.vala"
	_tmp16_ = tag;
#line 319 "../lib/hypertextview.vala"
	if (gtk_text_iter_has_tag (&start, _tmp16_)) {
#line 1814 "hypertextview.c"
		GtkTextBuffer* _tmp17_;
		GtkTextBuffer* _tmp18_;
		GtkTextTag* _tmp19_;
		GtkTextIter _tmp20_;
		GtkTextIter _tmp21_;
#line 320 "../lib/hypertextview.vala"
		_tmp17_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 320 "../lib/hypertextview.vala"
		_tmp18_ = _tmp17_;
#line 320 "../lib/hypertextview.vala"
		_tmp19_ = tag;
#line 320 "../lib/hypertextview.vala"
		_tmp20_ = start;
#line 320 "../lib/hypertextview.vala"
		_tmp21_ = end;
#line 320 "../lib/hypertextview.vala"
		gtk_text_buffer_remove_tag (_tmp18_, _tmp19_, &_tmp20_, &_tmp21_);
#line 1832 "hypertextview.c"
	} else {
		GtkTextBuffer* _tmp22_;
		GtkTextBuffer* _tmp23_;
		GtkTextTag* _tmp24_;
		GtkTextIter _tmp25_;
		GtkTextIter _tmp26_;
#line 322 "../lib/hypertextview.vala"
		_tmp22_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 322 "../lib/hypertextview.vala"
		_tmp23_ = _tmp22_;
#line 322 "../lib/hypertextview.vala"
		_tmp24_ = tag;
#line 322 "../lib/hypertextview.vala"
		_tmp25_ = start;
#line 322 "../lib/hypertextview.vala"
		_tmp26_ = end;
#line 322 "../lib/hypertextview.vala"
		gtk_text_buffer_apply_tag (_tmp23_, _tmp24_, &_tmp25_, &_tmp26_);
#line 1851 "hypertextview.c"
	}
#line 324 "../lib/hypertextview.vala"
	_tmp27_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 324 "../lib/hypertextview.vala"
	_tmp28_ = _tmp27_;
#line 324 "../lib/hypertextview.vala"
	g_signal_emit_by_name (_tmp28_, "changed");
#line 302 "../lib/hypertextview.vala"
	_g_object_unref0 (tag);
#line 1861 "hypertextview.c"
}

/**
 * get_text_with_tags:
 *
 * Get text from buffer with tags embedded.
 */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 332 "../lib/hypertextview.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 332 "../lib/hypertextview.vala"
	return _data5_;
#line 1876 "hypertextview.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 332 "../lib/hypertextview.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1886 "hypertextview.c"
		XnpHypertextView* self;
#line 332 "../lib/hypertextview.vala"
		self = _data5_->self;
#line 332 "../lib/hypertextview.vala"
		_g_free0 (_data5_->tags_text);
#line 332 "../lib/hypertextview.vala"
		_g_object_unref0 (self);
#line 332 "../lib/hypertextview.vala"
		g_slice_free (Block5Data, _data5_);
#line 1896 "hypertextview.c"
	}
}

static void
___lambda14_ (Block5Data* _data5_,
              GtkTextTag* tag)
{
	XnpHypertextView* self;
	gboolean _tmp0_ = FALSE;
	GtkTextTag* _tmp1_;
#line 349 "../lib/hypertextview.vala"
	self = _data5_->self;
#line 349 "../lib/hypertextview.vala"
	g_return_if_fail (tag != NULL);
#line 350 "../lib/hypertextview.vala"
	_tmp1_ = self->priv->tag_link;
#line 350 "../lib/hypertextview.vala"
	if (tag != _tmp1_) {
#line 1915 "hypertextview.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 350 "../lib/hypertextview.vala"
		g_object_get (tag, "name", &_tmp2_, NULL);
#line 350 "../lib/hypertextview.vala"
		_tmp3_ = _tmp2_;
#line 350 "../lib/hypertextview.vala"
		_tmp4_ = _tmp3_;
#line 350 "../lib/hypertextview.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 350 "../lib/hypertextview.vala"
		_g_free0 (_tmp4_);
#line 1929 "hypertextview.c"
	} else {
#line 350 "../lib/hypertextview.vala"
		_tmp0_ = FALSE;
#line 1933 "hypertextview.c"
	}
#line 350 "../lib/hypertextview.vala"
	if (_tmp0_) {
#line 1937 "hypertextview.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 351 "../lib/hypertextview.vala"
		_tmp5_ = _data5_->tags_text;
#line 351 "../lib/hypertextview.vala"
		g_object_get (tag, "name", &_tmp6_, NULL);
#line 351 "../lib/hypertextview.vala"
		_tmp7_ = _tmp6_;
#line 351 "../lib/hypertextview.vala"
		_tmp8_ = _tmp7_;
#line 351 "../lib/hypertextview.vala"
		_tmp9_ = g_strdup_printf ("</%s>", _tmp8_);
#line 351 "../lib/hypertextview.vala"
		_tmp10_ = _tmp9_;
#line 351 "../lib/hypertextview.vala"
		_tmp11_ = g_strconcat (_tmp5_, _tmp10_, NULL);
#line 351 "../lib/hypertextview.vala"
		_g_free0 (_data5_->tags_text);
#line 351 "../lib/hypertextview.vala"
		_data5_->tags_text = _tmp11_;
#line 351 "../lib/hypertextview.vala"
		_g_free0 (_tmp10_);
#line 351 "../lib/hypertextview.vala"
		_g_free0 (_tmp8_);
#line 1967 "hypertextview.c"
	}
}

static void
____lambda14__gfunc (gconstpointer data,
                     gpointer self)
{
#line 349 "../lib/hypertextview.vala"
	___lambda14_ (self, (GtkTextTag*) data);
#line 1977 "hypertextview.c"
}

static void
___lambda15_ (Block5Data* _data5_,
              GtkTextTag* tag)
{
	XnpHypertextView* self;
	gboolean _tmp0_ = FALSE;
	GtkTextTag* _tmp1_;
#line 356 "../lib/hypertextview.vala"
	self = _data5_->self;
#line 356 "../lib/hypertextview.vala"
	g_return_if_fail (tag != NULL);
#line 357 "../lib/hypertextview.vala"
	_tmp1_ = self->priv->tag_link;
#line 357 "../lib/hypertextview.vala"
	if (tag != _tmp1_) {
#line 1995 "hypertextview.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 357 "../lib/hypertextview.vala"
		g_object_get (tag, "name", &_tmp2_, NULL);
#line 357 "../lib/hypertextview.vala"
		_tmp3_ = _tmp2_;
#line 357 "../lib/hypertextview.vala"
		_tmp4_ = _tmp3_;
#line 357 "../lib/hypertextview.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 357 "../lib/hypertextview.vala"
		_g_free0 (_tmp4_);
#line 2009 "hypertextview.c"
	} else {
#line 357 "../lib/hypertextview.vala"
		_tmp0_ = FALSE;
#line 2013 "hypertextview.c"
	}
#line 357 "../lib/hypertextview.vala"
	if (_tmp0_) {
#line 2017 "hypertextview.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 358 "../lib/hypertextview.vala"
		_tmp5_ = _data5_->tags_text;
#line 358 "../lib/hypertextview.vala"
		g_object_get (tag, "name", &_tmp6_, NULL);
#line 358 "../lib/hypertextview.vala"
		_tmp7_ = _tmp6_;
#line 358 "../lib/hypertextview.vala"
		_tmp8_ = _tmp7_;
#line 358 "../lib/hypertextview.vala"
		_tmp9_ = g_strdup_printf ("<%s>", _tmp8_);
#line 358 "../lib/hypertextview.vala"
		_tmp10_ = _tmp9_;
#line 358 "../lib/hypertextview.vala"
		_tmp11_ = g_strconcat (_tmp5_, _tmp10_, NULL);
#line 358 "../lib/hypertextview.vala"
		_g_free0 (_data5_->tags_text);
#line 358 "../lib/hypertextview.vala"
		_data5_->tags_text = _tmp11_;
#line 358 "../lib/hypertextview.vala"
		_g_free0 (_tmp10_);
#line 358 "../lib/hypertextview.vala"
		_g_free0 (_tmp8_);
#line 2047 "hypertextview.c"
	}
}

static void
____lambda15__gfunc (gconstpointer data,
                     gpointer self)
{
#line 356 "../lib/hypertextview.vala"
	___lambda15_ (self, (GtkTextTag*) data);
#line 2057 "hypertextview.c"
}

gchar*
xnp_hypertext_view_get_text_with_tags (XnpHypertextView* self)
{
	Block5Data* _data5_;
	GSList* cb_list_iter = NULL;
	GSList* _tmp0_;
	GtkTextIter cb_text_iter = {0};
	GSList* _tmp1_;
	GtkTextIter start = {0};
	GtkTextIter prev = {0};
	gchar* text = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextIter _tmp14_ = {0};
	GtkTextIter _tmp15_;
	gchar* result;
#line 332 "../lib/hypertextview.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "../lib/hypertextview.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 332 "../lib/hypertextview.vala"
	_data5_->_ref_count_ = 1;
#line 332 "../lib/hypertextview.vala"
	_data5_->self = g_object_ref (self);
#line 333 "../lib/hypertextview.vala"
	_tmp0_ = self->priv->checkboxes;
#line 333 "../lib/hypertextview.vala"
	cb_list_iter = _tmp0_;
#line 335 "../lib/hypertextview.vala"
	_tmp1_ = cb_list_iter;
#line 335 "../lib/hypertextview.vala"
	if (_tmp1_ != NULL) {
#line 2094 "hypertextview.c"
		GtkTextBuffer* _tmp2_;
		GtkTextBuffer* _tmp3_;
		GSList* _tmp4_;
		gconstpointer _tmp5_;
		GtkTextIter _tmp6_ = {0};
#line 336 "../lib/hypertextview.vala"
		_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 336 "../lib/hypertextview.vala"
		_tmp3_ = _tmp2_;
#line 336 "../lib/hypertextview.vala"
		_tmp4_ = cb_list_iter;
#line 336 "../lib/hypertextview.vala"
		_tmp5_ = _tmp4_->data;
#line 336 "../lib/hypertextview.vala"
		gtk_text_buffer_get_iter_at_child_anchor (_tmp3_, &_tmp6_, (GtkTextChildAnchor*) _tmp5_);
#line 336 "../lib/hypertextview.vala"
		cb_text_iter = _tmp6_;
#line 2112 "hypertextview.c"
	} else {
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		GtkTextIter _tmp9_ = {0};
#line 338 "../lib/hypertextview.vala"
		_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 338 "../lib/hypertextview.vala"
		_tmp8_ = _tmp7_;
#line 338 "../lib/hypertextview.vala"
		gtk_text_buffer_get_end_iter (_tmp8_, &_tmp9_);
#line 338 "../lib/hypertextview.vala"
		cb_text_iter = _tmp9_;
#line 2125 "hypertextview.c"
	}
#line 342 "../lib/hypertextview.vala"
	_tmp10_ = g_strdup ("");
#line 342 "../lib/hypertextview.vala"
	text = _tmp10_;
#line 342 "../lib/hypertextview.vala"
	_tmp11_ = g_strdup ("");
#line 342 "../lib/hypertextview.vala"
	_data5_->tags_text = _tmp11_;
#line 343 "../lib/hypertextview.vala"
	_tmp12_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 343 "../lib/hypertextview.vala"
	_tmp13_ = _tmp12_;
#line 343 "../lib/hypertextview.vala"
	gtk_text_buffer_get_start_iter (_tmp13_, &_tmp14_);
#line 343 "../lib/hypertextview.vala"
	start = _tmp14_;
#line 344 "../lib/hypertextview.vala"
	_tmp15_ = start;
#line 344 "../lib/hypertextview.vala"
	prev = _tmp15_;
#line 346 "../lib/hypertextview.vala"
	while (TRUE) {
#line 2149 "hypertextview.c"
		GSList* tags = NULL;
		GSList* _tmp16_;
		GSList* _tmp17_;
		GSList* _tmp18_;
		GSList* _tmp19_;
		gboolean _tmp20_ = FALSE;
		GtkTextIter _tmp21_;
		const gchar* _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		GtkTextIter _tmp58_;
		GtkTextIter _tmp59_;
		const gchar* _tmp61_;
		GtkTextBuffer* _tmp62_;
		GtkTextBuffer* _tmp63_;
		GtkTextIter _tmp64_;
		GtkTextIter _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
#line 347 "../lib/hypertextview.vala"
		_tmp16_ = gtk_text_iter_get_toggled_tags (&start, FALSE);
#line 347 "../lib/hypertextview.vala"
		tags = _tmp16_;
#line 349 "../lib/hypertextview.vala"
		_tmp17_ = tags;
#line 349 "../lib/hypertextview.vala"
		g_slist_foreach (_tmp17_, ____lambda14__gfunc, _data5_);
#line 355 "../lib/hypertextview.vala"
		_tmp18_ = gtk_text_iter_get_toggled_tags (&start, TRUE);
#line 355 "../lib/hypertextview.vala"
		(tags == NULL) ? NULL : (tags = (g_slist_free (tags), NULL));
#line 355 "../lib/hypertextview.vala"
		tags = _tmp18_;
#line 356 "../lib/hypertextview.vala"
		_tmp19_ = tags;
#line 356 "../lib/hypertextview.vala"
		g_slist_foreach (_tmp19_, ____lambda15__gfunc, _data5_);
#line 362 "../lib/hypertextview.vala"
		_tmp21_ = cb_text_iter;
#line 362 "../lib/hypertextview.vala"
		if (gtk_text_iter_equal (&start, &_tmp21_)) {
#line 362 "../lib/hypertextview.vala"
			_tmp20_ = !gtk_text_iter_is_end (&start);
#line 2194 "hypertextview.c"
		} else {
#line 362 "../lib/hypertextview.vala"
			_tmp20_ = FALSE;
#line 2198 "hypertextview.c"
		}
#line 362 "../lib/hypertextview.vala"
		if (_tmp20_) {
#line 2202 "hypertextview.c"
			GtkCheckButton* checkbox = NULL;
			GSList* _tmp22_;
			gconstpointer _tmp23_;
			GList* _tmp24_;
			GList* _tmp25_;
			gconstpointer _tmp26_;
			GtkWidget* _tmp27_;
			GtkCheckButton* _tmp28_;
			GtkCheckButton* _tmp29_;
			const gchar* _tmp30_ = NULL;
			GtkCheckButton* _tmp31_;
			gboolean _tmp32_;
			gboolean _tmp33_;
			const gchar* _tmp34_;
			gchar* _tmp35_;
			GSList* _tmp36_;
			GSList* _tmp37_;
			GSList* _tmp38_;
#line 364 "../lib/hypertextview.vala"
			_tmp22_ = cb_list_iter;
#line 364 "../lib/hypertextview.vala"
			_tmp23_ = _tmp22_->data;
#line 364 "../lib/hypertextview.vala"
			_tmp24_ = gtk_text_child_anchor_get_widgets ((GtkTextChildAnchor*) _tmp23_);
#line 364 "../lib/hypertextview.vala"
			_tmp25_ = _tmp24_;
#line 364 "../lib/hypertextview.vala"
			_tmp26_ = _tmp25_->data;
#line 364 "../lib/hypertextview.vala"
			_tmp27_ = (GtkWidget*) _tmp26_;
#line 364 "../lib/hypertextview.vala"
			_tmp28_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, gtk_check_button_get_type ()) ? ((GtkCheckButton*) _tmp27_) : NULL);
#line 364 "../lib/hypertextview.vala"
			_tmp29_ = _tmp28_;
#line 364 "../lib/hypertextview.vala"
			(_tmp25_ == NULL) ? NULL : (_tmp25_ = (g_list_free (_tmp25_), NULL));
#line 364 "../lib/hypertextview.vala"
			checkbox = _tmp29_;
#line 365 "../lib/hypertextview.vala"
			_tmp31_ = checkbox;
#line 365 "../lib/hypertextview.vala"
			_tmp32_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp31_);
#line 365 "../lib/hypertextview.vala"
			_tmp33_ = _tmp32_;
#line 365 "../lib/hypertextview.vala"
			if (_tmp33_) {
#line 365 "../lib/hypertextview.vala"
				_tmp30_ = "☑";
#line 2251 "hypertextview.c"
			} else {
#line 365 "../lib/hypertextview.vala"
				_tmp30_ = "☐";
#line 2255 "hypertextview.c"
			}
#line 365 "../lib/hypertextview.vala"
			_tmp34_ = _data5_->tags_text;
#line 365 "../lib/hypertextview.vala"
			_tmp35_ = g_strconcat (_tmp34_, _tmp30_, NULL);
#line 365 "../lib/hypertextview.vala"
			_g_free0 (_data5_->tags_text);
#line 365 "../lib/hypertextview.vala"
			_data5_->tags_text = _tmp35_;
#line 366 "../lib/hypertextview.vala"
			_tmp36_ = cb_list_iter;
#line 366 "../lib/hypertextview.vala"
			_tmp37_ = _tmp36_->next;
#line 366 "../lib/hypertextview.vala"
			cb_list_iter = _tmp37_;
#line 367 "../lib/hypertextview.vala"
			_tmp38_ = cb_list_iter;
#line 367 "../lib/hypertextview.vala"
			if (_tmp38_ != NULL) {
#line 2275 "hypertextview.c"
				GtkTextBuffer* _tmp39_;
				GtkTextBuffer* _tmp40_;
				GSList* _tmp41_;
				gconstpointer _tmp42_;
				GtkTextIter _tmp43_ = {0};
#line 368 "../lib/hypertextview.vala"
				_tmp39_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 368 "../lib/hypertextview.vala"
				_tmp40_ = _tmp39_;
#line 368 "../lib/hypertextview.vala"
				_tmp41_ = cb_list_iter;
#line 368 "../lib/hypertextview.vala"
				_tmp42_ = _tmp41_->data;
#line 368 "../lib/hypertextview.vala"
				gtk_text_buffer_get_iter_at_child_anchor (_tmp40_, &_tmp43_, (GtkTextChildAnchor*) _tmp42_);
#line 368 "../lib/hypertextview.vala"
				cb_text_iter = _tmp43_;
#line 2293 "hypertextview.c"
			} else {
				GtkTextBuffer* _tmp44_;
				GtkTextBuffer* _tmp45_;
				GtkTextIter _tmp46_ = {0};
#line 370 "../lib/hypertextview.vala"
				_tmp44_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 370 "../lib/hypertextview.vala"
				_tmp45_ = _tmp44_;
#line 370 "../lib/hypertextview.vala"
				gtk_text_buffer_get_end_iter (_tmp45_, &_tmp46_);
#line 370 "../lib/hypertextview.vala"
				cb_text_iter = _tmp46_;
#line 2306 "hypertextview.c"
			}
#line 372 "../lib/hypertextview.vala"
			gtk_text_iter_forward_char (&start);
#line 373 "../lib/hypertextview.vala"
			_g_object_unref0 (checkbox);
#line 373 "../lib/hypertextview.vala"
			(tags == NULL) ? NULL : (tags = (g_slist_free (tags), NULL));
#line 373 "../lib/hypertextview.vala"
			continue;
#line 2316 "hypertextview.c"
		}
#line 376 "../lib/hypertextview.vala"
		_tmp47_ = _data5_->tags_text;
#line 376 "../lib/hypertextview.vala"
		_tmp48_ = strlen (_tmp47_);
#line 376 "../lib/hypertextview.vala"
		_tmp49_ = _tmp48_;
#line 376 "../lib/hypertextview.vala"
		if (_tmp49_ > 0) {
#line 2326 "hypertextview.c"
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			const gchar* _tmp52_;
			const gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
#line 377 "../lib/hypertextview.vala"
			_tmp50_ = text;
#line 377 "../lib/hypertextview.vala"
			_tmp51_ = xnp_hypertext_view_tag_char;
#line 377 "../lib/hypertextview.vala"
			_tmp52_ = _data5_->tags_text;
#line 377 "../lib/hypertextview.vala"
			_tmp53_ = xnp_hypertext_view_tag_char;
#line 377 "../lib/hypertextview.vala"
			_tmp54_ = g_strdup_printf ("%s%s%s", _tmp51_, _tmp52_, _tmp53_);
#line 377 "../lib/hypertextview.vala"
			_tmp55_ = _tmp54_;
#line 377 "../lib/hypertextview.vala"
			_tmp56_ = g_strconcat (_tmp50_, _tmp55_, NULL);
#line 377 "../lib/hypertextview.vala"
			_g_free0 (text);
#line 377 "../lib/hypertextview.vala"
			text = _tmp56_;
#line 377 "../lib/hypertextview.vala"
			_g_free0 (_tmp55_);
#line 378 "../lib/hypertextview.vala"
			_tmp57_ = g_strdup ("");
#line 378 "../lib/hypertextview.vala"
			_g_free0 (_data5_->tags_text);
#line 378 "../lib/hypertextview.vala"
			_data5_->tags_text = _tmp57_;
#line 2361 "hypertextview.c"
		}
#line 381 "../lib/hypertextview.vala"
		if (gtk_text_iter_is_end (&start)) {
#line 382 "../lib/hypertextview.vala"
			(tags == NULL) ? NULL : (tags = (g_slist_free (tags), NULL));
#line 382 "../lib/hypertextview.vala"
			break;
#line 2369 "hypertextview.c"
		}
#line 384 "../lib/hypertextview.vala"
		_tmp58_ = start;
#line 384 "../lib/hypertextview.vala"
		prev = _tmp58_;
#line 385 "../lib/hypertextview.vala"
		gtk_text_iter_forward_to_tag_toggle (&start, NULL);
#line 387 "../lib/hypertextview.vala"
		_tmp59_ = cb_text_iter;
#line 387 "../lib/hypertextview.vala"
		if (gtk_text_iter_compare (&start, &_tmp59_) >= 0) {
#line 2381 "hypertextview.c"
			GtkTextIter _tmp60_;
#line 389 "../lib/hypertextview.vala"
			_tmp60_ = cb_text_iter;
#line 389 "../lib/hypertextview.vala"
			start = _tmp60_;
#line 2387 "hypertextview.c"
		}
#line 392 "../lib/hypertextview.vala"
		_tmp61_ = text;
#line 392 "../lib/hypertextview.vala"
		_tmp62_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 392 "../lib/hypertextview.vala"
		_tmp63_ = _tmp62_;
#line 392 "../lib/hypertextview.vala"
		_tmp64_ = prev;
#line 392 "../lib/hypertextview.vala"
		_tmp65_ = start;
#line 392 "../lib/hypertextview.vala"
		_tmp66_ = gtk_text_buffer_get_text (_tmp63_, &_tmp64_, &_tmp65_, TRUE);
#line 392 "../lib/hypertextview.vala"
		_tmp67_ = _tmp66_;
#line 392 "../lib/hypertextview.vala"
		_tmp68_ = g_strconcat (_tmp61_, _tmp67_, NULL);
#line 392 "../lib/hypertextview.vala"
		_g_free0 (text);
#line 392 "../lib/hypertextview.vala"
		text = _tmp68_;
#line 392 "../lib/hypertextview.vala"
		_g_free0 (_tmp67_);
#line 346 "../lib/hypertextview.vala"
		(tags == NULL) ? NULL : (tags = (g_slist_free (tags), NULL));
#line 2413 "hypertextview.c"
	}
#line 395 "../lib/hypertextview.vala"
	result = text;
#line 395 "../lib/hypertextview.vala"
	block5_data_unref (_data5_);
#line 395 "../lib/hypertextview.vala"
	_data5_ = NULL;
#line 395 "../lib/hypertextview.vala"
	return result;
#line 2423 "hypertextview.c"
}

/**
 * set_text_with_tags:
 *
 * Load text to buffer and apply tags.
 */
static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 403 "../lib/hypertextview.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 403 "../lib/hypertextview.vala"
	return _data6_;
#line 2438 "hypertextview.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 403 "../lib/hypertextview.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2448 "hypertextview.c"
		XnpHypertextView* self;
#line 403 "../lib/hypertextview.vala"
		self = _data6_->self;
#line 403 "../lib/hypertextview.vala"
		_g_object_unref0 (self);
#line 403 "../lib/hypertextview.vala"
		g_slice_free (Block6Data, _data6_);
#line 2456 "hypertextview.c"
	}
}

static void
______lambda16_ (Block6Data* _data6_,
                 const gchar* tag)
{
	XnpHypertextView* self;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_;
	GtkTextIter _tmp3_;
#line 416 "../lib/hypertextview.vala"
	self = _data6_->self;
#line 416 "../lib/hypertextview.vala"
	g_return_if_fail (tag != NULL);
#line 417 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 417 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 417 "../lib/hypertextview.vala"
	_tmp2_ = _data6_->start;
#line 417 "../lib/hypertextview.vala"
	_tmp3_ = _data6_->end;
#line 417 "../lib/hypertextview.vala"
	gtk_text_buffer_apply_tag_by_name (_tmp1_, tag, &_tmp2_, &_tmp3_);
#line 2483 "hypertextview.c"
}

static void
_______lambda16__gfunc (gconstpointer data,
                        gpointer self)
{
#line 416 "../lib/hypertextview.vala"
	______lambda16_ (self, (const gchar*) data);
#line 2492 "hypertextview.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 2509 "hypertextview.c"
}

static void
__________lambda17_ (Block6Data* _data6_,
                     const gchar* tag)
{
	XnpHypertextView* self;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_;
	GtkTextIter _tmp3_;
#line 429 "../lib/hypertextview.vala"
	self = _data6_->self;
#line 429 "../lib/hypertextview.vala"
	g_return_if_fail (tag != NULL);
#line 430 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 430 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 430 "../lib/hypertextview.vala"
	_tmp2_ = _data6_->start;
#line 430 "../lib/hypertextview.vala"
	_tmp3_ = _data6_->end;
#line 430 "../lib/hypertextview.vala"
	gtk_text_buffer_apply_tag_by_name (_tmp1_, tag, &_tmp2_, &_tmp3_);
#line 2535 "hypertextview.c"
}

static void
___________lambda17__gfunc (gconstpointer data,
                            gpointer self)
{
#line 429 "../lib/hypertextview.vala"
	__________lambda17_ (self, (const gchar*) data);
#line 2544 "hypertextview.c"
}

static void
_g_free0_ (gpointer var)
{
#line 403 "../lib/hypertextview.vala"
	var = (g_free (var), NULL);
#line 2552 "hypertextview.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 403 "../lib/hypertextview.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 2560 "hypertextview.c"
}

void
xnp_hypertext_view_set_text_with_tags (XnpHypertextView* self,
                                       const gchar* text)
{
	Block6Data* _data6_;
	GList* tags = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkTextIter _tmp4_ = {0};
	GtkTextIter _tmp5_ = {0};
	gchar** tokens = NULL;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint tokens_length1;
	gint _tokens_size_;
#line 403 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 403 "../lib/hypertextview.vala"
	g_return_if_fail (text != NULL);
#line 403 "../lib/hypertextview.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 403 "../lib/hypertextview.vala"
	_data6_->_ref_count_ = 1;
#line 403 "../lib/hypertextview.vala"
	_data6_->self = g_object_ref (self);
#line 405 "../lib/hypertextview.vala"
	tags = NULL;
#line 406 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 406 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 406 "../lib/hypertextview.vala"
	g_object_set (_tmp1_, "text", "", NULL);
#line 407 "../lib/hypertextview.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 407 "../lib/hypertextview.vala"
	_tmp3_ = _tmp2_;
#line 407 "../lib/hypertextview.vala"
	gtk_text_buffer_get_bounds (_tmp3_, &_tmp4_, &_tmp5_);
#line 407 "../lib/hypertextview.vala"
	_data6_->start = _tmp4_;
#line 407 "../lib/hypertextview.vala"
	_data6_->end = _tmp5_;
#line 408 "../lib/hypertextview.vala"
	_tmp6_ = xnp_hypertext_view_tag_char;
#line 408 "../lib/hypertextview.vala"
	_tmp8_ = _tmp7_ = g_strsplit (text, _tmp6_, 0);
#line 408 "../lib/hypertextview.vala"
	tokens = _tmp8_;
#line 408 "../lib/hypertextview.vala"
	tokens_length1 = _vala_array_length (_tmp7_);
#line 408 "../lib/hypertextview.vala"
	_tokens_size_ = tokens_length1;
#line 2619 "hypertextview.c"
	{
		gint i = 0;
#line 410 "../lib/hypertextview.vala"
		i = 0;
#line 2624 "hypertextview.c"
		{
			gboolean _tmp9_ = FALSE;
#line 410 "../lib/hypertextview.vala"
			_tmp9_ = TRUE;
#line 410 "../lib/hypertextview.vala"
			while (TRUE) {
#line 2631 "hypertextview.c"
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
#line 410 "../lib/hypertextview.vala"
				if (!_tmp9_) {
#line 2637 "hypertextview.c"
					gint _tmp10_;
#line 410 "../lib/hypertextview.vala"
					_tmp10_ = i;
#line 410 "../lib/hypertextview.vala"
					i = _tmp10_ + 1;
#line 2643 "hypertextview.c"
				}
#line 410 "../lib/hypertextview.vala"
				_tmp9_ = FALSE;
#line 410 "../lib/hypertextview.vala"
				_tmp11_ = tokens;
#line 410 "../lib/hypertextview.vala"
				_tmp11__length1 = tokens_length1;
#line 410 "../lib/hypertextview.vala"
				_tmp12_ = _tmp11_[i];
#line 410 "../lib/hypertextview.vala"
				if (!(_tmp12_ != NULL)) {
#line 410 "../lib/hypertextview.vala"
					break;
#line 2657 "hypertextview.c"
				}
#line 411 "../lib/hypertextview.vala"
				if ((i % 2) == 0) {
#line 2661 "hypertextview.c"
					gint offset = 0;
					GtkTextBuffer* _tmp13_;
					GtkTextBuffer* _tmp14_;
					gchar** _tmp15_;
					gint _tmp15__length1;
					const gchar* _tmp16_;
					GtkTextBuffer* _tmp17_;
					GtkTextBuffer* _tmp18_;
					GtkTextIter _tmp19_ = {0};
					GList* _tmp20_;
#line 413 "../lib/hypertextview.vala"
					offset = gtk_text_iter_get_offset (&_data6_->end);
#line 414 "../lib/hypertextview.vala"
					_tmp13_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 414 "../lib/hypertextview.vala"
					_tmp14_ = _tmp13_;
#line 414 "../lib/hypertextview.vala"
					_tmp15_ = tokens;
#line 414 "../lib/hypertextview.vala"
					_tmp15__length1 = tokens_length1;
#line 414 "../lib/hypertextview.vala"
					_tmp16_ = _tmp15_[i];
#line 414 "../lib/hypertextview.vala"
					gtk_text_buffer_insert (_tmp14_, &_data6_->end, _tmp16_, -1);
#line 415 "../lib/hypertextview.vala"
					_tmp17_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 415 "../lib/hypertextview.vala"
					_tmp18_ = _tmp17_;
#line 415 "../lib/hypertextview.vala"
					gtk_text_buffer_get_iter_at_offset (_tmp18_, &_tmp19_, offset);
#line 415 "../lib/hypertextview.vala"
					_data6_->start = _tmp19_;
#line 416 "../lib/hypertextview.vala"
					_tmp20_ = tags;
#line 416 "../lib/hypertextview.vala"
					g_list_foreach (_tmp20_, _______lambda16__gfunc, _data6_);
#line 2698 "hypertextview.c"
				} else {
					gchar** tags_tokens = NULL;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gint _tmp23_ = 0;
					gchar** _tmp24_;
					gint tags_tokens_length1;
					gint _tags_tokens_size_;
					gchar** _tmp25_;
					gint _tmp25__length1;
#line 421 "../lib/hypertextview.vala"
					_tmp21_ = tokens;
#line 421 "../lib/hypertextview.vala"
					_tmp21__length1 = tokens_length1;
#line 421 "../lib/hypertextview.vala"
					_tmp22_ = _tmp21_[i];
#line 421 "../lib/hypertextview.vala"
					_tmp24_ = xnp_hypertext_view_split_tags (self, _tmp22_, &_tmp23_);
#line 421 "../lib/hypertextview.vala"
					tags_tokens = _tmp24_;
#line 421 "../lib/hypertextview.vala"
					tags_tokens_length1 = _tmp23_;
#line 421 "../lib/hypertextview.vala"
					_tags_tokens_size_ = tags_tokens_length1;
#line 422 "../lib/hypertextview.vala"
					_tmp25_ = tags_tokens;
#line 422 "../lib/hypertextview.vala"
					_tmp25__length1 = tags_tokens_length1;
#line 2728 "hypertextview.c"
					{
						gchar** tag_collection = NULL;
						gint tag_collection_length1 = 0;
						gint _tag_collection_size_ = 0;
						gint tag_it = 0;
#line 422 "../lib/hypertextview.vala"
						tag_collection = _tmp25_;
#line 422 "../lib/hypertextview.vala"
						tag_collection_length1 = _tmp25__length1;
#line 422 "../lib/hypertextview.vala"
						for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 2740 "hypertextview.c"
							gchar* _tmp26_;
							gchar* tag = NULL;
#line 422 "../lib/hypertextview.vala"
							_tmp26_ = g_strdup (tag_collection[tag_it]);
#line 422 "../lib/hypertextview.vala"
							tag = _tmp26_;
#line 2747 "hypertextview.c"
							{
								const gchar* _tmp27_;
#line 423 "../lib/hypertextview.vala"
								_tmp27_ = tag;
#line 423 "../lib/hypertextview.vala"
								if (string_get (_tmp27_, (glong) 0) != '<') {
#line 2754 "hypertextview.c"
									gboolean _tmp28_ = FALSE;
									const gchar* _tmp29_;
#line 425 "../lib/hypertextview.vala"
									_tmp29_ = tag;
#line 425 "../lib/hypertextview.vala"
									if (g_strcmp0 (_tmp29_, "☐") == 0) {
#line 425 "../lib/hypertextview.vala"
										_tmp28_ = TRUE;
#line 2763 "hypertextview.c"
									} else {
										const gchar* _tmp30_;
#line 425 "../lib/hypertextview.vala"
										_tmp30_ = tag;
#line 425 "../lib/hypertextview.vala"
										_tmp28_ = g_strcmp0 (_tmp30_, "☑") == 0;
#line 2770 "hypertextview.c"
									}
#line 425 "../lib/hypertextview.vala"
									if (_tmp28_) {
#line 2774 "hypertextview.c"
										const gchar* _tmp31_;
										GtkTextIter _tmp32_;
										GList* _tmp33_;
#line 426 "../lib/hypertextview.vala"
										_tmp31_ = tag;
#line 426 "../lib/hypertextview.vala"
										xnp_hypertext_view_insert_checkbox_at_iter (self, &_data6_->end, g_strcmp0 (_tmp31_, "☑") == 0);
#line 427 "../lib/hypertextview.vala"
										_tmp32_ = _data6_->end;
#line 427 "../lib/hypertextview.vala"
										_data6_->start = _tmp32_;
#line 428 "../lib/hypertextview.vala"
										gtk_text_iter_backward_char (&_data6_->start);
#line 429 "../lib/hypertextview.vala"
										_tmp33_ = tags;
#line 429 "../lib/hypertextview.vala"
										g_list_foreach (_tmp33_, ___________lambda17__gfunc, _data6_);
#line 2792 "hypertextview.c"
									}
								} else {
									const gchar* _tmp34_;
#line 435 "../lib/hypertextview.vala"
									_tmp34_ = tag;
#line 435 "../lib/hypertextview.vala"
									if (string_get (_tmp34_, (glong) 1) != '/') {
#line 2800 "hypertextview.c"
										const gchar* _tmp35_;
										gchar* _tmp36_;
#line 436 "../lib/hypertextview.vala"
										_tmp35_ = tag;
#line 436 "../lib/hypertextview.vala"
										_tmp36_ = string_slice (_tmp35_, (glong) 1, (glong) -1);
#line 436 "../lib/hypertextview.vala"
										tags = g_list_prepend (tags, _tmp36_);
#line 2809 "hypertextview.c"
									} else {
										GList* element = NULL;
										GList* _tmp37_;
										const gchar* _tmp38_;
										gchar* _tmp39_;
										gchar* _tmp40_;
										GCompareFunc _tmp41_;
										GList* _tmp42_;
										GList* _tmp43_;
										GList* _tmp44_;
#line 438 "../lib/hypertextview.vala"
										_tmp37_ = tags;
#line 438 "../lib/hypertextview.vala"
										_tmp38_ = tag;
#line 438 "../lib/hypertextview.vala"
										_tmp39_ = string_slice (_tmp38_, (glong) 2, (glong) -1);
#line 438 "../lib/hypertextview.vala"
										_tmp40_ = _tmp39_;
#line 438 "../lib/hypertextview.vala"
										_tmp41_ = ((GCompareFunc) g_strcmp0);
#line 438 "../lib/hypertextview.vala"
										_tmp42_ = g_list_find_custom (_tmp37_, _tmp40_, _tmp41_);
#line 438 "../lib/hypertextview.vala"
										_tmp43_ = _tmp42_;
#line 438 "../lib/hypertextview.vala"
										_g_free0 (_tmp40_);
#line 438 "../lib/hypertextview.vala"
										element = _tmp43_;
#line 439 "../lib/hypertextview.vala"
										_tmp44_ = element;
#line 439 "../lib/hypertextview.vala"
										if (_tmp44_ != NULL) {
#line 2842 "hypertextview.c"
											GList* _tmp45_;
#line 439 "../lib/hypertextview.vala"
											_tmp45_ = element;
#line 439 "../lib/hypertextview.vala"
											tags = g_list_delete_link (tags, _tmp45_);
#line 2848 "hypertextview.c"
										}
									}
								}
#line 422 "../lib/hypertextview.vala"
								_g_free0 (tag);
#line 2854 "hypertextview.c"
							}
						}
					}
#line 411 "../lib/hypertextview.vala"
					tags_tokens = (_vala_array_free (tags_tokens, tags_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 2860 "hypertextview.c"
				}
			}
		}
	}
#line 403 "../lib/hypertextview.vala"
	tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 403 "../lib/hypertextview.vala"
	(tags == NULL) ? NULL : (tags = (_g_list_free__g_free0_ (tags), NULL));
#line 403 "../lib/hypertextview.vala"
	block6_data_unref (_data6_);
#line 403 "../lib/hypertextview.vala"
	_data6_ = NULL;
#line 2873 "hypertextview.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1302 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1303 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1304 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 2889 "hypertextview.c"
		gchar* _tmp0_;
#line 1305 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1305 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1306 "glib-2.0.vapi"
		result = TRUE;
#line 1306 "glib-2.0.vapi"
		if (c) {
#line 1306 "glib-2.0.vapi"
			*c = _vala_c;
#line 2901 "hypertextview.c"
		}
#line 1306 "glib-2.0.vapi"
		return result;
#line 2905 "hypertextview.c"
	} else {
#line 1308 "glib-2.0.vapi"
		result = FALSE;
#line 1308 "glib-2.0.vapi"
		if (c) {
#line 1308 "glib-2.0.vapi"
			*c = _vala_c;
#line 2913 "hypertextview.c"
		}
#line 1308 "glib-2.0.vapi"
		return result;
#line 2917 "hypertextview.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 457 "../lib/hypertextview.vala"
	if ((*length) == (*size)) {
#line 457 "../lib/hypertextview.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 457 "../lib/hypertextview.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2933 "hypertextview.c"
	}
#line 457 "../lib/hypertextview.vala"
	(*array)[(*length)++] = value;
#line 457 "../lib/hypertextview.vala"
	(*array)[*length] = NULL;
#line 2939 "hypertextview.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 469 "../lib/hypertextview.vala"
	if ((*length) == (*size)) {
#line 469 "../lib/hypertextview.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 469 "../lib/hypertextview.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2954 "hypertextview.c"
	}
#line 469 "../lib/hypertextview.vala"
	(*array)[(*length)++] = value;
#line 469 "../lib/hypertextview.vala"
	(*array)[*length] = NULL;
#line 2960 "hypertextview.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 478 "../lib/hypertextview.vala"
	if ((*length) == (*size)) {
#line 478 "../lib/hypertextview.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 478 "../lib/hypertextview.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2975 "hypertextview.c"
	}
#line 478 "../lib/hypertextview.vala"
	(*array)[(*length)++] = value;
#line 478 "../lib/hypertextview.vala"
	(*array)[*length] = NULL;
#line 2981 "hypertextview.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 481 "../lib/hypertextview.vala"
	if ((*length) == (*size)) {
#line 481 "../lib/hypertextview.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 481 "../lib/hypertextview.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2996 "hypertextview.c"
	}
#line 481 "../lib/hypertextview.vala"
	(*array)[(*length)++] = value;
#line 481 "../lib/hypertextview.vala"
	(*array)[*length] = NULL;
#line 3002 "hypertextview.c"
}

static gchar**
xnp_hypertext_view_split_tags (XnpHypertextView* self,
                               const gchar* tags,
                               gint* result_length1)
{
	GString* builder = NULL;
	GString* _tmp0_;
	gchar** _result_ = NULL;
	gchar** _tmp1_;
	gint _result__length1;
	gint __result__size_;
	gboolean tag = FALSE;
	gunichar c = 0U;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar** result;
#line 447 "../lib/hypertextview.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 447 "../lib/hypertextview.vala"
	g_return_val_if_fail (tags != NULL, NULL);
#line 448 "../lib/hypertextview.vala"
	_tmp0_ = g_string_new ("");
#line 448 "../lib/hypertextview.vala"
	builder = _tmp0_;
#line 449 "../lib/hypertextview.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 449 "../lib/hypertextview.vala"
	_result_ = _tmp1_;
#line 449 "../lib/hypertextview.vala"
	_result__length1 = 0;
#line 449 "../lib/hypertextview.vala"
	__result__size_ = _result__length1;
#line 450 "../lib/hypertextview.vala"
	tag = FALSE;
#line 3039 "hypertextview.c"
	{
		gint i = 0;
#line 452 "../lib/hypertextview.vala"
		i = 0;
#line 3044 "hypertextview.c"
		{
			gboolean _tmp2_ = FALSE;
#line 452 "../lib/hypertextview.vala"
			_tmp2_ = TRUE;
#line 452 "../lib/hypertextview.vala"
			while (TRUE) {
#line 3051 "hypertextview.c"
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
#line 452 "../lib/hypertextview.vala"
				if (!_tmp2_) {
#line 3056 "hypertextview.c"
				}
#line 452 "../lib/hypertextview.vala"
				_tmp2_ = FALSE;
#line 452 "../lib/hypertextview.vala"
				_tmp4_ = string_get_next_char (tags, &i, &_tmp3_);
#line 452 "../lib/hypertextview.vala"
				c = _tmp3_;
#line 452 "../lib/hypertextview.vala"
				if (!_tmp4_) {
#line 452 "../lib/hypertextview.vala"
					break;
#line 3068 "hypertextview.c"
				}
#line 453 "../lib/hypertextview.vala"
				if (c == ((gunichar) '<')) {
#line 454 "../lib/hypertextview.vala"
					if (!tag) {
#line 3074 "hypertextview.c"
						GString* _tmp5_;
#line 456 "../lib/hypertextview.vala"
						_tmp5_ = builder;
#line 456 "../lib/hypertextview.vala"
						if (_tmp5_->len != ((gssize) 0)) {
#line 3080 "hypertextview.c"
							GString* _tmp6_;
							const gchar* _tmp7_;
							gchar* _tmp8_;
							GString* _tmp9_;
#line 457 "../lib/hypertextview.vala"
							_tmp6_ = builder;
#line 457 "../lib/hypertextview.vala"
							_tmp7_ = _tmp6_->str;
#line 457 "../lib/hypertextview.vala"
							_tmp8_ = g_strdup (_tmp7_);
#line 457 "../lib/hypertextview.vala"
							_vala_array_add1 (&_result_, &_result__length1, &__result__size_, _tmp8_);
#line 458 "../lib/hypertextview.vala"
							_tmp9_ = g_string_new ("<");
#line 458 "../lib/hypertextview.vala"
							_g_string_free0 (builder);
#line 458 "../lib/hypertextview.vala"
							builder = _tmp9_;
#line 3099 "hypertextview.c"
						} else {
							GString* _tmp10_;
#line 460 "../lib/hypertextview.vala"
							_tmp10_ = builder;
#line 460 "../lib/hypertextview.vala"
							g_string_append_c (_tmp10_, '<');
#line 3106 "hypertextview.c"
						}
#line 462 "../lib/hypertextview.vala"
						tag = TRUE;
#line 3110 "hypertextview.c"
					}
				} else {
#line 464 "../lib/hypertextview.vala"
					if (c == ((gunichar) '>')) {
#line 465 "../lib/hypertextview.vala"
						if (tag) {
#line 3117 "hypertextview.c"
							GString* _tmp11_;
							GString* _tmp12_;
							const gchar* _tmp13_;
							gchar* _tmp14_;
							GString* _tmp15_;
#line 467 "../lib/hypertextview.vala"
							tag = FALSE;
#line 468 "../lib/hypertextview.vala"
							_tmp11_ = builder;
#line 468 "../lib/hypertextview.vala"
							g_string_append_c (_tmp11_, '>');
#line 469 "../lib/hypertextview.vala"
							_tmp12_ = builder;
#line 469 "../lib/hypertextview.vala"
							_tmp13_ = _tmp12_->str;
#line 469 "../lib/hypertextview.vala"
							_tmp14_ = g_strdup (_tmp13_);
#line 469 "../lib/hypertextview.vala"
							_vala_array_add2 (&_result_, &_result__length1, &__result__size_, _tmp14_);
#line 470 "../lib/hypertextview.vala"
							_tmp15_ = g_string_new ("");
#line 470 "../lib/hypertextview.vala"
							_g_string_free0 (builder);
#line 470 "../lib/hypertextview.vala"
							builder = _tmp15_;
#line 3143 "hypertextview.c"
						}
					} else {
#line 472 "../lib/hypertextview.vala"
						if (tag) {
#line 3148 "hypertextview.c"
							GString* _tmp16_;
#line 474 "../lib/hypertextview.vala"
							_tmp16_ = builder;
#line 474 "../lib/hypertextview.vala"
							g_string_append_unichar (_tmp16_, c);
#line 3154 "hypertextview.c"
						} else {
							gboolean _tmp17_ = FALSE;
#line 475 "../lib/hypertextview.vala"
							if (c == ((gunichar) 0x2610)) {
#line 475 "../lib/hypertextview.vala"
								_tmp17_ = TRUE;
#line 3161 "hypertextview.c"
							} else {
#line 475 "../lib/hypertextview.vala"
								_tmp17_ = c == ((gunichar) 0x2611);
#line 3165 "hypertextview.c"
							}
#line 475 "../lib/hypertextview.vala"
							if (_tmp17_) {
#line 3169 "hypertextview.c"
								GString* _tmp18_;
								gchar* _tmp23_;
#line 477 "../lib/hypertextview.vala"
								_tmp18_ = builder;
#line 477 "../lib/hypertextview.vala"
								if (_tmp18_->len != ((gssize) 0)) {
#line 3176 "hypertextview.c"
									GString* _tmp19_;
									const gchar* _tmp20_;
									gchar* _tmp21_;
									GString* _tmp22_;
#line 478 "../lib/hypertextview.vala"
									_tmp19_ = builder;
#line 478 "../lib/hypertextview.vala"
									_tmp20_ = _tmp19_->str;
#line 478 "../lib/hypertextview.vala"
									_tmp21_ = g_strdup (_tmp20_);
#line 478 "../lib/hypertextview.vala"
									_vala_array_add3 (&_result_, &_result__length1, &__result__size_, _tmp21_);
#line 479 "../lib/hypertextview.vala"
									_tmp22_ = g_string_new ("");
#line 479 "../lib/hypertextview.vala"
									_g_string_free0 (builder);
#line 479 "../lib/hypertextview.vala"
									builder = _tmp22_;
#line 3195 "hypertextview.c"
								}
#line 481 "../lib/hypertextview.vala"
								_tmp23_ = g_unichar_to_string (c);
#line 481 "../lib/hypertextview.vala"
								_vala_array_add4 (&_result_, &_result__length1, &__result__size_, _tmp23_);
#line 3201 "hypertextview.c"
							} else {
							}
						}
					}
				}
			}
		}
	}
#line 487 "../lib/hypertextview.vala"
	_tmp24_ = _result_;
#line 487 "../lib/hypertextview.vala"
	_tmp24__length1 = _result__length1;
#line 487 "../lib/hypertextview.vala"
	if (result_length1) {
#line 487 "../lib/hypertextview.vala"
		*result_length1 = _tmp24__length1;
#line 3218 "hypertextview.c"
	}
#line 487 "../lib/hypertextview.vala"
	result = _tmp24_;
#line 487 "../lib/hypertextview.vala"
	_g_string_free0 (builder);
#line 487 "../lib/hypertextview.vala"
	return result;
#line 3226 "hypertextview.c"
}

/**
 * update_tags:
 *
 * Goes through the entire document to search for untagged links and tag them.
 */
void
xnp_hypertext_view_update_tags (XnpHypertextView* self)
{
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextBuffer* _tmp3_;
	GtkTextBuffer* _tmp4_;
	GtkTextIter _tmp5_ = {0};
	GtkTextIter _tmp6_;
	GtkTextIter _tmp7_;
#line 495 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 497 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 497 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 497 "../lib/hypertextview.vala"
	gtk_text_buffer_get_start_iter (_tmp1_, &_tmp2_);
#line 497 "../lib/hypertextview.vala"
	start = _tmp2_;
#line 498 "../lib/hypertextview.vala"
	_tmp3_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 498 "../lib/hypertextview.vala"
	_tmp4_ = _tmp3_;
#line 498 "../lib/hypertextview.vala"
	gtk_text_buffer_get_end_iter (_tmp4_, &_tmp5_);
#line 498 "../lib/hypertextview.vala"
	end = _tmp5_;
#line 499 "../lib/hypertextview.vala"
	_tmp6_ = start;
#line 499 "../lib/hypertextview.vala"
	_tmp7_ = end;
#line 499 "../lib/hypertextview.vala"
	xnp_hypertext_view_auto_highlight_urls (self, &_tmp6_, &_tmp7_);
#line 3271 "hypertextview.c"
}

static void
xnp_hypertext_view_auto_highlight_urls (XnpHypertextView* self,
                                        GtkTextIter* start,
                                        GtkTextIter* end)
{
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextTag* _tmp2_;
	GtkTextIter _tmp3_;
	GtkTextIter _tmp4_;
	gchar* str = NULL;
	GtkTextIter _tmp5_;
	gchar* _tmp6_;
	GMatchInfo* match_info = NULL;
	GRegex* _tmp7_;
	const gchar* _tmp8_;
	GMatchInfo* _tmp9_ = NULL;
	GError* _inner_error0_ = NULL;
#line 502 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 502 "../lib/hypertextview.vala"
	g_return_if_fail (start != NULL);
#line 502 "../lib/hypertextview.vala"
	g_return_if_fail (end != NULL);
#line 504 "../lib/hypertextview.vala"
	xnp_hypertext_view_extend_block (self, start, end, 256);
#line 507 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 507 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 507 "../lib/hypertextview.vala"
	_tmp2_ = self->priv->tag_link;
#line 507 "../lib/hypertextview.vala"
	_tmp3_ = *start;
#line 507 "../lib/hypertextview.vala"
	_tmp4_ = *end;
#line 507 "../lib/hypertextview.vala"
	gtk_text_buffer_remove_tag (_tmp1_, _tmp2_, &_tmp3_, &_tmp4_);
#line 510 "../lib/hypertextview.vala"
	_tmp5_ = *end;
#line 510 "../lib/hypertextview.vala"
	_tmp6_ = gtk_text_iter_get_slice (start, &_tmp5_);
#line 510 "../lib/hypertextview.vala"
	str = _tmp6_;
#line 514 "../lib/hypertextview.vala"
	_tmp7_ = self->priv->regex_link;
#line 514 "../lib/hypertextview.vala"
	_tmp8_ = str;
#line 514 "../lib/hypertextview.vala"
	g_regex_match (_tmp7_, _tmp8_, 0, &_tmp9_);
#line 514 "../lib/hypertextview.vala"
	_g_match_info_unref0 (match_info);
#line 514 "../lib/hypertextview.vala"
	match_info = _tmp9_;
#line 3328 "hypertextview.c"
	{
#line 518 "../lib/hypertextview.vala"
		while (TRUE) {
#line 3332 "hypertextview.c"
			GMatchInfo* _tmp10_;
			gint start_pos = 0;
			gint end_pos = 0;
			GMatchInfo* _tmp11_;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			GtkTextIter xstart = {0};
			GtkTextIter _tmp14_;
			const gchar* _tmp15_;
			GtkTextIter xend = {0};
			GtkTextIter _tmp16_;
			const gchar* _tmp17_;
			GtkTextBuffer* _tmp18_;
			GtkTextBuffer* _tmp19_;
			GtkTextTag* _tmp20_;
			GtkTextIter _tmp21_;
			GtkTextIter _tmp22_;
			GMatchInfo* _tmp23_;
#line 518 "../lib/hypertextview.vala"
			_tmp10_ = match_info;
#line 518 "../lib/hypertextview.vala"
			if (!g_match_info_matches (_tmp10_)) {
#line 518 "../lib/hypertextview.vala"
				break;
#line 3357 "hypertextview.c"
			}
#line 522 "../lib/hypertextview.vala"
			_tmp11_ = match_info;
#line 522 "../lib/hypertextview.vala"
			g_match_info_fetch_pos (_tmp11_, 0, &_tmp12_, &_tmp13_);
#line 522 "../lib/hypertextview.vala"
			start_pos = _tmp12_;
#line 522 "../lib/hypertextview.vala"
			end_pos = _tmp13_;
#line 525 "../lib/hypertextview.vala"
			_tmp14_ = *start;
#line 525 "../lib/hypertextview.vala"
			xstart = _tmp14_;
#line 526 "../lib/hypertextview.vala"
			_tmp15_ = str;
#line 526 "../lib/hypertextview.vala"
			gtk_text_iter_forward_chars (&xstart, g_utf8_strlen (_tmp15_, (gssize) start_pos));
#line 528 "../lib/hypertextview.vala"
			_tmp16_ = *start;
#line 528 "../lib/hypertextview.vala"
			xend = _tmp16_;
#line 529 "../lib/hypertextview.vala"
			_tmp17_ = str;
#line 529 "../lib/hypertextview.vala"
			gtk_text_iter_forward_chars (&xend, g_utf8_strlen (_tmp17_, (gssize) end_pos));
#line 531 "../lib/hypertextview.vala"
			_tmp18_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 531 "../lib/hypertextview.vala"
			_tmp19_ = _tmp18_;
#line 531 "../lib/hypertextview.vala"
			_tmp20_ = self->priv->tag_link;
#line 531 "../lib/hypertextview.vala"
			_tmp21_ = xstart;
#line 531 "../lib/hypertextview.vala"
			_tmp22_ = xend;
#line 531 "../lib/hypertextview.vala"
			gtk_text_buffer_apply_tag (_tmp19_, _tmp20_, &_tmp21_, &_tmp22_);
#line 533 "../lib/hypertextview.vala"
			_tmp23_ = match_info;
#line 533 "../lib/hypertextview.vala"
			g_match_info_next (_tmp23_, &_inner_error0_);
#line 533 "../lib/hypertextview.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 533 "../lib/hypertextview.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3403 "hypertextview.c"
					goto __catch0_g_regex_error;
				}
#line 533 "../lib/hypertextview.vala"
				_g_match_info_unref0 (match_info);
#line 533 "../lib/hypertextview.vala"
				_g_free0 (str);
#line 533 "../lib/hypertextview.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 533 "../lib/hypertextview.vala"
				g_clear_error (&_inner_error0_);
#line 533 "../lib/hypertextview.vala"
				return;
#line 3416 "hypertextview.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 517 "../lib/hypertextview.vala"
		e = _inner_error0_;
#line 517 "../lib/hypertextview.vala"
		_inner_error0_ = NULL;
#line 536 "../lib/hypertextview.vala"
		_tmp24_ = e;
#line 536 "../lib/hypertextview.vala"
		_tmp25_ = _tmp24_->message;
#line 536 "../lib/hypertextview.vala"
		g_warning ("hypertextview.vala:536: %s", _tmp25_);
#line 517 "../lib/hypertextview.vala"
		_g_error_free0 (e);
#line 3438 "hypertextview.c"
	}
	__finally0:
#line 517 "../lib/hypertextview.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 517 "../lib/hypertextview.vala"
		_g_match_info_unref0 (match_info);
#line 517 "../lib/hypertextview.vala"
		_g_free0 (str);
#line 517 "../lib/hypertextview.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 517 "../lib/hypertextview.vala"
		g_clear_error (&_inner_error0_);
#line 517 "../lib/hypertextview.vala"
		return;
#line 3453 "hypertextview.c"
	}
#line 502 "../lib/hypertextview.vala"
	_g_match_info_unref0 (match_info);
#line 502 "../lib/hypertextview.vala"
	_g_free0 (str);
#line 3459 "hypertextview.c"
}

static void
xnp_hypertext_view_extend_block (XnpHypertextView* self,
                                 GtkTextIter* start_iter,
                                 GtkTextIter* end_iter,
                                 gint max_len)
{
#line 540 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 540 "../lib/hypertextview.vala"
	g_return_if_fail (start_iter != NULL);
#line 540 "../lib/hypertextview.vala"
	g_return_if_fail (end_iter != NULL);
#line 542 "../lib/hypertextview.vala"
	if ((gtk_text_iter_get_line_offset (start_iter) - max_len) > 0) {
#line 3476 "hypertextview.c"
		GtkTextTag* _tmp0_;
#line 543 "../lib/hypertextview.vala"
		gtk_text_iter_backward_chars (start_iter, max_len);
#line 545 "../lib/hypertextview.vala"
		_tmp0_ = self->priv->tag_link;
#line 545 "../lib/hypertextview.vala"
		if (gtk_text_iter_has_tag (start_iter, _tmp0_)) {
#line 3484 "hypertextview.c"
			GtkTextTag* _tmp1_;
#line 546 "../lib/hypertextview.vala"
			_tmp1_ = self->priv->tag_link;
#line 546 "../lib/hypertextview.vala"
			gtk_text_iter_backward_to_tag_toggle (start_iter, _tmp1_);
#line 3490 "hypertextview.c"
		}
	} else {
#line 549 "../lib/hypertextview.vala"
		gtk_text_iter_set_line_offset (start_iter, 0);
#line 3495 "hypertextview.c"
	}
#line 553 "../lib/hypertextview.vala"
	if (!gtk_text_iter_ends_line (end_iter)) {
#line 554 "../lib/hypertextview.vala"
		if ((gtk_text_iter_get_line_offset (end_iter) + max_len) < gtk_text_iter_get_chars_in_line (end_iter)) {
#line 3501 "hypertextview.c"
			GtkTextTag* _tmp2_;
#line 555 "../lib/hypertextview.vala"
			gtk_text_iter_forward_chars (end_iter, max_len);
#line 557 "../lib/hypertextview.vala"
			_tmp2_ = self->priv->tag_link;
#line 557 "../lib/hypertextview.vala"
			if (gtk_text_iter_has_tag (end_iter, _tmp2_)) {
#line 3509 "hypertextview.c"
				GtkTextTag* _tmp3_;
#line 558 "../lib/hypertextview.vala"
				_tmp3_ = self->priv->tag_link;
#line 558 "../lib/hypertextview.vala"
				gtk_text_iter_forward_to_tag_toggle (end_iter, _tmp3_);
#line 3515 "hypertextview.c"
			}
		} else {
#line 561 "../lib/hypertextview.vala"
			gtk_text_iter_forward_to_line_end (end_iter);
#line 3520 "hypertextview.c"
		}
	}
}

/**
 * insert_checkbox:
 *
 * Insert a checkbox in the text of the note. Can be useful
 * for writing a TODO list.
 *
 * This doesn't work well with the GtkSourceView Undo/Redo
 * manager, so we reset it to avoid breaking.
 */
void
xnp_hypertext_view_insert_checkbox (XnpHypertextView* self,
                                    gboolean checked)
{
	GtkTextIter iter = {0};
	GtkSourceBuffer* buffer = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkSourceBuffer* _tmp2_;
	GtkTextIter _tmp3_ = {0};
#line 575 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 577 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 577 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 577 "../lib/hypertextview.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_source_buffer_get_type ()) ? ((GtkSourceBuffer*) _tmp1_) : NULL);
#line 577 "../lib/hypertextview.vala"
	buffer = _tmp2_;
#line 578 "../lib/hypertextview.vala"
	gtk_source_buffer_begin_not_undoable_action (buffer);
#line 579 "../lib/hypertextview.vala"
	gtk_text_buffer_get_selection_bounds ((GtkTextBuffer*) buffer, &_tmp3_, NULL);
#line 579 "../lib/hypertextview.vala"
	iter = _tmp3_;
#line 580 "../lib/hypertextview.vala"
	xnp_hypertext_view_insert_checkbox_at_iter (self, &iter, checked);
#line 581 "../lib/hypertextview.vala"
	gtk_source_buffer_end_not_undoable_action (buffer);
#line 575 "../lib/hypertextview.vala"
	_g_object_unref0 (buffer);
#line 3566 "hypertextview.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 584 "../lib/hypertextview.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 584 "../lib/hypertextview.vala"
	return _data7_;
#line 3576 "hypertextview.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 584 "../lib/hypertextview.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 3586 "hypertextview.c"
		XnpHypertextView* self;
#line 584 "../lib/hypertextview.vala"
		self = _data7_->self;
#line 584 "../lib/hypertextview.vala"
		_g_object_unref0 (_data7_->anchor);
#line 584 "../lib/hypertextview.vala"
		_g_object_unref0 (self);
#line 584 "../lib/hypertextview.vala"
		g_slice_free (Block7Data, _data7_);
#line 3596 "hypertextview.c"
	}
}

static gboolean
__lambda8_ (XnpHypertextView* self)
{
	gboolean result;
#line 593 "../lib/hypertextview.vala"
	self->priv->cursor_over_checkbox = TRUE;
#line 594 "../lib/hypertextview.vala"
	result = FALSE;
#line 594 "../lib/hypertextview.vala"
	return result;
#line 3610 "hypertextview.c"
}

static gboolean
___lambda8__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                           GdkEventCrossing* event,
                                           gpointer self)
{
	gboolean result;
	result = __lambda8_ ((XnpHypertextView*) self);
#line 592 "../lib/hypertextview.vala"
	return result;
#line 3622 "hypertextview.c"
}

static gboolean
__lambda9_ (XnpHypertextView* self)
{
	gboolean result;
#line 597 "../lib/hypertextview.vala"
	self->priv->cursor_over_checkbox = FALSE;
#line 598 "../lib/hypertextview.vala"
	result = FALSE;
#line 598 "../lib/hypertextview.vala"
	return result;
#line 3635 "hypertextview.c"
}

static gboolean
___lambda9__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                           GdkEventCrossing* event,
                                           gpointer self)
{
	gboolean result;
	result = __lambda9_ ((XnpHypertextView*) self);
#line 596 "../lib/hypertextview.vala"
	return result;
#line 3647 "hypertextview.c"
}

static void
__lambda10_ (XnpHypertextView* self)
{
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
#line 601 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 601 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 601 "../lib/hypertextview.vala"
	g_signal_emit_by_name (_tmp1_, "changed");
#line 3661 "hypertextview.c"
}

static void
___lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 600 "../lib/hypertextview.vala"
	__lambda10_ ((XnpHypertextView*) self);
#line 3670 "hypertextview.c"
}

static GSList*
vala_g_slist_remove_full (GSList* self,
                          gconstpointer data,
                          GFreeFunc func)
{
	GSList* l = NULL;
	GSList* result;
#line 5331 "glib-2.0.vapi"
	l = self;
#line 5332 "glib-2.0.vapi"
	while (TRUE) {
#line 3684 "hypertextview.c"
		GSList* _tmp0_;
		GSList* _tmp1_;
		gconstpointer _tmp2_;
#line 5332 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5332 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5332 "glib-2.0.vapi"
			break;
#line 3694 "hypertextview.c"
		}
#line 5333 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5333 "glib-2.0.vapi"
		_tmp2_ = ((GSList*) _tmp1_)->data;
#line 5333 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 3702 "hypertextview.c"
			GSList* _tmp3_;
			GSList* _tmp4_;
#line 5334 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5334 "glib-2.0.vapi"
			_tmp4_ = ((GSList*) _tmp3_)->next;
#line 5334 "glib-2.0.vapi"
			l = _tmp4_;
#line 3711 "hypertextview.c"
		} else {
			GSList* _tmp5_;
			gconstpointer _tmp6_;
			GSList* _tmp7_;
#line 5336 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5336 "glib-2.0.vapi"
			_tmp6_ = ((GSList*) _tmp5_)->data;
#line 5336 "glib-2.0.vapi"
			func (_tmp6_);
#line 5337 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5337 "glib-2.0.vapi"
			self = g_slist_delete_link (self, (GSList*) _tmp7_);
#line 5338 "glib-2.0.vapi"
			break;
#line 3728 "hypertextview.c"
		}
	}
#line 5341 "glib-2.0.vapi"
	result = self;
#line 5341 "glib-2.0.vapi"
	return result;
#line 3735 "hypertextview.c"
}

static void
__lambda11_ (Block7Data* _data7_)
{
	XnpHypertextView* self;
	GtkSourceBuffer* buffer = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkSourceBuffer* _tmp2_;
#line 603 "../lib/hypertextview.vala"
	self = _data7_->self;
#line 604 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 604 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 604 "../lib/hypertextview.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_source_buffer_get_type ()) ? ((GtkSourceBuffer*) _tmp1_) : NULL);
#line 604 "../lib/hypertextview.vala"
	buffer = _tmp2_;
#line 605 "../lib/hypertextview.vala"
	gtk_source_buffer_begin_not_undoable_action (buffer);
#line 606 "../lib/hypertextview.vala"
	gtk_source_buffer_end_not_undoable_action (buffer);
#line 607 "../lib/hypertextview.vala"
	self->priv->checkboxes = vala_g_slist_remove_full (self->priv->checkboxes, _data7_->anchor, _g_object_unref0_);
#line 608 "../lib/hypertextview.vala"
	_g_object_unref0 (_data7_->anchor);
#line 608 "../lib/hypertextview.vala"
	_data7_->anchor = NULL;
#line 603 "../lib/hypertextview.vala"
	_g_object_unref0 (buffer);
#line 3768 "hypertextview.c"
}

static void
___lambda11__gtk_widget_destroy (GtkWidget* _sender,
                                 gpointer self)
{
#line 603 "../lib/hypertextview.vala"
	__lambda11_ (self);
#line 3777 "hypertextview.c"
}

static gint
__lambda12_ (XnpHypertextView* self,
             GtkTextChildAnchor* a,
             GtkTextChildAnchor* b)
{
	GtkTextIter a_iter = {0};
	GtkTextIter b_iter = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextBuffer* _tmp3_;
	GtkTextBuffer* _tmp4_;
	GtkTextIter _tmp5_ = {0};
	GtkTextIter _tmp6_;
	gint result;
#line 610 "../lib/hypertextview.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 610 "../lib/hypertextview.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 612 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 612 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 612 "../lib/hypertextview.vala"
	gtk_text_buffer_get_iter_at_child_anchor (_tmp1_, &_tmp2_, a);
#line 612 "../lib/hypertextview.vala"
	a_iter = _tmp2_;
#line 613 "../lib/hypertextview.vala"
	_tmp3_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 613 "../lib/hypertextview.vala"
	_tmp4_ = _tmp3_;
#line 613 "../lib/hypertextview.vala"
	gtk_text_buffer_get_iter_at_child_anchor (_tmp4_, &_tmp5_, b);
#line 613 "../lib/hypertextview.vala"
	b_iter = _tmp5_;
#line 614 "../lib/hypertextview.vala"
	_tmp6_ = b_iter;
#line 614 "../lib/hypertextview.vala"
	result = gtk_text_iter_compare (&a_iter, &_tmp6_);
#line 614 "../lib/hypertextview.vala"
	return result;
#line 3821 "hypertextview.c"
}

static gint
___lambda12__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda12_ ((XnpHypertextView*) self, (GtkTextChildAnchor*) a, (GtkTextChildAnchor*) b);
#line 610 "../lib/hypertextview.vala"
	return result;
#line 3833 "hypertextview.c"
}

static void
xnp_hypertext_view_insert_checkbox_at_iter (XnpHypertextView* self,
                                            GtkTextIter* iter,
                                            gboolean checked)
{
	Block7Data* _data7_;
	GtkTextMark* mark = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_;
	GtkTextMark* _tmp3_;
	GtkTextMark* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkTextBuffer* _tmp6_;
	GtkTextIter _tmp7_;
	GtkTextChildAnchor* _tmp8_;
	GtkTextChildAnchor* _tmp9_;
	GtkCheckButton* checkbox = NULL;
	GtkCheckButton* _tmp10_;
	GtkTextChildAnchor* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextIter _tmp14_ = {0};
	GtkTextBuffer* _tmp15_;
	GtkTextBuffer* _tmp16_;
#line 584 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 584 "../lib/hypertextview.vala"
	g_return_if_fail (iter != NULL);
#line 584 "../lib/hypertextview.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 584 "../lib/hypertextview.vala"
	_data7_->_ref_count_ = 1;
#line 584 "../lib/hypertextview.vala"
	_data7_->self = g_object_ref (self);
#line 585 "../lib/hypertextview.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 585 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 585 "../lib/hypertextview.vala"
	_tmp2_ = *iter;
#line 585 "../lib/hypertextview.vala"
	_tmp3_ = gtk_text_buffer_create_mark (_tmp1_, NULL, &_tmp2_, FALSE);
#line 585 "../lib/hypertextview.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 585 "../lib/hypertextview.vala"
	mark = _tmp4_;
#line 586 "../lib/hypertextview.vala"
	_tmp5_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 586 "../lib/hypertextview.vala"
	_tmp6_ = _tmp5_;
#line 586 "../lib/hypertextview.vala"
	_tmp7_ = *iter;
#line 586 "../lib/hypertextview.vala"
	_tmp8_ = gtk_text_buffer_create_child_anchor (_tmp6_, &_tmp7_);
#line 586 "../lib/hypertextview.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 586 "../lib/hypertextview.vala"
	_data7_->anchor = _tmp9_;
#line 587 "../lib/hypertextview.vala"
	_tmp10_ = (GtkCheckButton*) gtk_check_button_new ();
#line 587 "../lib/hypertextview.vala"
	g_object_ref_sink (_tmp10_);
#line 587 "../lib/hypertextview.vala"
	checkbox = _tmp10_;
#line 588 "../lib/hypertextview.vala"
	gtk_text_view_add_child_at_anchor ((GtkTextView*) self, (GtkWidget*) checkbox, _data7_->anchor);
#line 589 "../lib/hypertextview.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) checkbox, checked);
#line 590 "../lib/hypertextview.vala"
	gtk_widget_show ((GtkWidget*) checkbox);
#line 591 "../lib/hypertextview.vala"
	gtk_widget_set_focus_on_click ((GtkWidget*) checkbox, FALSE);
#line 592 "../lib/hypertextview.vala"
	g_signal_connect_object ((GtkWidget*) checkbox, "enter-notify-event", (GCallback) ___lambda8__gtk_widget_enter_notify_event, self, 0);
#line 596 "../lib/hypertextview.vala"
	g_signal_connect_object ((GtkWidget*) checkbox, "leave-notify-event", (GCallback) ___lambda9__gtk_widget_leave_notify_event, self, 0);
#line 600 "../lib/hypertextview.vala"
	g_signal_connect_object ((GtkToggleButton*) checkbox, "toggled", (GCallback) ___lambda10__gtk_toggle_button_toggled, self, 0);
#line 603 "../lib/hypertextview.vala"
	g_signal_connect_data ((GtkWidget*) checkbox, "destroy", (GCallback) ___lambda11__gtk_widget_destroy, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 610 "../lib/hypertextview.vala"
	_tmp11_ = _g_object_ref0 (_data7_->anchor);
#line 610 "../lib/hypertextview.vala"
	self->priv->checkboxes = g_slist_insert_sorted_with_data (self->priv->checkboxes, _tmp11_, ___lambda12__gcompare_data_func, self);
#line 616 "../lib/hypertextview.vala"
	_tmp12_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 616 "../lib/hypertextview.vala"
	_tmp13_ = _tmp12_;
#line 616 "../lib/hypertextview.vala"
	gtk_text_buffer_get_iter_at_mark (_tmp13_, &_tmp14_, mark);
#line 616 "../lib/hypertextview.vala"
	*iter = _tmp14_;
#line 617 "../lib/hypertextview.vala"
	_tmp15_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 617 "../lib/hypertextview.vala"
	_tmp16_ = _tmp15_;
#line 617 "../lib/hypertextview.vala"
	gtk_text_buffer_delete_mark (_tmp16_, mark);
#line 584 "../lib/hypertextview.vala"
	_g_object_unref0 (checkbox);
#line 584 "../lib/hypertextview.vala"
	_g_object_unref0 (mark);
#line 584 "../lib/hypertextview.vala"
	block7_data_unref (_data7_);
#line 584 "../lib/hypertextview.vala"
	_data7_ = NULL;
#line 3943 "hypertextview.c"
}

const gchar*
xnp_hypertext_view_get_font (XnpHypertextView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 47 "../lib/hypertextview.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../lib/hypertextview.vala"
	_tmp0_ = self->priv->_font;
#line 48 "../lib/hypertextview.vala"
	result = _tmp0_;
#line 48 "../lib/hypertextview.vala"
	return result;
#line 3959 "hypertextview.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 50 "../lib/hypertextview.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 3967 "hypertextview.c"
}

void
xnp_hypertext_view_set_font (XnpHypertextView* self,
                             const gchar* value)
{
	gchar* _tmp0_;
	PangoFontDescription* font_descr = NULL;
	PangoFontDescription* _tmp1_;
#line 50 "../lib/hypertextview.vala"
	g_return_if_fail (self != NULL);
#line 51 "../lib/hypertextview.vala"
	_tmp0_ = g_strdup (value);
#line 51 "../lib/hypertextview.vala"
	_g_free0 (self->priv->_font);
#line 51 "../lib/hypertextview.vala"
	self->priv->_font = _tmp0_;
#line 52 "../lib/hypertextview.vala"
	_tmp1_ = pango_font_description_from_string (value);
#line 52 "../lib/hypertextview.vala"
	font_descr = _tmp1_;
#line 53 "../lib/hypertextview.vala"
	gtk_widget_override_font ((GtkWidget*) self, font_descr);
#line 50 "../lib/hypertextview.vala"
	__vala_PangoFontDescription_free0 (font_descr);
#line 50 "../lib/hypertextview.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_hypertext_view_properties[XNP_HYPERTEXT_VIEW_FONT_PROPERTY]);
#line 3995 "hypertextview.c"
}

static void
_vala_PangoTabArray_free (PangoTabArray* self)
{
#line 62 "../lib/hypertextview.vala"
	g_boxed_free (pango_tab_array_get_type (), self);
#line 4003 "hypertextview.c"
}

static GObject *
xnp_hypertext_view_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	XnpHypertextView * self;
	PangoTabArray* _tmp0_;
	PangoTabArray* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 60 "../lib/hypertextview.vala"
	parent_class = G_OBJECT_CLASS (xnp_hypertext_view_parent_class);
#line 60 "../lib/hypertextview.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 60 "../lib/hypertextview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView);
#line 61 "../lib/hypertextview.vala"
	xnp_hypertext_view_set_font (self, "Sans 13");
#line 62 "../lib/hypertextview.vala"
	_tmp0_ = pango_tab_array_new_with_positions (1, TRUE, PANGO_TAB_LEFT, 12, NULL);
#line 62 "../lib/hypertextview.vala"
	_tmp1_ = _tmp0_;
#line 62 "../lib/hypertextview.vala"
	gtk_text_view_set_tabs ((GtkTextView*) self, _tmp1_);
#line 62 "../lib/hypertextview.vala"
	__vala_PangoTabArray_free0 (_tmp1_);
#line 4033 "hypertextview.c"
	{
		GRegex* _tmp2_ = NULL;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
#line 64 "../lib/hypertextview.vala"
		_tmp3_ = g_regex_new ("((\\b((news|http|https|ftp|file|irc)://|mailto:|(www|ftp)\\." "|\\S*@\\S*\\.)|(?<=^|\\s)/\\S+/|(?<=^|\\s)~/\\S+)\\S*\\b/?)", G_REGEX_CASELESS | G_REGEX_OPTIMIZE, 0, &_inner_error0_);
#line 64 "../lib/hypertextview.vala"
		_tmp2_ = _tmp3_;
#line 64 "../lib/hypertextview.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../lib/hypertextview.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4046 "hypertextview.c"
				goto __catch0_g_regex_error;
			}
#line 64 "../lib/hypertextview.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../lib/hypertextview.vala"
			g_clear_error (&_inner_error0_);
#line 4053 "hypertextview.c"
		}
#line 64 "../lib/hypertextview.vala"
		_tmp4_ = _tmp2_;
#line 64 "../lib/hypertextview.vala"
		_tmp2_ = NULL;
#line 64 "../lib/hypertextview.vala"
		_g_regex_unref0 (self->priv->regex_link);
#line 64 "../lib/hypertextview.vala"
		self->priv->regex_link = _tmp4_;
#line 63 "../lib/hypertextview.vala"
		_g_regex_unref0 (_tmp2_);
#line 4065 "hypertextview.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 63 "../lib/hypertextview.vala"
		e = _inner_error0_;
#line 63 "../lib/hypertextview.vala"
		_inner_error0_ = NULL;
#line 68 "../lib/hypertextview.vala"
		_tmp5_ = e;
#line 68 "../lib/hypertextview.vala"
		_tmp6_ = _tmp5_->message;
#line 68 "../lib/hypertextview.vala"
		g_critical ("hypertextview.vala:68: %s", _tmp6_);
#line 63 "../lib/hypertextview.vala"
		_g_error_free0 (e);
#line 4085 "hypertextview.c"
	}
	__finally0:
#line 63 "../lib/hypertextview.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../lib/hypertextview.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../lib/hypertextview.vala"
		g_clear_error (&_inner_error0_);
#line 4094 "hypertextview.c"
	}
#line 60 "../lib/hypertextview.vala"
	return obj;
#line 4098 "hypertextview.c"
}

static void
xnp_hypertext_view_class_init (XnpHypertextViewClass * klass,
                               gpointer klass_data)
{
	gchar* _tmp0_;
#line 27 "../lib/hypertextview.vala"
	xnp_hypertext_view_parent_class = g_type_class_peek_parent (klass);
#line 27 "../lib/hypertextview.vala"
	g_type_class_adjust_private_offset (klass, &XnpHypertextView_private_offset);
#line 27 "../lib/hypertextview.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_xnp_hypertext_view_get_property;
#line 27 "../lib/hypertextview.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_xnp_hypertext_view_set_property;
#line 27 "../lib/hypertextview.vala"
	G_OBJECT_CLASS (klass)->constructor = xnp_hypertext_view_constructor;
#line 27 "../lib/hypertextview.vala"
	G_OBJECT_CLASS (klass)->finalize = xnp_hypertext_view_finalize;
#line 27 "../lib/hypertextview.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_HYPERTEXT_VIEW_FONT_PROPERTY, xnp_hypertext_view_properties[XNP_HYPERTEXT_VIEW_FONT_PROPERTY] = g_param_spec_string ("font", "font", "font", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../lib/hypertextview.vala"
	_tmp0_ = g_unichar_to_string ((gunichar) 0x200b);
#line 58 "../lib/hypertextview.vala"
	xnp_hypertext_view_tag_char = _tmp0_;
#line 4124 "hypertextview.c"
}

static void
xnp_hypertext_view_instance_init (XnpHypertextView * self,
                                  gpointer klass)
{
	GdkDisplay* _tmp0_;
	GdkCursor* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
#line 27 "../lib/hypertextview.vala"
	self->priv = xnp_hypertext_view_get_instance_private (self);
#line 29 "../lib/hypertextview.vala"
	self->priv->checkboxes = NULL;
#line 31 "../lib/hypertextview.vala"
	_tmp0_ = gdk_display_get_default ();
#line 31 "../lib/hypertextview.vala"
	_tmp1_ = gdk_cursor_new_for_display (_tmp0_, GDK_HAND2);
#line 31 "../lib/hypertextview.vala"
	self->priv->hand_cursor = _tmp1_;
#line 32 "../lib/hypertextview.vala"
	_tmp2_ = gdk_display_get_default ();
#line 32 "../lib/hypertextview.vala"
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_XTERM);
#line 32 "../lib/hypertextview.vala"
	self->priv->regular_cursor = _tmp3_;
#line 34 "../lib/hypertextview.vala"
	self->priv->cursor_over_checkbox = FALSE;
#line 35 "../lib/hypertextview.vala"
	self->priv->cursor_over_link = FALSE;
#line 4155 "hypertextview.c"
}

static void
xnp_hypertext_view_finalize (GObject * obj)
{
	XnpHypertextView * self;
#line 27 "../lib/hypertextview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView);
#line 29 "../lib/hypertextview.vala"
	(self->priv->checkboxes == NULL) ? NULL : (self->priv->checkboxes = (_g_slist_free__g_object_unref0_ (self->priv->checkboxes), NULL));
#line 31 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->hand_cursor);
#line 32 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->regular_cursor);
#line 37 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_bold);
#line 38 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_italic);
#line 39 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_strikethrough);
#line 40 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_underline);
#line 42 "../lib/hypertextview.vala"
	_g_object_unref0 (self->priv->tag_link);
#line 43 "../lib/hypertextview.vala"
	_g_regex_unref0 (self->priv->regex_link);
#line 45 "../lib/hypertextview.vala"
	_g_free0 (self->priv->_font);
#line 27 "../lib/hypertextview.vala"
	G_OBJECT_CLASS (xnp_hypertext_view_parent_class)->finalize (obj);
#line 4186 "hypertextview.c"
}

static GType
xnp_hypertext_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (XnpHypertextViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnp_hypertext_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnpHypertextView), 0, (GInstanceInitFunc) xnp_hypertext_view_instance_init, NULL };
	GType xnp_hypertext_view_type_id;
	xnp_hypertext_view_type_id = g_type_register_static (gtk_source_view_get_type (), "XnpHypertextView", &g_define_type_info, 0);
	XnpHypertextView_private_offset = g_type_add_instance_private (xnp_hypertext_view_type_id, sizeof (XnpHypertextViewPrivate));
	return xnp_hypertext_view_type_id;
}

GType
xnp_hypertext_view_get_type (void)
{
	static volatile gsize xnp_hypertext_view_type_id__once = 0;
	if (g_once_init_enter (&xnp_hypertext_view_type_id__once)) {
		GType xnp_hypertext_view_type_id;
		xnp_hypertext_view_type_id = xnp_hypertext_view_get_type_once ();
		g_once_init_leave (&xnp_hypertext_view_type_id__once, xnp_hypertext_view_type_id);
	}
	return xnp_hypertext_view_type_id__once;
}

static void
_vala_xnp_hypertext_view_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	XnpHypertextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView);
#line 27 "../lib/hypertextview.vala"
	switch (property_id) {
#line 27 "../lib/hypertextview.vala"
		case XNP_HYPERTEXT_VIEW_FONT_PROPERTY:
#line 27 "../lib/hypertextview.vala"
		g_value_set_string (value, xnp_hypertext_view_get_font (self));
#line 27 "../lib/hypertextview.vala"
		break;
#line 4227 "hypertextview.c"
		default:
#line 27 "../lib/hypertextview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../lib/hypertextview.vala"
		break;
#line 4233 "hypertextview.c"
	}
}

static void
_vala_xnp_hypertext_view_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	XnpHypertextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView);
#line 27 "../lib/hypertextview.vala"
	switch (property_id) {
#line 27 "../lib/hypertextview.vala"
		case XNP_HYPERTEXT_VIEW_FONT_PROPERTY:
#line 27 "../lib/hypertextview.vala"
		xnp_hypertext_view_set_font (self, g_value_get_string (value));
#line 27 "../lib/hypertextview.vala"
		break;
#line 4253 "hypertextview.c"
		default:
#line 27 "../lib/hypertextview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../lib/hypertextview.vala"
		break;
#line 4259 "hypertextview.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

