/* note.c generated by valac 0.56.18, the Vala compiler
 * generated from note.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (c) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "libnotes.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksource.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	XNP_NOTE_0_PROPERTY,
	XNP_NOTE_NAME_PROPERTY,
	XNP_NOTE_TEXT_PROPERTY,
	XNP_NOTE_CURSOR_PROPERTY,
	XNP_NOTE_ADJUSTMENT_PROPERTY,
	XNP_NOTE_DIRTY_PROPERTY,
	XNP_NOTE_NUM_PROPERTIES
};
static GParamSpec* xnp_note_properties[XNP_NOTE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block8Data Block8Data;
enum  {
	XNP_NOTE_SAVE_DATA_SIGNAL,
	XNP_NOTE_NUM_SIGNALS
};
static guint xnp_note_signals[XNP_NOTE_NUM_SIGNALS] = {0};

struct _XnpNotePrivate {
	gchar* _name;
	guint src_idle;
	guint save_timeout;
	gboolean _dirty;
};

struct _Block8Data {
	int _ref_count_;
	XnpNote* self;
	gdouble value;
};

static gint XnpNote_private_offset;
static gpointer xnp_note_parent_class = NULL;

static void xnp_note_buffer_changed_cb (XnpNote* self);
static void _xnp_note_buffer_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                          gpointer self);
static gboolean xnp_note_save_cb (XnpNote* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean _xnp_note_adjustment___lambda18_ (Block8Data* _data8_);
static gboolean __xnp_note_adjustment___lambda18__gsource_func (gpointer self);
static gboolean _xnp_note_save_cb_gsource_func (gpointer self);
static void xnp_note_finalize (GObject * obj);
static GType xnp_note_get_type_once (void);
static void _vala_xnp_note_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_xnp_note_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);

static inline gpointer
xnp_note_get_instance_private (XnpNote* self)
{
	return G_STRUCT_MEMBER_P (self, XnpNote_private_offset);
}

void
xnp_note_save (XnpNote* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 100 "../lib/note.vala"
	g_return_if_fail (self != NULL);
#line 101 "../lib/note.vala"
	_tmp0_ = xnp_note_get_dirty (self);
#line 101 "../lib/note.vala"
	_tmp1_ = _tmp0_;
#line 101 "../lib/note.vala"
	if (_tmp1_) {
#line 102 "../lib/note.vala"
		g_signal_emit (self, xnp_note_signals[XNP_NOTE_SAVE_DATA_SIGNAL], 0);
#line 120 "note.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 123 "../lib/note.vala"
	return self ? g_object_ref (self) : NULL;
#line 129 "note.c"
}

static void
_xnp_note_buffer_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                     gpointer self)
{
#line 124 "../lib/note.vala"
	xnp_note_buffer_changed_cb ((XnpNote*) self);
#line 138 "note.c"
}

XnpNote*
xnp_note_construct (GType object_type,
                    const gchar* name)
{
	XnpNote * self = NULL;
	XnpHypertextView* _tmp0_;
	XnpHypertextView* _tmp1_;
	XnpHypertextView* _tmp2_;
	XnpHypertextView* _tmp3_;
	XnpHypertextView* _tmp4_;
	XnpHypertextView* _tmp5_;
	XnpHypertextView* _tmp6_;
	XnpHypertextView* _tmp7_;
	GtkTextBuffer* buffer = NULL;
	XnpHypertextView* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextBuffer* _tmp10_;
#line 106 "../lib/note.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 107 "../lib/note.vala"
	self = (XnpNote*) g_object_new (object_type, NULL);
#line 109 "../lib/note.vala"
	xnp_note_set_name (self, name);
#line 111 "../lib/note.vala"
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 113 "../lib/note.vala"
	_tmp0_ = xnp_hypertext_view_new ();
#line 113 "../lib/note.vala"
	g_object_ref_sink (_tmp0_);
#line 113 "../lib/note.vala"
	_g_object_unref0 (self->text_view);
#line 113 "../lib/note.vala"
	self->text_view = _tmp0_;
#line 114 "../lib/note.vala"
	_tmp1_ = self->text_view;
#line 114 "../lib/note.vala"
	gtk_widget_show ((GtkWidget*) _tmp1_);
#line 115 "../lib/note.vala"
	_tmp2_ = self->text_view;
#line 115 "../lib/note.vala"
	gtk_text_view_set_wrap_mode ((GtkTextView*) _tmp2_, GTK_WRAP_WORD);
#line 116 "../lib/note.vala"
	_tmp3_ = self->text_view;
#line 116 "../lib/note.vala"
	gtk_text_view_set_left_margin ((GtkTextView*) _tmp3_, 2);
#line 117 "../lib/note.vala"
	_tmp4_ = self->text_view;
#line 117 "../lib/note.vala"
	gtk_text_view_set_right_margin ((GtkTextView*) _tmp4_, 2);
#line 118 "../lib/note.vala"
	_tmp5_ = self->text_view;
#line 118 "../lib/note.vala"
	gtk_text_view_set_pixels_above_lines ((GtkTextView*) _tmp5_, 1);
#line 119 "../lib/note.vala"
	_tmp6_ = self->text_view;
#line 119 "../lib/note.vala"
	gtk_text_view_set_pixels_below_lines ((GtkTextView*) _tmp6_, 1);
#line 121 "../lib/note.vala"
	_tmp7_ = self->text_view;
#line 121 "../lib/note.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
#line 123 "../lib/note.vala"
	_tmp8_ = self->text_view;
#line 123 "../lib/note.vala"
	_tmp9_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp8_);
#line 123 "../lib/note.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 123 "../lib/note.vala"
	buffer = _tmp10_;
#line 124 "../lib/note.vala"
	g_signal_connect_object (buffer, "changed", (GCallback) _xnp_note_buffer_changed_cb_gtk_text_buffer_changed, self, 0);
#line 106 "../lib/note.vala"
	_g_object_unref0 (buffer);
#line 106 "../lib/note.vala"
	return self;
#line 216 "note.c"
}

XnpNote*
xnp_note_new (const gchar* name)
{
#line 106 "../lib/note.vala"
	return xnp_note_construct (XNP_TYPE_NOTE, name);
#line 224 "note.c"
}

/**
 * buffer_changed_cb:
 *
 * Reset the save_timeout as long as the buffer is under constant
 * changes and send the save-data signal.
 */
static void
xnp_note_buffer_changed_cb (XnpNote* self)
{
#line 145 "../lib/note.vala"
	g_return_if_fail (self != NULL);
#line 146 "../lib/note.vala"
	xnp_note_set_dirty (self, TRUE);
#line 240 "note.c"
}

/**
 * save_cb:
 *
 * Send save-data signal.
 */
static gboolean
xnp_note_save_cb (XnpNote* self)
{
	gboolean result;
#line 154 "../lib/note.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 155 "../lib/note.vala"
	self->priv->save_timeout = (guint) 0;
#line 156 "../lib/note.vala"
	g_signal_emit (self, xnp_note_signals[XNP_NOTE_SAVE_DATA_SIGNAL], 0);
#line 157 "../lib/note.vala"
	result = FALSE;
#line 157 "../lib/note.vala"
	return result;
#line 262 "note.c"
}

const gchar*
xnp_note_get_name (XnpNote* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../lib/note.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/note.vala"
	_tmp0_ = self->priv->_name;
#line 27 "../lib/note.vala"
	result = _tmp0_;
#line 27 "../lib/note.vala"
	return result;
#line 278 "note.c"
}

void
xnp_note_set_name (XnpNote* self,
                   const gchar* value)
{
	gchar* old_value;
#line 27 "../lib/note.vala"
	g_return_if_fail (self != NULL);
#line 27 "../lib/note.vala"
	old_value = xnp_note_get_name (self);
#line 27 "../lib/note.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 292 "note.c"
		gchar* _tmp0_;
#line 27 "../lib/note.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../lib/note.vala"
		_g_free0 (self->priv->_name);
#line 27 "../lib/note.vala"
		self->priv->_name = _tmp0_;
#line 27 "../lib/note.vala"
		g_object_notify_by_pspec ((GObject *) self, xnp_note_properties[XNP_NOTE_NAME_PROPERTY]);
#line 302 "note.c"
	}
}

gchar*
xnp_note_get_text (XnpNote* self)
{
	gchar* result;
	XnpHypertextView* _tmp0_;
	gchar* _tmp1_;
#line 33 "../lib/note.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../lib/note.vala"
	_tmp0_ = self->text_view;
#line 34 "../lib/note.vala"
	_tmp1_ = xnp_hypertext_view_get_text_with_tags (_tmp0_);
#line 34 "../lib/note.vala"
	result = _tmp1_;
#line 34 "../lib/note.vala"
	return result;
#line 322 "note.c"
}

void
xnp_note_set_text (XnpNote* self,
                   const gchar* value)
{
	GtkSourceBuffer* buffer = NULL;
	XnpHypertextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkSourceBuffer* _tmp3_;
	XnpHypertextView* _tmp4_;
	XnpHypertextView* _tmp5_;
#line 36 "../lib/note.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/note.vala"
	_tmp0_ = self->text_view;
#line 37 "../lib/note.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
#line 37 "../lib/note.vala"
	_tmp2_ = _tmp1_;
#line 37 "../lib/note.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_source_buffer_get_type ()) ? ((GtkSourceBuffer*) _tmp2_) : NULL);
#line 37 "../lib/note.vala"
	buffer = _tmp3_;
#line 38 "../lib/note.vala"
	gtk_source_buffer_begin_not_undoable_action (buffer);
#line 39 "../lib/note.vala"
	_tmp4_ = self->text_view;
#line 39 "../lib/note.vala"
	xnp_hypertext_view_set_text_with_tags (_tmp4_, value);
#line 40 "../lib/note.vala"
	_tmp5_ = self->text_view;
#line 40 "../lib/note.vala"
	xnp_hypertext_view_update_tags (_tmp5_);
#line 41 "../lib/note.vala"
	gtk_source_buffer_end_not_undoable_action (buffer);
#line 42 "../lib/note.vala"
	xnp_note_set_dirty (self, FALSE);
#line 36 "../lib/note.vala"
	_g_object_unref0 (buffer);
#line 36 "../lib/note.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_note_properties[XNP_NOTE_TEXT_PROPERTY]);
#line 366 "note.c"
}

gint
xnp_note_get_cursor (XnpNote* self)
{
	gint result;
	XnpHypertextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 47 "../lib/note.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "../lib/note.vala"
	_tmp0_ = self->text_view;
#line 48 "../lib/note.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
#line 48 "../lib/note.vala"
	_tmp2_ = _tmp1_;
#line 48 "../lib/note.vala"
	g_object_get (_tmp2_, "cursor-position", &_tmp3_, NULL);
#line 48 "../lib/note.vala"
	_tmp4_ = _tmp3_;
#line 48 "../lib/note.vala"
	result = _tmp4_;
#line 48 "../lib/note.vala"
	return result;
#line 394 "note.c"
}

void
xnp_note_set_cursor (XnpNote* self,
                     gint value)
{
	GtkTextBuffer* buffer = NULL;
	XnpHypertextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkTextIter iter = {0};
	GtkTextIter _tmp4_ = {0};
	GtkTextIter _tmp5_;
#line 50 "../lib/note.vala"
	g_return_if_fail (self != NULL);
#line 51 "../lib/note.vala"
	_tmp0_ = self->text_view;
#line 51 "../lib/note.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
#line 51 "../lib/note.vala"
	_tmp2_ = _tmp1_;
#line 51 "../lib/note.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 51 "../lib/note.vala"
	buffer = _tmp3_;
#line 53 "../lib/note.vala"
	gtk_text_buffer_get_iter_at_offset (buffer, &_tmp4_, value);
#line 53 "../lib/note.vala"
	iter = _tmp4_;
#line 54 "../lib/note.vala"
	_tmp5_ = iter;
#line 54 "../lib/note.vala"
	gtk_text_buffer_place_cursor (buffer, &_tmp5_);
#line 50 "../lib/note.vala"
	_g_object_unref0 (buffer);
#line 50 "../lib/note.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_note_properties[XNP_NOTE_CURSOR_PROPERTY]);
#line 433 "note.c"
}

gdouble
xnp_note_get_adjustment (XnpNote* self)
{
	gdouble result;
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 60 "../lib/note.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 61 "../lib/note.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 61 "../lib/note.vala"
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
#line 61 "../lib/note.vala"
	_tmp2_ = _tmp1_;
#line 61 "../lib/note.vala"
	result = _tmp2_;
#line 61 "../lib/note.vala"
	return result;
#line 455 "note.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 63 "../lib/note.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 63 "../lib/note.vala"
	return _data8_;
#line 465 "note.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 63 "../lib/note.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 475 "note.c"
		XnpNote* self;
#line 63 "../lib/note.vala"
		self = _data8_->self;
#line 63 "../lib/note.vala"
		_g_object_unref0 (self);
#line 63 "../lib/note.vala"
		g_slice_free (Block8Data, _data8_);
#line 483 "note.c"
	}
}

static gboolean
_xnp_note_adjustment___lambda18_ (Block8Data* _data8_)
{
	XnpNote* self;
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GtkAdjustment* _tmp2_;
	GdkWindow* _tmp3_;
	gboolean result;
#line 70 "../lib/note.vala"
	self = _data8_->self;
#line 71 "../lib/note.vala"
	self->priv->src_idle = (guint) 0;
#line 72 "../lib/note.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 72 "../lib/note.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 72 "../lib/note.vala"
	window = _tmp1_;
#line 73 "../lib/note.vala"
	_tmp2_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 73 "../lib/note.vala"
	gtk_adjustment_set_value (_tmp2_, _data8_->value);
#line 74 "../lib/note.vala"
	_tmp3_ = window;
#line 74 "../lib/note.vala"
	if (_tmp3_ != NULL) {
#line 515 "note.c"
		GdkWindow* _tmp4_;
#line 74 "../lib/note.vala"
		_tmp4_ = window;
#line 74 "../lib/note.vala"
		gdk_window_thaw_updates (_tmp4_);
#line 521 "note.c"
	}
#line 75 "../lib/note.vala"
	result = G_SOURCE_REMOVE;
#line 75 "../lib/note.vala"
	_g_object_unref0 (window);
#line 75 "../lib/note.vala"
	return result;
#line 529 "note.c"
}

static gboolean
__xnp_note_adjustment___lambda18__gsource_func (gpointer self)
{
	gboolean result;
	result = _xnp_note_adjustment___lambda18_ (self);
#line 70 "../lib/note.vala"
	return result;
#line 539 "note.c"
}

void
xnp_note_set_adjustment (XnpNote* self,
                         gdouble value)
{
	Block8Data* _data8_;
#line 63 "../lib/note.vala"
	g_return_if_fail (self != NULL);
#line 63 "../lib/note.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 63 "../lib/note.vala"
	_data8_->_ref_count_ = 1;
#line 63 "../lib/note.vala"
	_data8_->self = g_object_ref (self);
#line 63 "../lib/note.vala"
	_data8_->value = value;
#line 64 "../lib/note.vala"
	if (self->priv->src_idle == ((guint) 0)) {
#line 559 "note.c"
		GdkWindow* window = NULL;
		GdkWindow* _tmp0_;
		GdkWindow* _tmp1_;
		GdkWindow* _tmp2_;
#line 65 "../lib/note.vala"
		_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 65 "../lib/note.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 65 "../lib/note.vala"
		window = _tmp1_;
#line 66 "../lib/note.vala"
		_tmp2_ = window;
#line 66 "../lib/note.vala"
		if (_tmp2_ != NULL) {
#line 574 "note.c"
			GdkWindow* _tmp3_;
#line 66 "../lib/note.vala"
			_tmp3_ = window;
#line 66 "../lib/note.vala"
			gdk_window_freeze_updates (_tmp3_);
#line 580 "note.c"
		}
#line 64 "../lib/note.vala"
		_g_object_unref0 (window);
#line 584 "note.c"
	} else {
#line 68 "../lib/note.vala"
		g_source_remove (self->priv->src_idle);
#line 588 "note.c"
	}
#line 70 "../lib/note.vala"
	self->priv->src_idle = g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __xnp_note_adjustment___lambda18__gsource_func, block8_data_ref (_data8_), block8_data_unref);
#line 63 "../lib/note.vala"
	block8_data_unref (_data8_);
#line 63 "../lib/note.vala"
	_data8_ = NULL;
#line 63 "../lib/note.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_note_properties[XNP_NOTE_ADJUSTMENT_PROPERTY]);
#line 598 "note.c"
}

gboolean
xnp_note_get_dirty (XnpNote* self)
{
	gboolean result;
#line 83 "../lib/note.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "../lib/note.vala"
	result = self->priv->_dirty;
#line 84 "../lib/note.vala"
	return result;
#line 611 "note.c"
}

static gboolean
_xnp_note_save_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = xnp_note_save_cb ((XnpNote*) self);
#line 93 "../lib/note.vala"
	return result;
#line 621 "note.c"
}

void
xnp_note_set_dirty (XnpNote* self,
                    gboolean value)
{
#line 86 "../lib/note.vala"
	g_return_if_fail (self != NULL);
#line 87 "../lib/note.vala"
	self->priv->_dirty = value;
#line 88 "../lib/note.vala"
	if (self->priv->save_timeout > ((guint) 0)) {
#line 89 "../lib/note.vala"
		g_source_remove (self->priv->save_timeout);
#line 90 "../lib/note.vala"
		self->priv->save_timeout = (guint) 0;
#line 638 "note.c"
	}
#line 92 "../lib/note.vala"
	if (value) {
#line 93 "../lib/note.vala"
		self->priv->save_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 60, _xnp_note_save_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 644 "note.c"
	}
#line 86 "../lib/note.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_note_properties[XNP_NOTE_DIRTY_PROPERTY]);
#line 648 "note.c"
}

static void
xnp_note_class_init (XnpNoteClass * klass,
                     gpointer klass_data)
{
#line 24 "../lib/note.vala"
	xnp_note_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/note.vala"
	g_type_class_adjust_private_offset (klass, &XnpNote_private_offset);
#line 24 "../lib/note.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_xnp_note_get_property;
#line 24 "../lib/note.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_xnp_note_set_property;
#line 24 "../lib/note.vala"
	G_OBJECT_CLASS (klass)->finalize = xnp_note_finalize;
#line 24 "../lib/note.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_NOTE_NAME_PROPERTY, xnp_note_properties[XNP_NOTE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/note.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_NOTE_TEXT_PROPERTY, xnp_note_properties[XNP_NOTE_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/note.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_NOTE_CURSOR_PROPERTY, xnp_note_properties[XNP_NOTE_CURSOR_PROPERTY] = g_param_spec_int ("cursor", "cursor", "cursor", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/note.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_NOTE_ADJUSTMENT_PROPERTY, xnp_note_properties[XNP_NOTE_ADJUSTMENT_PROPERTY] = g_param_spec_double ("adjustment", "adjustment", "adjustment", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/note.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_NOTE_DIRTY_PROPERTY, xnp_note_properties[XNP_NOTE_DIRTY_PROPERTY] = g_param_spec_boolean ("dirty", "dirty", "dirty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/note.vala"
	xnp_note_signals[XNP_NOTE_SAVE_DATA_SIGNAL] = g_signal_new ("save-data", XNP_TYPE_NOTE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 677 "note.c"
}

static void
xnp_note_instance_init (XnpNote * self,
                        gpointer klass)
{
#line 24 "../lib/note.vala"
	self->priv = xnp_note_get_instance_private (self);
#line 30 "../lib/note.vala"
	self->backed = TRUE;
#line 58 "../lib/note.vala"
	self->priv->src_idle = (guint) 0;
#line 81 "../lib/note.vala"
	self->priv->_dirty = FALSE;
#line 692 "note.c"
}

static void
xnp_note_finalize (GObject * obj)
{
	XnpNote * self;
#line 24 "../lib/note.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_NOTE, XnpNote);
#line 128 "../lib/note.vala"
	if (self->priv->src_idle != ((guint) 0)) {
#line 129 "../lib/note.vala"
		g_source_remove (self->priv->src_idle);
#line 705 "note.c"
	}
#line 130 "../lib/note.vala"
	if (self->priv->save_timeout != ((guint) 0)) {
#line 131 "../lib/note.vala"
		g_source_remove (self->priv->save_timeout);
#line 711 "note.c"
	}
#line 132 "../lib/note.vala"
	xnp_note_set_dirty (self, FALSE);
#line 26 "../lib/note.vala"
	_g_object_unref0 (self->text_view);
#line 27 "../lib/note.vala"
	_g_free0 (self->priv->_name);
#line 24 "../lib/note.vala"
	G_OBJECT_CLASS (xnp_note_parent_class)->finalize (obj);
#line 721 "note.c"
}

static GType
xnp_note_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (XnpNoteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnp_note_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnpNote), 0, (GInstanceInitFunc) xnp_note_instance_init, NULL };
	GType xnp_note_type_id;
	xnp_note_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "XnpNote", &g_define_type_info, 0);
	XnpNote_private_offset = g_type_add_instance_private (xnp_note_type_id, sizeof (XnpNotePrivate));
	return xnp_note_type_id;
}

GType
xnp_note_get_type (void)
{
	static volatile gsize xnp_note_type_id__once = 0;
	if (g_once_init_enter (&xnp_note_type_id__once)) {
		GType xnp_note_type_id;
		xnp_note_type_id = xnp_note_get_type_once ();
		g_once_init_leave (&xnp_note_type_id__once, xnp_note_type_id);
	}
	return xnp_note_type_id__once;
}

static void
_vala_xnp_note_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	XnpNote * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_NOTE, XnpNote);
#line 24 "../lib/note.vala"
	switch (property_id) {
#line 24 "../lib/note.vala"
		case XNP_NOTE_NAME_PROPERTY:
#line 24 "../lib/note.vala"
		g_value_set_string (value, xnp_note_get_name (self));
#line 24 "../lib/note.vala"
		break;
#line 24 "../lib/note.vala"
		case XNP_NOTE_TEXT_PROPERTY:
#line 24 "../lib/note.vala"
		g_value_take_string (value, xnp_note_get_text (self));
#line 24 "../lib/note.vala"
		break;
#line 24 "../lib/note.vala"
		case XNP_NOTE_CURSOR_PROPERTY:
#line 24 "../lib/note.vala"
		g_value_set_int (value, xnp_note_get_cursor (self));
#line 24 "../lib/note.vala"
		break;
#line 24 "../lib/note.vala"
		case XNP_NOTE_ADJUSTMENT_PROPERTY:
#line 24 "../lib/note.vala"
		g_value_set_double (value, xnp_note_get_adjustment (self));
#line 24 "../lib/note.vala"
		break;
#line 24 "../lib/note.vala"
		case XNP_NOTE_DIRTY_PROPERTY:
#line 24 "../lib/note.vala"
		g_value_set_boolean (value, xnp_note_get_dirty (self));
#line 24 "../lib/note.vala"
		break;
#line 786 "note.c"
		default:
#line 24 "../lib/note.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/note.vala"
		break;
#line 792 "note.c"
	}
}

static void
_vala_xnp_note_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	XnpNote * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_NOTE, XnpNote);
#line 24 "../lib/note.vala"
	switch (property_id) {
#line 24 "../lib/note.vala"
		case XNP_NOTE_NAME_PROPERTY:
#line 24 "../lib/note.vala"
		xnp_note_set_name (self, g_value_get_string (value));
#line 24 "../lib/note.vala"
		break;
#line 24 "../lib/note.vala"
		case XNP_NOTE_TEXT_PROPERTY:
#line 24 "../lib/note.vala"
		xnp_note_set_text (self, g_value_get_string (value));
#line 24 "../lib/note.vala"
		break;
#line 24 "../lib/note.vala"
		case XNP_NOTE_CURSOR_PROPERTY:
#line 24 "../lib/note.vala"
		xnp_note_set_cursor (self, g_value_get_int (value));
#line 24 "../lib/note.vala"
		break;
#line 24 "../lib/note.vala"
		case XNP_NOTE_ADJUSTMENT_PROPERTY:
#line 24 "../lib/note.vala"
		xnp_note_set_adjustment (self, g_value_get_double (value));
#line 24 "../lib/note.vala"
		break;
#line 24 "../lib/note.vala"
		case XNP_NOTE_DIRTY_PROPERTY:
#line 24 "../lib/note.vala"
		xnp_note_set_dirty (self, g_value_get_boolean (value));
#line 24 "../lib/note.vala"
		break;
#line 836 "note.c"
		default:
#line 24 "../lib/note.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/note.vala"
		break;
#line 842 "note.c"
	}
}

