/* theme-gtkcss.c generated by valac 0.56.18, the Vala compiler
 * generated from theme-gtkcss.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (c) 2006-2013  Mike Massonnet <mmassonnet@xfce.org>
 *  Copyright (c) 2023       Arthur Demchenkov <spinal.by@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "libnotes.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <xfce-revision.h>
#include <libxfce4util/libxfce4util.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	XNP_THEME_GTKCSS_0_PROPERTY,
	XNP_THEME_GTKCSS_USE_GTK_STYLE_PROPERTY,
	XNP_THEME_GTKCSS_NUM_PROPERTIES
};
static GParamSpec* xnp_theme_gtkcss_properties[XNP_THEME_GTKCSS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _XnpThemeGtkcssPrivate {
	gchar* css_path_default;
	gchar* css_path_system;
	gchar* css_path_user;
	GtkCssProvider* css_provider_color;
	GtkCssProvider* css_provider_default;
	GtkCssProvider* css_provider_system;
	GtkCssProvider* css_provider_user;
	gboolean _use_gtk_style;
	GdkRGBA bg_color;
};

static gint XnpThemeGtkcss_private_offset;
static gpointer xnp_theme_gtkcss_parent_class = NULL;

static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
static void xnp_theme_gtkcss_load_default_css (XnpThemeGtkcss* self);
static void xnp_theme_gtkcss_load_system_css (XnpThemeGtkcss* self);
static void xnp_theme_gtkcss_load_user_css (XnpThemeGtkcss* self);
static void xnp_theme_gtkcss_finalize (GObject * obj);
static GType xnp_theme_gtkcss_get_type_once (void);
static void _vala_xnp_theme_gtkcss_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_xnp_theme_gtkcss_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
xnp_theme_gtkcss_get_instance_private (XnpThemeGtkcss* self)
{
	return G_STRUCT_MEMBER_P (self, XnpThemeGtkcss_private_offset);
}

XnpThemeGtkcss*
xnp_theme_gtkcss_construct (GType object_type)
{
	XnpThemeGtkcss * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkCssProvider* _tmp3_;
#line 35 "../lib/theme-gtkcss.vala"
	self = (XnpThemeGtkcss*) g_object_new (object_type, NULL);
#line 36 "../lib/theme-gtkcss.vala"
	_tmp0_ = g_strdup_printf ("%s/gtk-3.0/gtk.css", PKGDATADIR);
#line 36 "../lib/theme-gtkcss.vala"
	_g_free0 (self->priv->css_path_default);
#line 36 "../lib/theme-gtkcss.vala"
	self->priv->css_path_default = _tmp0_;
#line 37 "../lib/theme-gtkcss.vala"
	_tmp1_ = g_strdup_printf ("%s/xdg/xfce4/notes/gtk.css", SYSCONFDIR);
#line 37 "../lib/theme-gtkcss.vala"
	_g_free0 (self->priv->css_path_system);
#line 37 "../lib/theme-gtkcss.vala"
	self->priv->css_path_system = _tmp1_;
#line 38 "../lib/theme-gtkcss.vala"
	_tmp2_ = xfce_resource_save_location (XFCE_RESOURCE_CONFIG, "xfce4/notes/gtk.css", TRUE);
#line 38 "../lib/theme-gtkcss.vala"
	_g_free0 (self->priv->css_path_user);
#line 38 "../lib/theme-gtkcss.vala"
	self->priv->css_path_user = _tmp2_;
#line 39 "../lib/theme-gtkcss.vala"
	_tmp3_ = gtk_css_provider_new ();
#line 39 "../lib/theme-gtkcss.vala"
	_g_object_unref0 (self->priv->css_provider_color);
#line 39 "../lib/theme-gtkcss.vala"
	self->priv->css_provider_color = _tmp3_;
#line 35 "../lib/theme-gtkcss.vala"
	return self;
#line 130 "theme-gtkcss.c"
}

XnpThemeGtkcss*
xnp_theme_gtkcss_new (void)
{
#line 35 "../lib/theme-gtkcss.vala"
	return xnp_theme_gtkcss_construct (XNP_TYPE_THEME_GTKCSS);
#line 138 "theme-gtkcss.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 78 "../lib/theme-gtkcss.vala"
	if (s1 == s2) {
#line 78 "../lib/theme-gtkcss.vala"
		return TRUE;
#line 149 "theme-gtkcss.c"
	}
#line 78 "../lib/theme-gtkcss.vala"
	if (s1 == NULL) {
#line 78 "../lib/theme-gtkcss.vala"
		return FALSE;
#line 155 "theme-gtkcss.c"
	}
#line 78 "../lib/theme-gtkcss.vala"
	if (s2 == NULL) {
#line 78 "../lib/theme-gtkcss.vala"
		return FALSE;
#line 161 "theme-gtkcss.c"
	}
#line 78 "../lib/theme-gtkcss.vala"
	if (s1->red != s2->red) {
#line 78 "../lib/theme-gtkcss.vala"
		return FALSE;
#line 167 "theme-gtkcss.c"
	}
#line 78 "../lib/theme-gtkcss.vala"
	if (s1->green != s2->green) {
#line 78 "../lib/theme-gtkcss.vala"
		return FALSE;
#line 173 "theme-gtkcss.c"
	}
#line 78 "../lib/theme-gtkcss.vala"
	if (s1->blue != s2->blue) {
#line 78 "../lib/theme-gtkcss.vala"
		return FALSE;
#line 179 "theme-gtkcss.c"
	}
#line 78 "../lib/theme-gtkcss.vala"
	if (s1->alpha != s2->alpha) {
#line 78 "../lib/theme-gtkcss.vala"
		return FALSE;
#line 185 "theme-gtkcss.c"
	}
#line 78 "../lib/theme-gtkcss.vala"
	return TRUE;
#line 189 "theme-gtkcss.c"
}

void
xnp_theme_gtkcss_update_color_css (XnpThemeGtkcss* self,
                                   GdkRGBA* rgba)
{
	GError* _inner_error0_ = NULL;
#line 76 "../lib/theme-gtkcss.vala"
	g_return_if_fail (self != NULL);
#line 76 "../lib/theme-gtkcss.vala"
	g_return_if_fail (rgba != NULL);
#line 201 "theme-gtkcss.c"
	{
		GdkRGBA _tmp0_;
		GdkRGBA _tmp1_;
#line 78 "../lib/theme-gtkcss.vala"
		_tmp0_ = self->priv->bg_color;
#line 78 "../lib/theme-gtkcss.vala"
		_tmp1_ = *rgba;
#line 78 "../lib/theme-gtkcss.vala"
		if (_gdk_rgba_equal (&_tmp0_, &_tmp1_) != TRUE) {
#line 211 "theme-gtkcss.c"
			GdkRGBA _tmp2_;
			gchar* css = NULL;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GtkCssProvider* _tmp7_;
			const gchar* _tmp8_;
#line 79 "../lib/theme-gtkcss.vala"
			_tmp2_ = *rgba;
#line 79 "../lib/theme-gtkcss.vala"
			self->priv->bg_color = _tmp2_;
#line 80 "../lib/theme-gtkcss.vala"
			_tmp3_ = gdk_rgba_to_string (&self->priv->bg_color);
#line 80 "../lib/theme-gtkcss.vala"
			_tmp4_ = _tmp3_;
#line 80 "../lib/theme-gtkcss.vala"
			_tmp5_ = g_strdup_printf ("@define-color notes_bg_color %s;", _tmp4_);
#line 80 "../lib/theme-gtkcss.vala"
			_tmp6_ = _tmp5_;
#line 80 "../lib/theme-gtkcss.vala"
			_g_free0 (_tmp4_);
#line 80 "../lib/theme-gtkcss.vala"
			css = _tmp6_;
#line 82 "../lib/theme-gtkcss.vala"
			_tmp7_ = self->priv->css_provider_color;
#line 82 "../lib/theme-gtkcss.vala"
			_tmp8_ = css;
#line 82 "../lib/theme-gtkcss.vala"
			gtk_css_provider_load_from_data (_tmp7_, _tmp8_, (gssize) -1, &_inner_error0_);
#line 82 "../lib/theme-gtkcss.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../lib/theme-gtkcss.vala"
				_g_free0 (css);
#line 246 "theme-gtkcss.c"
				goto __catch0_g_error;
			}
#line 78 "../lib/theme-gtkcss.vala"
			_g_free0 (css);
#line 251 "theme-gtkcss.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 77 "../lib/theme-gtkcss.vala"
		e = _inner_error0_;
#line 77 "../lib/theme-gtkcss.vala"
		_inner_error0_ = NULL;
#line 85 "../lib/theme-gtkcss.vala"
		_tmp9_ = e;
#line 85 "../lib/theme-gtkcss.vala"
		_tmp10_ = _tmp9_->message;
#line 85 "../lib/theme-gtkcss.vala"
		g_warning ("theme-gtkcss.vala:85: %s", _tmp10_);
#line 77 "../lib/theme-gtkcss.vala"
		_g_error_free0 (e);
#line 272 "theme-gtkcss.c"
	}
	__finally0:
#line 77 "../lib/theme-gtkcss.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../lib/theme-gtkcss.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../lib/theme-gtkcss.vala"
		g_clear_error (&_inner_error0_);
#line 77 "../lib/theme-gtkcss.vala"
		return;
#line 283 "theme-gtkcss.c"
	}
}

static void
xnp_theme_gtkcss_load_default_css (XnpThemeGtkcss* self)
{
	GError* _inner_error0_ = NULL;
#line 89 "../lib/theme-gtkcss.vala"
	g_return_if_fail (self != NULL);
#line 293 "theme-gtkcss.c"
	{
		GtkCssProvider* _tmp0_;
		const gchar* _tmp1_;
#line 91 "../lib/theme-gtkcss.vala"
		_tmp0_ = self->priv->css_provider_default;
#line 91 "../lib/theme-gtkcss.vala"
		_tmp1_ = self->priv->css_path_default;
#line 91 "../lib/theme-gtkcss.vala"
		gtk_css_provider_load_from_path (_tmp0_, _tmp1_, &_inner_error0_);
#line 91 "../lib/theme-gtkcss.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 305 "theme-gtkcss.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 90 "../lib/theme-gtkcss.vala"
		e = _inner_error0_;
#line 90 "../lib/theme-gtkcss.vala"
		_inner_error0_ = NULL;
#line 93 "../lib/theme-gtkcss.vala"
		_tmp2_ = e;
#line 93 "../lib/theme-gtkcss.vala"
		_tmp3_ = _tmp2_->message;
#line 93 "../lib/theme-gtkcss.vala"
		g_warning ("theme-gtkcss.vala:93: %s", _tmp3_);
#line 90 "../lib/theme-gtkcss.vala"
		_g_error_free0 (e);
#line 327 "theme-gtkcss.c"
	}
	__finally0:
#line 90 "../lib/theme-gtkcss.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../lib/theme-gtkcss.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../lib/theme-gtkcss.vala"
		g_clear_error (&_inner_error0_);
#line 90 "../lib/theme-gtkcss.vala"
		return;
#line 338 "theme-gtkcss.c"
	}
}

static void
xnp_theme_gtkcss_load_system_css (XnpThemeGtkcss* self)
{
	GError* _inner_error0_ = NULL;
#line 97 "../lib/theme-gtkcss.vala"
	g_return_if_fail (self != NULL);
#line 348 "theme-gtkcss.c"
	{
		const gchar* _tmp0_;
		GtkCssProvider* _tmp1_;
		const gchar* _tmp2_;
#line 99 "../lib/theme-gtkcss.vala"
		_tmp0_ = self->priv->css_path_system;
#line 99 "../lib/theme-gtkcss.vala"
		if (!xnp_file_utils_path_exists (_tmp0_)) {
#line 100 "../lib/theme-gtkcss.vala"
			return;
#line 359 "theme-gtkcss.c"
		}
#line 101 "../lib/theme-gtkcss.vala"
		_tmp1_ = self->priv->css_provider_system;
#line 101 "../lib/theme-gtkcss.vala"
		_tmp2_ = self->priv->css_path_system;
#line 101 "../lib/theme-gtkcss.vala"
		gtk_css_provider_load_from_path (_tmp1_, _tmp2_, &_inner_error0_);
#line 101 "../lib/theme-gtkcss.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 369 "theme-gtkcss.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 98 "../lib/theme-gtkcss.vala"
		e = _inner_error0_;
#line 98 "../lib/theme-gtkcss.vala"
		_inner_error0_ = NULL;
#line 103 "../lib/theme-gtkcss.vala"
		_tmp3_ = e;
#line 103 "../lib/theme-gtkcss.vala"
		_tmp4_ = _tmp3_->message;
#line 103 "../lib/theme-gtkcss.vala"
		g_warning ("theme-gtkcss.vala:103: %s", _tmp4_);
#line 98 "../lib/theme-gtkcss.vala"
		_g_error_free0 (e);
#line 391 "theme-gtkcss.c"
	}
	__finally0:
#line 98 "../lib/theme-gtkcss.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../lib/theme-gtkcss.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../lib/theme-gtkcss.vala"
		g_clear_error (&_inner_error0_);
#line 98 "../lib/theme-gtkcss.vala"
		return;
#line 402 "theme-gtkcss.c"
	}
}

static void
xnp_theme_gtkcss_load_user_css (XnpThemeGtkcss* self)
{
	GError* _inner_error0_ = NULL;
#line 107 "../lib/theme-gtkcss.vala"
	g_return_if_fail (self != NULL);
#line 412 "theme-gtkcss.c"
	{
		const gchar* _tmp0_;
		GtkCssProvider* _tmp4_;
		const gchar* _tmp5_;
#line 109 "../lib/theme-gtkcss.vala"
		_tmp0_ = self->priv->css_path_user;
#line 109 "../lib/theme-gtkcss.vala"
		if (!xnp_file_utils_path_exists (_tmp0_)) {
#line 421 "theme-gtkcss.c"
			gchar* css = NULL;
			gchar* _tmp1_;
			const gchar* _tmp2_;
			const gchar* _tmp3_;
#line 110 "../lib/theme-gtkcss.vala"
			_tmp1_ = g_strdup ("/* Put your fun stuff here */");
#line 110 "../lib/theme-gtkcss.vala"
			css = _tmp1_;
#line 111 "../lib/theme-gtkcss.vala"
			_tmp2_ = self->priv->css_path_user;
#line 111 "../lib/theme-gtkcss.vala"
			_tmp3_ = css;
#line 111 "../lib/theme-gtkcss.vala"
			g_file_set_contents (_tmp2_, _tmp3_, (gssize) -1, &_inner_error0_);
#line 111 "../lib/theme-gtkcss.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../lib/theme-gtkcss.vala"
				_g_free0 (css);
#line 440 "theme-gtkcss.c"
				goto __catch0_g_error;
			}
#line 109 "../lib/theme-gtkcss.vala"
			_g_free0 (css);
#line 445 "theme-gtkcss.c"
		}
#line 113 "../lib/theme-gtkcss.vala"
		_tmp4_ = self->priv->css_provider_user;
#line 113 "../lib/theme-gtkcss.vala"
		_tmp5_ = self->priv->css_path_user;
#line 113 "../lib/theme-gtkcss.vala"
		gtk_css_provider_load_from_path (_tmp4_, _tmp5_, &_inner_error0_);
#line 113 "../lib/theme-gtkcss.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 455 "theme-gtkcss.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 108 "../lib/theme-gtkcss.vala"
		e = _inner_error0_;
#line 108 "../lib/theme-gtkcss.vala"
		_inner_error0_ = NULL;
#line 115 "../lib/theme-gtkcss.vala"
		_tmp6_ = e;
#line 115 "../lib/theme-gtkcss.vala"
		_tmp7_ = _tmp6_->message;
#line 115 "../lib/theme-gtkcss.vala"
		g_warning ("theme-gtkcss.vala:115: %s", _tmp7_);
#line 108 "../lib/theme-gtkcss.vala"
		_g_error_free0 (e);
#line 477 "theme-gtkcss.c"
	}
	__finally0:
#line 108 "../lib/theme-gtkcss.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../lib/theme-gtkcss.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../lib/theme-gtkcss.vala"
		g_clear_error (&_inner_error0_);
#line 108 "../lib/theme-gtkcss.vala"
		return;
#line 488 "theme-gtkcss.c"
	}
}

gboolean
xnp_theme_gtkcss_get_use_gtk_style (XnpThemeGtkcss* self)
{
	gboolean result;
#line 43 "../lib/theme-gtkcss.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../lib/theme-gtkcss.vala"
	result = self->priv->_use_gtk_style;
#line 44 "../lib/theme-gtkcss.vala"
	return result;
#line 502 "theme-gtkcss.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../lib/theme-gtkcss.vala"
	return self ? g_object_ref (self) : NULL;
#line 510 "theme-gtkcss.c"
}

void
xnp_theme_gtkcss_set_use_gtk_style (XnpThemeGtkcss* self,
                                    gboolean value)
{
	GdkScreen* default_screen = NULL;
	GdkScreen* _tmp0_;
	GdkScreen* _tmp1_;
#line 47 "../lib/theme-gtkcss.vala"
	g_return_if_fail (self != NULL);
#line 48 "../lib/theme-gtkcss.vala"
	if (self->priv->_use_gtk_style == value) {
#line 49 "../lib/theme-gtkcss.vala"
		return;
#line 526 "theme-gtkcss.c"
	}
#line 50 "../lib/theme-gtkcss.vala"
	_tmp0_ = gdk_screen_get_default ();
#line 50 "../lib/theme-gtkcss.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 50 "../lib/theme-gtkcss.vala"
	default_screen = _tmp1_;
#line 51 "../lib/theme-gtkcss.vala"
	if (value) {
#line 536 "theme-gtkcss.c"
		GdkScreen* _tmp2_;
		GtkCssProvider* _tmp3_;
		GdkScreen* _tmp4_;
		GtkCssProvider* _tmp5_;
		GdkScreen* _tmp6_;
		GtkCssProvider* _tmp7_;
		GdkScreen* _tmp8_;
		GtkCssProvider* _tmp9_;
#line 52 "../lib/theme-gtkcss.vala"
		_tmp2_ = default_screen;
#line 52 "../lib/theme-gtkcss.vala"
		_tmp3_ = self->priv->css_provider_color;
#line 52 "../lib/theme-gtkcss.vala"
		gtk_style_context_remove_provider_for_screen (_tmp2_, (GtkStyleProvider*) _tmp3_);
#line 53 "../lib/theme-gtkcss.vala"
		_tmp4_ = default_screen;
#line 53 "../lib/theme-gtkcss.vala"
		_tmp5_ = self->priv->css_provider_default;
#line 53 "../lib/theme-gtkcss.vala"
		gtk_style_context_remove_provider_for_screen (_tmp4_, (GtkStyleProvider*) _tmp5_);
#line 54 "../lib/theme-gtkcss.vala"
		_tmp6_ = default_screen;
#line 54 "../lib/theme-gtkcss.vala"
		_tmp7_ = self->priv->css_provider_system;
#line 54 "../lib/theme-gtkcss.vala"
		gtk_style_context_remove_provider_for_screen (_tmp6_, (GtkStyleProvider*) _tmp7_);
#line 55 "../lib/theme-gtkcss.vala"
		_tmp8_ = default_screen;
#line 55 "../lib/theme-gtkcss.vala"
		_tmp9_ = self->priv->css_provider_user;
#line 55 "../lib/theme-gtkcss.vala"
		gtk_style_context_remove_provider_for_screen (_tmp8_, (GtkStyleProvider*) _tmp9_);
#line 56 "../lib/theme-gtkcss.vala"
		_g_object_unref0 (self->priv->css_provider_default);
#line 56 "../lib/theme-gtkcss.vala"
		self->priv->css_provider_default = NULL;
#line 57 "../lib/theme-gtkcss.vala"
		_g_object_unref0 (self->priv->css_provider_system);
#line 57 "../lib/theme-gtkcss.vala"
		self->priv->css_provider_system = NULL;
#line 58 "../lib/theme-gtkcss.vala"
		_g_object_unref0 (self->priv->css_provider_user);
#line 58 "../lib/theme-gtkcss.vala"
		self->priv->css_provider_user = NULL;
#line 581 "theme-gtkcss.c"
	} else {
		GtkCssProvider* _tmp10_;
		GtkCssProvider* _tmp11_;
		GtkCssProvider* _tmp12_;
		GdkScreen* _tmp13_;
		GtkCssProvider* _tmp14_;
		GdkScreen* _tmp15_;
		GtkCssProvider* _tmp16_;
		GdkScreen* _tmp17_;
		GtkCssProvider* _tmp18_;
		GdkScreen* _tmp19_;
		GtkCssProvider* _tmp20_;
#line 61 "../lib/theme-gtkcss.vala"
		_tmp10_ = gtk_css_provider_new ();
#line 61 "../lib/theme-gtkcss.vala"
		_g_object_unref0 (self->priv->css_provider_default);
#line 61 "../lib/theme-gtkcss.vala"
		self->priv->css_provider_default = _tmp10_;
#line 62 "../lib/theme-gtkcss.vala"
		_tmp11_ = gtk_css_provider_new ();
#line 62 "../lib/theme-gtkcss.vala"
		_g_object_unref0 (self->priv->css_provider_system);
#line 62 "../lib/theme-gtkcss.vala"
		self->priv->css_provider_system = _tmp11_;
#line 63 "../lib/theme-gtkcss.vala"
		_tmp12_ = gtk_css_provider_new ();
#line 63 "../lib/theme-gtkcss.vala"
		_g_object_unref0 (self->priv->css_provider_user);
#line 63 "../lib/theme-gtkcss.vala"
		self->priv->css_provider_user = _tmp12_;
#line 64 "../lib/theme-gtkcss.vala"
		_tmp13_ = default_screen;
#line 64 "../lib/theme-gtkcss.vala"
		_tmp14_ = self->priv->css_provider_color;
#line 64 "../lib/theme-gtkcss.vala"
		gtk_style_context_add_provider_for_screen (_tmp13_, (GtkStyleProvider*) _tmp14_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 65 "../lib/theme-gtkcss.vala"
		_tmp15_ = default_screen;
#line 65 "../lib/theme-gtkcss.vala"
		_tmp16_ = self->priv->css_provider_default;
#line 65 "../lib/theme-gtkcss.vala"
		gtk_style_context_add_provider_for_screen (_tmp15_, (GtkStyleProvider*) _tmp16_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 66 "../lib/theme-gtkcss.vala"
		_tmp17_ = default_screen;
#line 66 "../lib/theme-gtkcss.vala"
		_tmp18_ = self->priv->css_provider_system;
#line 66 "../lib/theme-gtkcss.vala"
		gtk_style_context_add_provider_for_screen (_tmp17_, (GtkStyleProvider*) _tmp18_, (guint) (GTK_STYLE_PROVIDER_PRIORITY_USER - 1));
#line 67 "../lib/theme-gtkcss.vala"
		_tmp19_ = default_screen;
#line 67 "../lib/theme-gtkcss.vala"
		_tmp20_ = self->priv->css_provider_user;
#line 67 "../lib/theme-gtkcss.vala"
		gtk_style_context_add_provider_for_screen (_tmp19_, (GtkStyleProvider*) _tmp20_, (guint) (GTK_STYLE_PROVIDER_PRIORITY_USER + 1));
#line 68 "../lib/theme-gtkcss.vala"
		xnp_theme_gtkcss_load_default_css (self);
#line 69 "../lib/theme-gtkcss.vala"
		xnp_theme_gtkcss_load_system_css (self);
#line 70 "../lib/theme-gtkcss.vala"
		xnp_theme_gtkcss_load_user_css (self);
#line 642 "theme-gtkcss.c"
	}
#line 72 "../lib/theme-gtkcss.vala"
	self->priv->_use_gtk_style = value;
#line 47 "../lib/theme-gtkcss.vala"
	_g_object_unref0 (default_screen);
#line 47 "../lib/theme-gtkcss.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_theme_gtkcss_properties[XNP_THEME_GTKCSS_USE_GTK_STYLE_PROPERTY]);
#line 650 "theme-gtkcss.c"
}

static void
xnp_theme_gtkcss_class_init (XnpThemeGtkcssClass * klass,
                             gpointer klass_data)
{
#line 23 "../lib/theme-gtkcss.vala"
	xnp_theme_gtkcss_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/theme-gtkcss.vala"
	g_type_class_adjust_private_offset (klass, &XnpThemeGtkcss_private_offset);
#line 23 "../lib/theme-gtkcss.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_xnp_theme_gtkcss_get_property;
#line 23 "../lib/theme-gtkcss.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_xnp_theme_gtkcss_set_property;
#line 23 "../lib/theme-gtkcss.vala"
	G_OBJECT_CLASS (klass)->finalize = xnp_theme_gtkcss_finalize;
#line 23 "../lib/theme-gtkcss.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_THEME_GTKCSS_USE_GTK_STYLE_PROPERTY, xnp_theme_gtkcss_properties[XNP_THEME_GTKCSS_USE_GTK_STYLE_PROPERTY] = g_param_spec_boolean ("use-gtk-style", "use-gtk-style", "use-gtk-style", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 669 "theme-gtkcss.c"
}

static void
xnp_theme_gtkcss_instance_init (XnpThemeGtkcss * self,
                                gpointer klass)
{
#line 23 "../lib/theme-gtkcss.vala"
	self->priv = xnp_theme_gtkcss_get_instance_private (self);
#line 32 "../lib/theme-gtkcss.vala"
	self->priv->_use_gtk_style = TRUE;
#line 33 "../lib/theme-gtkcss.vala"
	self->priv->bg_color = (GdkRGBA) {(gdouble) 0};
#line 682 "theme-gtkcss.c"
}

static void
xnp_theme_gtkcss_finalize (GObject * obj)
{
	XnpThemeGtkcss * self;
#line 23 "../lib/theme-gtkcss.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_THEME_GTKCSS, XnpThemeGtkcss);
#line 25 "../lib/theme-gtkcss.vala"
	_g_free0 (self->priv->css_path_default);
#line 26 "../lib/theme-gtkcss.vala"
	_g_free0 (self->priv->css_path_system);
#line 27 "../lib/theme-gtkcss.vala"
	_g_free0 (self->priv->css_path_user);
#line 28 "../lib/theme-gtkcss.vala"
	_g_object_unref0 (self->priv->css_provider_color);
#line 29 "../lib/theme-gtkcss.vala"
	_g_object_unref0 (self->priv->css_provider_default);
#line 30 "../lib/theme-gtkcss.vala"
	_g_object_unref0 (self->priv->css_provider_system);
#line 31 "../lib/theme-gtkcss.vala"
	_g_object_unref0 (self->priv->css_provider_user);
#line 23 "../lib/theme-gtkcss.vala"
	G_OBJECT_CLASS (xnp_theme_gtkcss_parent_class)->finalize (obj);
#line 707 "theme-gtkcss.c"
}

static GType
xnp_theme_gtkcss_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (XnpThemeGtkcssClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnp_theme_gtkcss_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnpThemeGtkcss), 0, (GInstanceInitFunc) xnp_theme_gtkcss_instance_init, NULL };
	GType xnp_theme_gtkcss_type_id;
	xnp_theme_gtkcss_type_id = g_type_register_static (G_TYPE_OBJECT, "XnpThemeGtkcss", &g_define_type_info, 0);
	XnpThemeGtkcss_private_offset = g_type_add_instance_private (xnp_theme_gtkcss_type_id, sizeof (XnpThemeGtkcssPrivate));
	return xnp_theme_gtkcss_type_id;
}

GType
xnp_theme_gtkcss_get_type (void)
{
	static volatile gsize xnp_theme_gtkcss_type_id__once = 0;
	if (g_once_init_enter (&xnp_theme_gtkcss_type_id__once)) {
		GType xnp_theme_gtkcss_type_id;
		xnp_theme_gtkcss_type_id = xnp_theme_gtkcss_get_type_once ();
		g_once_init_leave (&xnp_theme_gtkcss_type_id__once, xnp_theme_gtkcss_type_id);
	}
	return xnp_theme_gtkcss_type_id__once;
}

static void
_vala_xnp_theme_gtkcss_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	XnpThemeGtkcss * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_THEME_GTKCSS, XnpThemeGtkcss);
#line 23 "../lib/theme-gtkcss.vala"
	switch (property_id) {
#line 23 "../lib/theme-gtkcss.vala"
		case XNP_THEME_GTKCSS_USE_GTK_STYLE_PROPERTY:
#line 23 "../lib/theme-gtkcss.vala"
		g_value_set_boolean (value, xnp_theme_gtkcss_get_use_gtk_style (self));
#line 23 "../lib/theme-gtkcss.vala"
		break;
#line 748 "theme-gtkcss.c"
		default:
#line 23 "../lib/theme-gtkcss.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/theme-gtkcss.vala"
		break;
#line 754 "theme-gtkcss.c"
	}
}

static void
_vala_xnp_theme_gtkcss_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	XnpThemeGtkcss * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_THEME_GTKCSS, XnpThemeGtkcss);
#line 23 "../lib/theme-gtkcss.vala"
	switch (property_id) {
#line 23 "../lib/theme-gtkcss.vala"
		case XNP_THEME_GTKCSS_USE_GTK_STYLE_PROPERTY:
#line 23 "../lib/theme-gtkcss.vala"
		xnp_theme_gtkcss_set_use_gtk_style (self, g_value_get_boolean (value));
#line 23 "../lib/theme-gtkcss.vala"
		break;
#line 774 "theme-gtkcss.c"
		default:
#line 23 "../lib/theme-gtkcss.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/theme-gtkcss.vala"
		break;
#line 780 "theme-gtkcss.c"
	}
}

