/* window-monitor.c generated by valac 0.56.18, the Vala compiler
 * generated from window-monitor.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (c) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *  Copyright (c) 2024-2025  Arthur Demchenkov <spinal.by@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "libnotes.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define XNP_WINDOW_MONITOR_CREATED G_FILE_MONITOR_EVENT_CREATED
#define XNP_WINDOW_MONITOR_CHANGES_DONE_HINT G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define XNP_WINDOW_MONITOR_TYPE_FILE_EVENT (xnp_window_monitor_file_event_get_type ())
typedef struct _XnpWindowMonitorFileEvent XnpWindowMonitorFileEvent;
enum  {
	XNP_WINDOW_MONITOR_0_PROPERTY,
	XNP_WINDOW_MONITOR_NUM_PROPERTIES
};
static GParamSpec* xnp_window_monitor_properties[XNP_WINDOW_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	XNP_WINDOW_MONITOR_NOTE_UPDATED_SIGNAL,
	XNP_WINDOW_MONITOR_NOTE_DELETED_SIGNAL,
	XNP_WINDOW_MONITOR_NOTE_CREATED_SIGNAL,
	XNP_WINDOW_MONITOR_NOTE_RENAMED_SIGNAL,
	XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL,
	XNP_WINDOW_MONITOR_NUM_SIGNALS
};
static guint xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NUM_SIGNALS] = {0};

struct _XnpWindowMonitorFileEvent {
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
};

struct _XnpWindowMonitorPrivate {
	GFileMonitor* monitor;
	guint src_external;
	guint src_internal;
	gboolean skip;
	XnpWindowMonitorFileEvent* events;
	gint events_length1;
	gint _events_size_;
	XnpWindowMonitorFileEvent dummy;
};

static gint XnpWindowMonitor_private_offset;
static gpointer xnp_window_monitor_parent_class = NULL;

static GType xnp_window_monitor_file_event_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static XnpWindowMonitorFileEvent* xnp_window_monitor_file_event_dup (const XnpWindowMonitorFileEvent* self);
static void xnp_window_monitor_file_event_free (XnpWindowMonitorFileEvent* self);
static void xnp_window_monitor_file_event_copy (const XnpWindowMonitorFileEvent* self,
                                         XnpWindowMonitorFileEvent* dest);
static void xnp_window_monitor_file_event_destroy (XnpWindowMonitorFileEvent* self);
static void _vala_XnpWindowMonitorFileEvent_array_free (XnpWindowMonitorFileEvent * array,
                                                 gssize array_length);
static void xnp_window_monitor_file_event_init (XnpWindowMonitorFileEvent *self,
                                         GFile* file,
                                         GFile* other_file,
                                         GFileMonitorEvent event);
static void xnp_window_monitor_monitor_change_cb (XnpWindowMonitor* self,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event);
static void _xnp_window_monitor_monitor_change_cb_g_file_monitor_changed (GFileMonitor* _sender,
                                                                   GFile* file,
                                                                   GFile* other_file,
                                                                   GFileMonitorEvent event_type,
                                                                   gpointer self);
static void _vala_array_add5 (XnpWindowMonitorFileEvent* * array,
                       gint* length,
                       gint* size,
                       const XnpWindowMonitorFileEvent* value);
static gboolean __lambda4_ (XnpWindowMonitor* self);
static void xnp_window_monitor_optimize_events (XnpWindowMonitor* self);
static void xnp_window_monitor_process_events (XnpWindowMonitor* self);
static gboolean ___lambda4__gsource_func (gpointer self);
static gboolean __lambda5_ (XnpWindowMonitor* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static void xnp_window_monitor_optimize_event_created (XnpWindowMonitor* self,
                                                gint n);
static void xnp_window_monitor_optimize_event_deleted (XnpWindowMonitor* self,
                                                gint n);
static void xnp_window_monitor_optimize_event_renamed (XnpWindowMonitor* self,
                                                gint n);
static gboolean _xnp_window_monitor_file_event_equal (const XnpWindowMonitorFileEvent * s1,
                                               const XnpWindowMonitorFileEvent * s2);
static void _vala_array_add6 (XnpWindowMonitorFileEvent* * array,
                       gint* length,
                       gint* size,
                       const XnpWindowMonitorFileEvent* value);
static XnpWindowMonitorFileEvent* _vala_array_dup1 (XnpWindowMonitorFileEvent* self,
                                             gssize length);
static void _vala_array_add7 (XnpWindowMonitorFileEvent* * array,
                       gint* length,
                       gint* size,
                       const XnpWindowMonitorFileEvent* value);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void xnp_window_monitor_finalize (GObject * obj);
static GType xnp_window_monitor_get_type_once (void);

static inline gpointer
xnp_window_monitor_get_instance_private (XnpWindowMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, XnpWindowMonitor_private_offset);
}

static void
_vala_XnpWindowMonitorFileEvent_array_free (XnpWindowMonitorFileEvent * array,
                                            gssize array_length)
{
#line 47 "../lib/window-monitor.vala"
	if (array != NULL) {
#line 159 "window-monitor.c"
		gssize i;
#line 47 "../lib/window-monitor.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 47 "../lib/window-monitor.vala"
			xnp_window_monitor_file_event_destroy (&array[i]);
#line 165 "window-monitor.c"
		}
	}
#line 47 "../lib/window-monitor.vala"
	g_free (array);
#line 170 "window-monitor.c"
}

static void
_xnp_window_monitor_monitor_change_cb_g_file_monitor_changed (GFileMonitor* _sender,
                                                              GFile* file,
                                                              GFile* other_file,
                                                              GFileMonitorEvent event_type,
                                                              gpointer self)
{
#line 56 "../lib/window-monitor.vala"
	xnp_window_monitor_monitor_change_cb ((XnpWindowMonitor*) self, file, other_file, event_type);
#line 182 "window-monitor.c"
}

XnpWindowMonitor*
xnp_window_monitor_construct (GType object_type,
                              GFile* path)
{
	XnpWindowMonitor * self = NULL;
	GError* _inner_error0_ = NULL;
#line 52 "../lib/window-monitor.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 52 "../lib/window-monitor.vala"
	self = (XnpWindowMonitor*) g_object_new (object_type, NULL);
#line 195 "window-monitor.c"
	{
		GFileMonitor* _tmp0_ = NULL;
		GFileMonitor* _tmp1_;
		GFileMonitor* _tmp2_;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
#line 54 "../lib/window-monitor.vala"
		_tmp1_ = g_file_monitor_directory (path, G_FILE_MONITOR_WATCH_MOVES, NULL, &_inner_error0_);
#line 54 "../lib/window-monitor.vala"
		_tmp0_ = _tmp1_;
#line 54 "../lib/window-monitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "window-monitor.c"
			goto __catch0_g_error;
		}
#line 54 "../lib/window-monitor.vala"
		_tmp2_ = _tmp0_;
#line 54 "../lib/window-monitor.vala"
		_tmp0_ = NULL;
#line 54 "../lib/window-monitor.vala"
		_g_object_unref0 (self->priv->monitor);
#line 54 "../lib/window-monitor.vala"
		self->priv->monitor = _tmp2_;
#line 55 "../lib/window-monitor.vala"
		_tmp3_ = self->priv->monitor;
#line 55 "../lib/window-monitor.vala"
		g_file_monitor_set_rate_limit (_tmp3_, 1000);
#line 56 "../lib/window-monitor.vala"
		_tmp4_ = self->priv->monitor;
#line 56 "../lib/window-monitor.vala"
		g_signal_connect_object (_tmp4_, "changed", (GCallback) _xnp_window_monitor_monitor_change_cb_g_file_monitor_changed, self, 0);
#line 53 "../lib/window-monitor.vala"
		_g_object_unref0 (_tmp0_);
#line 229 "window-monitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 53 "../lib/window-monitor.vala"
		e = _inner_error0_;
#line 53 "../lib/window-monitor.vala"
		_inner_error0_ = NULL;
#line 59 "../lib/window-monitor.vala"
		_tmp5_ = e;
#line 59 "../lib/window-monitor.vala"
		_tmp6_ = _tmp5_->message;
#line 59 "../lib/window-monitor.vala"
		g_message ("window-monitor.vala:59: Unable to create a directory monitor: %s", _tmp6_);
#line 53 "../lib/window-monitor.vala"
		_g_error_free0 (e);
#line 249 "window-monitor.c"
	}
	__finally0:
#line 53 "../lib/window-monitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 53 "../lib/window-monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 53 "../lib/window-monitor.vala"
		g_clear_error (&_inner_error0_);
#line 53 "../lib/window-monitor.vala"
		return NULL;
#line 260 "window-monitor.c"
	}
#line 52 "../lib/window-monitor.vala"
	return self;
#line 264 "window-monitor.c"
}

XnpWindowMonitor*
xnp_window_monitor_new (GFile* path)
{
#line 52 "../lib/window-monitor.vala"
	return xnp_window_monitor_construct (XNP_TYPE_WINDOW_MONITOR, path);
#line 272 "window-monitor.c"
}

static void
_vala_array_add5 (XnpWindowMonitorFileEvent* * array,
                  gint* length,
                  gint* size,
                  const XnpWindowMonitorFileEvent* value)
{
#line 73 "../lib/window-monitor.vala"
	if ((*length) == (*size)) {
#line 73 "../lib/window-monitor.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 73 "../lib/window-monitor.vala"
		*array = g_renew (XnpWindowMonitorFileEvent, *array, *size);
#line 287 "window-monitor.c"
	}
#line 73 "../lib/window-monitor.vala"
	(*array)[(*length)++] = *value;
#line 291 "window-monitor.c"
}

static gboolean
__lambda4_ (XnpWindowMonitor* self)
{
	XnpWindowMonitorFileEvent* _tmp0_;
	gboolean result;
#line 80 "../lib/window-monitor.vala"
	xnp_window_monitor_optimize_events (self);
#line 81 "../lib/window-monitor.vala"
	xnp_window_monitor_process_events (self);
#line 82 "../lib/window-monitor.vala"
	self->priv->src_external = (guint) 0;
#line 83 "../lib/window-monitor.vala"
	_tmp0_ = g_new0 (XnpWindowMonitorFileEvent, 0);
#line 83 "../lib/window-monitor.vala"
	self->priv->events = (_vala_XnpWindowMonitorFileEvent_array_free (self->priv->events, self->priv->events_length1), NULL);
#line 83 "../lib/window-monitor.vala"
	self->priv->events = _tmp0_;
#line 83 "../lib/window-monitor.vala"
	self->priv->events_length1 = 0;
#line 83 "../lib/window-monitor.vala"
	self->priv->_events_size_ = self->priv->events_length1;
#line 84 "../lib/window-monitor.vala"
	result = G_SOURCE_REMOVE;
#line 84 "../lib/window-monitor.vala"
	return result;
#line 319 "window-monitor.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((XnpWindowMonitor*) self);
#line 79 "../lib/window-monitor.vala"
	return result;
#line 329 "window-monitor.c"
}

static void
xnp_window_monitor_monitor_change_cb (XnpWindowMonitor* self,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event)
{
	XnpWindowMonitorFileEvent _tmp0_ = {0};
#line 70 "../lib/window-monitor.vala"
	g_return_if_fail (self != NULL);
#line 70 "../lib/window-monitor.vala"
	g_return_if_fail (file != NULL);
#line 71 "../lib/window-monitor.vala"
	if (self->priv->skip) {
#line 71 "../lib/window-monitor.vala"
		return;
#line 347 "window-monitor.c"
	}
#line 73 "../lib/window-monitor.vala"
	xnp_window_monitor_file_event_init (&_tmp0_, file, other_file, event);
#line 73 "../lib/window-monitor.vala"
	_vala_array_add5 (&self->priv->events, &self->priv->events_length1, &self->priv->_events_size_, &_tmp0_);
#line 75 "../lib/window-monitor.vala"
	if (self->priv->src_external != ((guint) 0)) {
#line 76 "../lib/window-monitor.vala"
		g_source_remove (self->priv->src_external);
#line 357 "window-monitor.c"
	}
#line 79 "../lib/window-monitor.vala"
	self->priv->src_external = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 361 "window-monitor.c"
}

static void
xnp_window_monitor_process_events (XnpWindowMonitor* self)
{
	XnpWindowMonitorFileEvent* _tmp0_;
	gint _tmp0__length1;
#line 88 "../lib/window-monitor.vala"
	g_return_if_fail (self != NULL);
#line 89 "../lib/window-monitor.vala"
	_tmp0_ = self->priv->events;
#line 89 "../lib/window-monitor.vala"
	_tmp0__length1 = self->priv->events_length1;
#line 375 "window-monitor.c"
	{
		XnpWindowMonitorFileEvent* ev_collection = NULL;
		gint ev_collection_length1 = 0;
		gint _ev_collection_size_ = 0;
		gint ev_it = 0;
#line 89 "../lib/window-monitor.vala"
		ev_collection = _tmp0_;
#line 89 "../lib/window-monitor.vala"
		ev_collection_length1 = _tmp0__length1;
#line 89 "../lib/window-monitor.vala"
		for (ev_it = 0; ev_it < ev_collection_length1; ev_it = ev_it + 1) {
#line 387 "window-monitor.c"
			XnpWindowMonitorFileEvent _tmp1_;
			XnpWindowMonitorFileEvent _tmp2_ = {0};
			XnpWindowMonitorFileEvent ev = {0};
#line 89 "../lib/window-monitor.vala"
			_tmp1_ = ev_collection[ev_it];
#line 89 "../lib/window-monitor.vala"
			xnp_window_monitor_file_event_copy (&_tmp1_, &_tmp2_);
#line 89 "../lib/window-monitor.vala"
			ev = _tmp2_;
#line 397 "window-monitor.c"
			{
				gchar* note_name = NULL;
				XnpWindowMonitorFileEvent _tmp3_;
				GFile* _tmp4_;
				gchar* _tmp5_;
				XnpWindowMonitorFileEvent _tmp6_;
#line 90 "../lib/window-monitor.vala"
				_tmp3_ = ev;
#line 90 "../lib/window-monitor.vala"
				_tmp4_ = _tmp3_.file;
#line 90 "../lib/window-monitor.vala"
				_tmp5_ = g_file_get_basename (_tmp4_);
#line 90 "../lib/window-monitor.vala"
				note_name = _tmp5_;
#line 91 "../lib/window-monitor.vala"
				_tmp6_ = ev;
#line 91 "../lib/window-monitor.vala"
				switch (_tmp6_.event) {
#line 91 "../lib/window-monitor.vala"
					case XNP_WINDOW_MONITOR_CHANGES_DONE_HINT:
#line 418 "window-monitor.c"
					{
						const gchar* _tmp7_;
#line 93 "../lib/window-monitor.vala"
						_tmp7_ = note_name;
#line 93 "../lib/window-monitor.vala"
						g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_UPDATED_SIGNAL], 0, _tmp7_);
#line 94 "../lib/window-monitor.vala"
						break;
#line 427 "window-monitor.c"
					}
#line 91 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_DELETED:
#line 91 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_MOVED_OUT:
#line 433 "window-monitor.c"
					{
						const gchar* _tmp8_;
#line 98 "../lib/window-monitor.vala"
						_tmp8_ = note_name;
#line 98 "../lib/window-monitor.vala"
						g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_DELETED_SIGNAL], 0, _tmp8_);
#line 99 "../lib/window-monitor.vala"
						break;
#line 442 "window-monitor.c"
					}
#line 91 "../lib/window-monitor.vala"
					case XNP_WINDOW_MONITOR_CREATED:
#line 91 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_MOVED_IN:
#line 448 "window-monitor.c"
					{
						const gchar* _tmp9_;
#line 103 "../lib/window-monitor.vala"
						_tmp9_ = note_name;
#line 103 "../lib/window-monitor.vala"
						g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_CREATED_SIGNAL], 0, _tmp9_);
#line 104 "../lib/window-monitor.vala"
						break;
#line 457 "window-monitor.c"
					}
#line 91 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_RENAMED:
#line 461 "window-monitor.c"
					{
						const gchar* _tmp10_;
						XnpWindowMonitorFileEvent _tmp11_;
						GFile* _tmp12_;
						gchar* _tmp13_;
						gchar* _tmp14_;
#line 107 "../lib/window-monitor.vala"
						_tmp10_ = note_name;
#line 107 "../lib/window-monitor.vala"
						_tmp11_ = ev;
#line 107 "../lib/window-monitor.vala"
						_tmp12_ = _tmp11_.other_file;
#line 107 "../lib/window-monitor.vala"
						_tmp13_ = g_file_get_basename (_tmp12_);
#line 107 "../lib/window-monitor.vala"
						_tmp14_ = _tmp13_;
#line 107 "../lib/window-monitor.vala"
						g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_RENAMED_SIGNAL], 0, _tmp10_, _tmp14_);
#line 107 "../lib/window-monitor.vala"
						_g_free0 (_tmp14_);
#line 108 "../lib/window-monitor.vala"
						break;
#line 484 "window-monitor.c"
					}
					default:
					{
#line 111 "../lib/window-monitor.vala"
						break;
#line 490 "window-monitor.c"
					}
				}
#line 89 "../lib/window-monitor.vala"
				_g_free0 (note_name);
#line 89 "../lib/window-monitor.vala"
				xnp_window_monitor_file_event_destroy (&ev);
#line 497 "window-monitor.c"
			}
		}
	}
}

static gboolean
__lambda5_ (XnpWindowMonitor* self)
{
	gboolean result;
#line 123 "../lib/window-monitor.vala"
	self->priv->skip = FALSE;
#line 124 "../lib/window-monitor.vala"
	self->priv->src_internal = (guint) 0;
#line 125 "../lib/window-monitor.vala"
	result = G_SOURCE_REMOVE;
#line 125 "../lib/window-monitor.vala"
	return result;
#line 515 "window-monitor.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((XnpWindowMonitor*) self);
#line 122 "../lib/window-monitor.vala"
	return result;
#line 525 "window-monitor.c"
}

void
xnp_window_monitor_internal_change (XnpWindowMonitor* self)
{
#line 117 "../lib/window-monitor.vala"
	g_return_if_fail (self != NULL);
#line 118 "../lib/window-monitor.vala"
	if (self->priv->src_internal != ((guint) 0)) {
#line 119 "../lib/window-monitor.vala"
		g_source_remove (self->priv->src_internal);
#line 537 "window-monitor.c"
	}
#line 121 "../lib/window-monitor.vala"
	self->priv->skip = TRUE;
#line 122 "../lib/window-monitor.vala"
	self->priv->src_internal = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 543 "window-monitor.c"
}

static gboolean
_xnp_window_monitor_file_event_equal (const XnpWindowMonitorFileEvent * s1,
                                      const XnpWindowMonitorFileEvent * s2)
{
#line 184 "../lib/window-monitor.vala"
	if (s1 == s2) {
#line 184 "../lib/window-monitor.vala"
		return TRUE;
#line 554 "window-monitor.c"
	}
#line 184 "../lib/window-monitor.vala"
	if (s1 == NULL) {
#line 184 "../lib/window-monitor.vala"
		return FALSE;
#line 560 "window-monitor.c"
	}
#line 184 "../lib/window-monitor.vala"
	if (s2 == NULL) {
#line 184 "../lib/window-monitor.vala"
		return FALSE;
#line 566 "window-monitor.c"
	}
#line 184 "../lib/window-monitor.vala"
	if (s1->file != s2->file) {
#line 184 "../lib/window-monitor.vala"
		return FALSE;
#line 572 "window-monitor.c"
	}
#line 184 "../lib/window-monitor.vala"
	if (s1->other_file != s2->other_file) {
#line 184 "../lib/window-monitor.vala"
		return FALSE;
#line 578 "window-monitor.c"
	}
#line 184 "../lib/window-monitor.vala"
	if (s1->event != s2->event) {
#line 184 "../lib/window-monitor.vala"
		return FALSE;
#line 584 "window-monitor.c"
	}
#line 184 "../lib/window-monitor.vala"
	return TRUE;
#line 588 "window-monitor.c"
}

static void
_vala_array_add6 (XnpWindowMonitorFileEvent* * array,
                  gint* length,
                  gint* size,
                  const XnpWindowMonitorFileEvent* value)
{
#line 185 "../lib/window-monitor.vala"
	if ((*length) == (*size)) {
#line 185 "../lib/window-monitor.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 185 "../lib/window-monitor.vala"
		*array = g_renew (XnpWindowMonitorFileEvent, *array, *size);
#line 603 "window-monitor.c"
	}
#line 185 "../lib/window-monitor.vala"
	(*array)[(*length)++] = *value;
#line 607 "window-monitor.c"
}

static XnpWindowMonitorFileEvent*
_vala_array_dup1 (XnpWindowMonitorFileEvent* self,
                  gssize length)
{
#line 187 "../lib/window-monitor.vala"
	if (length > 0) {
#line 616 "window-monitor.c"
		XnpWindowMonitorFileEvent* result;
		gssize i;
#line 187 "../lib/window-monitor.vala"
		result = g_new0 (XnpWindowMonitorFileEvent, length);
#line 187 "../lib/window-monitor.vala"
		for (i = 0; i < length; i++) {
#line 623 "window-monitor.c"
			XnpWindowMonitorFileEvent _tmp0_;
			XnpWindowMonitorFileEvent _tmp1_ = {0};
#line 187 "../lib/window-monitor.vala"
			_tmp0_ = self[i];
#line 187 "../lib/window-monitor.vala"
			xnp_window_monitor_file_event_copy (&_tmp0_, &_tmp1_);
#line 187 "../lib/window-monitor.vala"
			result[i] = _tmp1_;
#line 632 "window-monitor.c"
		}
#line 187 "../lib/window-monitor.vala"
		return result;
#line 636 "window-monitor.c"
	}
#line 187 "../lib/window-monitor.vala"
	return NULL;
#line 640 "window-monitor.c"
}

static void
xnp_window_monitor_optimize_events (XnpWindowMonitor* self)
{
	XnpWindowMonitorFileEvent* new_events = NULL;
	XnpWindowMonitorFileEvent* _tmp9_;
	gint new_events_length1;
	gint _new_events_size_;
	XnpWindowMonitorFileEvent* _tmp10_;
	gint _tmp10__length1;
	XnpWindowMonitorFileEvent* _tmp18_;
	gint _tmp18__length1;
	XnpWindowMonitorFileEvent* _tmp19_;
	gint _tmp19__length1;
#line 157 "../lib/window-monitor.vala"
	g_return_if_fail (self != NULL);
#line 658 "window-monitor.c"
	{
		gint i = 0;
#line 158 "../lib/window-monitor.vala"
		i = 0;
#line 663 "window-monitor.c"
		{
			gboolean _tmp0_ = FALSE;
#line 158 "../lib/window-monitor.vala"
			_tmp0_ = TRUE;
#line 158 "../lib/window-monitor.vala"
			while (TRUE) {
#line 670 "window-monitor.c"
				XnpWindowMonitorFileEvent* _tmp2_;
				gint _tmp2__length1;
				XnpWindowMonitorFileEvent* _tmp3_;
				gint _tmp3__length1;
				XnpWindowMonitorFileEvent _tmp4_;
#line 158 "../lib/window-monitor.vala"
				if (!_tmp0_) {
#line 678 "window-monitor.c"
					gint _tmp1_;
#line 158 "../lib/window-monitor.vala"
					_tmp1_ = i;
#line 158 "../lib/window-monitor.vala"
					i = _tmp1_ + 1;
#line 684 "window-monitor.c"
				}
#line 158 "../lib/window-monitor.vala"
				_tmp0_ = FALSE;
#line 158 "../lib/window-monitor.vala"
				_tmp2_ = self->priv->events;
#line 158 "../lib/window-monitor.vala"
				_tmp2__length1 = self->priv->events_length1;
#line 158 "../lib/window-monitor.vala"
				if (!(i < _tmp2__length1)) {
#line 158 "../lib/window-monitor.vala"
					break;
#line 696 "window-monitor.c"
				}
#line 159 "../lib/window-monitor.vala"
				_tmp3_ = self->priv->events;
#line 159 "../lib/window-monitor.vala"
				_tmp3__length1 = self->priv->events_length1;
#line 159 "../lib/window-monitor.vala"
				_tmp4_ = _tmp3_[i];
#line 159 "../lib/window-monitor.vala"
				switch (_tmp4_.event) {
#line 159 "../lib/window-monitor.vala"
					case XNP_WINDOW_MONITOR_CREATED:
#line 159 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_MOVED_IN:
#line 159 "../lib/window-monitor.vala"
					case XNP_WINDOW_MONITOR_CHANGES_DONE_HINT:
#line 712 "window-monitor.c"
					{
#line 163 "../lib/window-monitor.vala"
						xnp_window_monitor_optimize_event_created (self, i);
#line 164 "../lib/window-monitor.vala"
						break;
#line 718 "window-monitor.c"
					}
#line 159 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_DELETED:
#line 159 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_MOVED_OUT:
#line 724 "window-monitor.c"
					{
#line 168 "../lib/window-monitor.vala"
						xnp_window_monitor_optimize_event_deleted (self, i);
#line 169 "../lib/window-monitor.vala"
						break;
#line 730 "window-monitor.c"
					}
#line 159 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_RENAMED:
#line 734 "window-monitor.c"
					{
#line 172 "../lib/window-monitor.vala"
						xnp_window_monitor_optimize_event_renamed (self, i);
#line 173 "../lib/window-monitor.vala"
						break;
#line 740 "window-monitor.c"
					}
					default:
					{
						XnpWindowMonitorFileEvent* _tmp5_;
						gint _tmp5__length1;
						XnpWindowMonitorFileEvent _tmp6_;
						XnpWindowMonitorFileEvent _tmp7_;
						XnpWindowMonitorFileEvent _tmp8_ = {0};
#line 176 "../lib/window-monitor.vala"
						_tmp5_ = self->priv->events;
#line 176 "../lib/window-monitor.vala"
						_tmp5__length1 = self->priv->events_length1;
#line 176 "../lib/window-monitor.vala"
						_tmp6_ = self->priv->dummy;
#line 176 "../lib/window-monitor.vala"
						_tmp7_ = _tmp6_;
#line 176 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_copy (&_tmp7_, &_tmp8_);
#line 176 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_destroy (&_tmp5_[i]);
#line 176 "../lib/window-monitor.vala"
						_tmp5_[i] = _tmp8_;
#line 177 "../lib/window-monitor.vala"
						break;
#line 765 "window-monitor.c"
					}
				}
			}
		}
	}
#line 182 "../lib/window-monitor.vala"
	_tmp9_ = g_new0 (XnpWindowMonitorFileEvent, 0);
#line 182 "../lib/window-monitor.vala"
	new_events = _tmp9_;
#line 182 "../lib/window-monitor.vala"
	new_events_length1 = 0;
#line 182 "../lib/window-monitor.vala"
	_new_events_size_ = new_events_length1;
#line 183 "../lib/window-monitor.vala"
	_tmp10_ = self->priv->events;
#line 183 "../lib/window-monitor.vala"
	_tmp10__length1 = self->priv->events_length1;
#line 783 "window-monitor.c"
	{
		XnpWindowMonitorFileEvent* ev_collection = NULL;
		gint ev_collection_length1 = 0;
		gint _ev_collection_size_ = 0;
		gint ev_it = 0;
#line 183 "../lib/window-monitor.vala"
		ev_collection = _tmp10_;
#line 183 "../lib/window-monitor.vala"
		ev_collection_length1 = _tmp10__length1;
#line 183 "../lib/window-monitor.vala"
		for (ev_it = 0; ev_it < ev_collection_length1; ev_it = ev_it + 1) {
#line 795 "window-monitor.c"
			XnpWindowMonitorFileEvent _tmp11_;
			XnpWindowMonitorFileEvent _tmp12_ = {0};
			XnpWindowMonitorFileEvent ev = {0};
#line 183 "../lib/window-monitor.vala"
			_tmp11_ = ev_collection[ev_it];
#line 183 "../lib/window-monitor.vala"
			xnp_window_monitor_file_event_copy (&_tmp11_, &_tmp12_);
#line 183 "../lib/window-monitor.vala"
			ev = _tmp12_;
#line 805 "window-monitor.c"
			{
				XnpWindowMonitorFileEvent _tmp13_;
				XnpWindowMonitorFileEvent _tmp14_;
#line 184 "../lib/window-monitor.vala"
				_tmp13_ = ev;
#line 184 "../lib/window-monitor.vala"
				_tmp14_ = self->priv->dummy;
#line 184 "../lib/window-monitor.vala"
				if (_xnp_window_monitor_file_event_equal (&_tmp13_, &_tmp14_) != TRUE) {
#line 815 "window-monitor.c"
					XnpWindowMonitorFileEvent _tmp15_;
					XnpWindowMonitorFileEvent _tmp16_;
					XnpWindowMonitorFileEvent _tmp17_ = {0};
#line 185 "../lib/window-monitor.vala"
					_tmp15_ = ev;
#line 185 "../lib/window-monitor.vala"
					_tmp16_ = _tmp15_;
#line 185 "../lib/window-monitor.vala"
					xnp_window_monitor_file_event_copy (&_tmp16_, &_tmp17_);
#line 185 "../lib/window-monitor.vala"
					_vala_array_add6 (&new_events, &new_events_length1, &_new_events_size_, &_tmp17_);
#line 827 "window-monitor.c"
				}
#line 183 "../lib/window-monitor.vala"
				xnp_window_monitor_file_event_destroy (&ev);
#line 831 "window-monitor.c"
			}
		}
	}
#line 187 "../lib/window-monitor.vala"
	_tmp18_ = new_events;
#line 187 "../lib/window-monitor.vala"
	_tmp18__length1 = new_events_length1;
#line 187 "../lib/window-monitor.vala"
	_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup1 (_tmp18_, _tmp18__length1) : _tmp18_;
#line 187 "../lib/window-monitor.vala"
	_tmp19__length1 = _tmp18__length1;
#line 187 "../lib/window-monitor.vala"
	self->priv->events = (_vala_XnpWindowMonitorFileEvent_array_free (self->priv->events, self->priv->events_length1), NULL);
#line 187 "../lib/window-monitor.vala"
	self->priv->events = _tmp19_;
#line 187 "../lib/window-monitor.vala"
	self->priv->events_length1 = _tmp19__length1;
#line 187 "../lib/window-monitor.vala"
	self->priv->_events_size_ = self->priv->events_length1;
#line 157 "../lib/window-monitor.vala"
	new_events = (_vala_XnpWindowMonitorFileEvent_array_free (new_events, new_events_length1), NULL);
#line 853 "window-monitor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 192 "../lib/window-monitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 861 "window-monitor.c"
}

static void
xnp_window_monitor_optimize_event_created (XnpWindowMonitor* self,
                                           gint n)
{
	GFile* file = NULL;
	XnpWindowMonitorFileEvent* _tmp0_;
	gint _tmp0__length1;
	XnpWindowMonitorFileEvent _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFileMonitorEvent _tmp4_ = 0;
	GFile* _tmp5_;
	gboolean _tmp6_ = FALSE;
	XnpWindowMonitorFileEvent* _tmp7_;
	gint _tmp7__length1;
#line 191 "../lib/window-monitor.vala"
	g_return_if_fail (self != NULL);
#line 192 "../lib/window-monitor.vala"
	_tmp0_ = self->priv->events;
#line 192 "../lib/window-monitor.vala"
	_tmp0__length1 = self->priv->events_length1;
#line 192 "../lib/window-monitor.vala"
	_tmp1_ = _tmp0_[n];
#line 192 "../lib/window-monitor.vala"
	_tmp2_ = _tmp1_.file;
#line 192 "../lib/window-monitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 192 "../lib/window-monitor.vala"
	file = _tmp3_;
#line 194 "../lib/window-monitor.vala"
	_tmp5_ = file;
#line 194 "../lib/window-monitor.vala"
	g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL], 0, _tmp5_, &_tmp6_);
#line 194 "../lib/window-monitor.vala"
	if (_tmp6_) {
#line 194 "../lib/window-monitor.vala"
		_tmp4_ = XNP_WINDOW_MONITOR_CHANGES_DONE_HINT;
#line 901 "window-monitor.c"
	} else {
#line 194 "../lib/window-monitor.vala"
		_tmp4_ = XNP_WINDOW_MONITOR_CREATED;
#line 905 "window-monitor.c"
	}
#line 194 "../lib/window-monitor.vala"
	_tmp7_ = self->priv->events;
#line 194 "../lib/window-monitor.vala"
	_tmp7__length1 = self->priv->events_length1;
#line 194 "../lib/window-monitor.vala"
	_tmp7_[n].event = _tmp4_;
#line 913 "window-monitor.c"
	{
		gint i = 0;
#line 196 "../lib/window-monitor.vala"
		i = n + 1;
#line 918 "window-monitor.c"
		{
			gboolean _tmp8_ = FALSE;
#line 196 "../lib/window-monitor.vala"
			_tmp8_ = TRUE;
#line 196 "../lib/window-monitor.vala"
			while (TRUE) {
#line 925 "window-monitor.c"
				XnpWindowMonitorFileEvent* _tmp10_;
				gint _tmp10__length1;
				GFile* _tmp11_;
				XnpWindowMonitorFileEvent* _tmp12_;
				gint _tmp12__length1;
				XnpWindowMonitorFileEvent _tmp13_;
				GFile* _tmp14_;
				XnpWindowMonitorFileEvent* _tmp15_;
				gint _tmp15__length1;
				XnpWindowMonitorFileEvent _tmp16_;
#line 196 "../lib/window-monitor.vala"
				if (!_tmp8_) {
#line 938 "window-monitor.c"
					gint _tmp9_;
#line 196 "../lib/window-monitor.vala"
					_tmp9_ = i;
#line 196 "../lib/window-monitor.vala"
					i = _tmp9_ + 1;
#line 944 "window-monitor.c"
				}
#line 196 "../lib/window-monitor.vala"
				_tmp8_ = FALSE;
#line 196 "../lib/window-monitor.vala"
				_tmp10_ = self->priv->events;
#line 196 "../lib/window-monitor.vala"
				_tmp10__length1 = self->priv->events_length1;
#line 196 "../lib/window-monitor.vala"
				if (!(i < _tmp10__length1)) {
#line 196 "../lib/window-monitor.vala"
					break;
#line 956 "window-monitor.c"
				}
#line 197 "../lib/window-monitor.vala"
				_tmp11_ = file;
#line 197 "../lib/window-monitor.vala"
				_tmp12_ = self->priv->events;
#line 197 "../lib/window-monitor.vala"
				_tmp12__length1 = self->priv->events_length1;
#line 197 "../lib/window-monitor.vala"
				_tmp13_ = _tmp12_[i];
#line 197 "../lib/window-monitor.vala"
				_tmp14_ = _tmp13_.file;
#line 197 "../lib/window-monitor.vala"
				if (!g_file_equal (_tmp11_, _tmp14_)) {
#line 197 "../lib/window-monitor.vala"
					continue;
#line 972 "window-monitor.c"
				}
#line 198 "../lib/window-monitor.vala"
				_tmp15_ = self->priv->events;
#line 198 "../lib/window-monitor.vala"
				_tmp15__length1 = self->priv->events_length1;
#line 198 "../lib/window-monitor.vala"
				_tmp16_ = _tmp15_[i];
#line 198 "../lib/window-monitor.vala"
				switch (_tmp16_.event) {
#line 198 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_DELETED:
#line 198 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_MOVED_OUT:
#line 986 "window-monitor.c"
					{
						XnpWindowMonitorFileEvent* _tmp17_;
						gint _tmp17__length1;
						XnpWindowMonitorFileEvent _tmp18_;
						XnpWindowMonitorFileEvent* _tmp23_;
						gint _tmp23__length1;
						XnpWindowMonitorFileEvent _tmp24_;
						XnpWindowMonitorFileEvent _tmp25_;
						XnpWindowMonitorFileEvent _tmp26_ = {0};
#line 203 "../lib/window-monitor.vala"
						_tmp17_ = self->priv->events;
#line 203 "../lib/window-monitor.vala"
						_tmp17__length1 = self->priv->events_length1;
#line 203 "../lib/window-monitor.vala"
						_tmp18_ = _tmp17_[n];
#line 203 "../lib/window-monitor.vala"
						if (_tmp18_.event == XNP_WINDOW_MONITOR_CREATED) {
#line 1004 "window-monitor.c"
							XnpWindowMonitorFileEvent* _tmp19_;
							gint _tmp19__length1;
							XnpWindowMonitorFileEvent _tmp20_;
							XnpWindowMonitorFileEvent _tmp21_;
							XnpWindowMonitorFileEvent _tmp22_ = {0};
#line 203 "../lib/window-monitor.vala"
							_tmp19_ = self->priv->events;
#line 203 "../lib/window-monitor.vala"
							_tmp19__length1 = self->priv->events_length1;
#line 203 "../lib/window-monitor.vala"
							_tmp20_ = self->priv->dummy;
#line 203 "../lib/window-monitor.vala"
							_tmp21_ = _tmp20_;
#line 203 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_copy (&_tmp21_, &_tmp22_);
#line 203 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_destroy (&_tmp19_[i]);
#line 203 "../lib/window-monitor.vala"
							_tmp19_[i] = _tmp22_;
#line 1024 "window-monitor.c"
						}
#line 204 "../lib/window-monitor.vala"
						_tmp23_ = self->priv->events;
#line 204 "../lib/window-monitor.vala"
						_tmp23__length1 = self->priv->events_length1;
#line 204 "../lib/window-monitor.vala"
						_tmp24_ = self->priv->dummy;
#line 204 "../lib/window-monitor.vala"
						_tmp25_ = _tmp24_;
#line 204 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_copy (&_tmp25_, &_tmp26_);
#line 204 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_destroy (&_tmp23_[n]);
#line 204 "../lib/window-monitor.vala"
						_tmp23_[n] = _tmp26_;
#line 205 "../lib/window-monitor.vala"
						_g_object_unref0 (file);
#line 205 "../lib/window-monitor.vala"
						return;
#line 1044 "window-monitor.c"
					}
#line 198 "../lib/window-monitor.vala"
					case XNP_WINDOW_MONITOR_CHANGES_DONE_HINT:
#line 1048 "window-monitor.c"
					{
						XnpWindowMonitorFileEvent* _tmp27_;
						gint _tmp27__length1;
						XnpWindowMonitorFileEvent* _tmp28_;
						gint _tmp28__length1;
						XnpWindowMonitorFileEvent _tmp29_;
						XnpWindowMonitorFileEvent _tmp30_;
						XnpWindowMonitorFileEvent _tmp31_ = {0};
						XnpWindowMonitorFileEvent* _tmp32_;
						gint _tmp32__length1;
						XnpWindowMonitorFileEvent _tmp33_;
						XnpWindowMonitorFileEvent _tmp34_;
						XnpWindowMonitorFileEvent _tmp35_ = {0};
#line 210 "../lib/window-monitor.vala"
						_tmp27_ = self->priv->events;
#line 210 "../lib/window-monitor.vala"
						_tmp27__length1 = self->priv->events_length1;
#line 210 "../lib/window-monitor.vala"
						_tmp28_ = self->priv->events;
#line 210 "../lib/window-monitor.vala"
						_tmp28__length1 = self->priv->events_length1;
#line 210 "../lib/window-monitor.vala"
						_tmp29_ = _tmp28_[n];
#line 210 "../lib/window-monitor.vala"
						_tmp30_ = _tmp29_;
#line 210 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_copy (&_tmp30_, &_tmp31_);
#line 210 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_destroy (&_tmp27_[i]);
#line 210 "../lib/window-monitor.vala"
						_tmp27_[i] = _tmp31_;
#line 211 "../lib/window-monitor.vala"
						_tmp32_ = self->priv->events;
#line 211 "../lib/window-monitor.vala"
						_tmp32__length1 = self->priv->events_length1;
#line 211 "../lib/window-monitor.vala"
						_tmp33_ = self->priv->dummy;
#line 211 "../lib/window-monitor.vala"
						_tmp34_ = _tmp33_;
#line 211 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_copy (&_tmp34_, &_tmp35_);
#line 211 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_destroy (&_tmp32_[n]);
#line 211 "../lib/window-monitor.vala"
						_tmp32_[n] = _tmp35_;
#line 212 "../lib/window-monitor.vala"
						n = i;
#line 213 "../lib/window-monitor.vala"
						break;
#line 1098 "window-monitor.c"
					}
#line 198 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_RENAMED:
#line 1102 "window-monitor.c"
					{
						GFile* other_file = NULL;
						XnpWindowMonitorFileEvent* _tmp36_;
						gint _tmp36__length1;
						XnpWindowMonitorFileEvent _tmp37_;
						GFile* _tmp38_;
						GFile* _tmp39_;
						XnpWindowMonitorFileEvent* _tmp40_;
						gint _tmp40__length1;
						XnpWindowMonitorFileEvent _tmp41_;
						XnpWindowMonitorFileEvent* _tmp56_;
						gint _tmp56__length1;
						GFile* _tmp57_;
						GFile* _tmp58_;
						XnpWindowMonitorFileEvent* _tmp59_;
						gint _tmp59__length1;
#line 220 "../lib/window-monitor.vala"
						_tmp36_ = self->priv->events;
#line 220 "../lib/window-monitor.vala"
						_tmp36__length1 = self->priv->events_length1;
#line 220 "../lib/window-monitor.vala"
						_tmp37_ = _tmp36_[i];
#line 220 "../lib/window-monitor.vala"
						_tmp38_ = _tmp37_.other_file;
#line 220 "../lib/window-monitor.vala"
						_tmp39_ = _g_object_ref0 (_tmp38_);
#line 220 "../lib/window-monitor.vala"
						other_file = _tmp39_;
#line 221 "../lib/window-monitor.vala"
						_tmp40_ = self->priv->events;
#line 221 "../lib/window-monitor.vala"
						_tmp40__length1 = self->priv->events_length1;
#line 221 "../lib/window-monitor.vala"
						_tmp41_ = _tmp40_[n];
#line 221 "../lib/window-monitor.vala"
						if (_tmp41_.event == XNP_WINDOW_MONITOR_CREATED) {
#line 1139 "window-monitor.c"
							XnpWindowMonitorFileEvent* _tmp42_;
							gint _tmp42__length1;
							XnpWindowMonitorFileEvent _tmp43_;
							XnpWindowMonitorFileEvent _tmp44_;
							XnpWindowMonitorFileEvent _tmp45_ = {0};
							GFileMonitorEvent _tmp46_ = 0;
							GFile* _tmp47_;
							gboolean _tmp48_ = FALSE;
							XnpWindowMonitorFileEvent* _tmp49_;
							gint _tmp49__length1;
#line 222 "../lib/window-monitor.vala"
							_tmp42_ = self->priv->events;
#line 222 "../lib/window-monitor.vala"
							_tmp42__length1 = self->priv->events_length1;
#line 222 "../lib/window-monitor.vala"
							_tmp43_ = self->priv->dummy;
#line 222 "../lib/window-monitor.vala"
							_tmp44_ = _tmp43_;
#line 222 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_copy (&_tmp44_, &_tmp45_);
#line 222 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_destroy (&_tmp42_[n]);
#line 222 "../lib/window-monitor.vala"
							_tmp42_[n] = _tmp45_;
#line 223 "../lib/window-monitor.vala"
							_tmp47_ = other_file;
#line 223 "../lib/window-monitor.vala"
							g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL], 0, _tmp47_, &_tmp48_);
#line 223 "../lib/window-monitor.vala"
							if (_tmp48_) {
#line 223 "../lib/window-monitor.vala"
								_tmp46_ = XNP_WINDOW_MONITOR_CHANGES_DONE_HINT;
#line 1172 "window-monitor.c"
							} else {
#line 223 "../lib/window-monitor.vala"
								_tmp46_ = XNP_WINDOW_MONITOR_CREATED;
#line 1176 "window-monitor.c"
							}
#line 223 "../lib/window-monitor.vala"
							_tmp49_ = self->priv->events;
#line 223 "../lib/window-monitor.vala"
							_tmp49__length1 = self->priv->events_length1;
#line 223 "../lib/window-monitor.vala"
							_tmp49_[i].event = _tmp46_;
#line 1184 "window-monitor.c"
						} else {
							XnpWindowMonitorFileEvent* _tmp50_;
							gint _tmp50__length1;
							XnpWindowMonitorFileEvent* _tmp51_;
							gint _tmp51__length1;
							XnpWindowMonitorFileEvent _tmp52_;
							XnpWindowMonitorFileEvent _tmp53_;
							XnpWindowMonitorFileEvent _tmp54_ = {0};
							XnpWindowMonitorFileEvent* _tmp55_;
							gint _tmp55__length1;
#line 225 "../lib/window-monitor.vala"
							_tmp50_ = self->priv->events;
#line 225 "../lib/window-monitor.vala"
							_tmp50__length1 = self->priv->events_length1;
#line 225 "../lib/window-monitor.vala"
							_tmp51_ = self->priv->events;
#line 225 "../lib/window-monitor.vala"
							_tmp51__length1 = self->priv->events_length1;
#line 225 "../lib/window-monitor.vala"
							_tmp52_ = _tmp51_[i];
#line 225 "../lib/window-monitor.vala"
							_tmp53_ = _tmp52_;
#line 225 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_copy (&_tmp53_, &_tmp54_);
#line 225 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_destroy (&_tmp50_[n]);
#line 225 "../lib/window-monitor.vala"
							_tmp50_[n] = _tmp54_;
#line 226 "../lib/window-monitor.vala"
							_tmp55_ = self->priv->events;
#line 226 "../lib/window-monitor.vala"
							_tmp55__length1 = self->priv->events_length1;
#line 226 "../lib/window-monitor.vala"
							_tmp55_[i].event = XNP_WINDOW_MONITOR_CHANGES_DONE_HINT;
#line 1219 "window-monitor.c"
						}
#line 228 "../lib/window-monitor.vala"
						_tmp56_ = self->priv->events;
#line 228 "../lib/window-monitor.vala"
						_tmp56__length1 = self->priv->events_length1;
#line 228 "../lib/window-monitor.vala"
						_tmp57_ = other_file;
#line 228 "../lib/window-monitor.vala"
						_tmp58_ = _g_object_ref0 (_tmp57_);
#line 228 "../lib/window-monitor.vala"
						_g_object_unref0 (_tmp56_[i].file);
#line 228 "../lib/window-monitor.vala"
						_tmp56_[i].file = _tmp58_;
#line 229 "../lib/window-monitor.vala"
						_tmp59_ = self->priv->events;
#line 229 "../lib/window-monitor.vala"
						_tmp59__length1 = self->priv->events_length1;
#line 229 "../lib/window-monitor.vala"
						_g_object_unref0 (_tmp59_[i].other_file);
#line 229 "../lib/window-monitor.vala"
						_tmp59_[i].other_file = NULL;
#line 230 "../lib/window-monitor.vala"
						_g_object_unref0 (other_file);
#line 230 "../lib/window-monitor.vala"
						_g_object_unref0 (file);
#line 230 "../lib/window-monitor.vala"
						return;
#line 1247 "window-monitor.c"
					}
					default:
					{
#line 233 "../lib/window-monitor.vala"
						break;
#line 1253 "window-monitor.c"
					}
				}
			}
		}
	}
#line 191 "../lib/window-monitor.vala"
	_g_object_unref0 (file);
#line 1261 "window-monitor.c"
}

static void
xnp_window_monitor_optimize_event_deleted (XnpWindowMonitor* self,
                                           gint n)
{
	GFile* file = NULL;
	XnpWindowMonitorFileEvent* _tmp0_;
	gint _tmp0__length1;
	XnpWindowMonitorFileEvent _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 239 "../lib/window-monitor.vala"
	g_return_if_fail (self != NULL);
#line 240 "../lib/window-monitor.vala"
	_tmp0_ = self->priv->events;
#line 240 "../lib/window-monitor.vala"
	_tmp0__length1 = self->priv->events_length1;
#line 240 "../lib/window-monitor.vala"
	_tmp1_ = _tmp0_[n];
#line 240 "../lib/window-monitor.vala"
	_tmp2_ = _tmp1_.file;
#line 240 "../lib/window-monitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 240 "../lib/window-monitor.vala"
	file = _tmp3_;
#line 242 "../lib/window-monitor.vala"
	_tmp4_ = file;
#line 242 "../lib/window-monitor.vala"
	g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL], 0, _tmp4_, &_tmp5_);
#line 242 "../lib/window-monitor.vala"
	if (!_tmp5_) {
#line 242 "../lib/window-monitor.vala"
		_g_object_unref0 (file);
#line 242 "../lib/window-monitor.vala"
		return;
#line 1300 "window-monitor.c"
	}
	{
		gint i = 0;
#line 244 "../lib/window-monitor.vala"
		i = n + 1;
#line 1306 "window-monitor.c"
		{
			gboolean _tmp6_ = FALSE;
#line 244 "../lib/window-monitor.vala"
			_tmp6_ = TRUE;
#line 244 "../lib/window-monitor.vala"
			while (TRUE) {
#line 1313 "window-monitor.c"
				XnpWindowMonitorFileEvent* _tmp8_;
				gint _tmp8__length1;
				gboolean file_equal = FALSE;
				GFile* _tmp9_;
				XnpWindowMonitorFileEvent* _tmp10_;
				gint _tmp10__length1;
				XnpWindowMonitorFileEvent _tmp11_;
				GFile* _tmp12_;
				GFile* other_file = NULL;
				XnpWindowMonitorFileEvent* _tmp13_;
				gint _tmp13__length1;
				XnpWindowMonitorFileEvent _tmp14_;
				GFile* _tmp15_;
				GFile* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GFile* _tmp18_;
				gboolean other_file_equal = FALSE;
				gboolean _tmp21_ = FALSE;
				XnpWindowMonitorFileEvent* _tmp22_;
				gint _tmp22__length1;
				XnpWindowMonitorFileEvent _tmp23_;
#line 244 "../lib/window-monitor.vala"
				if (!_tmp6_) {
#line 1337 "window-monitor.c"
					gint _tmp7_;
#line 244 "../lib/window-monitor.vala"
					_tmp7_ = i;
#line 244 "../lib/window-monitor.vala"
					i = _tmp7_ + 1;
#line 1343 "window-monitor.c"
				}
#line 244 "../lib/window-monitor.vala"
				_tmp6_ = FALSE;
#line 244 "../lib/window-monitor.vala"
				_tmp8_ = self->priv->events;
#line 244 "../lib/window-monitor.vala"
				_tmp8__length1 = self->priv->events_length1;
#line 244 "../lib/window-monitor.vala"
				if (!(i < _tmp8__length1)) {
#line 244 "../lib/window-monitor.vala"
					break;
#line 1355 "window-monitor.c"
				}
#line 245 "../lib/window-monitor.vala"
				_tmp9_ = file;
#line 245 "../lib/window-monitor.vala"
				_tmp10_ = self->priv->events;
#line 245 "../lib/window-monitor.vala"
				_tmp10__length1 = self->priv->events_length1;
#line 245 "../lib/window-monitor.vala"
				_tmp11_ = _tmp10_[i];
#line 245 "../lib/window-monitor.vala"
				_tmp12_ = _tmp11_.file;
#line 245 "../lib/window-monitor.vala"
				file_equal = g_file_equal (_tmp9_, _tmp12_);
#line 246 "../lib/window-monitor.vala"
				_tmp13_ = self->priv->events;
#line 246 "../lib/window-monitor.vala"
				_tmp13__length1 = self->priv->events_length1;
#line 246 "../lib/window-monitor.vala"
				_tmp14_ = _tmp13_[i];
#line 246 "../lib/window-monitor.vala"
				_tmp15_ = _tmp14_.other_file;
#line 246 "../lib/window-monitor.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 246 "../lib/window-monitor.vala"
				other_file = _tmp16_;
#line 247 "../lib/window-monitor.vala"
				_tmp18_ = other_file;
#line 247 "../lib/window-monitor.vala"
				if (_tmp18_ != NULL) {
#line 1385 "window-monitor.c"
					GFile* _tmp19_;
					GFile* _tmp20_;
#line 247 "../lib/window-monitor.vala"
					_tmp19_ = file;
#line 247 "../lib/window-monitor.vala"
					_tmp20_ = other_file;
#line 247 "../lib/window-monitor.vala"
					_tmp17_ = g_file_equal (_tmp19_, _tmp20_);
#line 1394 "window-monitor.c"
				} else {
#line 247 "../lib/window-monitor.vala"
					_tmp17_ = FALSE;
#line 1398 "window-monitor.c"
				}
#line 247 "../lib/window-monitor.vala"
				other_file_equal = _tmp17_;
#line 248 "../lib/window-monitor.vala"
				if (!file_equal) {
#line 248 "../lib/window-monitor.vala"
					_tmp21_ = !other_file_equal;
#line 1406 "window-monitor.c"
				} else {
#line 248 "../lib/window-monitor.vala"
					_tmp21_ = FALSE;
#line 1410 "window-monitor.c"
				}
#line 248 "../lib/window-monitor.vala"
				if (_tmp21_) {
#line 249 "../lib/window-monitor.vala"
					_g_object_unref0 (other_file);
#line 249 "../lib/window-monitor.vala"
					continue;
#line 1418 "window-monitor.c"
				}
#line 250 "../lib/window-monitor.vala"
				_tmp22_ = self->priv->events;
#line 250 "../lib/window-monitor.vala"
				_tmp22__length1 = self->priv->events_length1;
#line 250 "../lib/window-monitor.vala"
				_tmp23_ = _tmp22_[i];
#line 250 "../lib/window-monitor.vala"
				switch (_tmp23_.event) {
#line 250 "../lib/window-monitor.vala"
					case XNP_WINDOW_MONITOR_CREATED:
#line 250 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_MOVED_IN:
#line 1432 "window-monitor.c"
					{
						XnpWindowMonitorFileEvent* _tmp24_;
						gint _tmp24__length1;
						XnpWindowMonitorFileEvent _tmp25_;
						XnpWindowMonitorFileEvent _tmp26_;
						XnpWindowMonitorFileEvent _tmp27_ = {0};
						XnpWindowMonitorFileEvent* _tmp28_;
						gint _tmp28__length1;
#line 254 "../lib/window-monitor.vala"
						_tmp24_ = self->priv->events;
#line 254 "../lib/window-monitor.vala"
						_tmp24__length1 = self->priv->events_length1;
#line 254 "../lib/window-monitor.vala"
						_tmp25_ = self->priv->dummy;
#line 254 "../lib/window-monitor.vala"
						_tmp26_ = _tmp25_;
#line 254 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_copy (&_tmp26_, &_tmp27_);
#line 254 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_destroy (&_tmp24_[n]);
#line 254 "../lib/window-monitor.vala"
						_tmp24_[n] = _tmp27_;
#line 255 "../lib/window-monitor.vala"
						_tmp28_ = self->priv->events;
#line 255 "../lib/window-monitor.vala"
						_tmp28__length1 = self->priv->events_length1;
#line 255 "../lib/window-monitor.vala"
						_tmp28_[i].event = XNP_WINDOW_MONITOR_CHANGES_DONE_HINT;
#line 256 "../lib/window-monitor.vala"
						_g_object_unref0 (other_file);
#line 256 "../lib/window-monitor.vala"
						_g_object_unref0 (file);
#line 256 "../lib/window-monitor.vala"
						return;
#line 1467 "window-monitor.c"
					}
#line 250 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_RENAMED:
#line 1471 "window-monitor.c"
					{
						XnpWindowMonitorFileEvent* _tmp29_;
						gint _tmp29__length1;
						XnpWindowMonitorFileEvent _tmp30_;
						XnpWindowMonitorFileEvent _tmp31_;
						XnpWindowMonitorFileEvent _tmp32_ = {0};
						XnpWindowMonitorFileEvent* _tmp33_;
						gint _tmp33__length1;
						XnpWindowMonitorFileEvent* _tmp34_;
						gint _tmp34__length1;
						GFile* _tmp35_;
						GFile* _tmp36_;
						XnpWindowMonitorFileEvent* _tmp37_;
						gint _tmp37__length1;
#line 260 "../lib/window-monitor.vala"
						_tmp29_ = self->priv->events;
#line 260 "../lib/window-monitor.vala"
						_tmp29__length1 = self->priv->events_length1;
#line 260 "../lib/window-monitor.vala"
						_tmp30_ = self->priv->dummy;
#line 260 "../lib/window-monitor.vala"
						_tmp31_ = _tmp30_;
#line 260 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_copy (&_tmp31_, &_tmp32_);
#line 260 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_destroy (&_tmp29_[n]);
#line 260 "../lib/window-monitor.vala"
						_tmp29_[n] = _tmp32_;
#line 261 "../lib/window-monitor.vala"
						_tmp33_ = self->priv->events;
#line 261 "../lib/window-monitor.vala"
						_tmp33__length1 = self->priv->events_length1;
#line 261 "../lib/window-monitor.vala"
						_tmp33_[i].event = XNP_WINDOW_MONITOR_CHANGES_DONE_HINT;
#line 262 "../lib/window-monitor.vala"
						_tmp34_ = self->priv->events;
#line 262 "../lib/window-monitor.vala"
						_tmp34__length1 = self->priv->events_length1;
#line 262 "../lib/window-monitor.vala"
						_tmp35_ = file;
#line 262 "../lib/window-monitor.vala"
						_tmp36_ = _g_object_ref0 (_tmp35_);
#line 262 "../lib/window-monitor.vala"
						_g_object_unref0 (_tmp34_[i].file);
#line 262 "../lib/window-monitor.vala"
						_tmp34_[i].file = _tmp36_;
#line 263 "../lib/window-monitor.vala"
						_tmp37_ = self->priv->events;
#line 263 "../lib/window-monitor.vala"
						_tmp37__length1 = self->priv->events_length1;
#line 263 "../lib/window-monitor.vala"
						_g_object_unref0 (_tmp37_[i].other_file);
#line 263 "../lib/window-monitor.vala"
						_tmp37_[i].other_file = NULL;
#line 264 "../lib/window-monitor.vala"
						_g_object_unref0 (other_file);
#line 264 "../lib/window-monitor.vala"
						_g_object_unref0 (file);
#line 264 "../lib/window-monitor.vala"
						return;
#line 1532 "window-monitor.c"
					}
					default:
					{
#line 267 "../lib/window-monitor.vala"
						break;
#line 1538 "window-monitor.c"
					}
				}
#line 244 "../lib/window-monitor.vala"
				_g_object_unref0 (other_file);
#line 1543 "window-monitor.c"
			}
		}
	}
#line 239 "../lib/window-monitor.vala"
	_g_object_unref0 (file);
#line 1549 "window-monitor.c"
}

static void
_vala_array_add7 (XnpWindowMonitorFileEvent* * array,
                  gint* length,
                  gint* size,
                  const XnpWindowMonitorFileEvent* value)
{
#line 282 "../lib/window-monitor.vala"
	if ((*length) == (*size)) {
#line 282 "../lib/window-monitor.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 282 "../lib/window-monitor.vala"
		*array = g_renew (XnpWindowMonitorFileEvent, *array, *size);
#line 1564 "window-monitor.c"
	}
#line 282 "../lib/window-monitor.vala"
	(*array)[(*length)++] = *value;
#line 1568 "window-monitor.c"
}

static void
xnp_window_monitor_optimize_event_renamed (XnpWindowMonitor* self,
                                           gint n)
{
	GFile* file = NULL;
	XnpWindowMonitorFileEvent* _tmp0_;
	gint _tmp0__length1;
	XnpWindowMonitorFileEvent _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* other_file = NULL;
	XnpWindowMonitorFileEvent* _tmp4_;
	gint _tmp4__length1;
	XnpWindowMonitorFileEvent _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	gboolean _tmp9_ = FALSE;
#line 273 "../lib/window-monitor.vala"
	g_return_if_fail (self != NULL);
#line 274 "../lib/window-monitor.vala"
	_tmp0_ = self->priv->events;
#line 274 "../lib/window-monitor.vala"
	_tmp0__length1 = self->priv->events_length1;
#line 274 "../lib/window-monitor.vala"
	_tmp1_ = _tmp0_[n];
#line 274 "../lib/window-monitor.vala"
	_tmp2_ = _tmp1_.file;
#line 274 "../lib/window-monitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 274 "../lib/window-monitor.vala"
	file = _tmp3_;
#line 275 "../lib/window-monitor.vala"
	_tmp4_ = self->priv->events;
#line 275 "../lib/window-monitor.vala"
	_tmp4__length1 = self->priv->events_length1;
#line 275 "../lib/window-monitor.vala"
	_tmp5_ = _tmp4_[n];
#line 275 "../lib/window-monitor.vala"
	_tmp6_ = _tmp5_.other_file;
#line 275 "../lib/window-monitor.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 275 "../lib/window-monitor.vala"
	other_file = _tmp7_;
#line 279 "../lib/window-monitor.vala"
	_tmp8_ = other_file;
#line 279 "../lib/window-monitor.vala"
	g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL], 0, _tmp8_, &_tmp9_);
#line 279 "../lib/window-monitor.vala"
	if (_tmp9_) {
#line 1621 "window-monitor.c"
		GFile* _tmp10_;
		gboolean _tmp11_ = FALSE;
#line 280 "../lib/window-monitor.vala"
		_tmp10_ = file;
#line 280 "../lib/window-monitor.vala"
		g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL], 0, _tmp10_, &_tmp11_);
#line 280 "../lib/window-monitor.vala"
		if (_tmp11_) {
#line 1630 "window-monitor.c"
			XnpWindowMonitorFileEvent* _tmp12_;
			gint _tmp12__length1;
			GFile* _tmp13_;
			XnpWindowMonitorFileEvent _tmp14_ = {0};
#line 281 "../lib/window-monitor.vala"
			_tmp12_ = self->priv->events;
#line 281 "../lib/window-monitor.vala"
			_tmp12__length1 = self->priv->events_length1;
#line 281 "../lib/window-monitor.vala"
			_tmp12_[n].event = G_FILE_MONITOR_EVENT_DELETED;
#line 282 "../lib/window-monitor.vala"
			_tmp13_ = other_file;
#line 282 "../lib/window-monitor.vala"
			xnp_window_monitor_file_event_init (&_tmp14_, _tmp13_, NULL, XNP_WINDOW_MONITOR_CHANGES_DONE_HINT);
#line 282 "../lib/window-monitor.vala"
			_vala_array_add7 (&self->priv->events, &self->priv->events_length1, &self->priv->_events_size_, &_tmp14_);
#line 283 "../lib/window-monitor.vala"
			xnp_window_monitor_optimize_event_deleted (self, n);
#line 1649 "window-monitor.c"
		} else {
			XnpWindowMonitorFileEvent* _tmp15_;
			gint _tmp15__length1;
			XnpWindowMonitorFileEvent* _tmp16_;
			gint _tmp16__length1;
			GFile* _tmp17_;
			GFile* _tmp18_;
#line 285 "../lib/window-monitor.vala"
			_tmp15_ = self->priv->events;
#line 285 "../lib/window-monitor.vala"
			_tmp15__length1 = self->priv->events_length1;
#line 285 "../lib/window-monitor.vala"
			_tmp15_[n].event = XNP_WINDOW_MONITOR_CHANGES_DONE_HINT;
#line 286 "../lib/window-monitor.vala"
			_tmp16_ = self->priv->events;
#line 286 "../lib/window-monitor.vala"
			_tmp16__length1 = self->priv->events_length1;
#line 286 "../lib/window-monitor.vala"
			_tmp17_ = other_file;
#line 286 "../lib/window-monitor.vala"
			_tmp18_ = _g_object_ref0 (_tmp17_);
#line 286 "../lib/window-monitor.vala"
			_g_object_unref0 (_tmp16_[n].file);
#line 286 "../lib/window-monitor.vala"
			_tmp16_[n].file = _tmp18_;
#line 287 "../lib/window-monitor.vala"
			xnp_window_monitor_optimize_event_created (self, n);
#line 1677 "window-monitor.c"
		}
#line 289 "../lib/window-monitor.vala"
		_g_object_unref0 (other_file);
#line 289 "../lib/window-monitor.vala"
		_g_object_unref0 (file);
#line 289 "../lib/window-monitor.vala"
		return;
#line 1685 "window-monitor.c"
	}
	{
		gint i = 0;
#line 292 "../lib/window-monitor.vala"
		i = n + 1;
#line 1691 "window-monitor.c"
		{
			gboolean _tmp19_ = FALSE;
#line 292 "../lib/window-monitor.vala"
			_tmp19_ = TRUE;
#line 292 "../lib/window-monitor.vala"
			while (TRUE) {
#line 1698 "window-monitor.c"
				XnpWindowMonitorFileEvent* _tmp21_;
				gint _tmp21__length1;
				gboolean _tmp22_ = FALSE;
				GFile* _tmp23_;
				XnpWindowMonitorFileEvent* _tmp24_;
				gint _tmp24__length1;
				XnpWindowMonitorFileEvent _tmp25_;
				GFile* _tmp26_;
				XnpWindowMonitorFileEvent* _tmp31_;
				gint _tmp31__length1;
				XnpWindowMonitorFileEvent _tmp32_;
#line 292 "../lib/window-monitor.vala"
				if (!_tmp19_) {
#line 1712 "window-monitor.c"
					gint _tmp20_;
#line 292 "../lib/window-monitor.vala"
					_tmp20_ = i;
#line 292 "../lib/window-monitor.vala"
					i = _tmp20_ + 1;
#line 1718 "window-monitor.c"
				}
#line 292 "../lib/window-monitor.vala"
				_tmp19_ = FALSE;
#line 292 "../lib/window-monitor.vala"
				_tmp21_ = self->priv->events;
#line 292 "../lib/window-monitor.vala"
				_tmp21__length1 = self->priv->events_length1;
#line 292 "../lib/window-monitor.vala"
				if (!(i < _tmp21__length1)) {
#line 292 "../lib/window-monitor.vala"
					break;
#line 1730 "window-monitor.c"
				}
#line 293 "../lib/window-monitor.vala"
				_tmp23_ = file;
#line 293 "../lib/window-monitor.vala"
				_tmp24_ = self->priv->events;
#line 293 "../lib/window-monitor.vala"
				_tmp24__length1 = self->priv->events_length1;
#line 293 "../lib/window-monitor.vala"
				_tmp25_ = _tmp24_[i];
#line 293 "../lib/window-monitor.vala"
				_tmp26_ = _tmp25_.file;
#line 293 "../lib/window-monitor.vala"
				if (!g_file_equal (_tmp23_, _tmp26_)) {
#line 1744 "window-monitor.c"
					GFile* _tmp27_;
					XnpWindowMonitorFileEvent* _tmp28_;
					gint _tmp28__length1;
					XnpWindowMonitorFileEvent _tmp29_;
					GFile* _tmp30_;
#line 293 "../lib/window-monitor.vala"
					_tmp27_ = other_file;
#line 293 "../lib/window-monitor.vala"
					_tmp28_ = self->priv->events;
#line 293 "../lib/window-monitor.vala"
					_tmp28__length1 = self->priv->events_length1;
#line 293 "../lib/window-monitor.vala"
					_tmp29_ = _tmp28_[i];
#line 293 "../lib/window-monitor.vala"
					_tmp30_ = _tmp29_.file;
#line 293 "../lib/window-monitor.vala"
					_tmp22_ = !g_file_equal (_tmp27_, _tmp30_);
#line 1762 "window-monitor.c"
				} else {
#line 293 "../lib/window-monitor.vala"
					_tmp22_ = FALSE;
#line 1766 "window-monitor.c"
				}
#line 293 "../lib/window-monitor.vala"
				if (_tmp22_) {
#line 294 "../lib/window-monitor.vala"
					continue;
#line 1772 "window-monitor.c"
				}
#line 296 "../lib/window-monitor.vala"
				_tmp31_ = self->priv->events;
#line 296 "../lib/window-monitor.vala"
				_tmp31__length1 = self->priv->events_length1;
#line 296 "../lib/window-monitor.vala"
				_tmp32_ = _tmp31_[i];
#line 296 "../lib/window-monitor.vala"
				switch (_tmp32_.event) {
#line 296 "../lib/window-monitor.vala"
					case XNP_WINDOW_MONITOR_CREATED:
#line 296 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_MOVED_IN:
#line 1786 "window-monitor.c"
					{
						XnpWindowMonitorFileEvent* _tmp33_;
						gint _tmp33__length1;
						XnpWindowMonitorFileEvent* _tmp34_;
						gint _tmp34__length1;
						GFile* _tmp35_;
						GFile* _tmp36_;
						XnpWindowMonitorFileEvent* _tmp37_;
						gint _tmp37__length1;
						XnpWindowMonitorFileEvent* _tmp38_;
						gint _tmp38__length1;
#line 300 "../lib/window-monitor.vala"
						_tmp33_ = self->priv->events;
#line 300 "../lib/window-monitor.vala"
						_tmp33__length1 = self->priv->events_length1;
#line 300 "../lib/window-monitor.vala"
						_tmp33_[n].event = XNP_WINDOW_MONITOR_CREATED;
#line 301 "../lib/window-monitor.vala"
						_tmp34_ = self->priv->events;
#line 301 "../lib/window-monitor.vala"
						_tmp34__length1 = self->priv->events_length1;
#line 301 "../lib/window-monitor.vala"
						_tmp35_ = other_file;
#line 301 "../lib/window-monitor.vala"
						_tmp36_ = _g_object_ref0 (_tmp35_);
#line 301 "../lib/window-monitor.vala"
						_g_object_unref0 (_tmp34_[n].file);
#line 301 "../lib/window-monitor.vala"
						_tmp34_[n].file = _tmp36_;
#line 302 "../lib/window-monitor.vala"
						_tmp37_ = self->priv->events;
#line 302 "../lib/window-monitor.vala"
						_tmp37__length1 = self->priv->events_length1;
#line 302 "../lib/window-monitor.vala"
						_g_object_unref0 (_tmp37_[n].other_file);
#line 302 "../lib/window-monitor.vala"
						_tmp37_[n].other_file = NULL;
#line 303 "../lib/window-monitor.vala"
						_tmp38_ = self->priv->events;
#line 303 "../lib/window-monitor.vala"
						_tmp38__length1 = self->priv->events_length1;
#line 303 "../lib/window-monitor.vala"
						_tmp38_[i].event = XNP_WINDOW_MONITOR_CHANGES_DONE_HINT;
#line 304 "../lib/window-monitor.vala"
						xnp_window_monitor_optimize_event_created (self, n);
#line 305 "../lib/window-monitor.vala"
						_g_object_unref0 (other_file);
#line 305 "../lib/window-monitor.vala"
						_g_object_unref0 (file);
#line 305 "../lib/window-monitor.vala"
						return;
#line 1838 "window-monitor.c"
					}
#line 296 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_DELETED:
#line 296 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_MOVED_OUT:
#line 1844 "window-monitor.c"
					{
						XnpWindowMonitorFileEvent* _tmp39_;
						gint _tmp39__length1;
						XnpWindowMonitorFileEvent* _tmp40_;
						gint _tmp40__length1;
						XnpWindowMonitorFileEvent* _tmp41_;
						gint _tmp41__length1;
						XnpWindowMonitorFileEvent* _tmp42_;
						gint _tmp42__length1;
						XnpWindowMonitorFileEvent _tmp43_;
						XnpWindowMonitorFileEvent _tmp44_;
						XnpWindowMonitorFileEvent _tmp45_ = {0};
						XnpWindowMonitorFileEvent* _tmp46_;
						gint _tmp46__length1;
						XnpWindowMonitorFileEvent _tmp47_;
						XnpWindowMonitorFileEvent _tmp48_;
						XnpWindowMonitorFileEvent _tmp49_ = {0};
#line 310 "../lib/window-monitor.vala"
						_tmp39_ = self->priv->events;
#line 310 "../lib/window-monitor.vala"
						_tmp39__length1 = self->priv->events_length1;
#line 310 "../lib/window-monitor.vala"
						_tmp39_[n].event = G_FILE_MONITOR_EVENT_DELETED;
#line 311 "../lib/window-monitor.vala"
						_tmp40_ = self->priv->events;
#line 311 "../lib/window-monitor.vala"
						_tmp40__length1 = self->priv->events_length1;
#line 311 "../lib/window-monitor.vala"
						_g_object_unref0 (_tmp40_[n].other_file);
#line 311 "../lib/window-monitor.vala"
						_tmp40_[n].other_file = NULL;
#line 312 "../lib/window-monitor.vala"
						_tmp41_ = self->priv->events;
#line 312 "../lib/window-monitor.vala"
						_tmp41__length1 = self->priv->events_length1;
#line 312 "../lib/window-monitor.vala"
						_tmp42_ = self->priv->events;
#line 312 "../lib/window-monitor.vala"
						_tmp42__length1 = self->priv->events_length1;
#line 312 "../lib/window-monitor.vala"
						_tmp43_ = _tmp42_[n];
#line 312 "../lib/window-monitor.vala"
						_tmp44_ = _tmp43_;
#line 312 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_copy (&_tmp44_, &_tmp45_);
#line 312 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_destroy (&_tmp41_[i]);
#line 312 "../lib/window-monitor.vala"
						_tmp41_[i] = _tmp45_;
#line 313 "../lib/window-monitor.vala"
						_tmp46_ = self->priv->events;
#line 313 "../lib/window-monitor.vala"
						_tmp46__length1 = self->priv->events_length1;
#line 313 "../lib/window-monitor.vala"
						_tmp47_ = self->priv->dummy;
#line 313 "../lib/window-monitor.vala"
						_tmp48_ = _tmp47_;
#line 313 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_copy (&_tmp48_, &_tmp49_);
#line 313 "../lib/window-monitor.vala"
						xnp_window_monitor_file_event_destroy (&_tmp46_[n]);
#line 313 "../lib/window-monitor.vala"
						_tmp46_[n] = _tmp49_;
#line 314 "../lib/window-monitor.vala"
						_g_object_unref0 (other_file);
#line 314 "../lib/window-monitor.vala"
						_g_object_unref0 (file);
#line 314 "../lib/window-monitor.vala"
						return;
#line 1914 "window-monitor.c"
					}
#line 296 "../lib/window-monitor.vala"
					case XNP_WINDOW_MONITOR_CHANGES_DONE_HINT:
#line 1918 "window-monitor.c"
					{
#line 318 "../lib/window-monitor.vala"
						_g_object_unref0 (other_file);
#line 318 "../lib/window-monitor.vala"
						_g_object_unref0 (file);
#line 318 "../lib/window-monitor.vala"
						return;
#line 1926 "window-monitor.c"
					}
#line 296 "../lib/window-monitor.vala"
					case G_FILE_MONITOR_EVENT_RENAMED:
#line 1930 "window-monitor.c"
					{
						XnpWindowMonitorFileEvent* _tmp50_;
						gint _tmp50__length1;
						XnpWindowMonitorFileEvent _tmp51_;
						GFile* _tmp52_;
						gboolean _tmp53_ = FALSE;
#line 324 "../lib/window-monitor.vala"
						_tmp50_ = self->priv->events;
#line 324 "../lib/window-monitor.vala"
						_tmp50__length1 = self->priv->events_length1;
#line 324 "../lib/window-monitor.vala"
						_tmp51_ = _tmp50_[i];
#line 324 "../lib/window-monitor.vala"
						_tmp52_ = _tmp51_.other_file;
#line 324 "../lib/window-monitor.vala"
						g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL], 0, _tmp52_, &_tmp53_);
#line 324 "../lib/window-monitor.vala"
						if (_tmp53_) {
#line 1949 "window-monitor.c"
							GFile* _tmp54_;
							gboolean _tmp55_ = FALSE;
#line 325 "../lib/window-monitor.vala"
							_tmp54_ = file;
#line 325 "../lib/window-monitor.vala"
							g_signal_emit (self, xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL], 0, _tmp54_, &_tmp55_);
#line 325 "../lib/window-monitor.vala"
							if (_tmp55_) {
#line 1958 "window-monitor.c"
								XnpWindowMonitorFileEvent* _tmp56_;
								gint _tmp56__length1;
								XnpWindowMonitorFileEvent _tmp57_;
								XnpWindowMonitorFileEvent _tmp58_;
								XnpWindowMonitorFileEvent _tmp59_ = {0};
								XnpWindowMonitorFileEvent* _tmp60_;
								gint _tmp60__length1;
								GFile* _tmp61_;
								GFile* _tmp62_;
#line 326 "../lib/window-monitor.vala"
								_tmp56_ = self->priv->events;
#line 326 "../lib/window-monitor.vala"
								_tmp56__length1 = self->priv->events_length1;
#line 326 "../lib/window-monitor.vala"
								_tmp57_ = self->priv->dummy;
#line 326 "../lib/window-monitor.vala"
								_tmp58_ = _tmp57_;
#line 326 "../lib/window-monitor.vala"
								xnp_window_monitor_file_event_copy (&_tmp58_, &_tmp59_);
#line 326 "../lib/window-monitor.vala"
								xnp_window_monitor_file_event_destroy (&_tmp56_[n]);
#line 326 "../lib/window-monitor.vala"
								_tmp56_[n] = _tmp59_;
#line 327 "../lib/window-monitor.vala"
								_tmp60_ = self->priv->events;
#line 327 "../lib/window-monitor.vala"
								_tmp60__length1 = self->priv->events_length1;
#line 327 "../lib/window-monitor.vala"
								_tmp61_ = file;
#line 327 "../lib/window-monitor.vala"
								_tmp62_ = _g_object_ref0 (_tmp61_);
#line 327 "../lib/window-monitor.vala"
								_g_object_unref0 (_tmp60_[i].file);
#line 327 "../lib/window-monitor.vala"
								_tmp60_[i].file = _tmp62_;
#line 1994 "window-monitor.c"
							} else {
								XnpWindowMonitorFileEvent* _tmp63_;
								gint _tmp63__length1;
								XnpWindowMonitorFileEvent _tmp64_;
								XnpWindowMonitorFileEvent _tmp65_;
								XnpWindowMonitorFileEvent _tmp66_ = {0};
								XnpWindowMonitorFileEvent* _tmp67_;
								gint _tmp67__length1;
								XnpWindowMonitorFileEvent* _tmp68_;
								gint _tmp68__length1;
								XnpWindowMonitorFileEvent* _tmp69_;
								gint _tmp69__length1;
								XnpWindowMonitorFileEvent _tmp70_;
								GFile* _tmp71_;
								GFile* _tmp72_;
								XnpWindowMonitorFileEvent* _tmp73_;
								gint _tmp73__length1;
#line 329 "../lib/window-monitor.vala"
								_tmp63_ = self->priv->events;
#line 329 "../lib/window-monitor.vala"
								_tmp63__length1 = self->priv->events_length1;
#line 329 "../lib/window-monitor.vala"
								_tmp64_ = self->priv->dummy;
#line 329 "../lib/window-monitor.vala"
								_tmp65_ = _tmp64_;
#line 329 "../lib/window-monitor.vala"
								xnp_window_monitor_file_event_copy (&_tmp65_, &_tmp66_);
#line 329 "../lib/window-monitor.vala"
								xnp_window_monitor_file_event_destroy (&_tmp63_[n]);
#line 329 "../lib/window-monitor.vala"
								_tmp63_[n] = _tmp66_;
#line 330 "../lib/window-monitor.vala"
								_tmp67_ = self->priv->events;
#line 330 "../lib/window-monitor.vala"
								_tmp67__length1 = self->priv->events_length1;
#line 330 "../lib/window-monitor.vala"
								_tmp67_[i].event = XNP_WINDOW_MONITOR_CHANGES_DONE_HINT;
#line 331 "../lib/window-monitor.vala"
								_tmp68_ = self->priv->events;
#line 331 "../lib/window-monitor.vala"
								_tmp68__length1 = self->priv->events_length1;
#line 331 "../lib/window-monitor.vala"
								_tmp69_ = self->priv->events;
#line 331 "../lib/window-monitor.vala"
								_tmp69__length1 = self->priv->events_length1;
#line 331 "../lib/window-monitor.vala"
								_tmp70_ = _tmp69_[i];
#line 331 "../lib/window-monitor.vala"
								_tmp71_ = _tmp70_.other_file;
#line 331 "../lib/window-monitor.vala"
								_tmp72_ = _g_object_ref0 (_tmp71_);
#line 331 "../lib/window-monitor.vala"
								_g_object_unref0 (_tmp68_[i].file);
#line 331 "../lib/window-monitor.vala"
								_tmp68_[i].file = _tmp72_;
#line 332 "../lib/window-monitor.vala"
								_tmp73_ = self->priv->events;
#line 332 "../lib/window-monitor.vala"
								_tmp73__length1 = self->priv->events_length1;
#line 332 "../lib/window-monitor.vala"
								_g_object_unref0 (_tmp73_[i].other_file);
#line 332 "../lib/window-monitor.vala"
								_tmp73_[i].other_file = NULL;
#line 2058 "window-monitor.c"
							}
						} else {
							XnpWindowMonitorFileEvent* _tmp74_;
							gint _tmp74__length1;
							XnpWindowMonitorFileEvent* _tmp75_;
							gint _tmp75__length1;
							XnpWindowMonitorFileEvent _tmp76_;
							GFile* _tmp77_;
							GFile* _tmp78_;
							XnpWindowMonitorFileEvent* _tmp79_;
							gint _tmp79__length1;
							XnpWindowMonitorFileEvent* _tmp80_;
							gint _tmp80__length1;
							XnpWindowMonitorFileEvent _tmp81_;
							XnpWindowMonitorFileEvent _tmp82_;
							XnpWindowMonitorFileEvent _tmp83_ = {0};
							XnpWindowMonitorFileEvent* _tmp84_;
							gint _tmp84__length1;
							XnpWindowMonitorFileEvent _tmp85_;
							XnpWindowMonitorFileEvent _tmp86_;
							XnpWindowMonitorFileEvent _tmp87_ = {0};
#line 335 "../lib/window-monitor.vala"
							_tmp74_ = self->priv->events;
#line 335 "../lib/window-monitor.vala"
							_tmp74__length1 = self->priv->events_length1;
#line 335 "../lib/window-monitor.vala"
							_tmp75_ = self->priv->events;
#line 335 "../lib/window-monitor.vala"
							_tmp75__length1 = self->priv->events_length1;
#line 335 "../lib/window-monitor.vala"
							_tmp76_ = _tmp75_[i];
#line 335 "../lib/window-monitor.vala"
							_tmp77_ = _tmp76_.other_file;
#line 335 "../lib/window-monitor.vala"
							_tmp78_ = _g_object_ref0 (_tmp77_);
#line 335 "../lib/window-monitor.vala"
							_g_object_unref0 (_tmp74_[n].other_file);
#line 335 "../lib/window-monitor.vala"
							_tmp74_[n].other_file = _tmp78_;
#line 336 "../lib/window-monitor.vala"
							_tmp79_ = self->priv->events;
#line 336 "../lib/window-monitor.vala"
							_tmp79__length1 = self->priv->events_length1;
#line 336 "../lib/window-monitor.vala"
							_tmp80_ = self->priv->events;
#line 336 "../lib/window-monitor.vala"
							_tmp80__length1 = self->priv->events_length1;
#line 336 "../lib/window-monitor.vala"
							_tmp81_ = _tmp80_[n];
#line 336 "../lib/window-monitor.vala"
							_tmp82_ = _tmp81_;
#line 336 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_copy (&_tmp82_, &_tmp83_);
#line 336 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_destroy (&_tmp79_[i]);
#line 336 "../lib/window-monitor.vala"
							_tmp79_[i] = _tmp83_;
#line 337 "../lib/window-monitor.vala"
							_tmp84_ = self->priv->events;
#line 337 "../lib/window-monitor.vala"
							_tmp84__length1 = self->priv->events_length1;
#line 337 "../lib/window-monitor.vala"
							_tmp85_ = self->priv->dummy;
#line 337 "../lib/window-monitor.vala"
							_tmp86_ = _tmp85_;
#line 337 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_copy (&_tmp86_, &_tmp87_);
#line 337 "../lib/window-monitor.vala"
							xnp_window_monitor_file_event_destroy (&_tmp84_[n]);
#line 337 "../lib/window-monitor.vala"
							_tmp84_[n] = _tmp87_;
#line 2130 "window-monitor.c"
						}
#line 339 "../lib/window-monitor.vala"
						_g_object_unref0 (other_file);
#line 339 "../lib/window-monitor.vala"
						_g_object_unref0 (file);
#line 339 "../lib/window-monitor.vala"
						return;
#line 2138 "window-monitor.c"
					}
					default:
					{
#line 342 "../lib/window-monitor.vala"
						break;
#line 2144 "window-monitor.c"
					}
				}
			}
		}
	}
#line 273 "../lib/window-monitor.vala"
	_g_object_unref0 (other_file);
#line 273 "../lib/window-monitor.vala"
	_g_object_unref0 (file);
#line 2154 "window-monitor.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../lib/window-monitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../lib/window-monitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../lib/window-monitor.vala"
		data1 = closure->data;
#line 23 "../lib/window-monitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 2179 "window-monitor.c"
	} else {
#line 23 "../lib/window-monitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../lib/window-monitor.vala"
		data2 = closure->data;
#line 2185 "window-monitor.c"
	}
#line 23 "../lib/window-monitor.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 23 "../lib/window-monitor.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 2191 "window-monitor.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 23 "../lib/window-monitor.vala"
	g_return_if_fail (return_value != NULL);
#line 23 "../lib/window-monitor.vala"
	g_return_if_fail (n_param_values == 2);
#line 23 "../lib/window-monitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../lib/window-monitor.vala"
		data1 = closure->data;
#line 23 "../lib/window-monitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 2219 "window-monitor.c"
	} else {
#line 23 "../lib/window-monitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../lib/window-monitor.vala"
		data2 = closure->data;
#line 2225 "window-monitor.c"
	}
#line 23 "../lib/window-monitor.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 23 "../lib/window-monitor.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
#line 23 "../lib/window-monitor.vala"
	g_value_set_boolean (return_value, v_return);
#line 2233 "window-monitor.c"
}

static void
xnp_window_monitor_file_event_init (XnpWindowMonitorFileEvent *self,
                                    GFile* file,
                                    GFile* other_file,
                                    GFileMonitorEvent event)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 40 "../lib/window-monitor.vala"
	memset (self, 0, sizeof (XnpWindowMonitorFileEvent));
#line 41 "../lib/window-monitor.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 41 "../lib/window-monitor.vala"
	_g_object_unref0 ((*self).file);
#line 41 "../lib/window-monitor.vala"
	(*self).file = _tmp0_;
#line 42 "../lib/window-monitor.vala"
	_tmp1_ = _g_object_ref0 (other_file);
#line 42 "../lib/window-monitor.vala"
	_g_object_unref0 ((*self).other_file);
#line 42 "../lib/window-monitor.vala"
	(*self).other_file = _tmp1_;
#line 43 "../lib/window-monitor.vala"
	(*self).event = event;
#line 2260 "window-monitor.c"
}

static void
xnp_window_monitor_file_event_copy (const XnpWindowMonitorFileEvent* self,
                                    XnpWindowMonitorFileEvent* dest)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 36 "../lib/window-monitor.vala"
	_tmp0_ = (*self).file;
#line 36 "../lib/window-monitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 36 "../lib/window-monitor.vala"
	_g_object_unref0 ((*dest).file);
#line 36 "../lib/window-monitor.vala"
	(*dest).file = _tmp1_;
#line 36 "../lib/window-monitor.vala"
	_tmp2_ = (*self).other_file;
#line 36 "../lib/window-monitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 36 "../lib/window-monitor.vala"
	_g_object_unref0 ((*dest).other_file);
#line 36 "../lib/window-monitor.vala"
	(*dest).other_file = _tmp3_;
#line 36 "../lib/window-monitor.vala"
	(*dest).event = (*self).event;
#line 2289 "window-monitor.c"
}

static void
xnp_window_monitor_file_event_destroy (XnpWindowMonitorFileEvent* self)
{
#line 37 "../lib/window-monitor.vala"
	_g_object_unref0 ((*self).file);
#line 38 "../lib/window-monitor.vala"
	_g_object_unref0 ((*self).other_file);
#line 2299 "window-monitor.c"
}

static XnpWindowMonitorFileEvent*
xnp_window_monitor_file_event_dup (const XnpWindowMonitorFileEvent* self)
{
	XnpWindowMonitorFileEvent* dup;
#line 36 "../lib/window-monitor.vala"
	dup = g_new0 (XnpWindowMonitorFileEvent, 1);
#line 36 "../lib/window-monitor.vala"
	xnp_window_monitor_file_event_copy (self, dup);
#line 36 "../lib/window-monitor.vala"
	return dup;
#line 2312 "window-monitor.c"
}

static void
xnp_window_monitor_file_event_free (XnpWindowMonitorFileEvent* self)
{
#line 36 "../lib/window-monitor.vala"
	xnp_window_monitor_file_event_destroy (self);
#line 36 "../lib/window-monitor.vala"
	g_free (self);
#line 2322 "window-monitor.c"
}

static GType
xnp_window_monitor_file_event_get_type_once (void)
{
	GType xnp_window_monitor_file_event_type_id;
	xnp_window_monitor_file_event_type_id = g_boxed_type_register_static ("XnpWindowMonitorFileEvent", (GBoxedCopyFunc) xnp_window_monitor_file_event_dup, (GBoxedFreeFunc) xnp_window_monitor_file_event_free);
	return xnp_window_monitor_file_event_type_id;
}

static GType
xnp_window_monitor_file_event_get_type (void)
{
	static volatile gsize xnp_window_monitor_file_event_type_id__once = 0;
	if (g_once_init_enter (&xnp_window_monitor_file_event_type_id__once)) {
		GType xnp_window_monitor_file_event_type_id;
		xnp_window_monitor_file_event_type_id = xnp_window_monitor_file_event_get_type_once ();
		g_once_init_leave (&xnp_window_monitor_file_event_type_id__once, xnp_window_monitor_file_event_type_id);
	}
	return xnp_window_monitor_file_event_type_id__once;
}

static void
xnp_window_monitor_class_init (XnpWindowMonitorClass * klass,
                               gpointer klass_data)
{
#line 23 "../lib/window-monitor.vala"
	xnp_window_monitor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/window-monitor.vala"
	g_type_class_adjust_private_offset (klass, &XnpWindowMonitor_private_offset);
#line 23 "../lib/window-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = xnp_window_monitor_finalize;
#line 23 "../lib/window-monitor.vala"
	xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_UPDATED_SIGNAL] = g_signal_new ("note-updated", XNP_TYPE_WINDOW_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 23 "../lib/window-monitor.vala"
	xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_DELETED_SIGNAL] = g_signal_new ("note-deleted", XNP_TYPE_WINDOW_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 23 "../lib/window-monitor.vala"
	xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_CREATED_SIGNAL] = g_signal_new ("note-created", XNP_TYPE_WINDOW_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 23 "../lib/window-monitor.vala"
	xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_RENAMED_SIGNAL] = g_signal_new ("note-renamed", XNP_TYPE_WINDOW_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
#line 23 "../lib/window-monitor.vala"
	xnp_window_monitor_signals[XNP_WINDOW_MONITOR_NOTE_EXISTS_SIGNAL] = g_signal_new ("note-exists", XNP_TYPE_WINDOW_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, g_file_get_type ());
#line 2365 "window-monitor.c"
}

static void
xnp_window_monitor_instance_init (XnpWindowMonitor * self,
                                  gpointer klass)
{
	XnpWindowMonitorFileEvent* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 23 "../lib/window-monitor.vala"
	self->priv = xnp_window_monitor_get_instance_private (self);
#line 26 "../lib/window-monitor.vala"
	self->priv->src_external = (guint) 0;
#line 27 "../lib/window-monitor.vala"
	self->priv->src_internal = (guint) 0;
#line 28 "../lib/window-monitor.vala"
	self->priv->skip = FALSE;
#line 47 "../lib/window-monitor.vala"
	_tmp0_ = g_new0 (XnpWindowMonitorFileEvent, 0);
#line 47 "../lib/window-monitor.vala"
	self->priv->events = _tmp0_;
#line 47 "../lib/window-monitor.vala"
	self->priv->events_length1 = 0;
#line 47 "../lib/window-monitor.vala"
	self->priv->_events_size_ = self->priv->events_length1;
#line 48 "../lib/window-monitor.vala"
	_tmp1_ = g_file_new_for_path ("");
#line 48 "../lib/window-monitor.vala"
	_tmp2_ = _tmp1_;
#line 48 "../lib/window-monitor.vala"
	xnp_window_monitor_file_event_init (&self->priv->dummy, _tmp2_, NULL, -1);
#line 48 "../lib/window-monitor.vala"
	_g_object_unref0 (_tmp2_);
#line 2399 "window-monitor.c"
}

static void
xnp_window_monitor_finalize (GObject * obj)
{
	XnpWindowMonitor * self;
#line 23 "../lib/window-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_WINDOW_MONITOR, XnpWindowMonitor);
#line 64 "../lib/window-monitor.vala"
	if (self->priv->src_external != ((guint) 0)) {
#line 65 "../lib/window-monitor.vala"
		g_source_remove (self->priv->src_external);
#line 2412 "window-monitor.c"
	}
#line 66 "../lib/window-monitor.vala"
	if (self->priv->src_internal != ((guint) 0)) {
#line 67 "../lib/window-monitor.vala"
		g_source_remove (self->priv->src_internal);
#line 2418 "window-monitor.c"
	}
#line 25 "../lib/window-monitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 47 "../lib/window-monitor.vala"
	self->priv->events = (_vala_XnpWindowMonitorFileEvent_array_free (self->priv->events, self->priv->events_length1), NULL);
#line 48 "../lib/window-monitor.vala"
	xnp_window_monitor_file_event_destroy (&self->priv->dummy);
#line 23 "../lib/window-monitor.vala"
	G_OBJECT_CLASS (xnp_window_monitor_parent_class)->finalize (obj);
#line 2428 "window-monitor.c"
}

static GType
xnp_window_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (XnpWindowMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnp_window_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnpWindowMonitor), 0, (GInstanceInitFunc) xnp_window_monitor_instance_init, NULL };
	GType xnp_window_monitor_type_id;
	xnp_window_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "XnpWindowMonitor", &g_define_type_info, 0);
	XnpWindowMonitor_private_offset = g_type_add_instance_private (xnp_window_monitor_type_id, sizeof (XnpWindowMonitorPrivate));
	return xnp_window_monitor_type_id;
}

GType
xnp_window_monitor_get_type (void)
{
	static volatile gsize xnp_window_monitor_type_id__once = 0;
	if (g_once_init_enter (&xnp_window_monitor_type_id__once)) {
		GType xnp_window_monitor_type_id;
		xnp_window_monitor_type_id = xnp_window_monitor_get_type_once ();
		g_once_init_leave (&xnp_window_monitor_type_id__once, xnp_window_monitor_type_id);
	}
	return xnp_window_monitor_type_id__once;
}

