/* main-panel-plugin.c generated by valac 0.56.18, the Vala compiler
 * generated from main-panel-plugin.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (C) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "notes.h"
#include <gtk/gtk.h>
#include "libnotes.h"
#include <libxfce4panel/libxfce4panel.h>
#include <glib-object.h>
#include <libxfce4util/libxfce4util.h>
#include <xfce-revision.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	NOTES_PLUGIN_0_PROPERTY,
	NOTES_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* notes_plugin_properties[NOTES_PLUGIN_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NotesPluginPrivate {
	GtkButton* button;
	GtkImage* image;
	XnpApplication* application;
};

static gint NotesPlugin_private_offset;
static gpointer notes_plugin_parent_class = NULL;
static GType notes_plugin_type_id = 0;

static void notes_plugin_real_construct (XfcePanelPlugin* base);
static void __lambda4_ (NotesPlugin* self);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static gboolean __lambda5_ (NotesPlugin* self,
                     XfcePanelPlugin* p,
                     gint size);
static gboolean ___lambda5__xfce_panel_plugin_size_changed (XfcePanelPlugin* _sender,
                                                     gint size,
                                                     gpointer self);
static void __lambda6_ (NotesPlugin* self);
static void ___lambda6__xfce_panel_plugin_save (XfcePanelPlugin* _sender,
                                         gpointer self);
static void __lambda7_ (NotesPlugin* self);
static void ___lambda7__xfce_panel_plugin_free_data (XfcePanelPlugin* _sender,
                                              gpointer self);
static void __lambda8_ (NotesPlugin* self);
static void ___lambda8__xfce_panel_plugin_configure_plugin (XfcePanelPlugin* _sender,
                                                     gpointer self);
static void __lambda9_ (NotesPlugin* self);
static void ___lambda9__xfce_panel_plugin_about (XfcePanelPlugin* _sender,
                                          gpointer self);
static void notes_plugin_finalize (GObject * obj);

static inline gpointer
notes_plugin_get_instance_private (NotesPlugin* self)
{
	return G_STRUCT_MEMBER_P (self, NotesPlugin_private_offset);
}

NotesPlugin*
notes_plugin_construct (GType object_type)
{
	NotesPlugin * self = NULL;
#line 31 "../src/main-panel-plugin.vala"
	self = (NotesPlugin*) g_object_new (object_type, NULL);
#line 30 "../src/main-panel-plugin.vala"
	return self;
#line 101 "main-panel-plugin.c"
}

NotesPlugin*
notes_plugin_new (void)
{
#line 30 "../src/main-panel-plugin.vala"
	return notes_plugin_construct (TYPE_NOTES_PLUGIN);
#line 109 "main-panel-plugin.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/main-panel-plugin.vala"
	return self ? g_object_ref (self) : NULL;
#line 117 "main-panel-plugin.c"
}

static void
__lambda4_ (NotesPlugin* self)
{
	XnpApplication* _tmp0_;
#line 41 "../src/main-panel-plugin.vala"
	_tmp0_ = self->priv->application;
#line 41 "../src/main-panel-plugin.vala"
	xnp_application_show_hide_notes (_tmp0_);
#line 128 "main-panel-plugin.c"
}

static void
___lambda4__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 41 "../src/main-panel-plugin.vala"
	__lambda4_ ((NotesPlugin*) self);
#line 137 "main-panel-plugin.c"
}

static gboolean
__lambda5_ (NotesPlugin* self,
            XfcePanelPlugin* p,
            gint size)
{
	guint _tmp0_;
	guint _tmp1_;
	GtkButton* _tmp2_;
	gint icon_size = 0;
	GtkImage* _tmp3_;
	gboolean result;
#line 56 "../src/main-panel-plugin.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 57 "../src/main-panel-plugin.vala"
	_tmp0_ = xfce_panel_plugin_get_nrows ((XfcePanelPlugin*) self);
#line 57 "../src/main-panel-plugin.vala"
	_tmp1_ = _tmp0_;
#line 57 "../src/main-panel-plugin.vala"
	size = size / ((gint) _tmp1_);
#line 58 "../src/main-panel-plugin.vala"
	_tmp2_ = self->priv->button;
#line 58 "../src/main-panel-plugin.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp2_, size, size);
#line 59 "../src/main-panel-plugin.vala"
	icon_size = xfce_panel_plugin_get_icon_size (p);
#line 60 "../src/main-panel-plugin.vala"
	_tmp3_ = self->priv->image;
#line 60 "../src/main-panel-plugin.vala"
	gtk_image_set_pixel_size (_tmp3_, icon_size);
#line 61 "../src/main-panel-plugin.vala"
	result = TRUE;
#line 61 "../src/main-panel-plugin.vala"
	return result;
#line 173 "main-panel-plugin.c"
}

static gboolean
___lambda5__xfce_panel_plugin_size_changed (XfcePanelPlugin* _sender,
                                            gint size,
                                            gpointer self)
{
	gboolean result;
	result = __lambda5_ ((NotesPlugin*) self, _sender, size);
#line 56 "../src/main-panel-plugin.vala"
	return result;
#line 185 "main-panel-plugin.c"
}

static void
__lambda6_ (NotesPlugin* self)
{
	XnpApplication* _tmp0_;
#line 63 "../src/main-panel-plugin.vala"
	_tmp0_ = self->priv->application;
#line 63 "../src/main-panel-plugin.vala"
	xnp_application_save_windows_configuration (_tmp0_);
#line 196 "main-panel-plugin.c"
}

static void
___lambda6__xfce_panel_plugin_save (XfcePanelPlugin* _sender,
                                    gpointer self)
{
#line 63 "../src/main-panel-plugin.vala"
	__lambda6_ ((NotesPlugin*) self);
#line 205 "main-panel-plugin.c"
}

static void
__lambda7_ (NotesPlugin* self)
{
	XnpApplication* _tmp0_;
#line 64 "../src/main-panel-plugin.vala"
	_tmp0_ = self->priv->application;
#line 64 "../src/main-panel-plugin.vala"
	xnp_application_save_notes (_tmp0_);
#line 216 "main-panel-plugin.c"
}

static void
___lambda7__xfce_panel_plugin_free_data (XfcePanelPlugin* _sender,
                                         gpointer self)
{
#line 64 "../src/main-panel-plugin.vala"
	__lambda7_ ((NotesPlugin*) self);
#line 225 "main-panel-plugin.c"
}

static void
__lambda8_ (NotesPlugin* self)
{
	XnpApplication* _tmp0_;
#line 65 "../src/main-panel-plugin.vala"
	_tmp0_ = self->priv->application;
#line 65 "../src/main-panel-plugin.vala"
	xnp_application_open_settings_dialog (_tmp0_);
#line 236 "main-panel-plugin.c"
}

static void
___lambda8__xfce_panel_plugin_configure_plugin (XfcePanelPlugin* _sender,
                                                gpointer self)
{
#line 65 "../src/main-panel-plugin.vala"
	__lambda8_ ((NotesPlugin*) self);
#line 245 "main-panel-plugin.c"
}

static void
__lambda9_ (NotesPlugin* self)
{
	XnpApplication* _tmp0_;
#line 66 "../src/main-panel-plugin.vala"
	_tmp0_ = self->priv->application;
#line 66 "../src/main-panel-plugin.vala"
	xnp_application_open_about_dialog (_tmp0_);
#line 256 "main-panel-plugin.c"
}

static void
___lambda9__xfce_panel_plugin_about (XfcePanelPlugin* _sender,
                                     gpointer self)
{
#line 66 "../src/main-panel-plugin.vala"
	__lambda9_ ((NotesPlugin*) self);
#line 265 "main-panel-plugin.c"
}

static void
notes_plugin_real_construct (XfcePanelPlugin* base)
{
	NotesPlugin * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	XnpApplication* _tmp2_;
	GtkWidget* _tmp3_;
	GtkButton* _tmp4_;
	GtkImage* _tmp5_;
	GtkButton* _tmp6_;
	GtkImage* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkMenuItem* mi = NULL;
	GtkMenuItem* _tmp12_;
	GtkMenu* menu = NULL;
	XnpApplication* _tmp13_;
	GtkMenu* _tmp14_;
#line 34 "../src/main-panel-plugin.vala"
	self = (NotesPlugin*) base;
#line 35 "../src/main-panel-plugin.vala"
	xfce_textdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR, "UTF-8");
#line 36 "../src/main-panel-plugin.vala"
	_tmp0_ = xfce_panel_plugin_save_location ((XfcePanelPlugin*) self, TRUE);
#line 36 "../src/main-panel-plugin.vala"
	_tmp1_ = _tmp0_;
#line 36 "../src/main-panel-plugin.vala"
	_tmp2_ = xnp_application_new (_tmp1_);
#line 36 "../src/main-panel-plugin.vala"
	_g_object_unref0 (self->priv->application);
#line 36 "../src/main-panel-plugin.vala"
	self->priv->application = _tmp2_;
#line 36 "../src/main-panel-plugin.vala"
	_g_free0 (_tmp1_);
#line 38 "../src/main-panel-plugin.vala"
	_tmp3_ = xfce_panel_create_button ();
#line 38 "../src/main-panel-plugin.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_button_get_type (), GtkButton));
#line 38 "../src/main-panel-plugin.vala"
	_g_object_unref0 (self->priv->button);
#line 38 "../src/main-panel-plugin.vala"
	self->priv->button = _tmp4_;
#line 39 "../src/main-panel-plugin.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("org.xfce.panel.notes", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 39 "../src/main-panel-plugin.vala"
	g_object_ref_sink (_tmp5_);
#line 39 "../src/main-panel-plugin.vala"
	_g_object_unref0 (self->priv->image);
#line 39 "../src/main-panel-plugin.vala"
	self->priv->image = _tmp5_;
#line 40 "../src/main-panel-plugin.vala"
	_tmp6_ = self->priv->button;
#line 40 "../src/main-panel-plugin.vala"
	_tmp7_ = self->priv->image;
#line 40 "../src/main-panel-plugin.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 41 "../src/main-panel-plugin.vala"
	_tmp8_ = self->priv->button;
#line 41 "../src/main-panel-plugin.vala"
	g_signal_connect_object (_tmp8_, "clicked", (GCallback) ___lambda4__gtk_button_clicked, self, 0);
#line 42 "../src/main-panel-plugin.vala"
	_tmp9_ = self->priv->button;
#line 42 "../src/main-panel-plugin.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp9_);
#line 43 "../src/main-panel-plugin.vala"
	xfce_panel_plugin_set_small ((XfcePanelPlugin*) self, TRUE);
#line 44 "../src/main-panel-plugin.vala"
	_tmp10_ = self->priv->button;
#line 44 "../src/main-panel-plugin.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp10_);
#line 45 "../src/main-panel-plugin.vala"
	_tmp11_ = self->priv->button;
#line 45 "../src/main-panel-plugin.vala"
	xfce_panel_plugin_add_action_widget ((XfcePanelPlugin*) self, (GtkWidget*) _tmp11_);
#line 46 "../src/main-panel-plugin.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Notes"));
#line 47 "../src/main-panel-plugin.vala"
	xfce_panel_plugin_menu_show_configure ((XfcePanelPlugin*) self);
#line 48 "../src/main-panel-plugin.vala"
	xfce_panel_plugin_menu_show_about ((XfcePanelPlugin*) self);
#line 50 "../src/main-panel-plugin.vala"
	_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Groups"));
#line 50 "../src/main-panel-plugin.vala"
	g_object_ref_sink (_tmp12_);
#line 50 "../src/main-panel-plugin.vala"
	mi = _tmp12_;
#line 51 "../src/main-panel-plugin.vala"
	_tmp13_ = self->priv->application;
#line 51 "../src/main-panel-plugin.vala"
	_tmp14_ = xnp_application_context_menu (_tmp13_);
#line 51 "../src/main-panel-plugin.vala"
	menu = _tmp14_;
#line 52 "../src/main-panel-plugin.vala"
	gtk_menu_item_set_submenu (mi, menu);
#line 53 "../src/main-panel-plugin.vala"
	gtk_widget_show_all ((GtkWidget*) mi);
#line 54 "../src/main-panel-plugin.vala"
	xfce_panel_plugin_menu_insert_item ((XfcePanelPlugin*) self, mi);
#line 56 "../src/main-panel-plugin.vala"
	g_signal_connect_object ((XfcePanelPlugin*) self, "size-changed", (GCallback) ___lambda5__xfce_panel_plugin_size_changed, self, 0);
#line 63 "../src/main-panel-plugin.vala"
	g_signal_connect_object ((XfcePanelPlugin*) self, "save", (GCallback) ___lambda6__xfce_panel_plugin_save, self, 0);
#line 64 "../src/main-panel-plugin.vala"
	g_signal_connect_object ((XfcePanelPlugin*) self, "free-data", (GCallback) ___lambda7__xfce_panel_plugin_free_data, self, 0);
#line 65 "../src/main-panel-plugin.vala"
	g_signal_connect_object ((XfcePanelPlugin*) self, "configure-plugin", (GCallback) ___lambda8__xfce_panel_plugin_configure_plugin, self, 0);
#line 66 "../src/main-panel-plugin.vala"
	g_signal_connect_object ((XfcePanelPlugin*) self, "about", (GCallback) ___lambda9__xfce_panel_plugin_about, self, 0);
#line 34 "../src/main-panel-plugin.vala"
	_g_object_unref0 (menu);
#line 34 "../src/main-panel-plugin.vala"
	_g_object_unref0 (mi);
#line 383 "main-panel-plugin.c"
}

static void
notes_plugin_class_init (NotesPluginClass * klass,
                         gpointer klass_data)
{
#line 24 "../src/main-panel-plugin.vala"
	notes_plugin_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/main-panel-plugin.vala"
	g_type_class_adjust_private_offset (klass, &NotesPlugin_private_offset);
#line 24 "../src/main-panel-plugin.vala"
	((XfcePanelPluginClass *) klass)->construct = (void (*) (XfcePanelPlugin*)) notes_plugin_real_construct;
#line 24 "../src/main-panel-plugin.vala"
	G_OBJECT_CLASS (klass)->finalize = notes_plugin_finalize;
#line 398 "main-panel-plugin.c"
}

static void
notes_plugin_instance_init (NotesPlugin * self,
                            gpointer klass)
{
#line 24 "../src/main-panel-plugin.vala"
	self->priv = notes_plugin_get_instance_private (self);
#line 407 "main-panel-plugin.c"
}

static void
notes_plugin_finalize (GObject * obj)
{
	NotesPlugin * self;
#line 24 "../src/main-panel-plugin.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOTES_PLUGIN, NotesPlugin);
#line 26 "../src/main-panel-plugin.vala"
	_g_object_unref0 (self->priv->button);
#line 27 "../src/main-panel-plugin.vala"
	_g_object_unref0 (self->priv->image);
#line 28 "../src/main-panel-plugin.vala"
	_g_object_unref0 (self->priv->application);
#line 24 "../src/main-panel-plugin.vala"
	G_OBJECT_CLASS (notes_plugin_parent_class)->finalize (obj);
#line 424 "main-panel-plugin.c"
}

GType
notes_plugin_get_type (void)
{
	return notes_plugin_type_id;
}

GType
notes_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NotesPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notes_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotesPlugin), 0, (GInstanceInitFunc) notes_plugin_instance_init, NULL };
	notes_plugin_type_id = g_type_module_register_type (module, xfce_panel_plugin_get_type (), "NotesPlugin", &g_define_type_info, 0);
	NotesPlugin_private_offset = sizeof (NotesPluginPrivate);
	return notes_plugin_type_id;
}

GType
xfce_panel_module_init (GTypeModule* module)
{
	GType result;
#line 72 "../src/main-panel-plugin.vala"
	g_return_val_if_fail (module != NULL, 0UL);
#line 72 "../src/main-panel-plugin.vala"
	notes_plugin_register_type (module);
#line 73 "../src/main-panel-plugin.vala"
	result = TYPE_NOTES_PLUGIN;
#line 73 "../src/main-panel-plugin.vala"
	return result;
#line 454 "main-panel-plugin.c"
}

