/* application.c generated by valac 0.56.18, the Vala compiler
 * generated from application.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (c) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "libnotes.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <xfconf/xfconf.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <xfce-revision.h>
#include <libxfce4util/libxfce4util.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>
#include <errno.h>
#include <float.h>
#include <math.h>
#include <signal.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	XNP_APPLICATION_0_PROPERTY,
	XNP_APPLICATION_NOTES_PATH_PROPERTY,
	XNP_APPLICATION_CONFIG_FILE_PROPERTY,
	XNP_APPLICATION_SKIP_TASKBAR_HINT_PROPERTY,
	XNP_APPLICATION_NEXT_FOCUS_PROPERTY,
	XNP_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* xnp_application_properties[XNP_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;

struct _XnpApplicationPrivate {
	gchar* _notes_path;
	gchar* _config_file;
	GSList* window_list;
	GSList* focus_order;
	XfconfChannel* xfconf_channel;
	gboolean lock_focus_order;
	guint save_config_timeout;
	gchar* default_notes_path;
	XnpTheme* theme;
	gboolean _skip_taskbar_hint;
};

struct _Block1Data {
	int _ref_count_;
	XnpApplication* self;
	XnpWindow* window;
};

struct _Block2Data {
	int _ref_count_;
	XnpApplication* self;
	XnpWindow* window;
};

struct _Block3Data {
	int _ref_count_;
	XnpApplication* self;
	GtkMenu* menu;
};

static gint XnpApplication_private_offset;
static gpointer xnp_application_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void xnp_application_update_version (XnpApplication* self);
static void xnp_application_update_notes_path (XnpApplication* self);
static gboolean xnp_application_get_main_instance (XnpApplication* self);
static void xnp_application_notes_path_error (XnpApplication* self,
                                       const gchar* message);
static void xnp_application_update_color (XnpApplication* self);
static void xnp_application_sort_groups_by_focus_order (XnpApplication* self,
                                                 GSList** groups);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean xnp_application_window_name_exists (XnpApplication* self,
                                             const gchar* name);
static void xnp_application_load_window_data (XnpApplication* self,
                                       XnpWindow* window);
static void xnp_application_destroy_window (XnpApplication* self,
                                     XnpWindow* window);
static void xnp_application_set_window_monitor (XnpApplication* self,
                                         XnpWindow* window);
static void __lambda48_ (Block1Data* _data1_,
                  XnpWindow* win,
                  const gchar* action);
static void xnp_application_rename_window (XnpApplication* self,
                                    XnpWindow* window);
static void xnp_application_delete_window (XnpApplication* self,
                                    XnpWindow* window);
static void ___lambda48__xnp_window_action (XnpWindow* _sender,
                                     const gchar* action,
                                     gpointer self);
static void __lambda49_ (XnpApplication* self,
                  XnpWindow* win,
                  XnpNote* note);
static void xnp_application_save_note (XnpApplication* self,
                                XnpWindow* window,
                                XnpNote* note);
static void ___lambda49__xnp_window_save_data (XnpWindow* _sender,
                                        XnpNote* note,
                                        gpointer self);
static void __lambda50_ (XnpApplication* self,
                  XnpWindow* win,
                  XnpNote* note);
static void ___lambda50__xnp_window_note_inserted (XnpWindow* _sender,
                                            XnpNote* note,
                                            gpointer self);
static void __lambda51_ (XnpApplication* self,
                  XnpWindow* win,
                  XnpNote* note);
static void ___lambda51__xnp_window_note_deleted (XnpWindow* _sender,
                                           XnpNote* note,
                                           gpointer self);
static void __lambda52_ (XnpApplication* self,
                  XnpWindow* win,
                  XnpNote* note,
                  const gchar* name);
static gboolean xnp_application_name_is_valid (XnpApplication* self,
                                        const gchar* name);
static void ___lambda52__xnp_window_note_renamed (XnpWindow* _sender,
                                           XnpNote* note,
                                           const gchar* name,
                                           gpointer self);
static void __lambda53_ (Block1Data* _data1_);
static gboolean _xnp_application_save_windows_configuration_gsource_func (gpointer self);
static void ___lambda53__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean __lambda54_ (XnpApplication* self,
                      XnpWindow* to_win,
                      XnpWindow* from_win,
                      XnpNote* note);
static gboolean ___lambda54__xnp_window_note_moved (XnpWindow* _sender,
                                             XnpWindow* src_win,
                                             XnpNote* note,
                                             gpointer self);
static void xnp_application_load_note (XnpApplication* self,
                                XnpWindow* window,
                                const gchar* note_name);
static void xnp_application_reload_note (XnpApplication* self,
                                  XnpWindow* window,
                                  const gchar* note_name);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda43_ (Block2Data* _data2_,
                  const gchar* note_name);
static void ___lambda43__xnp_window_monitor_note_deleted (XnpWindowMonitor* _sender,
                                                   const gchar* note_name,
                                                   gpointer self);
static void __lambda44_ (Block2Data* _data2_,
                  const gchar* note_name,
                  const gchar* new_name);
static void ___lambda44__xnp_window_monitor_note_renamed (XnpWindowMonitor* _sender,
                                                   const gchar* note_name,
                                                   const gchar* new_name,
                                                   gpointer self);
static void __lambda45_ (Block2Data* _data2_,
                  const gchar* note_name);
static void ___lambda45__xnp_window_monitor_note_created (XnpWindowMonitor* _sender,
                                                   const gchar* note_name,
                                                   gpointer self);
static void __lambda46_ (Block2Data* _data2_,
                  const gchar* note_name);
static void ___lambda46__xnp_window_monitor_note_updated (XnpWindowMonitor* _sender,
                                                   const gchar* note_name,
                                                   gpointer self);
static gboolean __lambda47_ (Block2Data* _data2_,
                      GFile* file);
static gboolean ___lambda47__xnp_window_monitor_note_exists (XnpWindowMonitor* _sender,
                                                      GFile* file,
                                                      gpointer self);
static void xnp_application_present_windows (XnpApplication* self);
static void xnp_application_show_windows (XnpApplication* self);
static void xnp_application_hide_windows (XnpApplication* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda55_ (Block3Data* _data3_);
static void __lambda56_ (XnpApplication* self,
                  GtkWidget* w);
static void ___lambda56__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void ____lambda57_ (XnpApplication* self,
                    GtkMenuItem* i);
static void _____lambda57__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void __lambda58_ (XnpApplication* self);
static void ___lambda58__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void ___lambda55__gtk_widget_show (GtkWidget* _sender,
                                   gpointer self);
static void _xnp_application_main_instance___lambda42_ (XnpApplication* self);
static void __xnp_application_main_instance___lambda42__g_application_activate (GApplication* _sender,
                                                                         gpointer self);
static GObject * xnp_application_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _xnp_application_quit_xfce_posix_signal_handler (gint signal,
                                                      gpointer self);
static void _xnp_application___lambda59_ (XnpApplication* self);
static void __xnp_application___lambda59__xfconf_get_channel_property_changed (XfconfChannel* _sender,
                                                                        const gchar* property,
                                                                        GValue* value,
                                                                        gpointer self);
static void _xnp_application___lambda60_ (XnpApplication* self);
static void __xnp_application___lambda60__xfconf_get_channel_property_changed (XfconfChannel* _sender,
                                                                        const gchar* property,
                                                                        GValue* value,
                                                                        gpointer self);
static void xnp_application_finalize (GObject * obj);
static GType xnp_application_get_type_once (void);
static void _vala_xnp_application_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_xnp_application_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
xnp_application_get_instance_private (XnpApplication* self)
{
	return G_STRUCT_MEMBER_P (self, XnpApplication_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 167 "../lib/application.vala"
	return self ? g_object_ref (self) : NULL;
#line 278 "application.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 32 "../lib/application.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 286 "application.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 32 "../lib/application.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 294 "application.c"
}

XnpApplication*
xnp_application_construct (GType object_type,
                           const gchar* config_file)
{
	XnpApplication * self = NULL;
#line 153 "../lib/application.vala"
	g_return_val_if_fail (config_file != NULL, NULL);
#line 154 "../lib/application.vala"
	self = (XnpApplication*) g_object_new (object_type, "config-file", config_file, NULL);
#line 153 "../lib/application.vala"
	return self;
#line 308 "application.c"
}

XnpApplication*
xnp_application_new (const gchar* config_file)
{
#line 153 "../lib/application.vala"
	return xnp_application_construct (XNP_TYPE_APPLICATION, config_file);
#line 316 "application.c"
}

XnpApplication*
xnp_application_construct_with_notes_path (GType object_type,
                                           const gchar* config_file,
                                           const gchar* notes_path)
{
	XnpApplication * self = NULL;
#line 157 "../lib/application.vala"
	g_return_val_if_fail (config_file != NULL, NULL);
#line 157 "../lib/application.vala"
	g_return_val_if_fail (notes_path != NULL, NULL);
#line 158 "../lib/application.vala"
	self = (XnpApplication*) g_object_new (object_type, "config-file", config_file, "notes-path", notes_path, NULL);
#line 157 "../lib/application.vala"
	return self;
#line 333 "application.c"
}

XnpApplication*
xnp_application_new_with_notes_path (const gchar* config_file,
                                     const gchar* notes_path)
{
#line 157 "../lib/application.vala"
	return xnp_application_construct_with_notes_path (XNP_TYPE_APPLICATION, config_file, notes_path);
#line 342 "application.c"
}

static void
xnp_application_update_version (XnpApplication* self)
{
	gchar* version = NULL;
	XfconfChannel* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	XfconfChannel* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 173 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 174 "../lib/application.vala"
	_tmp0_ = self->priv->xfconf_channel;
#line 174 "../lib/application.vala"
	_tmp1_ = xfconf_channel_get_string (_tmp0_, "/global/version", "0");
#line 174 "../lib/application.vala"
	version = _tmp1_;
#line 175 "../lib/application.vala"
	_tmp2_ = version;
#line 175 "../lib/application.vala"
	if (g_strcmp0 (_tmp2_, VERSION_FULL) == 0) {
#line 176 "../lib/application.vala"
		_g_free0 (version);
#line 176 "../lib/application.vala"
		return;
#line 371 "application.c"
	}
#line 177 "../lib/application.vala"
	_tmp3_ = version;
#line 177 "../lib/application.vala"
	if (g_strcmp0 (_tmp3_, "1.11") < 0) {
#line 377 "application.c"
		{
			gchar* css = NULL;
			gchar* _tmp4_;
			GFile* css_file = NULL;
			const gchar* _tmp5_;
			GFile* _tmp6_;
			GFile* _tmp7_;
			gchar* old_save_location = NULL;
			gchar* _tmp8_;
			GFile* old_save_location_file = NULL;
			const gchar* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
#line 179 "../lib/application.vala"
			_tmp4_ = xfce_resource_save_location (XFCE_RESOURCE_CONFIG, "xfce4/xfce4-notes.css", FALSE);
#line 179 "../lib/application.vala"
			css = _tmp4_;
#line 180 "../lib/application.vala"
			_tmp5_ = css;
#line 180 "../lib/application.vala"
			_tmp6_ = g_file_new_for_path (_tmp5_);
#line 180 "../lib/application.vala"
			css_file = _tmp6_;
#line 181 "../lib/application.vala"
			_tmp7_ = css_file;
#line 181 "../lib/application.vala"
			g_file_delete (_tmp7_, NULL, &_inner_error0_);
#line 181 "../lib/application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "../lib/application.vala"
				_g_object_unref0 (css_file);
#line 181 "../lib/application.vala"
				_g_free0 (css);
#line 411 "application.c"
				goto __catch0_g_error;
			}
#line 182 "../lib/application.vala"
			_tmp8_ = xfce_resource_save_location (XFCE_RESOURCE_CONFIG, "xfce4/xfce4-notes.rc", FALSE);
#line 182 "../lib/application.vala"
			old_save_location = _tmp8_;
#line 183 "../lib/application.vala"
			_tmp9_ = old_save_location;
#line 183 "../lib/application.vala"
			_tmp10_ = g_file_new_for_path (_tmp9_);
#line 183 "../lib/application.vala"
			old_save_location_file = _tmp10_;
#line 184 "../lib/application.vala"
			_tmp11_ = old_save_location_file;
#line 184 "../lib/application.vala"
			if (g_file_query_exists (_tmp11_, NULL)) {
#line 428 "application.c"
				gchar* save_location = NULL;
				gchar* _tmp12_;
				GFile* save_location_file = NULL;
				const gchar* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
				GFile* _tmp16_;
#line 185 "../lib/application.vala"
				_tmp12_ = xfce_resource_save_location (XFCE_RESOURCE_CONFIG, "xfce4/notes/xfce4-notes.rc", TRUE);
#line 185 "../lib/application.vala"
				save_location = _tmp12_;
#line 186 "../lib/application.vala"
				_tmp13_ = save_location;
#line 186 "../lib/application.vala"
				_tmp14_ = g_file_new_for_path (_tmp13_);
#line 186 "../lib/application.vala"
				save_location_file = _tmp14_;
#line 187 "../lib/application.vala"
				_tmp15_ = old_save_location_file;
#line 187 "../lib/application.vala"
				_tmp16_ = save_location_file;
#line 187 "../lib/application.vala"
				g_file_move (_tmp15_, _tmp16_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 187 "../lib/application.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 187 "../lib/application.vala"
					_g_object_unref0 (save_location_file);
#line 187 "../lib/application.vala"
					_g_free0 (save_location);
#line 187 "../lib/application.vala"
					_g_object_unref0 (old_save_location_file);
#line 187 "../lib/application.vala"
					_g_free0 (old_save_location);
#line 187 "../lib/application.vala"
					_g_object_unref0 (css_file);
#line 187 "../lib/application.vala"
					_g_free0 (css);
#line 466 "application.c"
					goto __catch0_g_error;
				}
#line 184 "../lib/application.vala"
				_g_object_unref0 (save_location_file);
#line 184 "../lib/application.vala"
				_g_free0 (save_location);
#line 473 "application.c"
			}
#line 178 "../lib/application.vala"
			_g_object_unref0 (old_save_location_file);
#line 178 "../lib/application.vala"
			_g_free0 (old_save_location);
#line 178 "../lib/application.vala"
			_g_object_unref0 (css_file);
#line 178 "../lib/application.vala"
			_g_free0 (css);
#line 483 "application.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 178 "../lib/application.vala"
			g_clear_error (&_inner_error0_);
#line 490 "application.c"
		}
		__finally0:
#line 178 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "../lib/application.vala"
			_g_free0 (version);
#line 178 "../lib/application.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 178 "../lib/application.vala"
			g_clear_error (&_inner_error0_);
#line 178 "../lib/application.vala"
			return;
#line 503 "application.c"
		}
	}
#line 192 "../lib/application.vala"
	_tmp17_ = self->priv->xfconf_channel;
#line 192 "../lib/application.vala"
	xfconf_channel_set_string (_tmp17_, "/global/version", VERSION_FULL);
#line 173 "../lib/application.vala"
	_g_free0 (version);
#line 512 "application.c"
}

static void
xnp_application_update_notes_path (XnpApplication* self)
{
	gchar* new_notes_path = NULL;
	XfconfChannel* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gchar* dirname = NULL;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gboolean _tmp17_ = FALSE;
	const gchar* _tmp18_;
	const gchar* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 195 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 196 "../lib/application.vala"
	_tmp0_ = self->priv->xfconf_channel;
#line 196 "../lib/application.vala"
	_tmp1_ = self->priv->default_notes_path;
#line 196 "../lib/application.vala"
	_tmp2_ = xfconf_channel_get_string (_tmp0_, "/global/notes-path", _tmp1_);
#line 196 "../lib/application.vala"
	new_notes_path = _tmp2_;
#line 197 "../lib/application.vala"
	_tmp3_ = self->priv->_notes_path;
#line 197 "../lib/application.vala"
	_tmp4_ = new_notes_path;
#line 197 "../lib/application.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 198 "../lib/application.vala"
		_g_free0 (new_notes_path);
#line 198 "../lib/application.vala"
		return;
#line 553 "application.c"
	}
#line 205 "../lib/application.vala"
	_tmp5_ = xnp_application_get_main_instance (self);
#line 205 "../lib/application.vala"
	_tmp6_ = _tmp5_;
#line 205 "../lib/application.vala"
	if (!_tmp6_) {
#line 561 "application.c"
		const gchar* _tmp7_;
#line 206 "../lib/application.vala"
		_tmp7_ = new_notes_path;
#line 206 "../lib/application.vala"
		xnp_application_set_notes_path (self, _tmp7_);
#line 207 "../lib/application.vala"
		_g_free0 (new_notes_path);
#line 207 "../lib/application.vala"
		return;
#line 571 "application.c"
	}
	{
		GDir* dir = NULL;
		const gchar* _tmp8_;
		GDir* _tmp9_;
		GDir* _tmp10_;
		const gchar* _tmp11_;
#line 212 "../lib/application.vala"
		_tmp8_ = new_notes_path;
#line 212 "../lib/application.vala"
		_tmp9_ = g_dir_open (_tmp8_, (guint) 0, &_inner_error0_);
#line 212 "../lib/application.vala"
		dir = _tmp9_;
#line 212 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 587 "application.c"
			goto __catch0_g_error;
		}
#line 213 "../lib/application.vala"
		_tmp10_ = dir;
#line 213 "../lib/application.vala"
		_tmp11_ = g_dir_read_name (_tmp10_);
#line 213 "../lib/application.vala"
		if (_tmp11_ != NULL) {
#line 596 "application.c"
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 214 "../lib/application.vala"
			_tmp12_ = new_notes_path;
#line 214 "../lib/application.vala"
			_tmp13_ = g_strdup_printf (_ ("The selected directory (%s) already contains files. " "You must select or create an empty directory."), _tmp12_);
#line 214 "../lib/application.vala"
			_tmp14_ = _tmp13_;
#line 214 "../lib/application.vala"
			xnp_application_notes_path_error (self, _tmp14_);
#line 214 "../lib/application.vala"
			_g_free0 (_tmp14_);
#line 216 "../lib/application.vala"
			_g_dir_close0 (dir);
#line 216 "../lib/application.vala"
			_g_free0 (new_notes_path);
#line 216 "../lib/application.vala"
			return;
#line 616 "application.c"
		}
#line 211 "../lib/application.vala"
		_g_dir_close0 (dir);
#line 620 "application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 211 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 627 "application.c"
	}
	__finally0:
#line 211 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "../lib/application.vala"
		_g_free0 (new_notes_path);
#line 211 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 211 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 211 "../lib/application.vala"
		return;
#line 640 "application.c"
	}
#line 223 "../lib/application.vala"
	_tmp15_ = new_notes_path;
#line 223 "../lib/application.vala"
	_tmp16_ = g_path_get_dirname (_tmp15_);
#line 223 "../lib/application.vala"
	dirname = _tmp16_;
#line 224 "../lib/application.vala"
	_tmp18_ = dirname;
#line 224 "../lib/application.vala"
	if (g_mkdir_with_parents (_tmp18_, 0700) != 0) {
#line 224 "../lib/application.vala"
		_tmp17_ = TRUE;
#line 654 "application.c"
	} else {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
#line 225 "../lib/application.vala"
		_tmp19_ = self->priv->_notes_path;
#line 225 "../lib/application.vala"
		_tmp20_ = new_notes_path;
#line 225 "../lib/application.vala"
		_tmp17_ = g_rename (_tmp19_, _tmp20_) != 0;
#line 664 "application.c"
	}
#line 224 "../lib/application.vala"
	if (_tmp17_) {
#line 668 "application.c"
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 226 "../lib/application.vala"
		_tmp21_ = g_strerror (errno);
#line 226 "../lib/application.vala"
		_tmp22_ = g_strdup_printf (_ ("Unable to select directory for new notes path: %s"), _tmp21_);
#line 226 "../lib/application.vala"
		_tmp23_ = _tmp22_;
#line 226 "../lib/application.vala"
		xnp_application_notes_path_error (self, _tmp23_);
#line 226 "../lib/application.vala"
		_g_free0 (_tmp23_);
#line 227 "../lib/application.vala"
		_g_free0 (dirname);
#line 227 "../lib/application.vala"
		_g_free0 (new_notes_path);
#line 227 "../lib/application.vala"
		return;
#line 688 "application.c"
	}
#line 230 "../lib/application.vala"
	_tmp24_ = new_notes_path;
#line 230 "../lib/application.vala"
	xnp_application_set_notes_path (self, _tmp24_);
#line 195 "../lib/application.vala"
	_g_free0 (dirname);
#line 195 "../lib/application.vala"
	_g_free0 (new_notes_path);
#line 698 "application.c"
}

static void
xnp_application_notes_path_error (XnpApplication* self,
                                  const gchar* message)
{
	GtkMessageDialog* error_dialog = NULL;
	GtkMessageDialog* _tmp0_;
	GtkMessageDialog* _tmp1_;
	GtkMessageDialog* _tmp2_;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp4_;
	GtkMessageDialog* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 233 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 233 "../lib/application.vala"
	g_return_if_fail (message != NULL);
#line 234 "../lib/application.vala"
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, 0, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", _ ("Notes path is unacceptable"));
#line 234 "../lib/application.vala"
	g_object_ref_sink (_tmp0_);
#line 234 "../lib/application.vala"
	error_dialog = _tmp0_;
#line 235 "../lib/application.vala"
	_tmp1_ = error_dialog;
#line 235 "../lib/application.vala"
	gtk_message_dialog_format_secondary_text (_tmp1_, "%s", message);
#line 236 "../lib/application.vala"
	_tmp2_ = error_dialog;
#line 236 "../lib/application.vala"
	gtk_window_set_icon_name ((GtkWindow*) _tmp2_, "gtk-dialog-error");
#line 237 "../lib/application.vala"
	_tmp3_ = error_dialog;
#line 237 "../lib/application.vala"
	gtk_window_set_title ((GtkWindow*) _tmp3_, _ ("Error"));
#line 238 "../lib/application.vala"
	_tmp4_ = error_dialog;
#line 238 "../lib/application.vala"
	gtk_dialog_run ((GtkDialog*) _tmp4_);
#line 239 "../lib/application.vala"
	_tmp5_ = error_dialog;
#line 239 "../lib/application.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp5_);
#line 240 "../lib/application.vala"
	_tmp6_ = self->priv->_notes_path;
#line 240 "../lib/application.vala"
	_tmp7_ = self->priv->default_notes_path;
#line 240 "../lib/application.vala"
	if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 750 "application.c"
		XfconfChannel* _tmp8_;
#line 241 "../lib/application.vala"
		_tmp8_ = self->priv->xfconf_channel;
#line 241 "../lib/application.vala"
		xfconf_channel_reset_property (_tmp8_, "/global/notes-path", FALSE);
#line 756 "application.c"
	} else {
		XfconfChannel* _tmp9_;
		const gchar* _tmp10_;
#line 243 "../lib/application.vala"
		_tmp9_ = self->priv->xfconf_channel;
#line 243 "../lib/application.vala"
		_tmp10_ = self->priv->_notes_path;
#line 243 "../lib/application.vala"
		xfconf_channel_set_string (_tmp9_, "/global/notes-path", _tmp10_);
#line 766 "application.c"
	}
#line 233 "../lib/application.vala"
	_g_object_unref0 (error_dialog);
#line 770 "application.c"
}

static void
xnp_application_update_color (XnpApplication* self)
{
	gchar* color = NULL;
	XfconfChannel* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 247 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 248 "../lib/application.vala"
	_tmp0_ = self->priv->xfconf_channel;
#line 248 "../lib/application.vala"
	_tmp1_ = xfconf_channel_get_string (_tmp0_, "/global/background-color", "#F7EB96");
#line 248 "../lib/application.vala"
	color = _tmp1_;
#line 249 "../lib/application.vala"
	_tmp2_ = color;
#line 249 "../lib/application.vala"
	if (g_strcmp0 (_tmp2_, "GTK+") == 0) {
#line 792 "application.c"
		XnpTheme* _tmp3_;
#line 250 "../lib/application.vala"
		_tmp3_ = self->priv->theme;
#line 250 "../lib/application.vala"
		xnp_theme_use_gtk_style (_tmp3_);
#line 798 "application.c"
	} else {
		XnpTheme* _tmp4_;
		const gchar* _tmp5_;
#line 252 "../lib/application.vala"
		_tmp4_ = self->priv->theme;
#line 252 "../lib/application.vala"
		_tmp5_ = color;
#line 252 "../lib/application.vala"
		xnp_theme_use_color (_tmp4_, _tmp5_);
#line 808 "application.c"
	}
#line 247 "../lib/application.vala"
	_g_free0 (color);
#line 812 "application.c"
}

/**
 * sort_groups_by_focus_order:
 *
 * Sort groups by last memorized windows focus order.
 */
static void
_g_free0_ (gpointer var)
{
#line 265 "../lib/application.vala"
	var = (g_free (var), NULL);
#line 825 "application.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 265 "../lib/application.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 833 "application.c"
}

static void
xnp_application_sort_groups_by_focus_order (XnpApplication* self,
                                            GSList** groups)
{
	GError* _inner_error0_ = NULL;
#line 260 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 843 "application.c"
	{
		GSList* last_focus_order = NULL;
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp0_;
		GSList* entry = NULL;
		const gchar* _tmp1_;
		gsize _tmp2_ = 0;
		gchar** _tmp3_;
#line 262 "../lib/application.vala"
		last_focus_order = NULL;
#line 263 "../lib/application.vala"
		_tmp0_ = g_key_file_new ();
#line 263 "../lib/application.vala"
		keyfile = _tmp0_;
#line 265 "../lib/application.vala"
		_tmp1_ = self->priv->_config_file;
#line 265 "../lib/application.vala"
		g_key_file_load_from_file (keyfile, _tmp1_, G_KEY_FILE_NONE, &_inner_error0_);
#line 265 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 265 "../lib/application.vala"
			_g_key_file_unref0 (keyfile);
#line 265 "../lib/application.vala"
			(last_focus_order == NULL) ? NULL : (last_focus_order = (_g_slist_free__g_free0_ (last_focus_order), NULL));
#line 868 "application.c"
			goto __catch0_g_error;
		}
#line 266 "../lib/application.vala"
		_tmp3_ = g_key_file_get_groups (keyfile, &_tmp2_);
#line 873 "application.c"
		{
			gchar** name_collection = NULL;
			gint name_collection_length1 = 0;
			gint _name_collection_size_ = 0;
			gint name_it = 0;
#line 266 "../lib/application.vala"
			name_collection = _tmp3_;
#line 266 "../lib/application.vala"
			name_collection_length1 = _tmp2_;
#line 266 "../lib/application.vala"
			for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 885 "application.c"
				gchar* _tmp4_;
				gchar* name = NULL;
#line 266 "../lib/application.vala"
				_tmp4_ = g_strdup (name_collection[name_it]);
#line 266 "../lib/application.vala"
				name = _tmp4_;
#line 892 "application.c"
				{
					const gchar* _tmp5_;
					gchar* _tmp6_;
#line 267 "../lib/application.vala"
					_tmp5_ = name;
#line 267 "../lib/application.vala"
					_tmp6_ = g_strdup (_tmp5_);
#line 267 "../lib/application.vala"
					last_focus_order = g_slist_prepend (last_focus_order, _tmp6_);
#line 266 "../lib/application.vala"
					_g_free0 (name);
#line 904 "application.c"
				}
			}
#line 266 "../lib/application.vala"
			name_collection = (_vala_array_free (name_collection, name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 909 "application.c"
		}
		{
			GSList* name_collection = NULL;
			GSList* name_it = NULL;
#line 269 "../lib/application.vala"
			name_collection = last_focus_order;
#line 269 "../lib/application.vala"
			for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
#line 918 "application.c"
				gchar* _tmp7_;
				gchar* name = NULL;
#line 269 "../lib/application.vala"
				_tmp7_ = g_strdup ((const gchar*) name_it->data);
#line 269 "../lib/application.vala"
				name = _tmp7_;
#line 925 "application.c"
				{
					const gchar* _tmp8_;
					GCompareFunc _tmp9_;
					GSList* _tmp10_;
					GSList* _tmp11_;
#line 270 "../lib/application.vala"
					_tmp8_ = name;
#line 270 "../lib/application.vala"
					_tmp9_ = ((GCompareFunc) g_strcmp0);
#line 270 "../lib/application.vala"
					_tmp10_ = g_slist_find_custom (*groups, _tmp8_, _tmp9_);
#line 270 "../lib/application.vala"
					entry = _tmp10_;
#line 270 "../lib/application.vala"
					_tmp11_ = entry;
#line 270 "../lib/application.vala"
					if (_tmp11_ != NULL) {
#line 943 "application.c"
						GSList* _tmp12_;
						gconstpointer _tmp13_;
						gchar* _tmp14_;
						GSList* _tmp15_;
#line 271 "../lib/application.vala"
						_tmp12_ = entry;
#line 271 "../lib/application.vala"
						_tmp13_ = _tmp12_->data;
#line 271 "../lib/application.vala"
						_tmp14_ = g_strdup ((const gchar*) _tmp13_);
#line 271 "../lib/application.vala"
						*groups = g_slist_prepend (*groups, _tmp14_);
#line 272 "../lib/application.vala"
						_tmp15_ = entry;
#line 272 "../lib/application.vala"
						*groups = g_slist_remove_link (*groups, _tmp15_);
#line 960 "application.c"
					}
#line 269 "../lib/application.vala"
					_g_free0 (name);
#line 964 "application.c"
				}
			}
		}
#line 261 "../lib/application.vala"
		_g_key_file_unref0 (keyfile);
#line 261 "../lib/application.vala"
		(last_focus_order == NULL) ? NULL : (last_focus_order = (_g_slist_free__g_free0_ (last_focus_order), NULL));
#line 972 "application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 261 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 979 "application.c"
	}
	__finally0:
#line 261 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 261 "../lib/application.vala"
		return;
#line 990 "application.c"
	}
}

void
xnp_application_quit (XnpApplication* self)
{
#line 280 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 282 "../lib/application.vala"
	xnp_application_save_notes (self);
#line 283 "../lib/application.vala"
	xnp_application_save_windows_configuration (self);
#line 284 "../lib/application.vala"
	gtk_main_quit ();
#line 1005 "application.c"
}

/**
 * create_window:
 *
 * Creates a new Xnp.Window and stores it inside window_list.
 * If a name is given, it assumes it can load existing notes.
 */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 297 "../lib/application.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 297 "../lib/application.vala"
	return _data1_;
#line 1021 "application.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 297 "../lib/application.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1031 "application.c"
		XnpApplication* self;
#line 297 "../lib/application.vala"
		self = _data1_->self;
#line 297 "../lib/application.vala"
		_g_object_unref0 (_data1_->window);
#line 297 "../lib/application.vala"
		_g_object_unref0 (self);
#line 297 "../lib/application.vala"
		g_slice_free (Block1Data, _data1_);
#line 1041 "application.c"
	}
}

static GSList*
vala_g_slist_remove_full (GSList* self,
                          gconstpointer data,
                          GFreeFunc func)
{
	GSList* l = NULL;
	GSList* result;
#line 5331 "glib-2.0.vapi"
	l = self;
#line 5332 "glib-2.0.vapi"
	while (TRUE) {
#line 1056 "application.c"
		GSList* _tmp0_;
		GSList* _tmp1_;
		gconstpointer _tmp2_;
#line 5332 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5332 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5332 "glib-2.0.vapi"
			break;
#line 1066 "application.c"
		}
#line 5333 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5333 "glib-2.0.vapi"
		_tmp2_ = ((GSList*) _tmp1_)->data;
#line 5333 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 1074 "application.c"
			GSList* _tmp3_;
			GSList* _tmp4_;
#line 5334 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5334 "glib-2.0.vapi"
			_tmp4_ = ((GSList*) _tmp3_)->next;
#line 5334 "glib-2.0.vapi"
			l = _tmp4_;
#line 1083 "application.c"
		} else {
			GSList* _tmp5_;
			gconstpointer _tmp6_;
			GSList* _tmp7_;
#line 5336 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5336 "glib-2.0.vapi"
			_tmp6_ = ((GSList*) _tmp5_)->data;
#line 5336 "glib-2.0.vapi"
			func (_tmp6_);
#line 5337 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5337 "glib-2.0.vapi"
			self = g_slist_delete_link (self, (GSList*) _tmp7_);
#line 5338 "glib-2.0.vapi"
			break;
#line 1100 "application.c"
		}
	}
#line 5341 "glib-2.0.vapi"
	result = self;
#line 5341 "glib-2.0.vapi"
	return result;
#line 1107 "application.c"
}

static void
__lambda48_ (Block1Data* _data1_,
             XnpWindow* win,
             const gchar* action)
{
	XnpApplication* self;
#line 362 "../lib/application.vala"
	self = _data1_->self;
#line 362 "../lib/application.vala"
	g_return_if_fail (win != NULL);
#line 362 "../lib/application.vala"
	g_return_if_fail (action != NULL);
#line 363 "../lib/application.vala"
	if (g_strcmp0 (action, "hide") == 0) {
#line 1124 "application.c"
		gint hidden_windows = 0;
		GSList* _tmp0_;
		XnpWindow* _tmp4_;
		XnpWindow* _tmp5_;
		XnpWindow* _tmp6_;
#line 364 "../lib/application.vala"
		if (self->priv->lock_focus_order) {
#line 365 "../lib/application.vala"
			return;
#line 1134 "application.c"
		}
#line 366 "../lib/application.vala"
		hidden_windows = 0;
#line 367 "../lib/application.vala"
		_tmp0_ = self->priv->focus_order;
#line 1140 "application.c"
		{
			GSList* w_collection = NULL;
			GSList* w_it = NULL;
#line 367 "../lib/application.vala"
			w_collection = _tmp0_;
#line 367 "../lib/application.vala"
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 1148 "application.c"
				XnpWindow* _tmp1_;
				XnpWindow* w = NULL;
#line 367 "../lib/application.vala"
				_tmp1_ = _g_object_ref0 ((XnpWindow*) w_it->data);
#line 367 "../lib/application.vala"
				w = _tmp1_;
#line 1155 "application.c"
				{
					XnpWindow* _tmp2_;
#line 368 "../lib/application.vala"
					_tmp2_ = w;
#line 368 "../lib/application.vala"
					if (!gtk_widget_get_visible ((GtkWidget*) _tmp2_)) {
#line 1162 "application.c"
						gint _tmp3_;
#line 369 "../lib/application.vala"
						_tmp3_ = hidden_windows;
#line 369 "../lib/application.vala"
						hidden_windows = _tmp3_ + 1;
#line 1168 "application.c"
					}
#line 367 "../lib/application.vala"
					_g_object_unref0 (w);
#line 1172 "application.c"
				}
			}
		}
#line 372 "../lib/application.vala"
		_tmp4_ = _data1_->window;
#line 372 "../lib/application.vala"
		self->priv->focus_order = vala_g_slist_remove_full (self->priv->focus_order, _tmp4_, _g_object_unref0_);
#line 373 "../lib/application.vala"
		_tmp5_ = _data1_->window;
#line 373 "../lib/application.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 373 "../lib/application.vala"
		self->priv->focus_order = g_slist_insert (self->priv->focus_order, _tmp6_, hidden_windows - 1);
#line 1186 "application.c"
	} else {
#line 375 "../lib/application.vala"
		if (g_strcmp0 (action, "rename") == 0) {
#line 376 "../lib/application.vala"
			xnp_application_rename_window (self, win);
#line 1192 "application.c"
		} else {
#line 378 "../lib/application.vala"
			if (g_strcmp0 (action, "delete") == 0) {
#line 379 "../lib/application.vala"
				xnp_application_delete_window (self, win);
#line 1198 "application.c"
			} else {
#line 381 "../lib/application.vala"
				if (g_strcmp0 (action, "create-new-window") == 0) {
#line 1202 "application.c"
					XnpWindow* new_win = NULL;
					XnpWindow* _tmp7_;
					XnpWindow* _tmp8_;
					XnpWindow* _tmp9_;
#line 382 "../lib/application.vala"
					_tmp7_ = xnp_application_create_window (self, NULL);
#line 382 "../lib/application.vala"
					new_win = _tmp7_;
#line 383 "../lib/application.vala"
					_tmp8_ = new_win;
#line 383 "../lib/application.vala"
					if (_tmp8_ == NULL) {
#line 384 "../lib/application.vala"
						_g_object_unref0 (new_win);
#line 384 "../lib/application.vala"
						return;
#line 1219 "application.c"
					}
#line 385 "../lib/application.vala"
					_tmp9_ = new_win;
#line 385 "../lib/application.vala"
					gtk_widget_show ((GtkWidget*) _tmp9_);
#line 381 "../lib/application.vala"
					_g_object_unref0 (new_win);
#line 1227 "application.c"
				} else {
#line 387 "../lib/application.vala"
					if (g_strcmp0 (action, "properties") == 0) {
#line 388 "../lib/application.vala"
						xnp_application_open_settings_dialog (self);
#line 1233 "application.c"
					} else {
#line 390 "../lib/application.vala"
						if (g_strcmp0 (action, "about") == 0) {
#line 391 "../lib/application.vala"
							xnp_application_open_about_dialog (self);
#line 1239 "application.c"
						}
					}
				}
			}
		}
	}
}

static void
___lambda48__xnp_window_action (XnpWindow* _sender,
                                const gchar* action,
                                gpointer self)
{
#line 362 "../lib/application.vala"
	__lambda48_ (self, _sender, action);
#line 1255 "application.c"
}

static void
__lambda49_ (XnpApplication* self,
             XnpWindow* win,
             XnpNote* note)
{
	XnpWindowMonitor* _tmp0_;
#line 394 "../lib/application.vala"
	g_return_if_fail (win != NULL);
#line 394 "../lib/application.vala"
	g_return_if_fail (note != NULL);
#line 395 "../lib/application.vala"
	_tmp0_ = win->monitor;
#line 395 "../lib/application.vala"
	xnp_window_monitor_internal_change (_tmp0_);
#line 396 "../lib/application.vala"
	xnp_application_save_note (self, win, note);
#line 1274 "application.c"
}

static void
___lambda49__xnp_window_save_data (XnpWindow* _sender,
                                   XnpNote* note,
                                   gpointer self)
{
#line 394 "../lib/application.vala"
	__lambda49_ ((XnpApplication*) self, _sender, note);
#line 1284 "application.c"
}

static void
__lambda50_ (XnpApplication* self,
             XnpWindow* win,
             XnpNote* note)
{
	XfconfChannel* _tmp0_;
	XnpHypertextView* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 398 "../lib/application.vala"
	g_return_if_fail (win != NULL);
#line 398 "../lib/application.vala"
	g_return_if_fail (note != NULL);
#line 399 "../lib/application.vala"
	if (self->external_event) {
#line 399 "../lib/application.vala"
		return;
#line 1303 "application.c"
	}
#line 400 "../lib/application.vala"
	_tmp0_ = self->priv->xfconf_channel;
#line 400 "../lib/application.vala"
	_tmp1_ = note->text_view;
#line 400 "../lib/application.vala"
	xfconf_g_property_bind (_tmp0_, "/global/font-description", G_TYPE_STRING, _tmp1_, "font");
#line 1311 "application.c"
	{
		XnpWindowMonitor* _tmp2_;
		GFile* file = NULL;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		GFileOutputStream* _tmp10_;
		GFileOutputStream* _tmp11_;
#line 404 "../lib/application.vala"
		note->backed = FALSE;
#line 405 "../lib/application.vala"
		_tmp2_ = win->monitor;
#line 405 "../lib/application.vala"
		xnp_window_monitor_internal_change (_tmp2_);
#line 406 "../lib/application.vala"
		_tmp3_ = self->priv->_notes_path;
#line 406 "../lib/application.vala"
		_tmp4_ = xnp_window_get_name (win);
#line 406 "../lib/application.vala"
		_tmp5_ = _tmp4_;
#line 406 "../lib/application.vala"
		_tmp6_ = xnp_note_get_name (note);
#line 406 "../lib/application.vala"
		_tmp7_ = _tmp6_;
#line 406 "../lib/application.vala"
		_tmp8_ = g_file_new_build_filename (_tmp3_, _tmp5_, _tmp7_, NULL);
#line 406 "../lib/application.vala"
		file = _tmp8_;
#line 407 "../lib/application.vala"
		_tmp9_ = file;
#line 407 "../lib/application.vala"
		_tmp10_ = g_file_create (_tmp9_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 407 "../lib/application.vala"
		_tmp11_ = _tmp10_;
#line 407 "../lib/application.vala"
		_g_object_unref0 (_tmp11_);
#line 407 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 407 "../lib/application.vala"
			_g_object_unref0 (file);
#line 1356 "application.c"
			goto __catch0_g_error;
		}
#line 408 "../lib/application.vala"
		note->backed = TRUE;
#line 403 "../lib/application.vala"
		_g_object_unref0 (file);
#line 1363 "application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 403 "../lib/application.vala"
		e = _inner_error0_;
#line 403 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 411 "../lib/application.vala"
		_tmp12_ = e;
#line 411 "../lib/application.vala"
		_tmp13_ = _tmp12_->message;
#line 411 "../lib/application.vala"
		xnp_window_popup_error (win, _tmp13_);
#line 403 "../lib/application.vala"
		_g_error_free0 (e);
#line 1383 "application.c"
	}
	__finally0:
#line 403 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 403 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 403 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 403 "../lib/application.vala"
		return;
#line 1394 "application.c"
	}
}

static void
___lambda50__xnp_window_note_inserted (XnpWindow* _sender,
                                       XnpNote* note,
                                       gpointer self)
{
#line 398 "../lib/application.vala"
	__lambda50_ ((XnpApplication*) self, _sender, note);
#line 1405 "application.c"
}

static void
__lambda51_ (XnpApplication* self,
             XnpWindow* win,
             XnpNote* note)
{
	GError* _inner_error0_ = NULL;
#line 414 "../lib/application.vala"
	g_return_if_fail (win != NULL);
#line 414 "../lib/application.vala"
	g_return_if_fail (note != NULL);
#line 1418 "application.c"
	{
		GFile* file = NULL;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GFile* _tmp5_;
		XnpWindowMonitor* _tmp6_;
#line 416 "../lib/application.vala"
		_tmp0_ = self->priv->_notes_path;
#line 416 "../lib/application.vala"
		_tmp1_ = xnp_window_get_name (win);
#line 416 "../lib/application.vala"
		_tmp2_ = _tmp1_;
#line 416 "../lib/application.vala"
		_tmp3_ = xnp_note_get_name (note);
#line 416 "../lib/application.vala"
		_tmp4_ = _tmp3_;
#line 416 "../lib/application.vala"
		_tmp5_ = g_file_new_build_filename (_tmp0_, _tmp2_, _tmp4_, NULL);
#line 416 "../lib/application.vala"
		file = _tmp5_;
#line 417 "../lib/application.vala"
		_tmp6_ = win->monitor;
#line 417 "../lib/application.vala"
		xnp_window_monitor_internal_change (_tmp6_);
#line 418 "../lib/application.vala"
		g_file_delete (file, NULL, &_inner_error0_);
#line 418 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 418 "../lib/application.vala"
			_g_object_unref0 (file);
#line 1452 "application.c"
			goto __catch0_g_error;
		}
#line 419 "../lib/application.vala"
		note->backed = FALSE;
#line 415 "../lib/application.vala"
		_g_object_unref0 (file);
#line 1459 "application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 415 "../lib/application.vala"
		e = _inner_error0_;
#line 415 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 422 "../lib/application.vala"
		_tmp7_ = e;
#line 422 "../lib/application.vala"
		_tmp8_ = _tmp7_->message;
#line 422 "../lib/application.vala"
		xnp_window_popup_error (win, _tmp8_);
#line 415 "../lib/application.vala"
		_g_error_free0 (e);
#line 1479 "application.c"
	}
	__finally0:
#line 415 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 415 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 415 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 415 "../lib/application.vala"
		return;
#line 1490 "application.c"
	}
}

static void
___lambda51__xnp_window_note_deleted (XnpWindow* _sender,
                                      XnpNote* note,
                                      gpointer self)
{
#line 414 "../lib/application.vala"
	__lambda51_ ((XnpApplication*) self, _sender, note);
#line 1501 "application.c"
}

static void
__lambda52_ (XnpApplication* self,
             XnpWindow* win,
             XnpNote* note,
             const gchar* name)
{
	GError* _inner_error0_ = NULL;
#line 425 "../lib/application.vala"
	g_return_if_fail (win != NULL);
#line 425 "../lib/application.vala"
	g_return_if_fail (note != NULL);
#line 425 "../lib/application.vala"
	g_return_if_fail (name != NULL);
#line 426 "../lib/application.vala"
	if (!xnp_application_name_is_valid (self, name)) {
#line 427 "../lib/application.vala"
		return;
#line 1521 "application.c"
	}
	{
		GFile* file = NULL;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GFile* _tmp5_;
		XnpWindowMonitor* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
#line 430 "../lib/application.vala"
		_tmp0_ = self->priv->_notes_path;
#line 430 "../lib/application.vala"
		_tmp1_ = xnp_window_get_name (win);
#line 430 "../lib/application.vala"
		_tmp2_ = _tmp1_;
#line 430 "../lib/application.vala"
		_tmp3_ = xnp_note_get_name (note);
#line 430 "../lib/application.vala"
		_tmp4_ = _tmp3_;
#line 430 "../lib/application.vala"
		_tmp5_ = g_file_new_build_filename (_tmp0_, _tmp2_, _tmp4_, NULL);
#line 430 "../lib/application.vala"
		file = _tmp5_;
#line 431 "../lib/application.vala"
		_tmp6_ = win->monitor;
#line 431 "../lib/application.vala"
		xnp_window_monitor_internal_change (_tmp6_);
#line 432 "../lib/application.vala"
		_tmp7_ = file;
#line 432 "../lib/application.vala"
		_tmp8_ = g_file_set_display_name (_tmp7_, name, NULL, &_inner_error0_);
#line 432 "../lib/application.vala"
		_tmp9_ = _tmp8_;
#line 432 "../lib/application.vala"
		_g_object_unref0 (_tmp9_);
#line 432 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 432 "../lib/application.vala"
			_g_object_unref0 (file);
#line 1565 "application.c"
			goto __catch0_g_error;
		}
#line 433 "../lib/application.vala"
		xnp_note_set_name (note, name);
#line 429 "../lib/application.vala"
		_g_object_unref0 (file);
#line 1572 "application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 429 "../lib/application.vala"
		e = _inner_error0_;
#line 429 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 436 "../lib/application.vala"
		_tmp10_ = e;
#line 436 "../lib/application.vala"
		_tmp11_ = _tmp10_->message;
#line 436 "../lib/application.vala"
		xnp_window_popup_error (win, _tmp11_);
#line 429 "../lib/application.vala"
		_g_error_free0 (e);
#line 1592 "application.c"
	}
	__finally0:
#line 429 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 429 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 429 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 429 "../lib/application.vala"
		return;
#line 1603 "application.c"
	}
}

static void
___lambda52__xnp_window_note_renamed (XnpWindow* _sender,
                                      XnpNote* note,
                                      const gchar* name,
                                      gpointer self)
{
#line 425 "../lib/application.vala"
	__lambda52_ ((XnpApplication*) self, _sender, note, name);
#line 1615 "application.c"
}

static gboolean
_xnp_application_save_windows_configuration_gsource_func (gpointer self)
{
	gboolean result;
	result = xnp_application_save_windows_configuration ((XnpApplication*) self);
#line 454 "../lib/application.vala"
	return result;
#line 1625 "application.c"
}

static void
__lambda53_ (Block1Data* _data1_)
{
	XnpApplication* self;
	XnpWindow* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 443 "../lib/application.vala"
	self = _data1_->self;
#line 444 "../lib/application.vala"
	if (self->priv->save_config_timeout > ((guint) 0)) {
#line 445 "../lib/application.vala"
		g_source_remove (self->priv->save_config_timeout);
#line 446 "../lib/application.vala"
		self->priv->save_config_timeout = (guint) 0;
#line 1643 "application.c"
	}
#line 449 "../lib/application.vala"
	_tmp0_ = _data1_->window;
#line 449 "../lib/application.vala"
	g_object_get ((GtkWindow*) _tmp0_, "is-active", &_tmp1_, NULL);
#line 449 "../lib/application.vala"
	_tmp2_ = _tmp1_;
#line 449 "../lib/application.vala"
	if (_tmp2_) {
#line 1653 "application.c"
		XnpWindow* _tmp3_;
		XnpWindow* _tmp4_;
		XnpWindow* _tmp5_;
#line 450 "../lib/application.vala"
		_tmp3_ = _data1_->window;
#line 450 "../lib/application.vala"
		self->priv->focus_order = vala_g_slist_remove_full (self->priv->focus_order, _tmp3_, _g_object_unref0_);
#line 451 "../lib/application.vala"
		_tmp4_ = _data1_->window;
#line 451 "../lib/application.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 451 "../lib/application.vala"
		self->priv->focus_order = g_slist_append (self->priv->focus_order, _tmp5_);
#line 1667 "application.c"
	} else {
#line 453 "../lib/application.vala"
		if (self->system_tray_mode) {
#line 454 "../lib/application.vala"
			self->priv->save_config_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _xnp_application_save_windows_configuration_gsource_func, g_object_ref (self), g_object_unref);
#line 1673 "application.c"
		}
	}
}

static void
___lambda53__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 443 "../lib/application.vala"
	__lambda53_ (self);
#line 1685 "application.c"
}

static gboolean
__lambda54_ (XnpApplication* self,
             XnpWindow* to_win,
             XnpWindow* from_win,
             XnpNote* note)
{
	gboolean _tmp19_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 458 "../lib/application.vala"
	g_return_val_if_fail (to_win != NULL, FALSE);
#line 458 "../lib/application.vala"
	g_return_val_if_fail (from_win != NULL, FALSE);
#line 458 "../lib/application.vala"
	g_return_val_if_fail (note != NULL, FALSE);
#line 1703 "application.c"
	{
		GFile* from_file = NULL;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GFile* _tmp5_;
		GFile* to_file = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		GFile* _tmp11_;
		XnpWindowMonitor* _tmp12_;
		XnpWindowMonitor* _tmp13_;
		GtkEventBox* tab_evbox = NULL;
		GtkEventBox* _tmp14_;
		GtkEventBox* _tmp15_;
		GtkEventBox* _tmp16_;
#line 460 "../lib/application.vala"
		_tmp0_ = self->priv->_notes_path;
#line 460 "../lib/application.vala"
		_tmp1_ = xnp_window_get_name (from_win);
#line 460 "../lib/application.vala"
		_tmp2_ = _tmp1_;
#line 460 "../lib/application.vala"
		_tmp3_ = xnp_note_get_name (note);
#line 460 "../lib/application.vala"
		_tmp4_ = _tmp3_;
#line 460 "../lib/application.vala"
		_tmp5_ = g_file_new_build_filename (_tmp0_, _tmp2_, _tmp4_, NULL);
#line 460 "../lib/application.vala"
		from_file = _tmp5_;
#line 461 "../lib/application.vala"
		_tmp6_ = self->priv->_notes_path;
#line 461 "../lib/application.vala"
		_tmp7_ = xnp_window_get_name (to_win);
#line 461 "../lib/application.vala"
		_tmp8_ = _tmp7_;
#line 461 "../lib/application.vala"
		_tmp9_ = xnp_note_get_name (note);
#line 461 "../lib/application.vala"
		_tmp10_ = _tmp9_;
#line 461 "../lib/application.vala"
		_tmp11_ = g_file_new_build_filename (_tmp6_, _tmp8_, _tmp10_, NULL);
#line 461 "../lib/application.vala"
		to_file = _tmp11_;
#line 462 "../lib/application.vala"
		_tmp12_ = from_win->monitor;
#line 462 "../lib/application.vala"
		xnp_window_monitor_internal_change (_tmp12_);
#line 463 "../lib/application.vala"
		_tmp13_ = to_win->monitor;
#line 463 "../lib/application.vala"
		xnp_window_monitor_internal_change (_tmp13_);
#line 464 "../lib/application.vala"
		g_file_move (from_file, to_file, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 464 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 464 "../lib/application.vala"
			_g_object_unref0 (to_file);
#line 464 "../lib/application.vala"
			_g_object_unref0 (from_file);
#line 1769 "application.c"
			goto __catch0_g_error;
		}
#line 465 "../lib/application.vala"
		_tmp14_ = xnp_window_get_tab_evbox (from_win, note);
#line 465 "../lib/application.vala"
		tab_evbox = _tmp14_;
#line 466 "../lib/application.vala"
		_tmp15_ = tab_evbox;
#line 466 "../lib/application.vala"
		xnp_window_disconnect_note_signals (from_win, note, _tmp15_);
#line 467 "../lib/application.vala"
		_tmp16_ = tab_evbox;
#line 467 "../lib/application.vala"
		xnp_window_connect_note_signals (to_win, note, _tmp16_);
#line 468 "../lib/application.vala"
		result = TRUE;
#line 468 "../lib/application.vala"
		_g_object_unref0 (tab_evbox);
#line 468 "../lib/application.vala"
		_g_object_unref0 (to_file);
#line 468 "../lib/application.vala"
		_g_object_unref0 (from_file);
#line 468 "../lib/application.vala"
		return result;
#line 1794 "application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 459 "../lib/application.vala"
		e = _inner_error0_;
#line 459 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 471 "../lib/application.vala"
		_tmp17_ = e;
#line 471 "../lib/application.vala"
		_tmp18_ = _tmp17_->message;
#line 471 "../lib/application.vala"
		xnp_window_popup_error (to_win, _tmp18_);
#line 472 "../lib/application.vala"
		result = FALSE;
#line 472 "../lib/application.vala"
		_g_error_free0 (e);
#line 472 "../lib/application.vala"
		return result;
#line 1818 "application.c"
	}
	__finally0:
#line 459 "../lib/application.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 459 "../lib/application.vala"
	g_clear_error (&_inner_error0_);
#line 459 "../lib/application.vala"
	return _tmp19_;
#line 1827 "application.c"
}

static gboolean
___lambda54__xnp_window_note_moved (XnpWindow* _sender,
                                    XnpWindow* src_win,
                                    XnpNote* note,
                                    gpointer self)
{
	gboolean result;
	result = __lambda54_ ((XnpApplication*) self, _sender, src_win, note);
#line 458 "../lib/application.vala"
	return result;
#line 1840 "application.c"
}

XnpWindow*
xnp_application_create_window (XnpApplication* self,
                               const gchar* name)
{
	Block1Data* _data1_;
	XnpWindow* _tmp0_;
	XnpWindow* _tmp18_;
	XnpWindow* _tmp19_;
	XnpWindow* _tmp20_;
	XnpWindow* _tmp21_;
	XnpWindow* _tmp22_;
	gchar* window_path = NULL;
	const gchar* _tmp23_;
	XnpWindow* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gboolean _tmp28_ = FALSE;
	XnpWindow* _tmp43_;
	XfconfChannel* _tmp44_;
	XnpWindow* _tmp45_;
	XnpWindow* _tmp46_;
	gboolean _tmp47_;
	gboolean _tmp48_;
	XnpWindow* _tmp49_;
	XnpWindow* _tmp50_;
	XnpWindow* _tmp51_;
	XnpWindow* _tmp52_;
	XnpWindow* _tmp53_;
	XnpWindow* _tmp54_;
	XnpWindow* _tmp55_;
	XnpWindow* _tmp56_;
	XnpWindow* _tmp57_;
	GError* _inner_error0_ = NULL;
	XnpWindow* result;
#line 297 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 297 "../lib/application.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 297 "../lib/application.vala"
	_data1_->_ref_count_ = 1;
#line 297 "../lib/application.vala"
	_data1_->self = g_object_ref (self);
#line 298 "../lib/application.vala"
	_tmp0_ = xnp_window_new (self);
#line 298 "../lib/application.vala"
	g_object_ref_sink (_tmp0_);
#line 298 "../lib/application.vala"
	_data1_->window = _tmp0_;
#line 301 "../lib/application.vala"
	if (name == NULL) {
#line 1894 "application.c"
		XnpWindow* _tmp1_;
		XfconfChannel* _tmp2_;
		XnpWindow* _tmp3_;
		XfconfChannel* _tmp4_;
		gint width = 0;
		XfconfChannel* _tmp5_;
		gint height = 0;
		XfconfChannel* _tmp6_;
		gboolean _tmp7_ = FALSE;
#line 302 "../lib/application.vala"
		_tmp1_ = _data1_->window;
#line 302 "../lib/application.vala"
		_tmp2_ = self->priv->xfconf_channel;
#line 302 "../lib/application.vala"
		xnp_window_set_above (_tmp1_, xfconf_channel_get_bool (_tmp2_, "/new-window/always-on-top", FALSE));
#line 303 "../lib/application.vala"
		_tmp3_ = _data1_->window;
#line 303 "../lib/application.vala"
		_tmp4_ = self->priv->xfconf_channel;
#line 303 "../lib/application.vala"
		xnp_window_set_sticky (_tmp3_, xfconf_channel_get_bool (_tmp4_, "/new-window/sticky", TRUE));
#line 304 "../lib/application.vala"
		_tmp5_ = self->priv->xfconf_channel;
#line 304 "../lib/application.vala"
		width = (gint) xfconf_channel_get_int (_tmp5_, "/new-window/width", (gint32) 0);
#line 305 "../lib/application.vala"
		_tmp6_ = self->priv->xfconf_channel;
#line 305 "../lib/application.vala"
		height = (gint) xfconf_channel_get_int (_tmp6_, "/new-window/height", (gint32) 0);
#line 306 "../lib/application.vala"
		if (width > 0) {
#line 306 "../lib/application.vala"
			_tmp7_ = height > 0;
#line 1928 "application.c"
		} else {
#line 306 "../lib/application.vala"
			_tmp7_ = FALSE;
#line 1932 "application.c"
		}
#line 306 "../lib/application.vala"
		if (_tmp7_) {
#line 1936 "application.c"
			XnpWindow* _tmp8_;
#line 307 "../lib/application.vala"
			_tmp8_ = _data1_->window;
#line 307 "../lib/application.vala"
			gtk_window_resize ((GtkWindow*) _tmp8_, width, height);
#line 1942 "application.c"
		}
	}
#line 312 "../lib/application.vala"
	if (name == NULL) {
#line 1947 "application.c"
		gchar* window_name = NULL;
		gchar* _tmp9_;
		gint len = 0;
		GSList* _tmp10_;
		XnpWindow* _tmp15_;
		const gchar* _tmp16_;
#line 313 "../lib/application.vala"
		_tmp9_ = g_strdup (_ ("Notes"));
#line 313 "../lib/application.vala"
		window_name = _tmp9_;
#line 314 "../lib/application.vala"
		_tmp10_ = self->priv->window_list;
#line 314 "../lib/application.vala"
		len = (gint) g_slist_length (_tmp10_);
#line 1962 "application.c"
		{
			gint id = 0;
#line 315 "../lib/application.vala"
			id = 1;
#line 1967 "application.c"
			{
				gboolean _tmp11_ = FALSE;
#line 315 "../lib/application.vala"
				_tmp11_ = TRUE;
#line 315 "../lib/application.vala"
				while (TRUE) {
#line 1974 "application.c"
					const gchar* _tmp14_;
#line 315 "../lib/application.vala"
					if (!_tmp11_) {
#line 1978 "application.c"
						gint _tmp12_;
#line 315 "../lib/application.vala"
						_tmp12_ = id;
#line 315 "../lib/application.vala"
						id = _tmp12_ + 1;
#line 1984 "application.c"
					}
#line 315 "../lib/application.vala"
					_tmp11_ = FALSE;
#line 315 "../lib/application.vala"
					if (!(id <= (len + 1))) {
#line 315 "../lib/application.vala"
						break;
#line 1992 "application.c"
					}
#line 316 "../lib/application.vala"
					if (id > 1) {
#line 1996 "application.c"
						gchar* _tmp13_;
#line 317 "../lib/application.vala"
						_tmp13_ = g_strdup_printf (_ ("Notes %d"), id);
#line 317 "../lib/application.vala"
						_g_free0 (window_name);
#line 317 "../lib/application.vala"
						window_name = _tmp13_;
#line 2004 "application.c"
					}
#line 319 "../lib/application.vala"
					_tmp14_ = window_name;
#line 319 "../lib/application.vala"
					if (!xnp_application_window_name_exists (self, _tmp14_)) {
#line 320 "../lib/application.vala"
						break;
#line 2012 "application.c"
					}
				}
			}
		}
#line 323 "../lib/application.vala"
		_tmp15_ = _data1_->window;
#line 323 "../lib/application.vala"
		_tmp16_ = window_name;
#line 323 "../lib/application.vala"
		xnp_window_set_name (_tmp15_, _tmp16_);
#line 312 "../lib/application.vala"
		_g_free0 (window_name);
#line 2025 "application.c"
	} else {
		XnpWindow* _tmp17_;
#line 326 "../lib/application.vala"
		_tmp17_ = _data1_->window;
#line 326 "../lib/application.vala"
		xnp_window_set_name (_tmp17_, name);
#line 2032 "application.c"
	}
#line 330 "../lib/application.vala"
	_tmp18_ = _data1_->window;
#line 330 "../lib/application.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 330 "../lib/application.vala"
	_tmp20_ = _data1_->window;
#line 330 "../lib/application.vala"
	self->priv->window_list = g_slist_insert_sorted (self->priv->window_list, _tmp19_, (GCompareFunc) xnp_window_compare_func);
#line 331 "../lib/application.vala"
	_tmp21_ = _data1_->window;
#line 331 "../lib/application.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 331 "../lib/application.vala"
	self->priv->focus_order = g_slist_append (self->priv->focus_order, _tmp22_);
#line 334 "../lib/application.vala"
	_tmp23_ = self->priv->_notes_path;
#line 334 "../lib/application.vala"
	_tmp24_ = _data1_->window;
#line 334 "../lib/application.vala"
	_tmp25_ = xnp_window_get_name (_tmp24_);
#line 334 "../lib/application.vala"
	_tmp26_ = _tmp25_;
#line 334 "../lib/application.vala"
	_tmp27_ = g_strdup_printf ("%s/%s", _tmp23_, _tmp26_);
#line 334 "../lib/application.vala"
	window_path = _tmp27_;
#line 335 "../lib/application.vala"
	if (name == NULL) {
#line 335 "../lib/application.vala"
		_tmp28_ = TRUE;
#line 2064 "application.c"
	} else {
		const gchar* _tmp29_;
#line 335 "../lib/application.vala"
		_tmp29_ = window_path;
#line 335 "../lib/application.vala"
		_tmp28_ = !g_file_test (_tmp29_, G_FILE_TEST_IS_DIR | G_FILE_TEST_EXISTS);
#line 2071 "application.c"
	}
#line 335 "../lib/application.vala"
	if (_tmp28_) {
#line 2075 "application.c"
		{
			const gchar* _tmp30_;
			gchar* note_path = NULL;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			const gchar* _tmp36_;
			XnpWindow* _tmp37_;
#line 337 "../lib/application.vala"
			_tmp30_ = window_path;
#line 337 "../lib/application.vala"
			g_mkdir_with_parents (_tmp30_, 0700);
#line 338 "../lib/application.vala"
			_tmp31_ = window_path;
#line 338 "../lib/application.vala"
			_tmp32_ = g_strdup_printf (_ ("Note %d"), 1);
#line 338 "../lib/application.vala"
			_tmp33_ = _tmp32_;
#line 338 "../lib/application.vala"
			_tmp34_ = g_strdup_printf ("%s/%s", _tmp31_, _tmp33_);
#line 338 "../lib/application.vala"
			_tmp35_ = _tmp34_;
#line 338 "../lib/application.vala"
			_g_free0 (_tmp33_);
#line 338 "../lib/application.vala"
			note_path = _tmp35_;
#line 339 "../lib/application.vala"
			_tmp36_ = note_path;
#line 339 "../lib/application.vala"
			g_file_set_contents (_tmp36_, "", (gssize) -1, &_inner_error0_);
#line 339 "../lib/application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 339 "../lib/application.vala"
				_g_free0 (note_path);
#line 339 "../lib/application.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2114 "application.c"
					goto __catch0_g_file_error;
				}
#line 339 "../lib/application.vala"
				_g_free0 (window_path);
#line 339 "../lib/application.vala"
				block1_data_unref (_data1_);
#line 339 "../lib/application.vala"
				_data1_ = NULL;
#line 339 "../lib/application.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 339 "../lib/application.vala"
				g_clear_error (&_inner_error0_);
#line 339 "../lib/application.vala"
				return NULL;
#line 2129 "application.c"
			}
#line 340 "../lib/application.vala"
			_tmp37_ = _data1_->window;
#line 340 "../lib/application.vala"
			xnp_application_load_window_data (self, _tmp37_);
#line 336 "../lib/application.vala"
			_g_free0 (note_path);
#line 2137 "application.c"
		}
		goto __finally0;
		__catch0_g_file_error:
		{
			GError* e = NULL;
			XnpWindow* _tmp38_;
			GError* _tmp39_;
			const gchar* _tmp40_;
			XnpWindow* _tmp41_;
#line 336 "../lib/application.vala"
			e = _inner_error0_;
#line 336 "../lib/application.vala"
			_inner_error0_ = NULL;
#line 343 "../lib/application.vala"
			_tmp38_ = _data1_->window;
#line 343 "../lib/application.vala"
			_tmp39_ = e;
#line 343 "../lib/application.vala"
			_tmp40_ = _tmp39_->message;
#line 343 "../lib/application.vala"
			xnp_window_popup_error (_tmp38_, _tmp40_);
#line 344 "../lib/application.vala"
			_tmp41_ = _data1_->window;
#line 344 "../lib/application.vala"
			xnp_application_destroy_window (self, _tmp41_);
#line 345 "../lib/application.vala"
			result = NULL;
#line 345 "../lib/application.vala"
			_g_error_free0 (e);
#line 345 "../lib/application.vala"
			_g_free0 (window_path);
#line 345 "../lib/application.vala"
			block1_data_unref (_data1_);
#line 345 "../lib/application.vala"
			_data1_ = NULL;
#line 345 "../lib/application.vala"
			return result;
#line 2175 "application.c"
		}
		__finally0:
#line 336 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 336 "../lib/application.vala"
			_g_free0 (window_path);
#line 336 "../lib/application.vala"
			block1_data_unref (_data1_);
#line 336 "../lib/application.vala"
			_data1_ = NULL;
#line 336 "../lib/application.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 336 "../lib/application.vala"
			g_clear_error (&_inner_error0_);
#line 336 "../lib/application.vala"
			return NULL;
#line 2192 "application.c"
		}
	} else {
		XnpWindow* _tmp42_;
#line 349 "../lib/application.vala"
		_tmp42_ = _data1_->window;
#line 349 "../lib/application.vala"
		xnp_application_load_window_data (self, _tmp42_);
#line 2200 "application.c"
	}
#line 353 "../lib/application.vala"
	_tmp43_ = _data1_->window;
#line 353 "../lib/application.vala"
	xnp_application_set_window_monitor (self, _tmp43_);
#line 356 "../lib/application.vala"
	_tmp44_ = self->priv->xfconf_channel;
#line 356 "../lib/application.vala"
	_tmp45_ = _data1_->window;
#line 356 "../lib/application.vala"
	xfconf_g_property_bind (_tmp44_, "/global/tabs-position", G_TYPE_INT, _tmp45_, "tabs-position");
#line 359 "../lib/application.vala"
	_tmp46_ = _data1_->window;
#line 359 "../lib/application.vala"
	_tmp47_ = xnp_application_get_skip_taskbar_hint (self);
#line 359 "../lib/application.vala"
	_tmp48_ = _tmp47_;
#line 359 "../lib/application.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) _tmp46_, _tmp48_);
#line 362 "../lib/application.vala"
	_tmp49_ = _data1_->window;
#line 362 "../lib/application.vala"
	g_signal_connect_data (_tmp49_, "action", (GCallback) ___lambda48__xnp_window_action, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 394 "../lib/application.vala"
	_tmp50_ = _data1_->window;
#line 394 "../lib/application.vala"
	g_signal_connect_object (_tmp50_, "save-data", (GCallback) ___lambda49__xnp_window_save_data, self, 0);
#line 398 "../lib/application.vala"
	_tmp51_ = _data1_->window;
#line 398 "../lib/application.vala"
	g_signal_connect_object (_tmp51_, "note-inserted", (GCallback) ___lambda50__xnp_window_note_inserted, self, 0);
#line 414 "../lib/application.vala"
	_tmp52_ = _data1_->window;
#line 414 "../lib/application.vala"
	g_signal_connect_object (_tmp52_, "note-deleted", (GCallback) ___lambda51__xnp_window_note_deleted, self, 0);
#line 425 "../lib/application.vala"
	_tmp53_ = _data1_->window;
#line 425 "../lib/application.vala"
	g_signal_connect_object (_tmp53_, "note-renamed", (GCallback) ___lambda52__xnp_window_note_renamed, self, 0);
#line 443 "../lib/application.vala"
	_tmp54_ = _data1_->window;
#line 443 "../lib/application.vala"
	g_signal_connect_data ((GObject*) _tmp54_, "notify::is-active", (GCallback) ___lambda53__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 458 "../lib/application.vala"
	_tmp55_ = _data1_->window;
#line 458 "../lib/application.vala"
	g_signal_connect_object (_tmp55_, "note-moved", (GCallback) ___lambda54__xnp_window_note_moved, self, 0);
#line 476 "../lib/application.vala"
	_tmp56_ = _data1_->window;
#line 476 "../lib/application.vala"
	_tmp57_ = _g_object_ref0 (_tmp56_);
#line 476 "../lib/application.vala"
	result = _tmp57_;
#line 476 "../lib/application.vala"
	_g_free0 (window_path);
#line 476 "../lib/application.vala"
	block1_data_unref (_data1_);
#line 476 "../lib/application.vala"
	_data1_ = NULL;
#line 476 "../lib/application.vala"
	return result;
#line 2262 "application.c"
}

/**
 * load_window_data:
 *
 * Load existing notes and configuration inside the window.
 */
static void
xnp_application_load_window_data (XnpApplication* self,
                                  XnpWindow* window)
{
	gchar* name = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 484 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 484 "../lib/application.vala"
	g_return_if_fail (window != NULL);
#line 487 "../lib/application.vala"
	_tmp0_ = self->priv->_notes_path;
#line 487 "../lib/application.vala"
	_tmp1_ = xnp_window_get_name (window);
#line 487 "../lib/application.vala"
	_tmp2_ = _tmp1_;
#line 487 "../lib/application.vala"
	_tmp3_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp2_);
#line 487 "../lib/application.vala"
	path = _tmp3_;
#line 2297 "application.c"
	{
		GDir* dir = NULL;
		const gchar* _tmp4_;
		GDir* _tmp5_;
#line 489 "../lib/application.vala"
		_tmp4_ = path;
#line 489 "../lib/application.vala"
		_tmp5_ = g_dir_open (_tmp4_, (guint) 0, &_inner_error0_);
#line 489 "../lib/application.vala"
		dir = _tmp5_;
#line 489 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 489 "../lib/application.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2312 "application.c"
				goto __catch0_g_file_error;
			}
#line 489 "../lib/application.vala"
			_g_free0 (path);
#line 489 "../lib/application.vala"
			_g_free0 (name);
#line 489 "../lib/application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 489 "../lib/application.vala"
			g_clear_error (&_inner_error0_);
#line 489 "../lib/application.vala"
			return;
#line 2325 "application.c"
		}
#line 490 "../lib/application.vala"
		while (TRUE) {
#line 2329 "application.c"
			GDir* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
#line 490 "../lib/application.vala"
			_tmp6_ = dir;
#line 490 "../lib/application.vala"
			_tmp7_ = g_dir_read_name (_tmp6_);
#line 490 "../lib/application.vala"
			_tmp8_ = g_strdup (_tmp7_);
#line 490 "../lib/application.vala"
			_g_free0 (name);
#line 490 "../lib/application.vala"
			name = _tmp8_;
#line 490 "../lib/application.vala"
			_tmp9_ = name;
#line 490 "../lib/application.vala"
			if (!(_tmp9_ != NULL)) {
#line 490 "../lib/application.vala"
				break;
#line 2351 "application.c"
			}
#line 491 "../lib/application.vala"
			_tmp10_ = name;
#line 491 "../lib/application.vala"
			xnp_application_load_note (self, window, _tmp10_);
#line 2357 "application.c"
		}
#line 488 "../lib/application.vala"
		_g_dir_close0 (dir);
#line 2361 "application.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 488 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 2368 "application.c"
	}
	__finally0:
#line 488 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 488 "../lib/application.vala"
		_g_free0 (path);
#line 488 "../lib/application.vala"
		_g_free0 (name);
#line 488 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 488 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 488 "../lib/application.vala"
		return;
#line 2383 "application.c"
	}
#line 498 "../lib/application.vala"
	_tmp11_ = g_key_file_new ();
#line 498 "../lib/application.vala"
	keyfile = _tmp11_;
#line 2389 "application.c"
	{
		GKeyFile* _tmp12_;
		const gchar* _tmp13_;
		gint winx = 0;
		GKeyFile* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gint winy = 0;
		GKeyFile* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gint width = 0;
		GKeyFile* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gint height = 0;
		GKeyFile* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar** tabs_order = NULL;
		GKeyFile* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gsize _tmp29_ = 0;
		gchar** _tmp30_;
		gint tabs_order_length1;
		gint _tabs_order_size_;
		gint last_page = 0;
		GKeyFile* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		gboolean above = FALSE;
		GKeyFile* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		gboolean sticky = FALSE;
		GKeyFile* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gint _tmp40_ = 0;
		GKeyFile* _tmp41_;
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		gdouble opacity = 0.0;
		gboolean visible = FALSE;
		GKeyFile* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
#line 500 "../lib/application.vala"
		_tmp12_ = keyfile;
#line 500 "../lib/application.vala"
		_tmp13_ = self->priv->_config_file;
#line 500 "../lib/application.vala"
		g_key_file_load_from_file (_tmp12_, _tmp13_, G_KEY_FILE_NONE, &_inner_error0_);
#line 500 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2446 "application.c"
			goto __catch1_g_error;
		}
#line 501 "../lib/application.vala"
		_tmp14_ = keyfile;
#line 501 "../lib/application.vala"
		_tmp15_ = xnp_window_get_name (window);
#line 501 "../lib/application.vala"
		_tmp16_ = _tmp15_;
#line 501 "../lib/application.vala"
		winx = g_key_file_get_integer (_tmp14_, _tmp16_, "PosX", &_inner_error0_);
#line 501 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2459 "application.c"
			goto __catch1_g_error;
		}
#line 502 "../lib/application.vala"
		_tmp17_ = keyfile;
#line 502 "../lib/application.vala"
		_tmp18_ = xnp_window_get_name (window);
#line 502 "../lib/application.vala"
		_tmp19_ = _tmp18_;
#line 502 "../lib/application.vala"
		winy = g_key_file_get_integer (_tmp17_, _tmp19_, "PosY", &_inner_error0_);
#line 502 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2472 "application.c"
			goto __catch1_g_error;
		}
#line 503 "../lib/application.vala"
		_tmp20_ = keyfile;
#line 503 "../lib/application.vala"
		_tmp21_ = xnp_window_get_name (window);
#line 503 "../lib/application.vala"
		_tmp22_ = _tmp21_;
#line 503 "../lib/application.vala"
		width = g_key_file_get_integer (_tmp20_, _tmp22_, "Width", &_inner_error0_);
#line 503 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2485 "application.c"
			goto __catch1_g_error;
		}
#line 504 "../lib/application.vala"
		_tmp23_ = keyfile;
#line 504 "../lib/application.vala"
		_tmp24_ = xnp_window_get_name (window);
#line 504 "../lib/application.vala"
		_tmp25_ = _tmp24_;
#line 504 "../lib/application.vala"
		height = g_key_file_get_integer (_tmp23_, _tmp25_, "Height", &_inner_error0_);
#line 504 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2498 "application.c"
			goto __catch1_g_error;
		}
#line 505 "../lib/application.vala"
		_tmp26_ = keyfile;
#line 505 "../lib/application.vala"
		_tmp27_ = xnp_window_get_name (window);
#line 505 "../lib/application.vala"
		_tmp28_ = _tmp27_;
#line 505 "../lib/application.vala"
		_tmp30_ = g_key_file_get_string_list (_tmp26_, _tmp28_, "TabsOrder", &_tmp29_, &_inner_error0_);
#line 505 "../lib/application.vala"
		tabs_order = _tmp30_;
#line 505 "../lib/application.vala"
		tabs_order_length1 = _tmp29_;
#line 505 "../lib/application.vala"
		_tabs_order_size_ = tabs_order_length1;
#line 505 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2517 "application.c"
			goto __catch1_g_error;
		}
#line 506 "../lib/application.vala"
		_tmp31_ = keyfile;
#line 506 "../lib/application.vala"
		_tmp32_ = xnp_window_get_name (window);
#line 506 "../lib/application.vala"
		_tmp33_ = _tmp32_;
#line 506 "../lib/application.vala"
		last_page = g_key_file_get_integer (_tmp31_, _tmp33_, "LastTab", &_inner_error0_);
#line 506 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 506 "../lib/application.vala"
			tabs_order = (_vala_array_free (tabs_order, tabs_order_length1, (GDestroyNotify) g_free), NULL);
#line 2532 "application.c"
			goto __catch1_g_error;
		}
#line 507 "../lib/application.vala"
		_tmp34_ = keyfile;
#line 507 "../lib/application.vala"
		_tmp35_ = xnp_window_get_name (window);
#line 507 "../lib/application.vala"
		_tmp36_ = _tmp35_;
#line 507 "../lib/application.vala"
		above = g_key_file_get_boolean (_tmp34_, _tmp36_, "Above", &_inner_error0_);
#line 507 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 507 "../lib/application.vala"
			tabs_order = (_vala_array_free (tabs_order, tabs_order_length1, (GDestroyNotify) g_free), NULL);
#line 2547 "application.c"
			goto __catch1_g_error;
		}
#line 508 "../lib/application.vala"
		_tmp37_ = keyfile;
#line 508 "../lib/application.vala"
		_tmp38_ = xnp_window_get_name (window);
#line 508 "../lib/application.vala"
		_tmp39_ = _tmp38_;
#line 508 "../lib/application.vala"
		sticky = g_key_file_get_boolean (_tmp37_, _tmp39_, "Sticky", &_inner_error0_);
#line 508 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 508 "../lib/application.vala"
			tabs_order = (_vala_array_free (tabs_order, tabs_order_length1, (GDestroyNotify) g_free), NULL);
#line 2562 "application.c"
			goto __catch1_g_error;
		}
#line 509 "../lib/application.vala"
		_tmp41_ = keyfile;
#line 509 "../lib/application.vala"
		_tmp42_ = xnp_window_get_name (window);
#line 509 "../lib/application.vala"
		_tmp43_ = _tmp42_;
#line 509 "../lib/application.vala"
		_tmp40_ = g_key_file_get_integer (_tmp41_, _tmp43_, "Transparency", &_inner_error0_);
#line 509 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 509 "../lib/application.vala"
			tabs_order = (_vala_array_free (tabs_order, tabs_order_length1, (GDestroyNotify) g_free), NULL);
#line 2577 "application.c"
			goto __catch1_g_error;
		}
#line 509 "../lib/application.vala"
		opacity = 1 - (((gdouble) _tmp40_) / 100);
#line 510 "../lib/application.vala"
		_tmp44_ = keyfile;
#line 510 "../lib/application.vala"
		_tmp45_ = xnp_window_get_name (window);
#line 510 "../lib/application.vala"
		_tmp46_ = _tmp45_;
#line 510 "../lib/application.vala"
		visible = g_key_file_get_boolean (_tmp44_, _tmp46_, "Visible", &_inner_error0_);
#line 510 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 510 "../lib/application.vala"
			tabs_order = (_vala_array_free (tabs_order, tabs_order_length1, (GDestroyNotify) g_free), NULL);
#line 2594 "application.c"
			goto __catch1_g_error;
		}
#line 512 "../lib/application.vala"
		gtk_window_move ((GtkWindow*) window, winx, winy);
#line 513 "../lib/application.vala"
		gtk_window_resize ((GtkWindow*) window, width, height);
#line 2601 "application.c"
		{
			gint i = 0;
#line 514 "../lib/application.vala"
			i = 0;
#line 2606 "application.c"
			{
				gboolean _tmp47_ = FALSE;
#line 514 "../lib/application.vala"
				_tmp47_ = TRUE;
#line 514 "../lib/application.vala"
				while (TRUE) {
#line 2613 "application.c"
					gchar** _tmp49_;
					gint _tmp49__length1;
					gchar** _tmp50_;
					gint _tmp50__length1;
					const gchar* _tmp51_;
#line 514 "../lib/application.vala"
					if (!_tmp47_) {
#line 2621 "application.c"
						gint _tmp48_;
#line 514 "../lib/application.vala"
						_tmp48_ = i;
#line 514 "../lib/application.vala"
						i = _tmp48_ + 1;
#line 2627 "application.c"
					}
#line 514 "../lib/application.vala"
					_tmp47_ = FALSE;
#line 514 "../lib/application.vala"
					_tmp49_ = tabs_order;
#line 514 "../lib/application.vala"
					_tmp49__length1 = tabs_order_length1;
#line 514 "../lib/application.vala"
					if (!(i < _tmp49__length1)) {
#line 514 "../lib/application.vala"
						break;
#line 2639 "application.c"
					}
#line 515 "../lib/application.vala"
					_tmp50_ = tabs_order;
#line 515 "../lib/application.vala"
					_tmp50__length1 = tabs_order_length1;
#line 515 "../lib/application.vala"
					_tmp51_ = _tmp50_[i];
#line 515 "../lib/application.vala"
					xnp_window_move_note (window, _tmp51_, i);
#line 2649 "application.c"
				}
			}
		}
#line 516 "../lib/application.vala"
		xnp_window_set_current_page (window, last_page);
#line 517 "../lib/application.vala"
		xnp_window_set_above (window, above);
#line 518 "../lib/application.vala"
		xnp_window_set_sticky (window, sticky);
#line 519 "../lib/application.vala"
		gtk_widget_set_opacity ((GtkWidget*) window, opacity);
#line 520 "../lib/application.vala"
		if (visible) {
#line 521 "../lib/application.vala"
			gtk_widget_show ((GtkWidget*) window);
#line 2665 "application.c"
		}
#line 499 "../lib/application.vala"
		tabs_order = (_vala_array_free (tabs_order, tabs_order_length1, (GDestroyNotify) g_free), NULL);
#line 2669 "application.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		XfconfChannel* _tmp52_;
		XfconfChannel* _tmp53_;
		gint width = 0;
		XfconfChannel* _tmp54_;
		gint height = 0;
		XfconfChannel* _tmp55_;
		gboolean _tmp56_ = FALSE;
#line 499 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 524 "../lib/application.vala"
		_tmp52_ = self->priv->xfconf_channel;
#line 524 "../lib/application.vala"
		xnp_window_set_above (window, xfconf_channel_get_bool (_tmp52_, "/new-window/always-on-top", FALSE));
#line 525 "../lib/application.vala"
		_tmp53_ = self->priv->xfconf_channel;
#line 525 "../lib/application.vala"
		xnp_window_set_sticky (window, xfconf_channel_get_bool (_tmp53_, "/new-window/sticky", TRUE));
#line 526 "../lib/application.vala"
		_tmp54_ = self->priv->xfconf_channel;
#line 526 "../lib/application.vala"
		width = (gint) xfconf_channel_get_int (_tmp54_, "/new-window/width", (gint32) 0);
#line 527 "../lib/application.vala"
		_tmp55_ = self->priv->xfconf_channel;
#line 527 "../lib/application.vala"
		height = (gint) xfconf_channel_get_int (_tmp55_, "/new-window/height", (gint32) 0);
#line 528 "../lib/application.vala"
		if (width > 0) {
#line 528 "../lib/application.vala"
			_tmp56_ = height > 0;
#line 2703 "application.c"
		} else {
#line 528 "../lib/application.vala"
			_tmp56_ = FALSE;
#line 2707 "application.c"
		}
#line 528 "../lib/application.vala"
		if (_tmp56_) {
#line 529 "../lib/application.vala"
			gtk_window_resize ((GtkWindow*) window, width, height);
#line 2713 "application.c"
		}
#line 531 "../lib/application.vala"
		gtk_widget_show ((GtkWidget*) window);
#line 2717 "application.c"
	}
	__finally1:
#line 499 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 499 "../lib/application.vala"
		_g_key_file_unref0 (keyfile);
#line 499 "../lib/application.vala"
		_g_free0 (path);
#line 499 "../lib/application.vala"
		_g_free0 (name);
#line 499 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 499 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 499 "../lib/application.vala"
		return;
#line 2734 "application.c"
	}
#line 484 "../lib/application.vala"
	_g_key_file_unref0 (keyfile);
#line 484 "../lib/application.vala"
	_g_free0 (path);
#line 484 "../lib/application.vala"
	_g_free0 (name);
#line 2742 "application.c"
}

/**
 * load_note:
 *
 * Load existing note to the window.
 */
static void
xnp_application_load_note (XnpApplication* self,
                           XnpWindow* window,
                           const gchar* note_name)
{
	GError* _inner_error0_ = NULL;
#line 540 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 540 "../lib/application.vala"
	g_return_if_fail (window != NULL);
#line 540 "../lib/application.vala"
	g_return_if_fail (note_name != NULL);
#line 2762 "application.c"
	{
		gchar* contents = NULL;
		GFile* file = NULL;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 543 "../lib/application.vala"
		_tmp0_ = self->priv->_notes_path;
#line 543 "../lib/application.vala"
		_tmp1_ = xnp_window_get_name (window);
#line 543 "../lib/application.vala"
		_tmp2_ = _tmp1_;
#line 543 "../lib/application.vala"
		_tmp3_ = g_file_new_build_filename (_tmp0_, _tmp2_, note_name, NULL);
#line 543 "../lib/application.vala"
		file = _tmp3_;
#line 544 "../lib/application.vala"
		_tmp4_ = file;
#line 544 "../lib/application.vala"
		if (xnp_file_utils_validate_text_file (_tmp4_)) {
#line 2785 "application.c"
			GFile* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_ = NULL;
			XnpNote* note = NULL;
			XnpNote* _tmp9_;
			XnpNote* _tmp10_;
			const gchar* _tmp11_;
			XfconfChannel* _tmp12_;
			XnpNote* _tmp13_;
			XnpHypertextView* _tmp14_;
			XnpNote* _tmp15_;
#line 545 "../lib/application.vala"
			_tmp5_ = file;
#line 545 "../lib/application.vala"
			_tmp6_ = g_file_get_path (_tmp5_);
#line 545 "../lib/application.vala"
			_tmp7_ = _tmp6_;
#line 545 "../lib/application.vala"
			g_file_get_contents (_tmp7_, &_tmp8_, NULL, &_inner_error0_);
#line 545 "../lib/application.vala"
			_g_free0 (contents);
#line 545 "../lib/application.vala"
			contents = _tmp8_;
#line 545 "../lib/application.vala"
			_g_free0 (_tmp7_);
#line 545 "../lib/application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 545 "../lib/application.vala"
				_g_object_unref0 (file);
#line 545 "../lib/application.vala"
				_g_free0 (contents);
#line 545 "../lib/application.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2820 "application.c"
					goto __catch0_g_file_error;
				}
#line 545 "../lib/application.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 545 "../lib/application.vala"
				g_clear_error (&_inner_error0_);
#line 545 "../lib/application.vala"
				return;
#line 2829 "application.c"
			}
#line 546 "../lib/application.vala"
			_tmp9_ = xnp_window_insert_note (window, note_name);
#line 546 "../lib/application.vala"
			note = _tmp9_;
#line 547 "../lib/application.vala"
			_tmp10_ = note;
#line 547 "../lib/application.vala"
			_tmp11_ = contents;
#line 547 "../lib/application.vala"
			xnp_note_set_text (_tmp10_, _tmp11_);
#line 548 "../lib/application.vala"
			_tmp12_ = self->priv->xfconf_channel;
#line 548 "../lib/application.vala"
			_tmp13_ = note;
#line 548 "../lib/application.vala"
			_tmp14_ = _tmp13_->text_view;
#line 548 "../lib/application.vala"
			xfconf_g_property_bind (_tmp12_, "/global/font-description", G_TYPE_STRING, _tmp14_, "font");
#line 550 "../lib/application.vala"
			_tmp15_ = note;
#line 550 "../lib/application.vala"
			_tmp15_->backed = TRUE;
#line 544 "../lib/application.vala"
			_g_object_unref0 (note);
#line 2855 "application.c"
		}
#line 541 "../lib/application.vala"
		_g_object_unref0 (file);
#line 541 "../lib/application.vala"
		_g_free0 (contents);
#line 2861 "application.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 541 "../lib/application.vala"
		e = _inner_error0_;
#line 541 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 554 "../lib/application.vala"
		_tmp16_ = e;
#line 554 "../lib/application.vala"
		_tmp17_ = _tmp16_->message;
#line 554 "../lib/application.vala"
		g_warning ("application.vala:554: %s", _tmp17_);
#line 541 "../lib/application.vala"
		_g_error_free0 (e);
#line 2881 "application.c"
	}
	__finally0:
#line 541 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 541 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 541 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 541 "../lib/application.vala"
		return;
#line 2892 "application.c"
	}
}

/**
 * reload_note:
 *
 * Reload externally updated note.
 */
static void
xnp_application_reload_note (XnpApplication* self,
                             XnpWindow* window,
                             const gchar* note_name)
{
	XnpNote* note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp4_;
	XnpNote* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 563 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 563 "../lib/application.vala"
	g_return_if_fail (window != NULL);
#line 563 "../lib/application.vala"
	g_return_if_fail (note_name != NULL);
#line 564 "../lib/application.vala"
	_tmp0_ = xnp_window_find_note_by_name (window, note_name);
#line 564 "../lib/application.vala"
	note = _tmp0_;
#line 567 "../lib/application.vala"
	_tmp1_ = note;
#line 567 "../lib/application.vala"
	if (_tmp1_ == NULL) {
#line 2926 "application.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 568 "../lib/application.vala"
		_tmp2_ = xnp_window_get_name (window);
#line 568 "../lib/application.vala"
		_tmp3_ = _tmp2_;
#line 568 "../lib/application.vala"
		g_warning ("application.vala:568: Note '%s' not found in '%s'", note_name, _tmp3_);
#line 569 "../lib/application.vala"
		_g_object_unref0 (note);
#line 569 "../lib/application.vala"
		return;
#line 2939 "application.c"
	}
#line 572 "../lib/application.vala"
	_tmp4_ = note;
#line 572 "../lib/application.vala"
	_tmp4_->backed = FALSE;
#line 2945 "application.c"
	{
		gchar* contents = NULL;
		GFile* file = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
#line 576 "../lib/application.vala"
		_tmp5_ = self->priv->_notes_path;
#line 576 "../lib/application.vala"
		_tmp6_ = xnp_window_get_name (window);
#line 576 "../lib/application.vala"
		_tmp7_ = _tmp6_;
#line 576 "../lib/application.vala"
		_tmp8_ = g_file_new_build_filename (_tmp5_, _tmp7_, note_name, NULL);
#line 576 "../lib/application.vala"
		file = _tmp8_;
#line 577 "../lib/application.vala"
		_tmp9_ = file;
#line 577 "../lib/application.vala"
		if (xnp_file_utils_validate_text_file (_tmp9_)) {
#line 2968 "application.c"
			GFile* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_ = NULL;
			gdouble adjustment = 0.0;
			XnpNote* _tmp14_;
			gdouble _tmp15_;
			gdouble _tmp16_;
			gint cursor = 0;
			XnpNote* _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			XnpNote* _tmp20_;
			const gchar* _tmp21_;
			XnpNote* _tmp22_;
			XnpNote* _tmp23_;
			XnpNote* _tmp24_;
#line 578 "../lib/application.vala"
			_tmp10_ = file;
#line 578 "../lib/application.vala"
			_tmp11_ = g_file_get_path (_tmp10_);
#line 578 "../lib/application.vala"
			_tmp12_ = _tmp11_;
#line 578 "../lib/application.vala"
			g_file_get_contents (_tmp12_, &_tmp13_, NULL, &_inner_error0_);
#line 578 "../lib/application.vala"
			_g_free0 (contents);
#line 578 "../lib/application.vala"
			contents = _tmp13_;
#line 578 "../lib/application.vala"
			_g_free0 (_tmp12_);
#line 578 "../lib/application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 578 "../lib/application.vala"
				_g_object_unref0 (file);
#line 578 "../lib/application.vala"
				_g_free0 (contents);
#line 578 "../lib/application.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3008 "application.c"
					goto __catch0_g_file_error;
				}
#line 578 "../lib/application.vala"
				_g_object_unref0 (note);
#line 578 "../lib/application.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 578 "../lib/application.vala"
				g_clear_error (&_inner_error0_);
#line 578 "../lib/application.vala"
				return;
#line 3019 "application.c"
			}
#line 579 "../lib/application.vala"
			_tmp14_ = note;
#line 579 "../lib/application.vala"
			_tmp15_ = xnp_note_get_adjustment (_tmp14_);
#line 579 "../lib/application.vala"
			_tmp16_ = _tmp15_;
#line 579 "../lib/application.vala"
			adjustment = _tmp16_;
#line 580 "../lib/application.vala"
			_tmp17_ = note;
#line 580 "../lib/application.vala"
			_tmp18_ = xnp_note_get_cursor (_tmp17_);
#line 580 "../lib/application.vala"
			_tmp19_ = _tmp18_;
#line 580 "../lib/application.vala"
			cursor = _tmp19_;
#line 581 "../lib/application.vala"
			_tmp20_ = note;
#line 581 "../lib/application.vala"
			_tmp21_ = contents;
#line 581 "../lib/application.vala"
			xnp_note_set_text (_tmp20_, _tmp21_);
#line 582 "../lib/application.vala"
			_tmp22_ = note;
#line 582 "../lib/application.vala"
			xnp_note_set_cursor (_tmp22_, cursor);
#line 583 "../lib/application.vala"
			_tmp23_ = note;
#line 583 "../lib/application.vala"
			xnp_note_set_adjustment (_tmp23_, adjustment);
#line 584 "../lib/application.vala"
			_tmp24_ = note;
#line 584 "../lib/application.vala"
			_tmp24_->backed = TRUE;
#line 3055 "application.c"
		}
#line 574 "../lib/application.vala"
		_g_object_unref0 (file);
#line 574 "../lib/application.vala"
		_g_free0 (contents);
#line 3061 "application.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 574 "../lib/application.vala"
		e = _inner_error0_;
#line 574 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 588 "../lib/application.vala"
		_tmp25_ = e;
#line 588 "../lib/application.vala"
		_tmp26_ = _tmp25_->message;
#line 588 "../lib/application.vala"
		g_warning ("application.vala:588: %s", _tmp26_);
#line 574 "../lib/application.vala"
		_g_error_free0 (e);
#line 3081 "application.c"
	}
	__finally0:
#line 574 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 574 "../lib/application.vala"
		_g_object_unref0 (note);
#line 574 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 574 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 574 "../lib/application.vala"
		return;
#line 3094 "application.c"
	}
#line 591 "../lib/application.vala"
	_tmp27_ = note;
#line 591 "../lib/application.vala"
	if (!_tmp27_->backed) {
#line 592 "../lib/application.vala"
		xnp_window_externally_removed (window, note_name);
#line 3102 "application.c"
	}
#line 563 "../lib/application.vala"
	_g_object_unref0 (note);
#line 3106 "application.c"
}

/**
 * save_windows_configuration:
 *
 * Save window configuration inside rc file.
 */
gboolean
xnp_application_save_windows_configuration (XnpApplication* self)
{
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp0_;
	gchar* old_contents = NULL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 600 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 601 "../lib/application.vala"
	_tmp0_ = g_key_file_new ();
#line 601 "../lib/application.vala"
	keyfile = _tmp0_;
#line 3128 "application.c"
	{
		const gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
#line 604 "../lib/application.vala"
		_tmp1_ = self->priv->_config_file;
#line 604 "../lib/application.vala"
		g_file_get_contents (_tmp1_, &_tmp2_, NULL, &_inner_error0_);
#line 604 "../lib/application.vala"
		_g_free0 (old_contents);
#line 604 "../lib/application.vala"
		old_contents = _tmp2_;
#line 604 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3142 "application.c"
			gboolean _tmp3_ = FALSE;
#line 604 "../lib/application.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3146 "application.c"
				goto __catch0_g_file_error;
			}
#line 604 "../lib/application.vala"
			_g_free0 (old_contents);
#line 604 "../lib/application.vala"
			_g_key_file_unref0 (keyfile);
#line 604 "../lib/application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 604 "../lib/application.vala"
			g_clear_error (&_inner_error0_);
#line 604 "../lib/application.vala"
			return _tmp3_;
#line 3159 "application.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 603 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 3167 "application.c"
	}
	__finally0:
#line 603 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3172 "application.c"
		gboolean _tmp4_ = FALSE;
#line 603 "../lib/application.vala"
		_g_free0 (old_contents);
#line 603 "../lib/application.vala"
		_g_key_file_unref0 (keyfile);
#line 603 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 603 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 603 "../lib/application.vala"
		return _tmp4_;
#line 3184 "application.c"
	}
	{
		GSList* _tmp5_;
		gchar* contents = NULL;
		gchar* _tmp57_;
		const gchar* _tmp58_;
#line 609 "../lib/application.vala"
		_tmp5_ = self->priv->focus_order;
#line 3193 "application.c"
		{
			GSList* win_collection = NULL;
			GSList* win_it = NULL;
#line 609 "../lib/application.vala"
			win_collection = _tmp5_;
#line 609 "../lib/application.vala"
			for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 3201 "application.c"
				XnpWindow* _tmp6_;
				XnpWindow* win = NULL;
#line 609 "../lib/application.vala"
				_tmp6_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 609 "../lib/application.vala"
				win = _tmp6_;
#line 3208 "application.c"
				{
					gint winx = 0;
					gint winy = 0;
					gint width = 0;
					gint height = 0;
					XnpWindow* _tmp7_;
					gint _tmp8_ = 0;
					gint _tmp9_ = 0;
					gint _tmp10_ = 0;
					gint _tmp11_ = 0;
					gchar** tabs_order = NULL;
					XnpWindow* _tmp12_;
					gint _tmp13_ = 0;
					gchar** _tmp14_;
					gint tabs_order_length1;
					gint _tabs_order_size_;
					gint last_page = 0;
					XnpWindow* _tmp15_;
					gint transparency = 0;
					XnpWindow* _tmp16_;
					gdouble _tmp17_;
					gdouble _tmp18_;
					gboolean visible = FALSE;
					XnpWindow* _tmp19_;
					XnpWindow* _tmp20_;
					const gchar* _tmp21_;
					const gchar* _tmp22_;
					XnpWindow* _tmp23_;
					const gchar* _tmp24_;
					const gchar* _tmp25_;
					XnpWindow* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					XnpWindow* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					XnpWindow* _tmp32_;
					const gchar* _tmp33_;
					const gchar* _tmp34_;
					gchar** _tmp35_;
					gint _tmp35__length1;
					XnpWindow* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					XnpWindow* _tmp39_;
					const gchar* _tmp40_;
					const gchar* _tmp41_;
					XnpWindow* _tmp42_;
					gboolean _tmp43_;
					gboolean _tmp44_;
					XnpWindow* _tmp45_;
					const gchar* _tmp46_;
					const gchar* _tmp47_;
					XnpWindow* _tmp48_;
					gboolean _tmp49_;
					gboolean _tmp50_;
					XnpWindow* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_;
					XnpWindow* _tmp54_;
					const gchar* _tmp55_;
					const gchar* _tmp56_;
#line 611 "../lib/application.vala"
					_tmp7_ = win;
#line 611 "../lib/application.vala"
					xnp_window_get_geometry (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 611 "../lib/application.vala"
					winx = _tmp8_;
#line 611 "../lib/application.vala"
					winy = _tmp9_;
#line 611 "../lib/application.vala"
					width = _tmp10_;
#line 611 "../lib/application.vala"
					height = _tmp11_;
#line 612 "../lib/application.vala"
					_tmp12_ = win;
#line 612 "../lib/application.vala"
					_tmp14_ = xnp_window_get_note_names (_tmp12_, &_tmp13_);
#line 612 "../lib/application.vala"
					tabs_order = _tmp14_;
#line 612 "../lib/application.vala"
					tabs_order_length1 = _tmp13_;
#line 612 "../lib/application.vala"
					_tabs_order_size_ = tabs_order_length1;
#line 613 "../lib/application.vala"
					_tmp15_ = win;
#line 613 "../lib/application.vala"
					last_page = xnp_window_get_current_page (_tmp15_);
#line 614 "../lib/application.vala"
					_tmp16_ = win;
#line 614 "../lib/application.vala"
					_tmp17_ = gtk_widget_get_opacity ((GtkWidget*) _tmp16_);
#line 614 "../lib/application.vala"
					_tmp18_ = _tmp17_;
#line 614 "../lib/application.vala"
					transparency = (gint) ((1 - _tmp18_) * 100);
#line 615 "../lib/application.vala"
					_tmp19_ = win;
#line 615 "../lib/application.vala"
					visible = gtk_widget_get_visible ((GtkWidget*) _tmp19_);
#line 617 "../lib/application.vala"
					_tmp20_ = win;
#line 617 "../lib/application.vala"
					_tmp21_ = xnp_window_get_name (_tmp20_);
#line 617 "../lib/application.vala"
					_tmp22_ = _tmp21_;
#line 617 "../lib/application.vala"
					g_key_file_set_integer (keyfile, _tmp22_, "PosX", winx);
#line 618 "../lib/application.vala"
					_tmp23_ = win;
#line 618 "../lib/application.vala"
					_tmp24_ = xnp_window_get_name (_tmp23_);
#line 618 "../lib/application.vala"
					_tmp25_ = _tmp24_;
#line 618 "../lib/application.vala"
					g_key_file_set_integer (keyfile, _tmp25_, "PosY", winy);
#line 619 "../lib/application.vala"
					_tmp26_ = win;
#line 619 "../lib/application.vala"
					_tmp27_ = xnp_window_get_name (_tmp26_);
#line 619 "../lib/application.vala"
					_tmp28_ = _tmp27_;
#line 619 "../lib/application.vala"
					g_key_file_set_integer (keyfile, _tmp28_, "Width", width);
#line 620 "../lib/application.vala"
					_tmp29_ = win;
#line 620 "../lib/application.vala"
					_tmp30_ = xnp_window_get_name (_tmp29_);
#line 620 "../lib/application.vala"
					_tmp31_ = _tmp30_;
#line 620 "../lib/application.vala"
					g_key_file_set_integer (keyfile, _tmp31_, "Height", height);
#line 621 "../lib/application.vala"
					_tmp32_ = win;
#line 621 "../lib/application.vala"
					_tmp33_ = xnp_window_get_name (_tmp32_);
#line 621 "../lib/application.vala"
					_tmp34_ = _tmp33_;
#line 621 "../lib/application.vala"
					_tmp35_ = tabs_order;
#line 621 "../lib/application.vala"
					_tmp35__length1 = tabs_order_length1;
#line 621 "../lib/application.vala"
					g_key_file_set_string_list (keyfile, _tmp34_, "TabsOrder", (const gchar* const*) _tmp35_, (gint) _tmp35__length1);
#line 622 "../lib/application.vala"
					_tmp36_ = win;
#line 622 "../lib/application.vala"
					_tmp37_ = xnp_window_get_name (_tmp36_);
#line 622 "../lib/application.vala"
					_tmp38_ = _tmp37_;
#line 622 "../lib/application.vala"
					g_key_file_set_integer (keyfile, _tmp38_, "LastTab", last_page);
#line 623 "../lib/application.vala"
					_tmp39_ = win;
#line 623 "../lib/application.vala"
					_tmp40_ = xnp_window_get_name (_tmp39_);
#line 623 "../lib/application.vala"
					_tmp41_ = _tmp40_;
#line 623 "../lib/application.vala"
					_tmp42_ = win;
#line 623 "../lib/application.vala"
					_tmp43_ = xnp_window_get_above (_tmp42_);
#line 623 "../lib/application.vala"
					_tmp44_ = _tmp43_;
#line 623 "../lib/application.vala"
					g_key_file_set_boolean (keyfile, _tmp41_, "Above", _tmp44_);
#line 624 "../lib/application.vala"
					_tmp45_ = win;
#line 624 "../lib/application.vala"
					_tmp46_ = xnp_window_get_name (_tmp45_);
#line 624 "../lib/application.vala"
					_tmp47_ = _tmp46_;
#line 624 "../lib/application.vala"
					_tmp48_ = win;
#line 624 "../lib/application.vala"
					_tmp49_ = xnp_window_get_sticky (_tmp48_);
#line 624 "../lib/application.vala"
					_tmp50_ = _tmp49_;
#line 624 "../lib/application.vala"
					g_key_file_set_boolean (keyfile, _tmp47_, "Sticky", _tmp50_);
#line 625 "../lib/application.vala"
					_tmp51_ = win;
#line 625 "../lib/application.vala"
					_tmp52_ = xnp_window_get_name (_tmp51_);
#line 625 "../lib/application.vala"
					_tmp53_ = _tmp52_;
#line 625 "../lib/application.vala"
					g_key_file_set_double (keyfile, _tmp53_, "Transparency", (gdouble) transparency);
#line 626 "../lib/application.vala"
					_tmp54_ = win;
#line 626 "../lib/application.vala"
					_tmp55_ = xnp_window_get_name (_tmp54_);
#line 626 "../lib/application.vala"
					_tmp56_ = _tmp55_;
#line 626 "../lib/application.vala"
					g_key_file_set_boolean (keyfile, _tmp56_, "Visible", visible);
#line 609 "../lib/application.vala"
					tabs_order = (_vala_array_free (tabs_order, tabs_order_length1, (GDestroyNotify) g_free), NULL);
#line 609 "../lib/application.vala"
					_g_object_unref0 (win);
#line 3409 "application.c"
				}
			}
		}
#line 628 "../lib/application.vala"
		_tmp57_ = g_key_file_to_data (keyfile, NULL, NULL);
#line 628 "../lib/application.vala"
		contents = _tmp57_;
#line 629 "../lib/application.vala"
		_tmp58_ = contents;
#line 629 "../lib/application.vala"
		if (g_strcmp0 (_tmp58_, old_contents) != 0) {
#line 3421 "application.c"
			const gchar* _tmp59_;
			const gchar* _tmp60_;
#line 630 "../lib/application.vala"
			_tmp59_ = self->priv->_config_file;
#line 630 "../lib/application.vala"
			_tmp60_ = contents;
#line 630 "../lib/application.vala"
			g_file_set_contents (_tmp59_, _tmp60_, (gssize) -1, &_inner_error0_);
#line 630 "../lib/application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3432 "application.c"
				gboolean _tmp61_ = FALSE;
#line 630 "../lib/application.vala"
				_g_free0 (contents);
#line 630 "../lib/application.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3438 "application.c"
					goto __catch1_g_file_error;
				}
#line 630 "../lib/application.vala"
				_g_free0 (old_contents);
#line 630 "../lib/application.vala"
				_g_key_file_unref0 (keyfile);
#line 630 "../lib/application.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 630 "../lib/application.vala"
				g_clear_error (&_inner_error0_);
#line 630 "../lib/application.vala"
				return _tmp61_;
#line 3451 "application.c"
			}
		}
#line 608 "../lib/application.vala"
		_g_free0 (contents);
#line 3456 "application.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp62_;
		GError* _tmp63_;
		const gchar* _tmp64_;
#line 608 "../lib/application.vala"
		e = _inner_error0_;
#line 608 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 633 "../lib/application.vala"
		_tmp62_ = self->priv->_config_file;
#line 633 "../lib/application.vala"
		_tmp63_ = e;
#line 633 "../lib/application.vala"
		_tmp64_ = _tmp63_->message;
#line 633 "../lib/application.vala"
		g_message ("application.vala:633: Unable to save window configuration from %s: %s", _tmp62_, _tmp64_);
#line 608 "../lib/application.vala"
		_g_error_free0 (e);
#line 3479 "application.c"
	}
	__finally1:
#line 608 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3484 "application.c"
		gboolean _tmp65_ = FALSE;
#line 608 "../lib/application.vala"
		_g_free0 (old_contents);
#line 608 "../lib/application.vala"
		_g_key_file_unref0 (keyfile);
#line 608 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 608 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 608 "../lib/application.vala"
		return _tmp65_;
#line 3496 "application.c"
	}
#line 635 "../lib/application.vala"
	if (self->priv->save_config_timeout > ((guint) 0)) {
#line 636 "../lib/application.vala"
		g_source_remove (self->priv->save_config_timeout);
#line 637 "../lib/application.vala"
		self->priv->save_config_timeout = (guint) 0;
#line 3504 "application.c"
	}
#line 639 "../lib/application.vala"
	result = FALSE;
#line 639 "../lib/application.vala"
	_g_free0 (old_contents);
#line 639 "../lib/application.vala"
	_g_key_file_unref0 (keyfile);
#line 639 "../lib/application.vala"
	return result;
#line 3514 "application.c"
}

/**
 * save_notes:
 *
 * Save the contents of every existing notes.
 */
void
xnp_application_save_notes (XnpApplication* self)
{
	GSList* _tmp0_;
#line 647 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 648 "../lib/application.vala"
	_tmp0_ = self->priv->window_list;
#line 3530 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 648 "../lib/application.vala"
		win_collection = _tmp0_;
#line 648 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 3538 "application.c"
			XnpWindow* _tmp1_;
			XnpWindow* win = NULL;
#line 648 "../lib/application.vala"
			_tmp1_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 648 "../lib/application.vala"
			win = _tmp1_;
#line 3545 "application.c"
			{
				XnpWindow* _tmp2_;
#line 649 "../lib/application.vala"
				_tmp2_ = win;
#line 649 "../lib/application.vala"
				xnp_window_save_notes (_tmp2_);
#line 648 "../lib/application.vala"
				_g_object_unref0 (win);
#line 3554 "application.c"
			}
		}
	}
}

/**
 * save_note:
 *
 * Save the contents of the given note.
 */
static void
xnp_application_save_note (XnpApplication* self,
                           XnpWindow* window,
                           XnpNote* note)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* old_contents = NULL;
	GError* _inner_error0_ = NULL;
#line 658 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 658 "../lib/application.vala"
	g_return_if_fail (window != NULL);
#line 658 "../lib/application.vala"
	g_return_if_fail (note != NULL);
#line 659 "../lib/application.vala"
	_tmp0_ = self->priv->_notes_path;
#line 659 "../lib/application.vala"
	_tmp1_ = xnp_window_get_name (window);
#line 659 "../lib/application.vala"
	_tmp2_ = _tmp1_;
#line 659 "../lib/application.vala"
	_tmp3_ = xnp_note_get_name (note);
#line 659 "../lib/application.vala"
	_tmp4_ = _tmp3_;
#line 659 "../lib/application.vala"
	_tmp5_ = g_strdup_printf ("%s/%s/%s", _tmp0_, _tmp2_, _tmp4_);
#line 659 "../lib/application.vala"
	path = _tmp5_;
#line 3599 "application.c"
	{
		gchar* _tmp6_ = NULL;
#line 662 "../lib/application.vala"
		g_file_get_contents (path, &_tmp6_, NULL, &_inner_error0_);
#line 662 "../lib/application.vala"
		_g_free0 (old_contents);
#line 662 "../lib/application.vala"
		old_contents = _tmp6_;
#line 662 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 662 "../lib/application.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3612 "application.c"
				goto __catch0_g_file_error;
			}
#line 662 "../lib/application.vala"
			_g_free0 (old_contents);
#line 662 "../lib/application.vala"
			_g_free0 (path);
#line 662 "../lib/application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 662 "../lib/application.vala"
			g_clear_error (&_inner_error0_);
#line 662 "../lib/application.vala"
			return;
#line 3625 "application.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 661 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 3633 "application.c"
	}
	__finally0:
#line 661 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 661 "../lib/application.vala"
		_g_free0 (old_contents);
#line 661 "../lib/application.vala"
		_g_free0 (path);
#line 661 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 661 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 661 "../lib/application.vala"
		return;
#line 3648 "application.c"
	}
	{
		gchar* contents = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
#line 667 "../lib/application.vala"
		_tmp7_ = xnp_note_get_text (note);
#line 667 "../lib/application.vala"
		_tmp8_ = _tmp7_;
#line 667 "../lib/application.vala"
		contents = _tmp8_;
#line 668 "../lib/application.vala"
		_tmp9_ = contents;
#line 668 "../lib/application.vala"
		if (g_strcmp0 (_tmp9_, old_contents) != 0) {
#line 3665 "application.c"
			const gchar* _tmp10_;
#line 669 "../lib/application.vala"
			_tmp10_ = contents;
#line 669 "../lib/application.vala"
			g_file_set_contents (path, _tmp10_, (gssize) -1, &_inner_error0_);
#line 669 "../lib/application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 669 "../lib/application.vala"
				_g_free0 (contents);
#line 669 "../lib/application.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3677 "application.c"
					goto __catch1_g_file_error;
				}
#line 669 "../lib/application.vala"
				_g_free0 (old_contents);
#line 669 "../lib/application.vala"
				_g_free0 (path);
#line 669 "../lib/application.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 669 "../lib/application.vala"
				g_clear_error (&_inner_error0_);
#line 669 "../lib/application.vala"
				return;
#line 3690 "application.c"
			}
		}
#line 670 "../lib/application.vala"
		xnp_note_set_dirty (note, FALSE);
#line 671 "../lib/application.vala"
		note->backed = TRUE;
#line 666 "../lib/application.vala"
		_g_free0 (contents);
#line 3699 "application.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 666 "../lib/application.vala"
		e = _inner_error0_;
#line 666 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 674 "../lib/application.vala"
		_tmp11_ = e;
#line 674 "../lib/application.vala"
		_tmp12_ = _tmp11_->message;
#line 674 "../lib/application.vala"
		xnp_window_popup_error (window, _tmp12_);
#line 666 "../lib/application.vala"
		_g_error_free0 (e);
#line 3719 "application.c"
	}
	__finally1:
#line 666 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 666 "../lib/application.vala"
		_g_free0 (old_contents);
#line 666 "../lib/application.vala"
		_g_free0 (path);
#line 666 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 666 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 666 "../lib/application.vala"
		return;
#line 3734 "application.c"
	}
#line 658 "../lib/application.vala"
	_g_free0 (old_contents);
#line 658 "../lib/application.vala"
	_g_free0 (path);
#line 3740 "application.c"
}

/**
 * rename_window:
 *
 * Rename the window.
 */
static void
xnp_application_rename_window (XnpApplication* self,
                               XnpWindow* window)
{
	GtkDialog* dialog = NULL;
	GtkDialog* _tmp0_;
	GtkBox* content_area = NULL;
	GtkDialog* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkDialog* _tmp4_;
	GtkDialog* _tmp5_;
	GtkDialog* _tmp6_;
	GtkDialog* _tmp7_;
	GtkEntry* entry = NULL;
	GtkEntry* _tmp8_;
	GtkEntry* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GtkEntry* _tmp12_;
	GtkBox* _tmp13_;
	GtkEntry* _tmp14_;
	GtkBox* _tmp15_;
	gint res = 0;
	GtkDialog* _tmp16_;
	GtkDialog* _tmp17_;
	GtkDialog* _tmp37_;
	GError* _inner_error0_ = NULL;
#line 683 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 683 "../lib/application.vala"
	g_return_if_fail (window != NULL);
#line 684 "../lib/application.vala"
	_tmp0_ = (GtkDialog*) gtk_dialog_new_with_buttons (_ ("Rename group"), (GtkWindow*) window, GTK_DIALOG_DESTROY_WITH_PARENT, "gtk-cancel", GTK_RESPONSE_CANCEL, "gtk-ok", GTK_RESPONSE_OK, NULL);
#line 684 "../lib/application.vala"
	g_object_ref_sink (_tmp0_);
#line 684 "../lib/application.vala"
	dialog = _tmp0_;
#line 687 "../lib/application.vala"
	_tmp1_ = dialog;
#line 687 "../lib/application.vala"
	_tmp2_ = gtk_dialog_get_content_area (_tmp1_);
#line 687 "../lib/application.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_box_get_type (), GtkBox));
#line 687 "../lib/application.vala"
	content_area = _tmp3_;
#line 688 "../lib/application.vala"
	_tmp4_ = dialog;
#line 688 "../lib/application.vala"
	gtk_dialog_set_default_response (_tmp4_, (gint) GTK_RESPONSE_OK);
#line 689 "../lib/application.vala"
	_tmp5_ = dialog;
#line 689 "../lib/application.vala"
	gtk_window_set_resizable ((GtkWindow*) _tmp5_, FALSE);
#line 690 "../lib/application.vala"
	_tmp6_ = dialog;
#line 690 "../lib/application.vala"
	gtk_window_set_icon_name ((GtkWindow*) _tmp6_, "gtk-edit");
#line 691 "../lib/application.vala"
	_tmp7_ = dialog;
#line 691 "../lib/application.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp7_, (guint) 4);
#line 693 "../lib/application.vala"
	_tmp8_ = (GtkEntry*) gtk_entry_new ();
#line 693 "../lib/application.vala"
	g_object_ref_sink (_tmp8_);
#line 693 "../lib/application.vala"
	entry = _tmp8_;
#line 694 "../lib/application.vala"
	_tmp9_ = entry;
#line 694 "../lib/application.vala"
	_tmp10_ = xnp_window_get_name (window);
#line 694 "../lib/application.vala"
	_tmp11_ = _tmp10_;
#line 694 "../lib/application.vala"
	gtk_entry_set_text (_tmp9_, _tmp11_);
#line 695 "../lib/application.vala"
	_tmp12_ = entry;
#line 695 "../lib/application.vala"
	gtk_entry_set_activates_default (_tmp12_, TRUE);
#line 696 "../lib/application.vala"
	_tmp13_ = content_area;
#line 696 "../lib/application.vala"
	_tmp14_ = entry;
#line 696 "../lib/application.vala"
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 697 "../lib/application.vala"
	_tmp15_ = content_area;
#line 697 "../lib/application.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 699 "../lib/application.vala"
	_tmp16_ = dialog;
#line 699 "../lib/application.vala"
	res = gtk_dialog_run (_tmp16_);
#line 700 "../lib/application.vala"
	_tmp17_ = dialog;
#line 700 "../lib/application.vala"
	xnp_window_dialog_hide (window, _tmp17_);
#line 701 "../lib/application.vala"
	if (res == ((gint) GTK_RESPONSE_OK)) {
#line 3848 "application.c"
		const gchar* name = NULL;
		GtkEntry* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
#line 702 "../lib/application.vala"
		_tmp18_ = entry;
#line 702 "../lib/application.vala"
		_tmp19_ = gtk_entry_get_text (_tmp18_);
#line 702 "../lib/application.vala"
		_tmp20_ = _tmp19_;
#line 702 "../lib/application.vala"
		name = _tmp20_;
#line 703 "../lib/application.vala"
		_tmp21_ = name;
#line 703 "../lib/application.vala"
		if (xnp_application_window_name_exists (self, _tmp21_)) {
#line 3866 "application.c"
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 704 "../lib/application.vala"
			_tmp22_ = name;
#line 704 "../lib/application.vala"
			_tmp23_ = g_strdup_printf (_ ("The name %s is already in use"), _tmp22_);
#line 704 "../lib/application.vala"
			_tmp24_ = _tmp23_;
#line 704 "../lib/application.vala"
			xnp_window_popup_error (window, _tmp24_);
#line 704 "../lib/application.vala"
			_g_free0 (_tmp24_);
#line 3880 "application.c"
		} else {
			const gchar* _tmp25_;
#line 707 "../lib/application.vala"
			_tmp25_ = name;
#line 707 "../lib/application.vala"
			if (!xnp_application_name_is_valid (self, _tmp25_)) {
#line 708 "../lib/application.vala"
				_g_object_unref0 (entry);
#line 708 "../lib/application.vala"
				_g_object_unref0 (content_area);
#line 708 "../lib/application.vala"
				_g_object_unref0 (dialog);
#line 708 "../lib/application.vala"
				return;
#line 3895 "application.c"
			}
			{
				GFile* group_dir = NULL;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				GFile* _tmp29_;
				GFile* _tmp30_;
				const gchar* _tmp31_;
				GFile* _tmp32_;
				GFile* _tmp33_;
				const gchar* _tmp34_;
#line 711 "../lib/application.vala"
				_tmp26_ = self->priv->_notes_path;
#line 711 "../lib/application.vala"
				_tmp27_ = xnp_window_get_name (window);
#line 711 "../lib/application.vala"
				_tmp28_ = _tmp27_;
#line 711 "../lib/application.vala"
				_tmp29_ = g_file_new_build_filename (_tmp26_, _tmp28_, NULL);
#line 711 "../lib/application.vala"
				group_dir = _tmp29_;
#line 712 "../lib/application.vala"
				_tmp30_ = group_dir;
#line 712 "../lib/application.vala"
				_tmp31_ = name;
#line 712 "../lib/application.vala"
				_tmp32_ = g_file_set_display_name (_tmp30_, _tmp31_, NULL, &_inner_error0_);
#line 712 "../lib/application.vala"
				_tmp33_ = _tmp32_;
#line 712 "../lib/application.vala"
				_g_object_unref0 (_tmp33_);
#line 712 "../lib/application.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 712 "../lib/application.vala"
					_g_object_unref0 (group_dir);
#line 3932 "application.c"
					goto __catch0_g_error;
				}
#line 713 "../lib/application.vala"
				_tmp34_ = name;
#line 713 "../lib/application.vala"
				xnp_window_set_name (window, _tmp34_);
#line 714 "../lib/application.vala"
				self->priv->window_list = g_slist_sort (self->priv->window_list, (GCompareFunc) xnp_window_compare_func);
#line 716 "../lib/application.vala"
				xnp_application_set_window_monitor (self, window);
#line 710 "../lib/application.vala"
				_g_object_unref0 (group_dir);
#line 3945 "application.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp35_;
				const gchar* _tmp36_;
#line 710 "../lib/application.vala"
				e = _inner_error0_;
#line 710 "../lib/application.vala"
				_inner_error0_ = NULL;
#line 718 "../lib/application.vala"
				_tmp35_ = e;
#line 718 "../lib/application.vala"
				_tmp36_ = _tmp35_->message;
#line 718 "../lib/application.vala"
				xnp_window_popup_error (window, _tmp36_);
#line 710 "../lib/application.vala"
				_g_error_free0 (e);
#line 3965 "application.c"
			}
			__finally0:
#line 710 "../lib/application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 710 "../lib/application.vala"
				_g_object_unref0 (entry);
#line 710 "../lib/application.vala"
				_g_object_unref0 (content_area);
#line 710 "../lib/application.vala"
				_g_object_unref0 (dialog);
#line 710 "../lib/application.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 710 "../lib/application.vala"
				g_clear_error (&_inner_error0_);
#line 710 "../lib/application.vala"
				return;
#line 3982 "application.c"
			}
		}
	}
#line 722 "../lib/application.vala"
	_tmp37_ = dialog;
#line 722 "../lib/application.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp37_);
#line 683 "../lib/application.vala"
	_g_object_unref0 (entry);
#line 683 "../lib/application.vala"
	_g_object_unref0 (content_area);
#line 683 "../lib/application.vala"
	_g_object_unref0 (dialog);
#line 3996 "application.c"
}

/**
 * delete_window:
 *
 * Delete the window.
 */
static void
xnp_application_delete_window (XnpApplication* self,
                               XnpWindow* window)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar* name = NULL;
	GFile* path = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GSList* _tmp47_;
	GError* _inner_error0_ = NULL;
#line 730 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 730 "../lib/application.vala"
	g_return_if_fail (window != NULL);
#line 731 "../lib/application.vala"
	_tmp0_ = xnp_window_get_empty (window);
#line 731 "../lib/application.vala"
	_tmp1_ = _tmp0_;
#line 731 "../lib/application.vala"
	if (!_tmp1_) {
#line 4029 "application.c"
		GtkMessageDialog* dialog = NULL;
		GtkMessageDialog* _tmp2_;
		GtkMessageDialog* _tmp3_;
		GtkMessageDialog* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint res = 0;
		GtkMessageDialog* _tmp7_;
		GtkMessageDialog* _tmp8_;
#line 732 "../lib/application.vala"
		_tmp2_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) window, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, "%s", _ ("Are you sure you want to delete this group?"));
#line 732 "../lib/application.vala"
		g_object_ref_sink (_tmp2_);
#line 732 "../lib/application.vala"
		dialog = _tmp2_;
#line 734 "../lib/application.vala"
		_tmp3_ = dialog;
#line 734 "../lib/application.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp3_, "gtk-delete");
#line 735 "../lib/application.vala"
		_tmp4_ = dialog;
#line 735 "../lib/application.vala"
		_tmp5_ = xnp_window_get_name (window);
#line 735 "../lib/application.vala"
		_tmp6_ = _tmp5_;
#line 735 "../lib/application.vala"
		gtk_window_set_title ((GtkWindow*) _tmp4_, _tmp6_);
#line 736 "../lib/application.vala"
		_tmp7_ = dialog;
#line 736 "../lib/application.vala"
		res = gtk_dialog_run ((GtkDialog*) _tmp7_);
#line 737 "../lib/application.vala"
		_tmp8_ = dialog;
#line 737 "../lib/application.vala"
		xnp_window_dialog_destroy (window, (GtkDialog*) _tmp8_);
#line 738 "../lib/application.vala"
		if (res != ((gint) GTK_RESPONSE_YES)) {
#line 739 "../lib/application.vala"
			_g_object_unref0 (dialog);
#line 739 "../lib/application.vala"
			return;
#line 4071 "application.c"
		}
#line 731 "../lib/application.vala"
		_g_object_unref0 (dialog);
#line 4075 "application.c"
	}
#line 743 "../lib/application.vala"
	_tmp9_ = self->priv->_notes_path;
#line 743 "../lib/application.vala"
	_tmp10_ = xnp_window_get_name (window);
#line 743 "../lib/application.vala"
	_tmp11_ = _tmp10_;
#line 743 "../lib/application.vala"
	_tmp12_ = g_file_new_build_filename (_tmp9_, _tmp11_, NULL);
#line 743 "../lib/application.vala"
	path = _tmp12_;
#line 744 "../lib/application.vala"
	_tmp13_ = path;
#line 744 "../lib/application.vala"
	if (g_file_query_exists (_tmp13_, NULL)) {
#line 4091 "application.c"
		{
			XnpWindowMonitor* _tmp14_;
			GDir* dir = NULL;
			GFile* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			GDir* _tmp18_;
			GDir* _tmp19_;
			GDir* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
#line 746 "../lib/application.vala"
			_tmp14_ = window->monitor;
#line 746 "../lib/application.vala"
			xnp_window_monitor_internal_change (_tmp14_);
#line 747 "../lib/application.vala"
			_tmp15_ = path;
#line 747 "../lib/application.vala"
			_tmp16_ = g_file_get_path (_tmp15_);
#line 747 "../lib/application.vala"
			_tmp17_ = _tmp16_;
#line 747 "../lib/application.vala"
			_tmp18_ = g_dir_open (_tmp17_, (guint) 0, &_inner_error0_);
#line 747 "../lib/application.vala"
			_tmp19_ = _tmp18_;
#line 747 "../lib/application.vala"
			_g_free0 (_tmp17_);
#line 747 "../lib/application.vala"
			dir = _tmp19_;
#line 747 "../lib/application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4125 "application.c"
				goto __catch0_g_error;
			}
#line 748 "../lib/application.vala"
			_tmp20_ = dir;
#line 748 "../lib/application.vala"
			_tmp21_ = g_dir_read_name (_tmp20_);
#line 748 "../lib/application.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 748 "../lib/application.vala"
			_g_free0 (name);
#line 748 "../lib/application.vala"
			name = _tmp22_;
#line 749 "../lib/application.vala"
			_tmp23_ = xnp_window_get_n_pages (window);
#line 749 "../lib/application.vala"
			_tmp24_ = _tmp23_;
#line 749 "../lib/application.vala"
			if (_tmp24_ == 0) {
#line 4144 "application.c"
				const gchar* _tmp25_;
#line 753 "../lib/application.vala"
				_tmp25_ = name;
#line 753 "../lib/application.vala"
				if (_tmp25_ == NULL) {
#line 4150 "application.c"
					GFile* _tmp26_;
#line 754 "../lib/application.vala"
					_tmp26_ = path;
#line 754 "../lib/application.vala"
					g_file_delete (_tmp26_, NULL, &_inner_error0_);
#line 754 "../lib/application.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 754 "../lib/application.vala"
						_g_dir_close0 (dir);
#line 4160 "application.c"
						goto __catch0_g_error;
					}
				} else {
#line 756 "../lib/application.vala"
					_g_dir_close0 (dir);
#line 756 "../lib/application.vala"
					_g_object_unref0 (path);
#line 756 "../lib/application.vala"
					_g_free0 (name);
#line 756 "../lib/application.vala"
					return;
#line 4172 "application.c"
				}
			} else {
				const gchar* _tmp27_;
				GFile* _tmp37_;
#line 760 "../lib/application.vala"
				_tmp27_ = name;
#line 760 "../lib/application.vala"
				if (_tmp27_ != NULL) {
#line 4181 "application.c"
					{
						gboolean _tmp28_ = FALSE;
#line 761 "../lib/application.vala"
						_tmp28_ = TRUE;
#line 761 "../lib/application.vala"
						while (TRUE) {
#line 4188 "application.c"
							GFile* _tmp33_;
							const gchar* _tmp34_;
							GFile* _tmp35_;
							GFile* _tmp36_;
#line 761 "../lib/application.vala"
							if (!_tmp28_) {
#line 4195 "application.c"
								GDir* _tmp29_;
								const gchar* _tmp30_;
								gchar* _tmp31_;
								const gchar* _tmp32_;
#line 763 "../lib/application.vala"
								_tmp29_ = dir;
#line 763 "../lib/application.vala"
								_tmp30_ = g_dir_read_name (_tmp29_);
#line 763 "../lib/application.vala"
								_tmp31_ = g_strdup (_tmp30_);
#line 763 "../lib/application.vala"
								_g_free0 (name);
#line 763 "../lib/application.vala"
								name = _tmp31_;
#line 763 "../lib/application.vala"
								_tmp32_ = name;
#line 763 "../lib/application.vala"
								if (!(_tmp32_ != NULL)) {
#line 763 "../lib/application.vala"
									break;
#line 4216 "application.c"
								}
							}
#line 761 "../lib/application.vala"
							_tmp28_ = FALSE;
#line 762 "../lib/application.vala"
							_tmp33_ = path;
#line 762 "../lib/application.vala"
							_tmp34_ = name;
#line 762 "../lib/application.vala"
							_tmp35_ = g_file_get_child (_tmp33_, _tmp34_);
#line 762 "../lib/application.vala"
							_tmp36_ = _tmp35_;
#line 762 "../lib/application.vala"
							g_file_delete (_tmp36_, NULL, &_inner_error0_);
#line 762 "../lib/application.vala"
							_g_object_unref0 (_tmp36_);
#line 762 "../lib/application.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 762 "../lib/application.vala"
								_g_dir_close0 (dir);
#line 4237 "application.c"
								goto __catch0_g_error;
							}
						}
					}
				}
#line 765 "../lib/application.vala"
				_tmp37_ = path;
#line 765 "../lib/application.vala"
				g_file_delete (_tmp37_, NULL, &_inner_error0_);
#line 765 "../lib/application.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 765 "../lib/application.vala"
					_g_dir_close0 (dir);
#line 4251 "application.c"
					goto __catch0_g_error;
				}
			}
#line 745 "../lib/application.vala"
			_g_dir_close0 (dir);
#line 4257 "application.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp38_;
			const gchar* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			XnpWindow* win = NULL;
			const gchar* _tmp43_;
			XnpWindow* _tmp44_;
			XnpWindow* _tmp45_;
#line 745 "../lib/application.vala"
			e = _inner_error0_;
#line 745 "../lib/application.vala"
			_inner_error0_ = NULL;
#line 769 "../lib/application.vala"
			_tmp38_ = e;
#line 769 "../lib/application.vala"
			_tmp39_ = _tmp38_->message;
#line 769 "../lib/application.vala"
			xnp_window_popup_error (window, _tmp39_);
#line 770 "../lib/application.vala"
			_tmp40_ = xnp_window_get_name (window);
#line 770 "../lib/application.vala"
			_tmp41_ = _tmp40_;
#line 770 "../lib/application.vala"
			_tmp42_ = g_strdup (_tmp41_);
#line 770 "../lib/application.vala"
			_g_free0 (name);
#line 770 "../lib/application.vala"
			name = _tmp42_;
#line 771 "../lib/application.vala"
			xnp_application_destroy_window (self, window);
#line 772 "../lib/application.vala"
			_tmp43_ = name;
#line 772 "../lib/application.vala"
			_tmp44_ = xnp_application_create_window (self, _tmp43_);
#line 772 "../lib/application.vala"
			win = _tmp44_;
#line 773 "../lib/application.vala"
			_tmp45_ = win;
#line 773 "../lib/application.vala"
			if (_tmp45_ != NULL) {
#line 4304 "application.c"
				XnpWindow* _tmp46_;
#line 774 "../lib/application.vala"
				_tmp46_ = win;
#line 774 "../lib/application.vala"
				gtk_widget_show ((GtkWidget*) _tmp46_);
#line 4310 "application.c"
			}
#line 775 "../lib/application.vala"
			_g_object_unref0 (win);
#line 775 "../lib/application.vala"
			_g_error_free0 (e);
#line 775 "../lib/application.vala"
			_g_object_unref0 (path);
#line 775 "../lib/application.vala"
			_g_free0 (name);
#line 775 "../lib/application.vala"
			return;
#line 4322 "application.c"
		}
		__finally0:
#line 745 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 745 "../lib/application.vala"
			_g_object_unref0 (path);
#line 745 "../lib/application.vala"
			_g_free0 (name);
#line 745 "../lib/application.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 745 "../lib/application.vala"
			g_clear_error (&_inner_error0_);
#line 745 "../lib/application.vala"
			return;
#line 4337 "application.c"
		}
	}
#line 779 "../lib/application.vala"
	_tmp47_ = self->priv->window_list;
#line 779 "../lib/application.vala"
	if (g_slist_length (_tmp47_) < ((guint) 2)) {
#line 4344 "application.c"
		XnpWindow* new_win = NULL;
		XnpWindow* _tmp48_;
		XnpWindow* _tmp49_;
#line 780 "../lib/application.vala"
		xnp_application_destroy_window (self, window);
#line 781 "../lib/application.vala"
		_tmp48_ = xnp_application_create_window (self, NULL);
#line 781 "../lib/application.vala"
		new_win = _tmp48_;
#line 782 "../lib/application.vala"
		_tmp49_ = new_win;
#line 782 "../lib/application.vala"
		if (_tmp49_ != NULL) {
#line 4358 "application.c"
			XnpWindow* _tmp50_;
#line 783 "../lib/application.vala"
			_tmp50_ = new_win;
#line 783 "../lib/application.vala"
			gtk_widget_show ((GtkWidget*) _tmp50_);
#line 4364 "application.c"
		}
#line 779 "../lib/application.vala"
		_g_object_unref0 (new_win);
#line 4368 "application.c"
	} else {
		XnpWindow* new_focus = NULL;
		XnpWindow* _tmp51_;
		XnpWindow* _tmp52_;
		XnpWindow* _tmp53_;
		XnpWindow* _tmp54_;
#line 785 "../lib/application.vala"
		_tmp51_ = xnp_application_get_next_focus (self);
#line 785 "../lib/application.vala"
		_tmp52_ = _tmp51_;
#line 785 "../lib/application.vala"
		_tmp53_ = _g_object_ref0 (_tmp52_);
#line 785 "../lib/application.vala"
		new_focus = _tmp53_;
#line 786 "../lib/application.vala"
		_tmp54_ = new_focus;
#line 786 "../lib/application.vala"
		if (_tmp54_ != NULL) {
#line 4387 "application.c"
			XnpWindow* _tmp55_;
			XnpWindow* _tmp56_;
			gboolean _tmp57_;
			gboolean _tmp58_;
#line 787 "../lib/application.vala"
			_tmp55_ = new_focus;
#line 787 "../lib/application.vala"
			gtk_window_set_skip_taskbar_hint ((GtkWindow*) _tmp55_, FALSE);
#line 788 "../lib/application.vala"
			xnp_application_destroy_window (self, window);
#line 789 "../lib/application.vala"
			_tmp56_ = new_focus;
#line 789 "../lib/application.vala"
			_tmp57_ = xnp_application_get_skip_taskbar_hint (self);
#line 789 "../lib/application.vala"
			_tmp58_ = _tmp57_;
#line 789 "../lib/application.vala"
			gtk_window_set_skip_taskbar_hint ((GtkWindow*) _tmp56_, _tmp58_);
#line 4406 "application.c"
		} else {
#line 791 "../lib/application.vala"
			xnp_application_destroy_window (self, window);
#line 4410 "application.c"
		}
#line 779 "../lib/application.vala"
		_g_object_unref0 (new_focus);
#line 4414 "application.c"
	}
#line 730 "../lib/application.vala"
	_g_object_unref0 (path);
#line 730 "../lib/application.vala"
	_g_free0 (name);
#line 4420 "application.c"
}

/**
 * destroy_window:
 *
 * Destroy window and forget it exists.
 */
static void
xnp_application_destroy_window (XnpApplication* self,
                                XnpWindow* window)
{
#line 801 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 801 "../lib/application.vala"
	g_return_if_fail (window != NULL);
#line 802 "../lib/application.vala"
	self->priv->window_list = vala_g_slist_remove_full (self->priv->window_list, window, _g_object_unref0_);
#line 803 "../lib/application.vala"
	self->priv->focus_order = vala_g_slist_remove_full (self->priv->focus_order, window, _g_object_unref0_);
#line 804 "../lib/application.vala"
	gtk_widget_destroy ((GtkWidget*) window);
#line 4442 "application.c"
}

/**
 * get_window_list:
 *
 * Get the window_list property value.
 */
GSList*
xnp_application_get_window_list (XnpApplication* self)
{
	GSList* _tmp0_;
	GSList* result;
#line 812 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 813 "../lib/application.vala"
	_tmp0_ = self->priv->window_list;
#line 813 "../lib/application.vala"
	result = _tmp0_;
#line 813 "../lib/application.vala"
	return result;
#line 4463 "application.c"
}

/**
 * set_window_monitor:
 *
 * Creates an Xnp.WindowMonitor object and stores it inside window.
 */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 825 "../lib/application.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 825 "../lib/application.vala"
	return _data2_;
#line 4478 "application.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 825 "../lib/application.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 4488 "application.c"
		XnpApplication* self;
#line 825 "../lib/application.vala"
		self = _data2_->self;
#line 825 "../lib/application.vala"
		_g_object_unref0 (_data2_->window);
#line 825 "../lib/application.vala"
		_g_object_unref0 (self);
#line 825 "../lib/application.vala"
		g_slice_free (Block2Data, _data2_);
#line 4498 "application.c"
	}
}

static void
__lambda43_ (Block2Data* _data2_,
             const gchar* note_name)
{
	XnpApplication* self;
#line 829 "../lib/application.vala"
	self = _data2_->self;
#line 829 "../lib/application.vala"
	g_return_if_fail (note_name != NULL);
#line 830 "../lib/application.vala"
	xnp_window_externally_removed (_data2_->window, note_name);
#line 4513 "application.c"
}

static void
___lambda43__xnp_window_monitor_note_deleted (XnpWindowMonitor* _sender,
                                              const gchar* note_name,
                                              gpointer self)
{
#line 829 "../lib/application.vala"
	__lambda43_ (self, note_name);
#line 4523 "application.c"
}

static void
__lambda44_ (Block2Data* _data2_,
             const gchar* note_name,
             const gchar* new_name)
{
	XnpApplication* self;
#line 833 "../lib/application.vala"
	self = _data2_->self;
#line 833 "../lib/application.vala"
	g_return_if_fail (note_name != NULL);
#line 833 "../lib/application.vala"
	g_return_if_fail (new_name != NULL);
#line 834 "../lib/application.vala"
	xnp_window_rename_note (_data2_->window, note_name, new_name);
#line 4540 "application.c"
}

static void
___lambda44__xnp_window_monitor_note_renamed (XnpWindowMonitor* _sender,
                                              const gchar* note_name,
                                              const gchar* new_name,
                                              gpointer self)
{
#line 833 "../lib/application.vala"
	__lambda44_ (self, note_name, new_name);
#line 4551 "application.c"
}

static void
__lambda45_ (Block2Data* _data2_,
             const gchar* note_name)
{
	XnpApplication* self;
#line 837 "../lib/application.vala"
	self = _data2_->self;
#line 837 "../lib/application.vala"
	g_return_if_fail (note_name != NULL);
#line 838 "../lib/application.vala"
	self->external_event = TRUE;
#line 839 "../lib/application.vala"
	xnp_application_load_note (self, _data2_->window, note_name);
#line 840 "../lib/application.vala"
	self->external_event = FALSE;
#line 4569 "application.c"
}

static void
___lambda45__xnp_window_monitor_note_created (XnpWindowMonitor* _sender,
                                              const gchar* note_name,
                                              gpointer self)
{
#line 837 "../lib/application.vala"
	__lambda45_ (self, note_name);
#line 4579 "application.c"
}

static void
__lambda46_ (Block2Data* _data2_,
             const gchar* note_name)
{
	XnpApplication* self;
#line 843 "../lib/application.vala"
	self = _data2_->self;
#line 843 "../lib/application.vala"
	g_return_if_fail (note_name != NULL);
#line 844 "../lib/application.vala"
	self->external_event = TRUE;
#line 845 "../lib/application.vala"
	xnp_application_reload_note (self, _data2_->window, note_name);
#line 846 "../lib/application.vala"
	self->external_event = FALSE;
#line 4597 "application.c"
}

static void
___lambda46__xnp_window_monitor_note_updated (XnpWindowMonitor* _sender,
                                              const gchar* note_name,
                                              gpointer self)
{
#line 843 "../lib/application.vala"
	__lambda46_ (self, note_name);
#line 4607 "application.c"
}

static gboolean
__lambda47_ (Block2Data* _data2_,
             GFile* file)
{
	XnpApplication* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 849 "../lib/application.vala"
	self = _data2_->self;
#line 849 "../lib/application.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 850 "../lib/application.vala"
	_tmp0_ = g_file_get_basename (file);
#line 850 "../lib/application.vala"
	_tmp1_ = _tmp0_;
#line 850 "../lib/application.vala"
	_tmp2_ = xnp_window_note_name_exists (_data2_->window, _tmp1_);
#line 850 "../lib/application.vala"
	_g_free0 (_tmp1_);
#line 850 "../lib/application.vala"
	result = _tmp2_;
#line 850 "../lib/application.vala"
	return result;
#line 4635 "application.c"
}

static gboolean
___lambda47__xnp_window_monitor_note_exists (XnpWindowMonitor* _sender,
                                             GFile* file,
                                             gpointer self)
{
	gboolean result;
	result = __lambda47_ (self, file);
#line 849 "../lib/application.vala"
	return result;
#line 4647 "application.c"
}

static void
xnp_application_set_window_monitor (XnpApplication* self,
                                    XnpWindow* window)
{
	Block2Data* _data2_;
	XnpWindow* _tmp0_;
	GFile* path = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	XnpWindowMonitor* _tmp5_;
	XnpWindowMonitor* _tmp6_;
	XnpWindowMonitor* _tmp7_;
	XnpWindowMonitor* _tmp8_;
	XnpWindowMonitor* _tmp9_;
	XnpWindowMonitor* _tmp10_;
#line 825 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 825 "../lib/application.vala"
	g_return_if_fail (window != NULL);
#line 825 "../lib/application.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 825 "../lib/application.vala"
	_data2_->_ref_count_ = 1;
#line 825 "../lib/application.vala"
	_data2_->self = g_object_ref (self);
#line 825 "../lib/application.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 825 "../lib/application.vala"
	_g_object_unref0 (_data2_->window);
#line 825 "../lib/application.vala"
	_data2_->window = _tmp0_;
#line 826 "../lib/application.vala"
	_tmp1_ = self->priv->_notes_path;
#line 826 "../lib/application.vala"
	_tmp2_ = xnp_window_get_name (_data2_->window);
#line 826 "../lib/application.vala"
	_tmp3_ = _tmp2_;
#line 826 "../lib/application.vala"
	_tmp4_ = g_file_new_build_filename (_tmp1_, _tmp3_, NULL);
#line 826 "../lib/application.vala"
	path = _tmp4_;
#line 827 "../lib/application.vala"
	_tmp5_ = xnp_window_monitor_new (path);
#line 827 "../lib/application.vala"
	_g_object_unref0 (_data2_->window->monitor);
#line 827 "../lib/application.vala"
	_data2_->window->monitor = _tmp5_;
#line 829 "../lib/application.vala"
	_tmp6_ = _data2_->window->monitor;
#line 829 "../lib/application.vala"
	g_signal_connect_data (_tmp6_, "note-deleted", (GCallback) ___lambda43__xnp_window_monitor_note_deleted, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 833 "../lib/application.vala"
	_tmp7_ = _data2_->window->monitor;
#line 833 "../lib/application.vala"
	g_signal_connect_data (_tmp7_, "note-renamed", (GCallback) ___lambda44__xnp_window_monitor_note_renamed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 837 "../lib/application.vala"
	_tmp8_ = _data2_->window->monitor;
#line 837 "../lib/application.vala"
	g_signal_connect_data (_tmp8_, "note-created", (GCallback) ___lambda45__xnp_window_monitor_note_created, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 843 "../lib/application.vala"
	_tmp9_ = _data2_->window->monitor;
#line 843 "../lib/application.vala"
	g_signal_connect_data (_tmp9_, "note-updated", (GCallback) ___lambda46__xnp_window_monitor_note_updated, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 849 "../lib/application.vala"
	_tmp10_ = _data2_->window->monitor;
#line 849 "../lib/application.vala"
	g_signal_connect_data (_tmp10_, "note-exists", (GCallback) ___lambda47__xnp_window_monitor_note_exists, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 825 "../lib/application.vala"
	_g_object_unref0 (path);
#line 825 "../lib/application.vala"
	block2_data_unref (_data2_);
#line 825 "../lib/application.vala"
	_data2_ = NULL;
#line 4725 "application.c"
}

/**
 * window_name_exists:
 *
 * Verify if the given name already exists in the window list.
 */
static gboolean
xnp_application_window_name_exists (XnpApplication* self,
                                    const gchar* name)
{
	GSList* _tmp0_;
	gboolean result;
#line 863 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 863 "../lib/application.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 864 "../lib/application.vala"
	_tmp0_ = self->priv->window_list;
#line 4745 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 864 "../lib/application.vala"
		win_collection = _tmp0_;
#line 864 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 4753 "application.c"
			XnpWindow* _tmp1_;
			XnpWindow* win = NULL;
#line 864 "../lib/application.vala"
			_tmp1_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 864 "../lib/application.vala"
			win = _tmp1_;
#line 4760 "application.c"
			{
				XnpWindow* _tmp2_;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
#line 865 "../lib/application.vala"
				_tmp2_ = win;
#line 865 "../lib/application.vala"
				_tmp3_ = xnp_window_get_name (_tmp2_);
#line 865 "../lib/application.vala"
				_tmp4_ = _tmp3_;
#line 865 "../lib/application.vala"
				if (g_strcmp0 (_tmp4_, name) == 0) {
#line 866 "../lib/application.vala"
					result = TRUE;
#line 866 "../lib/application.vala"
					_g_object_unref0 (win);
#line 866 "../lib/application.vala"
					return result;
#line 4779 "application.c"
				}
#line 864 "../lib/application.vala"
				_g_object_unref0 (win);
#line 4783 "application.c"
			}
		}
	}
#line 869 "../lib/application.vala"
	result = FALSE;
#line 869 "../lib/application.vala"
	return result;
#line 4791 "application.c"
}

/**
 * name_is_valid:
 *
 * Verify if the given name is valid for window and notes.
 */
static gboolean
xnp_application_name_is_valid (XnpApplication* self,
                               const gchar* name)
{
	gboolean res = FALSE;
	gboolean result;
#line 877 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 877 "../lib/application.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 878 "../lib/application.vala"
	res = g_regex_match_simple ("^[^*|/\\:\"<>?]+$", name, 0, 0);
#line 879 "../lib/application.vala"
	if (!res) {
#line 4813 "application.c"
		GtkMessageDialog* error_dialog = NULL;
		GtkMessageDialog* _tmp0_;
		GtkMessageDialog* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GtkMessageDialog* _tmp4_;
		GtkMessageDialog* _tmp5_;
		GtkMessageDialog* _tmp6_;
		GtkMessageDialog* _tmp7_;
#line 880 "../lib/application.vala"
		_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, 0, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, _ ("The name \"%s\" is invalid."), name);
#line 880 "../lib/application.vala"
		g_object_ref_sink (_tmp0_);
#line 880 "../lib/application.vala"
		error_dialog = _tmp0_;
#line 882 "../lib/application.vala"
		_tmp1_ = error_dialog;
#line 882 "../lib/application.vala"
		_tmp2_ = g_strdup_printf (_ ("The invalid characters are: %s"), "<tt>*|/\\:\"&lt;&gt;?</tt>");
#line 882 "../lib/application.vala"
		_tmp3_ = _tmp2_;
#line 882 "../lib/application.vala"
		gtk_message_dialog_format_secondary_markup (_tmp1_, "%s", _tmp3_);
#line 882 "../lib/application.vala"
		_g_free0 (_tmp3_);
#line 883 "../lib/application.vala"
		_tmp4_ = error_dialog;
#line 883 "../lib/application.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp4_, "gtk-dialog-error");
#line 884 "../lib/application.vala"
		_tmp5_ = error_dialog;
#line 884 "../lib/application.vala"
		gtk_window_set_title ((GtkWindow*) _tmp5_, _ ("Error"));
#line 885 "../lib/application.vala"
		_tmp6_ = error_dialog;
#line 885 "../lib/application.vala"
		gtk_dialog_run ((GtkDialog*) _tmp6_);
#line 886 "../lib/application.vala"
		_tmp7_ = error_dialog;
#line 886 "../lib/application.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp7_);
#line 879 "../lib/application.vala"
		_g_object_unref0 (error_dialog);
#line 4857 "application.c"
	}
#line 888 "../lib/application.vala"
	result = res;
#line 888 "../lib/application.vala"
	return result;
#line 4863 "application.c"
}

/**
 * show_hide_notes:
 *
 * Show all the notes or hide them if they are all shown.
 */
void
xnp_application_show_hide_notes (XnpApplication* self)
{
	gboolean invisible_found = FALSE;
	gboolean visible_found = FALSE;
	gboolean active_found = FALSE;
	GSList* _tmp0_;
	gboolean _tmp6_ = FALSE;
#line 896 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 897 "../lib/application.vala"
	invisible_found = FALSE;
#line 898 "../lib/application.vala"
	visible_found = FALSE;
#line 899 "../lib/application.vala"
	active_found = FALSE;
#line 900 "../lib/application.vala"
	_tmp0_ = self->priv->window_list;
#line 4889 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 900 "../lib/application.vala"
		win_collection = _tmp0_;
#line 900 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 4897 "application.c"
			XnpWindow* _tmp1_;
			XnpWindow* win = NULL;
#line 900 "../lib/application.vala"
			_tmp1_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 900 "../lib/application.vala"
			win = _tmp1_;
#line 4904 "application.c"
			{
				XnpWindow* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_;
				XnpWindow* _tmp5_;
#line 901 "../lib/application.vala"
				_tmp2_ = win;
#line 901 "../lib/application.vala"
				g_object_get ((GtkWindow*) _tmp2_, "is-active", &_tmp3_, NULL);
#line 901 "../lib/application.vala"
				_tmp4_ = _tmp3_;
#line 901 "../lib/application.vala"
				if (_tmp4_) {
#line 902 "../lib/application.vala"
					active_found = TRUE;
#line 4920 "application.c"
				}
#line 904 "../lib/application.vala"
				_tmp5_ = win;
#line 904 "../lib/application.vala"
				if (!gtk_widget_get_visible ((GtkWidget*) _tmp5_)) {
#line 905 "../lib/application.vala"
					invisible_found = TRUE;
#line 4928 "application.c"
				} else {
#line 908 "../lib/application.vala"
					visible_found = TRUE;
#line 4932 "application.c"
				}
#line 900 "../lib/application.vala"
				_g_object_unref0 (win);
#line 4936 "application.c"
			}
		}
	}
#line 912 "../lib/application.vala"
	if (!active_found) {
#line 912 "../lib/application.vala"
		_tmp6_ = visible_found;
#line 4944 "application.c"
	} else {
#line 912 "../lib/application.vala"
		_tmp6_ = FALSE;
#line 4948 "application.c"
	}
#line 912 "../lib/application.vala"
	if (_tmp6_) {
#line 913 "../lib/application.vala"
		xnp_application_present_windows (self);
#line 4954 "application.c"
	} else {
#line 915 "../lib/application.vala"
		if (invisible_found) {
#line 916 "../lib/application.vala"
			xnp_application_show_windows (self);
#line 4960 "application.c"
		} else {
#line 919 "../lib/application.vala"
			xnp_application_hide_windows (self);
#line 4964 "application.c"
		}
	}
}

/**
 * present_windows:
 *
 * Present visible notes windows.
 */
static void
xnp_application_present_windows (XnpApplication* self)
{
	GSList* _tmp0_;
#line 928 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 929 "../lib/application.vala"
	_tmp0_ = self->priv->focus_order;
#line 4982 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 929 "../lib/application.vala"
		win_collection = _tmp0_;
#line 929 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 4990 "application.c"
			XnpWindow* _tmp1_;
			XnpWindow* win = NULL;
#line 929 "../lib/application.vala"
			_tmp1_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 929 "../lib/application.vala"
			win = _tmp1_;
#line 4997 "application.c"
			{
				XnpWindow* _tmp2_;
#line 930 "../lib/application.vala"
				_tmp2_ = win;
#line 930 "../lib/application.vala"
				if (gtk_widget_get_visible ((GtkWidget*) _tmp2_)) {
#line 5004 "application.c"
					XnpWindow* _tmp3_;
#line 931 "../lib/application.vala"
					_tmp3_ = win;
#line 931 "../lib/application.vala"
					gtk_window_present ((GtkWindow*) _tmp3_);
#line 5010 "application.c"
				}
#line 929 "../lib/application.vala"
				_g_object_unref0 (win);
#line 5014 "application.c"
			}
		}
	}
}

/**
 * show_windows:
 *
 * Show all notes windows.
 */
static void
xnp_application_show_windows (XnpApplication* self)
{
	XnpWindow* focus = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
	gconstpointer _tmp2_;
	XnpWindow* _tmp3_;
	GSList* _tmp4_;
#line 941 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 942 "../lib/application.vala"
	_tmp0_ = self->priv->focus_order;
#line 942 "../lib/application.vala"
	_tmp1_ = g_slist_last (_tmp0_);
#line 942 "../lib/application.vala"
	_tmp2_ = _tmp1_->data;
#line 942 "../lib/application.vala"
	_tmp3_ = _g_object_ref0 ((XnpWindow*) _tmp2_);
#line 942 "../lib/application.vala"
	focus = _tmp3_;
#line 943 "../lib/application.vala"
	_tmp4_ = self->priv->focus_order;
#line 5048 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 943 "../lib/application.vala"
		win_collection = _tmp4_;
#line 943 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 5056 "application.c"
			XnpWindow* _tmp5_;
			XnpWindow* win = NULL;
#line 943 "../lib/application.vala"
			_tmp5_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 943 "../lib/application.vala"
			win = _tmp5_;
#line 5063 "application.c"
			{
				XnpWindow* _tmp6_;
				XnpWindow* _tmp7_;
#line 944 "../lib/application.vala"
				_tmp6_ = win;
#line 944 "../lib/application.vala"
				_tmp7_ = focus;
#line 944 "../lib/application.vala"
				if (_tmp6_ != _tmp7_) {
#line 5073 "application.c"
					XnpWindow* _tmp8_;
					XnpWindow* _tmp9_;
					XnpWindow* _tmp10_;
#line 945 "../lib/application.vala"
					_tmp8_ = win;
#line 945 "../lib/application.vala"
					gtk_window_set_focus_on_map ((GtkWindow*) _tmp8_, FALSE);
#line 946 "../lib/application.vala"
					_tmp9_ = win;
#line 946 "../lib/application.vala"
					gtk_widget_show ((GtkWidget*) _tmp9_);
#line 947 "../lib/application.vala"
					_tmp10_ = win;
#line 947 "../lib/application.vala"
					gtk_window_set_focus_on_map ((GtkWindow*) _tmp10_, TRUE);
#line 5089 "application.c"
				} else {
					XnpWindow* _tmp11_;
					XnpWindow* _tmp12_;
#line 949 "../lib/application.vala"
					_tmp11_ = win;
#line 949 "../lib/application.vala"
					gtk_widget_show ((GtkWidget*) _tmp11_);
#line 950 "../lib/application.vala"
					_tmp12_ = win;
#line 950 "../lib/application.vala"
					gtk_window_present ((GtkWindow*) _tmp12_);
#line 5101 "application.c"
				}
#line 943 "../lib/application.vala"
				_g_object_unref0 (win);
#line 5105 "application.c"
			}
		}
	}
#line 941 "../lib/application.vala"
	_g_object_unref0 (focus);
#line 5111 "application.c"
}

/**
 * hide_windows:
 *
 * Hide all notes windows.
 */
static void
xnp_application_hide_windows (XnpApplication* self)
{
	GSList* _tmp0_;
	GSList* _tmp1_;
#line 960 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 961 "../lib/application.vala"
	self->priv->lock_focus_order = TRUE;
#line 962 "../lib/application.vala"
	_tmp0_ = self->priv->focus_order;
#line 962 "../lib/application.vala"
	_tmp1_ = g_slist_copy (_tmp0_);
#line 5132 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 962 "../lib/application.vala"
		win_collection = _tmp1_;
#line 962 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 5140 "application.c"
			XnpWindow* win = NULL;
#line 962 "../lib/application.vala"
			win = (XnpWindow*) win_it->data;
#line 5144 "application.c"
			{
				XnpWindow* _tmp2_;
#line 963 "../lib/application.vala"
				_tmp2_ = win;
#line 963 "../lib/application.vala"
				xnp_window_hide (_tmp2_);
#line 5151 "application.c"
			}
		}
#line 962 "../lib/application.vala"
		(win_collection == NULL) ? NULL : (win_collection = (g_slist_free (win_collection), NULL));
#line 5156 "application.c"
	}
#line 965 "../lib/application.vala"
	self->priv->lock_focus_order = FALSE;
#line 5160 "application.c"
}

/**
 * open_settings_dialog:
 *
 * Open the settings dialog.
 */
void
xnp_application_open_settings_dialog (XnpApplication* self)
{
	GError* _inner_error0_ = NULL;
#line 973 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 5174 "application.c"
	{
#line 975 "../lib/application.vala"
		g_spawn_command_line_async ("xfce4-notes-settings", &_inner_error0_);
#line 975 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5180 "application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GtkMessageDialog* error_dialog = NULL;
		GtkMessageDialog* _tmp0_;
		GtkMessageDialog* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
		GtkMessageDialog* _tmp4_;
		GtkMessageDialog* _tmp5_;
		GtkMessageDialog* _tmp6_;
		GtkMessageDialog* _tmp7_;
#line 974 "../lib/application.vala"
		e = _inner_error0_;
#line 974 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 978 "../lib/application.vala"
		_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", _ ("Unable to open the settings dialog"));
#line 978 "../lib/application.vala"
		g_object_ref_sink (_tmp0_);
#line 978 "../lib/application.vala"
		error_dialog = _tmp0_;
#line 980 "../lib/application.vala"
		_tmp1_ = error_dialog;
#line 980 "../lib/application.vala"
		_tmp2_ = e;
#line 980 "../lib/application.vala"
		_tmp3_ = _tmp2_->message;
#line 980 "../lib/application.vala"
		gtk_message_dialog_format_secondary_text (_tmp1_, "%s", _tmp3_);
#line 981 "../lib/application.vala"
		_tmp4_ = error_dialog;
#line 981 "../lib/application.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp4_, "gtk-dialog-error");
#line 982 "../lib/application.vala"
		_tmp5_ = error_dialog;
#line 982 "../lib/application.vala"
		gtk_window_set_title ((GtkWindow*) _tmp5_, _ ("Error"));
#line 983 "../lib/application.vala"
		_tmp6_ = error_dialog;
#line 983 "../lib/application.vala"
		gtk_dialog_run ((GtkDialog*) _tmp6_);
#line 984 "../lib/application.vala"
		_tmp7_ = error_dialog;
#line 984 "../lib/application.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp7_);
#line 974 "../lib/application.vala"
		_g_object_unref0 (error_dialog);
#line 974 "../lib/application.vala"
		_g_error_free0 (e);
#line 5235 "application.c"
	}
	__finally0:
#line 974 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 974 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 974 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 974 "../lib/application.vala"
		return;
#line 5246 "application.c"
	}
}

/**
 * open_about_dialog:
 *
 * Open the about dialog.
 */
void
xnp_application_open_about_dialog (XnpApplication* self)
{
	gchar** authors = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint authors_length1;
	gint _authors_size_;
	const gchar* _tmp4_;
#line 993 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 994 "../lib/application.vala"
	_tmp0_ = g_strdup ("© 2003 Jakob Henriksson");
#line 994 "../lib/application.vala"
	_tmp1_ = g_strdup ("© 2006 Mike Massonnet");
#line 994 "../lib/application.vala"
	_tmp2_ = g_strdup ("© 2023 Arthur Demchenkov");
#line 994 "../lib/application.vala"
	_tmp3_ = g_new0 (gchar*, 4 + 1);
#line 994 "../lib/application.vala"
	_tmp3_[0] = _tmp0_;
#line 994 "../lib/application.vala"
	_tmp3_[1] = _tmp1_;
#line 994 "../lib/application.vala"
	_tmp3_[2] = _tmp2_;
#line 994 "../lib/application.vala"
	_tmp3_[3] = NULL;
#line 994 "../lib/application.vala"
	authors = _tmp3_;
#line 994 "../lib/application.vala"
	authors_length1 = 4;
#line 994 "../lib/application.vala"
	_authors_size_ = authors_length1;
#line 1001 "../lib/application.vala"
	_tmp4_ = xfce_get_license_text (XFCE_LICENSE_TEXT_GPL);
#line 1001 "../lib/application.vala"
	gtk_show_about_dialog (NULL, "program-name", _ ("Notes"), "logo-icon-name", "org.xfce.notes.logo", "comments", _ ("Ideal for your quick notes"), "version", VERSION_FULL, "copyright", "Copyright © 2003-" COPYRIGHT_YEAR " The Xfce development team", "license", _tmp4_, "website", "https://docs.xfce.org/panel-plugins/xfce4-notes-plugin", "website-label", "docs.xfce.org", "authors", authors, "translator-credits", _ ("translator-credits"), NULL, NULL);
#line 993 "../lib/application.vala"
	authors = (_vala_array_free (authors, authors_length1, (GDestroyNotify) g_free), NULL);
#line 5296 "application.c"
}

/**
 * context_menu:
 *
 * Provides a GtkMenu to be used for right click context menus
 * like in trayicons. Its items are destroyed/refreshed every
 * time the menu is shown.
 */
static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 1022 "../lib/application.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 1022 "../lib/application.vala"
	return _data3_;
#line 5313 "application.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 1022 "../lib/application.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 5323 "application.c"
		XnpApplication* self;
#line 1022 "../lib/application.vala"
		self = _data3_->self;
#line 1022 "../lib/application.vala"
		_g_object_unref0 (_data3_->menu);
#line 1022 "../lib/application.vala"
		_g_object_unref0 (self);
#line 1022 "../lib/application.vala"
		g_slice_free (Block3Data, _data3_);
#line 5333 "application.c"
	}
}

static void
__lambda56_ (XnpApplication* self,
             GtkWidget* w)
{
#line 1027 "../lib/application.vala"
	g_return_if_fail (w != NULL);
#line 1028 "../lib/application.vala"
	gtk_widget_destroy (w);
#line 5345 "application.c"
}

static void
___lambda56__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 1027 "../lib/application.vala"
	__lambda56_ ((XnpApplication*) self, widget);
#line 5354 "application.c"
}

static void
____lambda57_ (XnpApplication* self,
               GtkMenuItem* i)
{
	XnpWindow* w = NULL;
	gconstpointer _tmp0_;
	XnpWindow* _tmp1_;
#line 1035 "../lib/application.vala"
	g_return_if_fail (i != NULL);
#line 1037 "../lib/application.vala"
	_tmp0_ = g_object_get_data ((GObject*) i, "window");
#line 1037 "../lib/application.vala"
	_tmp1_ = _g_object_ref0 ((XnpWindow*) _tmp0_);
#line 1037 "../lib/application.vala"
	w = _tmp1_;
#line 1038 "../lib/application.vala"
	gtk_window_present ((GtkWindow*) w);
#line 1035 "../lib/application.vala"
	_g_object_unref0 (w);
#line 5376 "application.c"
}

static void
_____lambda57__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 1035 "../lib/application.vala"
	____lambda57_ ((XnpApplication*) self, _sender);
#line 5385 "application.c"
}

static void
__lambda58_ (XnpApplication* self)
{
	XnpWindow* new_win = NULL;
	XnpWindow* _tmp0_;
	XnpWindow* _tmp1_;
#line 1048 "../lib/application.vala"
	_tmp0_ = xnp_application_create_window (self, NULL);
#line 1048 "../lib/application.vala"
	new_win = _tmp0_;
#line 1049 "../lib/application.vala"
	_tmp1_ = new_win;
#line 1049 "../lib/application.vala"
	if (_tmp1_ != NULL) {
#line 5402 "application.c"
		XnpWindow* _tmp2_;
#line 1050 "../lib/application.vala"
		_tmp2_ = new_win;
#line 1050 "../lib/application.vala"
		gtk_widget_show ((GtkWidget*) _tmp2_);
#line 5408 "application.c"
	}
#line 1047 "../lib/application.vala"
	_g_object_unref0 (new_win);
#line 5412 "application.c"
}

static void
___lambda58__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1047 "../lib/application.vala"
	__lambda58_ ((XnpApplication*) self);
#line 5421 "application.c"
}

static void
__lambda55_ (Block3Data* _data3_)
{
	XnpApplication* self;
	GSList* _tmp0_;
	GtkSeparatorMenuItem* mi_sep = NULL;
	GtkSeparatorMenuItem* _tmp10_;
	GtkImageMenuItem* mi_add = NULL;
	GtkImageMenuItem* _tmp11_;
	GtkImage* image = NULL;
	GtkImage* _tmp12_;
#line 1025 "../lib/application.vala"
	self = _data3_->self;
#line 1027 "../lib/application.vala"
	gtk_container_foreach ((GtkContainer*) _data3_->menu, ___lambda56__gtk_callback, self);
#line 1032 "../lib/application.vala"
	_tmp0_ = self->priv->window_list;
#line 5441 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 1032 "../lib/application.vala"
		win_collection = _tmp0_;
#line 1032 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 5449 "application.c"
			XnpWindow* _tmp1_;
			XnpWindow* win = NULL;
#line 1032 "../lib/application.vala"
			_tmp1_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 1032 "../lib/application.vala"
			win = _tmp1_;
#line 5456 "application.c"
			{
				GtkMenuItem* mi = NULL;
				XnpWindow* _tmp2_;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				GtkMenuItem* _tmp5_;
				GtkMenuItem* _tmp6_;
				XnpWindow* _tmp7_;
				GtkMenuItem* _tmp8_;
				GtkMenuItem* _tmp9_;
#line 1033 "../lib/application.vala"
				_tmp2_ = win;
#line 1033 "../lib/application.vala"
				_tmp3_ = xnp_window_get_name (_tmp2_);
#line 1033 "../lib/application.vala"
				_tmp4_ = _tmp3_;
#line 1033 "../lib/application.vala"
				_tmp5_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp4_);
#line 1033 "../lib/application.vala"
				g_object_ref_sink (_tmp5_);
#line 1033 "../lib/application.vala"
				mi = _tmp5_;
#line 1034 "../lib/application.vala"
				_tmp6_ = mi;
#line 1034 "../lib/application.vala"
				_tmp7_ = win;
#line 1034 "../lib/application.vala"
				g_object_set_data_full ((GObject*) _tmp6_, "window", (void*) _tmp7_, NULL);
#line 1035 "../lib/application.vala"
				_tmp8_ = mi;
#line 1035 "../lib/application.vala"
				g_signal_connect_object (_tmp8_, "activate", (GCallback) _____lambda57__gtk_menu_item_activate, self, 0);
#line 1040 "../lib/application.vala"
				_tmp9_ = mi;
#line 1040 "../lib/application.vala"
				gtk_menu_shell_insert ((GtkMenuShell*) _data3_->menu, G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp9_) : NULL, -1);
#line 1032 "../lib/application.vala"
				_g_object_unref0 (mi);
#line 1032 "../lib/application.vala"
				_g_object_unref0 (win);
#line 5497 "application.c"
			}
		}
	}
#line 1044 "../lib/application.vala"
	_tmp10_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1044 "../lib/application.vala"
	g_object_ref_sink (_tmp10_);
#line 1044 "../lib/application.vala"
	mi_sep = _tmp10_;
#line 1045 "../lib/application.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _data3_->menu, G_TYPE_CHECK_INSTANCE_TYPE (mi_sep, gtk_widget_get_type ()) ? ((GtkWidget*) mi_sep) : NULL, -1);
#line 1046 "../lib/application.vala"
	_tmp11_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_mnemonic (_ ("_Add a new group"));
#line 1046 "../lib/application.vala"
	g_object_ref_sink (_tmp11_);
#line 1046 "../lib/application.vala"
	mi_add = _tmp11_;
#line 1047 "../lib/application.vala"
	g_signal_connect_object ((GtkMenuItem*) mi_add, "activate", (GCallback) ___lambda58__gtk_menu_item_activate, self, 0);
#line 1052 "../lib/application.vala"
	_tmp12_ = (GtkImage*) gtk_image_new_from_icon_name ("gtk-add", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 1052 "../lib/application.vala"
	g_object_ref_sink (_tmp12_);
#line 1052 "../lib/application.vala"
	image = _tmp12_;
#line 1053 "../lib/application.vala"
	gtk_image_menu_item_set_image (mi_add, (GtkWidget*) image);
#line 1054 "../lib/application.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) _data3_->menu, G_TYPE_CHECK_INSTANCE_TYPE (mi_add, gtk_widget_get_type ()) ? ((GtkWidget*) mi_add) : NULL, -1);
#line 1057 "../lib/application.vala"
	gtk_widget_show_all ((GtkWidget*) _data3_->menu);
#line 1025 "../lib/application.vala"
	_g_object_unref0 (image);
#line 1025 "../lib/application.vala"
	_g_object_unref0 (mi_add);
#line 1025 "../lib/application.vala"
	_g_object_unref0 (mi_sep);
#line 5535 "application.c"
}

static void
___lambda55__gtk_widget_show (GtkWidget* _sender,
                              gpointer self)
{
#line 1025 "../lib/application.vala"
	__lambda55_ (self);
#line 5544 "application.c"
}

GtkMenu*
xnp_application_context_menu (XnpApplication* self)
{
	Block3Data* _data3_;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* result;
#line 1022 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1022 "../lib/application.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 1022 "../lib/application.vala"
	_data3_->_ref_count_ = 1;
#line 1022 "../lib/application.vala"
	_data3_->self = g_object_ref (self);
#line 1023 "../lib/application.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 1023 "../lib/application.vala"
	g_object_ref_sink (_tmp0_);
#line 1023 "../lib/application.vala"
	_data3_->menu = _tmp0_;
#line 1025 "../lib/application.vala"
	g_signal_connect_data ((GtkWidget*) _data3_->menu, "show", (GCallback) ___lambda55__gtk_widget_show, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 1060 "../lib/application.vala"
	_tmp1_ = _g_object_ref0 (_data3_->menu);
#line 1060 "../lib/application.vala"
	result = _tmp1_;
#line 1060 "../lib/application.vala"
	block3_data_unref (_data3_);
#line 1060 "../lib/application.vala"
	_data3_ = NULL;
#line 1060 "../lib/application.vala"
	return result;
#line 5580 "application.c"
}

const gchar*
xnp_application_get_notes_path (XnpApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/application.vala"
	_tmp0_ = self->priv->_notes_path;
#line 27 "../lib/application.vala"
	result = _tmp0_;
#line 27 "../lib/application.vala"
	return result;
#line 5596 "application.c"
}

void
xnp_application_set_notes_path (XnpApplication* self,
                                const gchar* value)
{
	gchar* old_value;
#line 27 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 27 "../lib/application.vala"
	old_value = xnp_application_get_notes_path (self);
#line 27 "../lib/application.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 5610 "application.c"
		gchar* _tmp0_;
#line 27 "../lib/application.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../lib/application.vala"
		_g_free0 (self->priv->_notes_path);
#line 27 "../lib/application.vala"
		self->priv->_notes_path = _tmp0_;
#line 27 "../lib/application.vala"
		g_object_notify_by_pspec ((GObject *) self, xnp_application_properties[XNP_APPLICATION_NOTES_PATH_PROPERTY]);
#line 5620 "application.c"
	}
}

const gchar*
xnp_application_get_config_file (XnpApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../lib/application.vala"
	_tmp0_ = self->priv->_config_file;
#line 28 "../lib/application.vala"
	result = _tmp0_;
#line 28 "../lib/application.vala"
	return result;
#line 5637 "application.c"
}

static void
xnp_application_set_config_file (XnpApplication* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 28 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 28 "../lib/application.vala"
	old_value = xnp_application_get_config_file (self);
#line 28 "../lib/application.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 5651 "application.c"
		gchar* _tmp0_;
#line 28 "../lib/application.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../lib/application.vala"
		_g_free0 (self->priv->_config_file);
#line 28 "../lib/application.vala"
		self->priv->_config_file = _tmp0_;
#line 28 "../lib/application.vala"
		g_object_notify_by_pspec ((GObject *) self, xnp_application_properties[XNP_APPLICATION_CONFIG_FILE_PROPERTY]);
#line 5661 "application.c"
	}
}

static void
_xnp_application_main_instance___lambda42_ (XnpApplication* self)
{
}

static void
__xnp_application_main_instance___lambda42__g_application_activate (GApplication* _sender,
                                                                    gpointer self)
{
#line 47 "../lib/application.vala"
	_xnp_application_main_instance___lambda42_ ((XnpApplication*) self);
#line 5676 "application.c"
}

static gboolean
xnp_application_get_main_instance (XnpApplication* self)
{
	gboolean result;
	GtkApplication* app = NULL;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkApplication* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GtkApplication* _tmp7_;
	GtkApplication* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 41 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../lib/application.vala"
	if (self->system_tray_mode) {
#line 43 "../lib/application.vala"
		result = TRUE;
#line 43 "../lib/application.vala"
		return result;
#line 5700 "application.c"
	}
#line 46 "../lib/application.vala"
	_tmp0_ = gtk_application_new ("org.xfce.Notes", 0);
#line 46 "../lib/application.vala"
	app = _tmp0_;
#line 47 "../lib/application.vala"
	_tmp1_ = app;
#line 47 "../lib/application.vala"
	g_signal_connect_object ((GApplication*) _tmp1_, "activate", (GCallback) __xnp_application_main_instance___lambda42__g_application_activate, self, 0);
#line 5710 "application.c"
	{
		GtkApplication* _tmp2_;
#line 49 "../lib/application.vala"
		_tmp2_ = app;
#line 49 "../lib/application.vala"
		g_application_register ((GApplication*) _tmp2_, NULL, &_inner_error0_);
#line 49 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5719 "application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 48 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 5728 "application.c"
	}
	__finally0:
#line 48 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5733 "application.c"
		gboolean _tmp3_ = FALSE;
#line 48 "../lib/application.vala"
		_g_object_unref0 (app);
#line 48 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 48 "../lib/application.vala"
		return _tmp3_;
#line 5743 "application.c"
	}
#line 53 "../lib/application.vala"
	_tmp4_ = app;
#line 53 "../lib/application.vala"
	_tmp5_ = g_application_get_is_remote ((GApplication*) _tmp4_);
#line 53 "../lib/application.vala"
	_tmp6_ = _tmp5_;
#line 53 "../lib/application.vala"
	if (_tmp6_) {
#line 54 "../lib/application.vala"
		result = FALSE;
#line 54 "../lib/application.vala"
		_g_object_unref0 (app);
#line 54 "../lib/application.vala"
		return result;
#line 5759 "application.c"
	}
#line 57 "../lib/application.vala"
	_tmp7_ = app;
#line 57 "../lib/application.vala"
	g_application_run ((GApplication*) _tmp7_, (gint) 0, NULL);
#line 58 "../lib/application.vala"
	_tmp8_ = app;
#line 58 "../lib/application.vala"
	g_application_quit ((GApplication*) _tmp8_);
#line 60 "../lib/application.vala"
	result = TRUE;
#line 60 "../lib/application.vala"
	_g_object_unref0 (app);
#line 60 "../lib/application.vala"
	return result;
#line 5775 "application.c"
}

gboolean
xnp_application_get_skip_taskbar_hint (XnpApplication* self)
{
	gboolean result;
#line 66 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 67 "../lib/application.vala"
	result = self->priv->_skip_taskbar_hint;
#line 67 "../lib/application.vala"
	return result;
#line 5788 "application.c"
}

void
xnp_application_set_skip_taskbar_hint (XnpApplication* self,
                                       gboolean value)
{
	GSList* _tmp0_;
#line 69 "../lib/application.vala"
	g_return_if_fail (self != NULL);
#line 70 "../lib/application.vala"
	if (self->priv->_skip_taskbar_hint == value) {
#line 71 "../lib/application.vala"
		return;
#line 5802 "application.c"
	}
#line 72 "../lib/application.vala"
	self->priv->_skip_taskbar_hint = value;
#line 73 "../lib/application.vala"
	_tmp0_ = self->priv->window_list;
#line 5808 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 73 "../lib/application.vala"
		win_collection = _tmp0_;
#line 73 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 5816 "application.c"
			XnpWindow* _tmp1_;
			XnpWindow* win = NULL;
#line 73 "../lib/application.vala"
			_tmp1_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 73 "../lib/application.vala"
			win = _tmp1_;
#line 5823 "application.c"
			{
				XnpWindow* _tmp2_;
#line 74 "../lib/application.vala"
				_tmp2_ = win;
#line 74 "../lib/application.vala"
				gtk_window_set_skip_taskbar_hint ((GtkWindow*) _tmp2_, value);
#line 73 "../lib/application.vala"
				_g_object_unref0 (win);
#line 5832 "application.c"
			}
		}
	}
#line 69 "../lib/application.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_application_properties[XNP_APPLICATION_SKIP_TASKBAR_HINT_PROPERTY]);
#line 5838 "application.c"
}

XnpWindow*
xnp_application_get_next_focus (XnpApplication* self)
{
	XnpWindow* result;
	guint win_count = 0U;
	GSList* _tmp0_;
	XnpWindow* window = NULL;
	GSList* _tmp1_;
	gconstpointer _tmp2_;
	XnpWindow* _tmp3_;
	XnpWindow* _tmp4_ = NULL;
	XnpWindow* _tmp5_;
#line 79 "../lib/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 80 "../lib/application.vala"
	if (self->priv->lock_focus_order) {
#line 81 "../lib/application.vala"
		result = NULL;
#line 81 "../lib/application.vala"
		return result;
#line 5861 "application.c"
	}
#line 82 "../lib/application.vala"
	_tmp0_ = self->priv->focus_order;
#line 82 "../lib/application.vala"
	win_count = g_slist_length (_tmp0_);
#line 83 "../lib/application.vala"
	if (win_count < ((guint) 2)) {
#line 84 "../lib/application.vala"
		result = NULL;
#line 84 "../lib/application.vala"
		return result;
#line 5873 "application.c"
	}
#line 85 "../lib/application.vala"
	_tmp1_ = self->priv->focus_order;
#line 85 "../lib/application.vala"
	_tmp2_ = g_slist_nth_data (_tmp1_, win_count - 2);
#line 85 "../lib/application.vala"
	_tmp3_ = _g_object_ref0 ((XnpWindow*) _tmp2_);
#line 85 "../lib/application.vala"
	window = _tmp3_;
#line 86 "../lib/application.vala"
	_tmp5_ = window;
#line 86 "../lib/application.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp5_)) {
#line 5887 "application.c"
		XnpWindow* _tmp6_;
#line 86 "../lib/application.vala"
		_tmp6_ = window;
#line 86 "../lib/application.vala"
		_tmp4_ = _tmp6_;
#line 5893 "application.c"
	} else {
#line 86 "../lib/application.vala"
		_tmp4_ = NULL;
#line 5897 "application.c"
	}
#line 86 "../lib/application.vala"
	result = _tmp4_;
#line 86 "../lib/application.vala"
	_g_object_unref0 (window);
#line 86 "../lib/application.vala"
	return result;
#line 5905 "application.c"
}

static void
_xnp_application_quit_xfce_posix_signal_handler (gint signal,
                                                 gpointer self)
{
#line 93 "../lib/application.vala"
	xnp_application_quit ((XnpApplication*) self);
#line 5914 "application.c"
}

static void
_xnp_application___lambda59_ (XnpApplication* self)
{
#line 113 "../lib/application.vala"
	xnp_application_update_color (self);
#line 5922 "application.c"
}

static void
__xnp_application___lambda59__xfconf_get_channel_property_changed (XfconfChannel* _sender,
                                                                   const gchar* property,
                                                                   GValue* value,
                                                                   gpointer self)
{
#line 112 "../lib/application.vala"
	_xnp_application___lambda59_ ((XnpApplication*) self);
#line 5933 "application.c"
}

static void
_xnp_application___lambda60_ (XnpApplication* self)
{
#line 124 "../lib/application.vala"
	xnp_application_update_notes_path (self);
#line 5941 "application.c"
}

static void
__xnp_application___lambda60__xfconf_get_channel_property_changed (XfconfChannel* _sender,
                                                                   const gchar* property,
                                                                   GValue* value,
                                                                   gpointer self)
{
#line 123 "../lib/application.vala"
	_xnp_application___lambda60_ ((XnpApplication*) self);
#line 5952 "application.c"
}

static GObject *
xnp_application_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	XnpApplication * self;
	XfconfChannel* _tmp4_;
	XnpTheme* _tmp5_;
	XfconfChannel* _tmp6_;
	XfconfChannel* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	XfconfChannel* _tmp15_;
	gchar* name = NULL;
	gboolean found = FALSE;
	GError* _inner_error0_ = NULL;
#line 90 "../lib/application.vala"
	parent_class = G_OBJECT_CLASS (xnp_application_parent_class);
#line 90 "../lib/application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 90 "../lib/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_APPLICATION, XnpApplication);
#line 5980 "application.c"
	{
#line 92 "../lib/application.vala"
		xfce_posix_signal_handler_init (&_inner_error0_);
#line 92 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5986 "application.c"
			goto __catch0_g_error;
		}
#line 93 "../lib/application.vala"
		xfce_posix_signal_handler_set_handler ((gint) SIGTERM, _xnp_application_quit_xfce_posix_signal_handler, self, &_inner_error0_);
#line 93 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5993 "application.c"
			goto __catch0_g_error;
		}
#line 94 "../lib/application.vala"
		xfce_posix_signal_handler_set_handler ((gint) SIGINT, _xnp_application_quit_xfce_posix_signal_handler, self, &_inner_error0_);
#line 94 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6000 "application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 91 "../lib/application.vala"
		e = _inner_error0_;
#line 91 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 97 "../lib/application.vala"
		_tmp0_ = e;
#line 97 "../lib/application.vala"
		_tmp1_ = _tmp0_->message;
#line 97 "../lib/application.vala"
		g_critical ("application.vala:97: Unable to connect to UNIX signals. %s", _tmp1_);
#line 91 "../lib/application.vala"
		_g_error_free0 (e);
#line 6022 "application.c"
	}
	__finally0:
#line 91 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 6031 "application.c"
	}
	{
#line 101 "../lib/application.vala"
		xfconf_init (&_inner_error0_);
#line 101 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6038 "application.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 100 "../lib/application.vala"
		e = _inner_error0_;
#line 100 "../lib/application.vala"
		_inner_error0_ = NULL;
#line 104 "../lib/application.vala"
		_tmp2_ = e;
#line 104 "../lib/application.vala"
		_tmp3_ = _tmp2_->message;
#line 104 "../lib/application.vala"
		g_critical ("application.vala:104: %s", _tmp3_);
#line 100 "../lib/application.vala"
		_g_error_free0 (e);
#line 6060 "application.c"
	}
	__finally1:
#line 100 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 6069 "application.c"
	}
#line 107 "../lib/application.vala"
	_tmp4_ = xfconf_channel_new_with_property_base ("xfce4-panel", "/plugins/notes");
#line 107 "../lib/application.vala"
	_g_object_unref0 (self->priv->xfconf_channel);
#line 107 "../lib/application.vala"
	self->priv->xfconf_channel = _tmp4_;
#line 108 "../lib/application.vala"
	xnp_application_update_version (self);
#line 110 "../lib/application.vala"
	_tmp5_ = xnp_theme_new ();
#line 110 "../lib/application.vala"
	_g_object_unref0 (self->priv->theme);
#line 110 "../lib/application.vala"
	self->priv->theme = _tmp5_;
#line 111 "../lib/application.vala"
	xnp_application_update_color (self);
#line 112 "../lib/application.vala"
	_tmp6_ = self->priv->xfconf_channel;
#line 112 "../lib/application.vala"
	g_signal_connect_object (_tmp6_, "property-changed::/global/background-color", (GCallback) __xnp_application___lambda59__xfconf_get_channel_property_changed, self, 0);
#line 116 "../lib/application.vala"
	_tmp7_ = self->priv->xfconf_channel;
#line 116 "../lib/application.vala"
	xfconf_g_property_bind (_tmp7_, "/global/skip-taskbar-hint", G_TYPE_BOOLEAN, self, "skip-taskbar-hint");
#line 119 "../lib/application.vala"
	_tmp8_ = g_get_user_data_dir ();
#line 119 "../lib/application.vala"
	_tmp9_ = g_strdup_printf ("%s/notes", _tmp8_);
#line 119 "../lib/application.vala"
	_g_free0 (self->priv->default_notes_path);
#line 119 "../lib/application.vala"
	self->priv->default_notes_path = _tmp9_;
#line 120 "../lib/application.vala"
	_tmp10_ = self->priv->_notes_path;
#line 120 "../lib/application.vala"
	if (_tmp10_ == NULL) {
#line 6107 "application.c"
		XfconfChannel* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 121 "../lib/application.vala"
		_tmp11_ = self->priv->xfconf_channel;
#line 121 "../lib/application.vala"
		_tmp12_ = self->priv->default_notes_path;
#line 121 "../lib/application.vala"
		_tmp13_ = xfconf_channel_get_string (_tmp11_, "/global/notes-path", _tmp12_);
#line 121 "../lib/application.vala"
		_tmp14_ = _tmp13_;
#line 121 "../lib/application.vala"
		xnp_application_set_notes_path (self, _tmp14_);
#line 121 "../lib/application.vala"
		_g_free0 (_tmp14_);
#line 6124 "application.c"
	}
#line 123 "../lib/application.vala"
	_tmp15_ = self->priv->xfconf_channel;
#line 123 "../lib/application.vala"
	g_signal_connect_object (_tmp15_, "property-changed::/global/notes-path", (GCallback) __xnp_application___lambda60__xfconf_get_channel_property_changed, self, 0);
#line 128 "../lib/application.vala"
	found = FALSE;
#line 6132 "application.c"
	{
		GSList* groups = NULL;
		GDir* dir = NULL;
		const gchar* _tmp16_;
		GDir* _tmp17_;
		GSList* _tmp24_;
#line 131 "../lib/application.vala"
		groups = NULL;
#line 132 "../lib/application.vala"
		_tmp16_ = self->priv->_notes_path;
#line 132 "../lib/application.vala"
		_tmp17_ = g_dir_open (_tmp16_, (guint) 0, &_inner_error0_);
#line 132 "../lib/application.vala"
		dir = _tmp17_;
#line 132 "../lib/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 132 "../lib/application.vala"
			(groups == NULL) ? NULL : (groups = (_g_slist_free__g_free0_ (groups), NULL));
#line 6151 "application.c"
			goto __catch2_g_error;
		}
#line 133 "../lib/application.vala"
		while (TRUE) {
#line 6156 "application.c"
			GDir* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
#line 133 "../lib/application.vala"
			_tmp18_ = dir;
#line 133 "../lib/application.vala"
			_tmp19_ = g_dir_read_name (_tmp18_);
#line 133 "../lib/application.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 133 "../lib/application.vala"
			_g_free0 (name);
#line 133 "../lib/application.vala"
			name = _tmp20_;
#line 133 "../lib/application.vala"
			_tmp21_ = name;
#line 133 "../lib/application.vala"
			if (!(_tmp21_ != NULL)) {
#line 133 "../lib/application.vala"
				break;
#line 6179 "application.c"
			}
#line 134 "../lib/application.vala"
			_tmp22_ = name;
#line 134 "../lib/application.vala"
			_tmp23_ = g_strdup (_tmp22_);
#line 134 "../lib/application.vala"
			groups = g_slist_prepend (groups, _tmp23_);
#line 135 "../lib/application.vala"
			found = TRUE;
#line 6189 "application.c"
		}
#line 137 "../lib/application.vala"
		xnp_application_sort_groups_by_focus_order (self, &groups);
#line 138 "../lib/application.vala"
		_tmp24_ = groups;
#line 6195 "application.c"
		{
			GSList* group_name_collection = NULL;
			GSList* group_name_it = NULL;
#line 138 "../lib/application.vala"
			group_name_collection = _tmp24_;
#line 138 "../lib/application.vala"
			for (group_name_it = group_name_collection; group_name_it != NULL; group_name_it = group_name_it->next) {
#line 6203 "application.c"
				gchar* _tmp25_;
				gchar* group_name = NULL;
#line 138 "../lib/application.vala"
				_tmp25_ = g_strdup ((const gchar*) group_name_it->data);
#line 138 "../lib/application.vala"
				group_name = _tmp25_;
#line 6210 "application.c"
				{
					const gchar* _tmp26_;
					XnpWindow* _tmp27_;
					XnpWindow* _tmp28_;
#line 139 "../lib/application.vala"
					_tmp26_ = group_name;
#line 139 "../lib/application.vala"
					_tmp27_ = xnp_application_create_window (self, _tmp26_);
#line 139 "../lib/application.vala"
					_tmp28_ = _tmp27_;
#line 139 "../lib/application.vala"
					_g_object_unref0 (_tmp28_);
#line 138 "../lib/application.vala"
					_g_free0 (group_name);
#line 6225 "application.c"
				}
			}
		}
#line 129 "../lib/application.vala"
		_g_dir_close0 (dir);
#line 129 "../lib/application.vala"
		(groups == NULL) ? NULL : (groups = (_g_slist_free__g_free0_ (groups), NULL));
#line 6233 "application.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		const gchar* _tmp29_;
#line 129 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 143 "../lib/application.vala"
		_tmp29_ = self->priv->_notes_path;
#line 143 "../lib/application.vala"
		g_mkdir_with_parents (_tmp29_, 0700);
#line 6245 "application.c"
	}
	__finally2:
#line 129 "../lib/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 129 "../lib/application.vala"
		_g_free0 (name);
#line 129 "../lib/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 129 "../lib/application.vala"
		g_clear_error (&_inner_error0_);
#line 6256 "application.c"
	}
#line 145 "../lib/application.vala"
	if (found == FALSE) {
#line 6260 "application.c"
		XnpWindow* _tmp30_;
		XnpWindow* _tmp31_;
#line 147 "../lib/application.vala"
		_tmp30_ = xnp_application_create_window (self, NULL);
#line 147 "../lib/application.vala"
		_tmp31_ = _tmp30_;
#line 147 "../lib/application.vala"
		_g_object_unref0 (_tmp31_);
#line 6269 "application.c"
	}
#line 150 "../lib/application.vala"
	gtk_window_set_default_icon_name ("org.xfce.notes");
#line 90 "../lib/application.vala"
	_g_free0 (name);
#line 90 "../lib/application.vala"
	return obj;
#line 6277 "application.c"
}

static void
xnp_application_class_init (XnpApplicationClass * klass,
                            gpointer klass_data)
{
#line 25 "../lib/application.vala"
	xnp_application_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/application.vala"
	g_type_class_adjust_private_offset (klass, &XnpApplication_private_offset);
#line 25 "../lib/application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_xnp_application_get_property;
#line 25 "../lib/application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_xnp_application_set_property;
#line 25 "../lib/application.vala"
	G_OBJECT_CLASS (klass)->constructor = xnp_application_constructor;
#line 25 "../lib/application.vala"
	G_OBJECT_CLASS (klass)->finalize = xnp_application_finalize;
#line 25 "../lib/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_APPLICATION_NOTES_PATH_PROPERTY, xnp_application_properties[XNP_APPLICATION_NOTES_PATH_PROPERTY] = g_param_spec_string ("notes-path", "notes-path", "notes-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 25 "../lib/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_APPLICATION_CONFIG_FILE_PROPERTY, xnp_application_properties[XNP_APPLICATION_CONFIG_FILE_PROPERTY] = g_param_spec_string ("config-file", "config-file", "config-file", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "../lib/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_APPLICATION_SKIP_TASKBAR_HINT_PROPERTY, xnp_application_properties[XNP_APPLICATION_SKIP_TASKBAR_HINT_PROPERTY] = g_param_spec_boolean ("skip-taskbar-hint", "skip-taskbar-hint", "skip-taskbar-hint", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_APPLICATION_NEXT_FOCUS_PROPERTY, xnp_application_properties[XNP_APPLICATION_NEXT_FOCUS_PROPERTY] = g_param_spec_object ("next-focus", "next-focus", "next-focus", XNP_TYPE_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6304 "application.c"
}

static void
xnp_application_instance_init (XnpApplication * self,
                               gpointer klass)
{
#line 25 "../lib/application.vala"
	self->priv = xnp_application_get_instance_private (self);
#line 29 "../lib/application.vala"
	self->system_tray_mode = FALSE;
#line 30 "../lib/application.vala"
	self->external_event = FALSE;
#line 35 "../lib/application.vala"
	self->priv->lock_focus_order = FALSE;
#line 36 "../lib/application.vala"
	self->priv->save_config_timeout = (guint) 0;
#line 64 "../lib/application.vala"
	self->priv->_skip_taskbar_hint = TRUE;
#line 6323 "application.c"
}

static void
xnp_application_finalize (GObject * obj)
{
	XnpApplication * self;
	GSList* _tmp0_;
#line 25 "../lib/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_APPLICATION, XnpApplication);
#line 162 "../lib/application.vala"
	_g_object_unref0 (self->priv->xfconf_channel);
#line 162 "../lib/application.vala"
	self->priv->xfconf_channel = NULL;
#line 163 "../lib/application.vala"
	xfconf_shutdown ();
#line 164 "../lib/application.vala"
	if (self->priv->save_config_timeout != ((guint) 0)) {
#line 165 "../lib/application.vala"
		g_source_remove (self->priv->save_config_timeout);
#line 6343 "application.c"
	}
#line 167 "../lib/application.vala"
	_tmp0_ = self->priv->window_list;
#line 6347 "application.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 167 "../lib/application.vala"
		win_collection = _tmp0_;
#line 167 "../lib/application.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 6355 "application.c"
			XnpWindow* _tmp1_;
			XnpWindow* win = NULL;
#line 167 "../lib/application.vala"
			_tmp1_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 167 "../lib/application.vala"
			win = _tmp1_;
#line 6362 "application.c"
			{
				XnpWindow* _tmp2_;
#line 168 "../lib/application.vala"
				_tmp2_ = win;
#line 168 "../lib/application.vala"
				gtk_widget_destroy ((GtkWidget*) _tmp2_);
#line 169 "../lib/application.vala"
				_g_object_unref0 (win);
#line 169 "../lib/application.vala"
				win = NULL;
#line 167 "../lib/application.vala"
				_g_object_unref0 (win);
#line 6375 "application.c"
			}
		}
	}
#line 27 "../lib/application.vala"
	_g_free0 (self->priv->_notes_path);
#line 28 "../lib/application.vala"
	_g_free0 (self->priv->_config_file);
#line 32 "../lib/application.vala"
	(self->priv->window_list == NULL) ? NULL : (self->priv->window_list = (_g_slist_free__g_object_unref0_ (self->priv->window_list), NULL));
#line 33 "../lib/application.vala"
	(self->priv->focus_order == NULL) ? NULL : (self->priv->focus_order = (_g_slist_free__g_object_unref0_ (self->priv->focus_order), NULL));
#line 34 "../lib/application.vala"
	_g_object_unref0 (self->priv->xfconf_channel);
#line 37 "../lib/application.vala"
	_g_free0 (self->priv->default_notes_path);
#line 38 "../lib/application.vala"
	_g_object_unref0 (self->priv->theme);
#line 25 "../lib/application.vala"
	G_OBJECT_CLASS (xnp_application_parent_class)->finalize (obj);
#line 6395 "application.c"
}

static GType
xnp_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (XnpApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnp_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnpApplication), 0, (GInstanceInitFunc) xnp_application_instance_init, NULL };
	GType xnp_application_type_id;
	xnp_application_type_id = g_type_register_static (G_TYPE_OBJECT, "XnpApplication", &g_define_type_info, 0);
	XnpApplication_private_offset = g_type_add_instance_private (xnp_application_type_id, sizeof (XnpApplicationPrivate));
	return xnp_application_type_id;
}

GType
xnp_application_get_type (void)
{
	static volatile gsize xnp_application_type_id__once = 0;
	if (g_once_init_enter (&xnp_application_type_id__once)) {
		GType xnp_application_type_id;
		xnp_application_type_id = xnp_application_get_type_once ();
		g_once_init_leave (&xnp_application_type_id__once, xnp_application_type_id);
	}
	return xnp_application_type_id__once;
}

static void
_vala_xnp_application_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	XnpApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_APPLICATION, XnpApplication);
#line 25 "../lib/application.vala"
	switch (property_id) {
#line 25 "../lib/application.vala"
		case XNP_APPLICATION_NOTES_PATH_PROPERTY:
#line 25 "../lib/application.vala"
		g_value_set_string (value, xnp_application_get_notes_path (self));
#line 25 "../lib/application.vala"
		break;
#line 25 "../lib/application.vala"
		case XNP_APPLICATION_CONFIG_FILE_PROPERTY:
#line 25 "../lib/application.vala"
		g_value_set_string (value, xnp_application_get_config_file (self));
#line 25 "../lib/application.vala"
		break;
#line 25 "../lib/application.vala"
		case XNP_APPLICATION_SKIP_TASKBAR_HINT_PROPERTY:
#line 25 "../lib/application.vala"
		g_value_set_boolean (value, xnp_application_get_skip_taskbar_hint (self));
#line 25 "../lib/application.vala"
		break;
#line 25 "../lib/application.vala"
		case XNP_APPLICATION_NEXT_FOCUS_PROPERTY:
#line 25 "../lib/application.vala"
		g_value_set_object (value, xnp_application_get_next_focus (self));
#line 25 "../lib/application.vala"
		break;
#line 6454 "application.c"
		default:
#line 25 "../lib/application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/application.vala"
		break;
#line 6460 "application.c"
	}
}

static void
_vala_xnp_application_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	XnpApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_APPLICATION, XnpApplication);
#line 25 "../lib/application.vala"
	switch (property_id) {
#line 25 "../lib/application.vala"
		case XNP_APPLICATION_NOTES_PATH_PROPERTY:
#line 25 "../lib/application.vala"
		xnp_application_set_notes_path (self, g_value_get_string (value));
#line 25 "../lib/application.vala"
		break;
#line 25 "../lib/application.vala"
		case XNP_APPLICATION_CONFIG_FILE_PROPERTY:
#line 25 "../lib/application.vala"
		xnp_application_set_config_file (self, g_value_get_string (value));
#line 25 "../lib/application.vala"
		break;
#line 25 "../lib/application.vala"
		case XNP_APPLICATION_SKIP_TASKBAR_HINT_PROPERTY:
#line 25 "../lib/application.vala"
		xnp_application_set_skip_taskbar_hint (self, g_value_get_boolean (value));
#line 25 "../lib/application.vala"
		break;
#line 6492 "application.c"
		default:
#line 25 "../lib/application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/application.vala"
		break;
#line 6498 "application.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

