/* window.c generated by valac 0.56.18, the Vala compiler
 * generated from window.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (c) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "libnotes.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <gio/gio.h>

#define XNP_WINDOW_ui_string "\n" \
"<ui>\n" \
"  <accelerator action=\"close-window\" />\n" \
"  <accelerator action=\"new-window\" />\n" \
"  <accelerator action=\"delete-window\" />\n" \
"  <accelerator action=\"rename-window\" />\n" \
"  <accelerator action=\"new-note\" />\n" \
"  <accelerator action=\"delete-note\" />\n" \
"  <accelerator action=\"rename-note\" />\n" \
"  <accelerator action=\"undo\" />\n" \
"  <accelerator action=\"redo\" />\n" \
"  <accelerator action=\"bold\" />\n" \
"  <accelerator action=\"italic\" />\n" \
"  <accelerator action=\"strikethrough\" />\n" \
"  <accelerator action=\"underline\" />\n" \
"  <accelerator action=\"checkbox\" />\n" \
"  <accelerator action=\"next-note\" />\n" \
"  <accelerator action=\"prev-note\" />\n" \
"</ui>\n"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	XNP_WINDOW_0_PROPERTY,
	XNP_WINDOW_NAME_PROPERTY,
	XNP_WINDOW_CURRENT_NOTE_PROPERTY,
	XNP_WINDOW_N_PAGES_PROPERTY,
	XNP_WINDOW_EMPTY_PROPERTY,
	XNP_WINDOW_SHOW_TABS_PROPERTY,
	XNP_WINDOW_TABS_POSITION_PROPERTY,
	XNP_WINDOW_ABOVE_PROPERTY,
	XNP_WINDOW_STICKY_PROPERTY,
	XNP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* xnp_window_properties[XNP_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
typedef struct _Block9Data Block9Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef void (*XnpWindowCallback) (gpointer user_data);
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
enum  {
	XNP_WINDOW_ACTION_SIGNAL,
	XNP_WINDOW_SAVE_DATA_SIGNAL,
	XNP_WINDOW_NOTE_INSERTED_SIGNAL,
	XNP_WINDOW_NOTE_DELETED_SIGNAL,
	XNP_WINDOW_NOTE_RENAMED_SIGNAL,
	XNP_WINDOW_NOTE_MOVED_SIGNAL,
	XNP_WINDOW_ACTION_CYCLE_FORWARD_SIGNAL,
	XNP_WINDOW_ACTION_CYCLE_BACKWARD_SIGNAL,
	XNP_WINDOW_NUM_SIGNALS
};
static guint xnp_window_signals[XNP_WINDOW_NUM_SIGNALS] = {0};

struct _XnpWindowPrivate {
	XnpApplication* app;
	gint width;
	gint height;
	GtkMenu* menu;
	GtkCheckMenuItem* mi_above;
	GtkCheckMenuItem* mi_sticky;
	GtkImage* menu_image;
	GtkLabel* title_label;
	XnpTitleBarButton* left_arrow_button;
	XnpTitleBarButton* right_arrow_button;
	XnpTitleBarButton* close_button;
	GtkBox* content_box;
	GtkNotebook* notebook;
	GtkUIManager* ui;
	GtkActionGroup* action_group;
	gint CORNER_MARGIN;
	GdkCursor* CURSOR_TOP_LC;
	GdkCursor* CURSOR_TOP;
	GdkCursor* CURSOR_TOP_RC;
	GdkCursor* CURSOR_RIGHT;
	GdkCursor* CURSOR_LEFT;
	GdkCursor* CURSOR_BOTTOM_RC;
	GdkCursor* CURSOR_BOTTOM;
	GdkCursor* CURSOR_BOTTOM_LC;
	gchar* _name;
	gint _tabs_position;
	gboolean _above;
	gboolean _sticky;
};

struct _Block9Data {
	int _ref_count_;
	XnpWindow* self;
	GtkEventBox* menu_evbox;
	XnpApplication* app;
};

struct _Block10Data {
	int _ref_count_;
	XnpWindow* self;
	XnpWindowCallback callback;
	gpointer callback_target;
};

struct _Block11Data {
	int _ref_count_;
	XnpWindow* self;
	XnpWindowCallback callback;
	gpointer callback_target;
};

struct _Block12Data {
	int _ref_count_;
	XnpWindow* self;
	XnpNote* note;
};

static gint XnpWindow_private_offset;
static gpointer xnp_window_parent_class = NULL;
static gboolean xnp_window_tab_hotkeys_bound;
static gboolean xnp_window_tab_hotkeys_bound = FALSE;

static void xnp_window_action_cycle_forward (XnpWindow* self);
static void xnp_window_action_cycle_backward (XnpWindow* self);
static void _xnp_window_hide_gcallback (GtkAction* action,
                                 gpointer self);
static void xnp_window_action_new_window (XnpWindow* self);
static void _xnp_window_action_new_window_gcallback (GtkAction* action,
                                              gpointer self);
static void xnp_window_action_delete_window (XnpWindow* self);
static void _xnp_window_action_delete_window_gcallback (GtkAction* action,
                                                 gpointer self);
static void xnp_window_action_rename_window (XnpWindow* self);
static void _xnp_window_action_rename_window_gcallback (GtkAction* action,
                                                 gpointer self);
static void xnp_window_action_new_note (XnpWindow* self);
static void _xnp_window_action_new_note_gcallback (GtkAction* action,
                                            gpointer self);
static void xnp_window_action_delete_note (XnpWindow* self);
static void _xnp_window_action_delete_note_gcallback (GtkAction* action,
                                               gpointer self);
static void xnp_window_action_rename_note (XnpWindow* self);
static void _xnp_window_action_rename_note_gcallback (GtkAction* action,
                                               gpointer self);
static void xnp_window_action_undo (XnpWindow* self);
static void _xnp_window_action_undo_gcallback (GtkAction* action,
                                        gpointer self);
static void xnp_window_action_redo (XnpWindow* self);
static void _xnp_window_action_redo_gcallback (GtkAction* action,
                                        gpointer self);
static void xnp_window_action_bold (XnpWindow* self);
static void _xnp_window_action_bold_gcallback (GtkAction* action,
                                        gpointer self);
static void xnp_window_action_italic (XnpWindow* self);
static void _xnp_window_action_italic_gcallback (GtkAction* action,
                                          gpointer self);
static void xnp_window_action_strikethrough (XnpWindow* self);
static void _xnp_window_action_strikethrough_gcallback (GtkAction* action,
                                                 gpointer self);
static void xnp_window_action_underline (XnpWindow* self);
static void _xnp_window_action_underline_gcallback (GtkAction* action,
                                             gpointer self);
static void xnp_window_action_checkbox (XnpWindow* self);
static void _xnp_window_action_checkbox_gcallback (GtkAction* action,
                                            gpointer self);
static void xnp_window_action_next_note (XnpWindow* self);
static void _xnp_window_action_next_note_gcallback (GtkAction* action,
                                             gpointer self);
static void xnp_window_action_prev_note (XnpWindow* self);
static void _xnp_window_action_prev_note_gcallback (GtkAction* action,
                                             gpointer self);
static void xnp_window_remove_tab_bindings (XnpWindow* self,
                                     GType t);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static GtkMenu* xnp_window_build_menu (XnpWindow* self);
static gboolean __lambda30_ (Block9Data* _data9_);
static gboolean ___lambda30__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                     GdkEventCrossing* event,
                                                     gpointer self);
static gboolean __lambda31_ (Block9Data* _data9_);
static gboolean ___lambda31__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                     GdkEventCrossing* event,
                                                     gpointer self);
static gboolean xnp_window_menu_evbox_pressed_cb (XnpWindow* self,
                                           GtkWidget* widget,
                                           GdkEventButton* event);
static gboolean _xnp_window_menu_evbox_pressed_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                          GdkEventButton* event,
                                                                          gpointer self);
static void _xnp_window_action_prev_note_xnp_icon_button_clicked (XnpIconButton* _sender,
                                                           gpointer self);
static void _xnp_window_action_next_note_xnp_icon_button_clicked (XnpIconButton* _sender,
                                                           gpointer self);
static void __lambda32_ (XnpWindow* self);
static void ___lambda32__xnp_icon_button_clicked (XnpIconButton* _sender,
                                           gpointer self);
static gboolean __lambda33_ (XnpWindow* self);
static gboolean ___lambda33__gtk_widget_delete_event (GtkWidget* _sender,
                                               GdkEventAny* event,
                                               gpointer self);
static void __lambda34_ (XnpWindow* self);
static void xnp_window_update_navigation_sensitivity (XnpWindow* self,
                                               gint page_num);
static void xnp_window_save_current_note (XnpWindow* self);
static void ___lambda34__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean xnp_window_window_leaved_cb (XnpWindow* self,
                                      GdkEventCrossing* event);
static gboolean _xnp_window_window_leaved_cb_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                     GdkEventCrossing* event,
                                                                     gpointer self);
static gboolean xnp_window_window_motion_cb (XnpWindow* self,
                                      GdkEventMotion* event);
static gboolean _xnp_window_window_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                      GdkEventMotion* event,
                                                                      gpointer self);
static gboolean xnp_window_window_pressed_cb (XnpWindow* self,
                                       GdkEventButton* event);
static gboolean _xnp_window_window_pressed_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self);
static gboolean xnp_window_window_state_cb (XnpWindow* self,
                                     GdkEventWindowState* event);
static gboolean _xnp_window_window_state_cb_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                    GdkEventWindowState* event,
                                                                    gpointer self);
static gboolean xnp_window_title_evbox_pressed_cb (XnpWindow* self,
                                            GtkWidget* widget,
                                            GdkEventButton* event);
static gboolean _xnp_window_title_evbox_pressed_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self);
static gboolean xnp_window_title_evbox_scrolled_cb (XnpWindow* self,
                                             GtkWidget* widget,
                                             GdkEventScroll* event);
static gboolean _xnp_window_title_evbox_scrolled_cb_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                      GdkEventScroll* event,
                                                                      gpointer self);
static gboolean xnp_window_notebook_tab_scroll_cb (XnpWindow* self,
                                            GdkEventScroll* event);
static gboolean _xnp_window_notebook_tab_scroll_cb_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                     GdkEventScroll* event,
                                                                     gpointer self);
static void __lambda35_ (Block9Data* _data9_,
                  GtkNotebook* n,
                  GtkWidget* c,
                  guint p);
static void ___lambda35__gtk_notebook_page_added (GtkNotebook* _sender,
                                           GtkWidget* child,
                                           guint page_num,
                                           gpointer self);
static void __lambda36_ (XnpWindow* self,
                  GtkNotebook* n,
                  GtkWidget* c,
                  guint p);
static void ___lambda36__gtk_notebook_page_removed (GtkNotebook* _sender,
                                             GtkWidget* child,
                                             guint page_num,
                                             gpointer self);
static void __lambda37_ (XnpWindow* self,
                  GtkNotebook* n,
                  GtkWidget* c,
                  guint p);
static void xnp_window_update_title (XnpWindow* self,
                              const gchar* note_name);
static XnpNote* xnp_window_get_note (XnpWindow* self,
                              gint p);
static void ___lambda37__gtk_notebook_switch_page (GtkNotebook* _sender,
                                            GtkWidget* page,
                                            guint page_num,
                                            gpointer self);
static void __lambda38_ (XnpWindow* self);
static void ___lambda38__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda39_ (XnpWindow* self);
static void ___lambda39__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean __lambda40_ (XnpWindow* self,
                      GdkDragContext* c,
                      gint x,
                      gint y,
                      guint t);
static gboolean ___lambda40__gtk_widget_drag_drop (GtkWidget* _sender,
                                            GdkDragContext* context,
                                            gint x,
                                            gint y,
                                            guint time_,
                                            gpointer self);
static void __lambda41_ (XnpWindow* self,
                  GdkDragContext* c);
static void ___lambda41__gtk_widget_drag_data_received (GtkWidget* _sender,
                                                 GdkDragContext* context,
                                                 gint x,
                                                 gint y,
                                                 GtkSelectionData* selection_data,
                                                 guint info,
                                                 guint time_,
                                                 gpointer self);
static void xnp_window_unshade (XnpWindow* self);
static void xnp_window_shade (XnpWindow* self);
static void xnp_window_note_notify_name_cb (XnpWindow* self,
                                     GObject* object,
                                     GParamSpec* pspec);
static void _xnp_window_notebook_update_tabs_angle (XnpWindow* self);
static gboolean xnp_window_tab_evbox_pressed_cb (XnpWindow* self,
                                          GdkEventButton* event,
                                          XnpNote* note);
static void xnp_window_menu_position (XnpWindow* self,
                               GtkMenu* menu,
                               gint* x,
                               gint* y,
                               gboolean* push_in);
static void _xnp_window_menu_position_gtk_menu_position_func (GtkMenu* menu,
                                                       gint* x,
                                                       gint* y,
                                                       gboolean* push_in,
                                                       gpointer self);
static void xnp_window_menu_add_icon_item (XnpWindow* self,
                                    GtkMenu* menu,
                                    const gchar* text,
                                    const gchar* icon,
                                    const gchar* accel,
                                    XnpWindowCallback callback,
                                    gpointer callback_target);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda24_ (Block10Data* _data10_);
static void ___lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static GtkCheckMenuItem* xnp_window_menu_add_check_item (XnpWindow* self,
                                                  GtkMenu* menu,
                                                  const gchar* text,
                                                  gboolean active,
                                                  XnpWindowCallback callback,
                                                  gpointer callback_target);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda25_ (Block11Data* _data11_);
static void ___lambda25__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                               gpointer self);
static void xnp_window_menu_add_separator (XnpWindow* self,
                                    GtkMenu* menu);
static void xnp_window_update_menu_go (XnpWindow* self,
                                GtkWidget* widget);
static void _xnp_window_update_menu_go_gtk_widget_show (GtkWidget* _sender,
                                                 gpointer self);
static void _xnp_window_action_new_note_xnp_window_callback (gpointer self);
static void _xnp_window_action_delete_note_xnp_window_callback (gpointer self);
static void _xnp_window_action_rename_note_xnp_window_callback (gpointer self);
static void __lambda26_ (XnpWindow* self);
static void ___lambda26__xnp_window_callback (gpointer self);
static void __lambda27_ (XnpWindow* self);
static void ___lambda27__xnp_window_callback (gpointer self);
static void __lambda28_ (XnpWindow* self);
static void ___lambda28__xnp_window_callback (gpointer self);
static void __lambda29_ (XnpWindow* self);
static void ___lambda29__xnp_window_callback (gpointer self);
static void __lambda21_ (XnpWindow* self,
                  GtkWidget* w);
static void ___lambda21__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void ________lambda22_ (XnpWindow* self,
                        GtkMenuItem* i);
static void _________lambda22__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                gpointer self);
static void _____lambda23_ (XnpWindow* self,
                     GtkMenuItem* i);
static void ______lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _xnp_window_action_rename_window_xnp_window_callback (gpointer self);
static void _xnp_window_action_delete_window_xnp_window_callback (gpointer self);
static void _xnp_window_action_new_window_xnp_window_callback (gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void _xnp_window_note_notify_name_cb_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void __lambda19_ (XnpWindow* self,
                  XnpNote* note);
static void ___lambda19__xnp_note_save_data (XnpNote* _sender,
                                      gpointer self);
static gboolean __lambda20_ (Block12Data* _data12_,
                      GdkEventButton* e);
static gboolean ___lambda20__gtk_widget_button_press_event (GtkWidget* _sender,
                                                     GdkEventButton* event,
                                                     gpointer self);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT_OBJECT (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static GObject * xnp_window_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void xnp_window_finalize (GObject * obj);
static GType xnp_window_get_type_once (void);
static void _vala_xnp_window_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_xnp_window_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static const GtkActionEntry XNP_WINDOW_action_entries[16] = {{"close-window", NULL, NULL, "Escape", NULL, (GCallback) _xnp_window_hide_gcallback}, {"new-window", NULL, NULL, "<Ctrl><Shift>n", NULL, (GCallback) _xnp_window_action_new_window_gcallback}, {"delete-window", NULL, NULL, "<Ctrl><Shift>w", NULL, (GCallback) _xnp_window_action_delete_window_gcallback}, {"rename-window", NULL, NULL, "<Shift>F2", NULL, (GCallback) _xnp_window_action_rename_window_gcallback}, {"new-note", NULL, NULL, "<Ctrl>n", NULL, (GCallback) _xnp_window_action_new_note_gcallback}, {"delete-note", NULL, NULL, "<Ctrl>w", NULL, (GCallback) _xnp_window_action_delete_note_gcallback}, {"rename-note", NULL, NULL, "F2", NULL, (GCallback) _xnp_window_action_rename_note_gcallback}, {"undo", NULL, NULL, "<Ctrl>z", NULL, (GCallback) _xnp_window_action_undo_gcallback}, {"redo", NULL, NULL, "<Ctrl>y", NULL, (GCallback) _xnp_window_action_redo_gcallback}, {"bold", NULL, NULL, "<Ctrl>b", NULL, (GCallback) _xnp_window_action_bold_gcallback}, {"italic", NULL, NULL, "<Ctrl>i", NULL, (GCallback) _xnp_window_action_italic_gcallback}, {"strikethrough", NULL, NULL, "<Ctrl>s", NULL, (GCallback) _xnp_window_action_strikethrough_gcallback}, {"underline", NULL, NULL, "<Ctrl>u", NULL, (GCallback) _xnp_window_action_underline_gcallback}, {"checkbox", NULL, NULL, "<Ctrl>o", NULL, (GCallback) _xnp_window_action_checkbox_gcallback}, {"next-note", NULL, NULL, "<Ctrl>Page_Down", NULL, (GCallback) _xnp_window_action_next_note_gcallback}, {"prev-note", NULL, NULL, "<Ctrl>Page_Up", NULL, (GCallback) _xnp_window_action_prev_note_gcallback}};

static inline gpointer
xnp_window_get_instance_private (XnpWindow* self)
{
	return G_STRUCT_MEMBER_P (self, XnpWindow_private_offset);
}

static void
_xnp_window_hide_gcallback (GtkAction* action,
                            gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_hide ((XnpWindow*) self);
#line 458 "window.c"
}

static void
_xnp_window_action_new_window_gcallback (GtkAction* action,
                                         gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_new_window ((XnpWindow*) self);
#line 467 "window.c"
}

static void
_xnp_window_action_delete_window_gcallback (GtkAction* action,
                                            gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_delete_window ((XnpWindow*) self);
#line 476 "window.c"
}

static void
_xnp_window_action_rename_window_gcallback (GtkAction* action,
                                            gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_rename_window ((XnpWindow*) self);
#line 485 "window.c"
}

static void
_xnp_window_action_new_note_gcallback (GtkAction* action,
                                       gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_new_note ((XnpWindow*) self);
#line 494 "window.c"
}

static void
_xnp_window_action_delete_note_gcallback (GtkAction* action,
                                          gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_delete_note ((XnpWindow*) self);
#line 503 "window.c"
}

static void
_xnp_window_action_rename_note_gcallback (GtkAction* action,
                                          gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_rename_note ((XnpWindow*) self);
#line 512 "window.c"
}

static void
_xnp_window_action_undo_gcallback (GtkAction* action,
                                   gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_undo ((XnpWindow*) self);
#line 521 "window.c"
}

static void
_xnp_window_action_redo_gcallback (GtkAction* action,
                                   gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_redo ((XnpWindow*) self);
#line 530 "window.c"
}

static void
_xnp_window_action_bold_gcallback (GtkAction* action,
                                   gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_bold ((XnpWindow*) self);
#line 539 "window.c"
}

static void
_xnp_window_action_italic_gcallback (GtkAction* action,
                                     gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_italic ((XnpWindow*) self);
#line 548 "window.c"
}

static void
_xnp_window_action_strikethrough_gcallback (GtkAction* action,
                                            gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_strikethrough ((XnpWindow*) self);
#line 557 "window.c"
}

static void
_xnp_window_action_underline_gcallback (GtkAction* action,
                                        gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_underline ((XnpWindow*) self);
#line 566 "window.c"
}

static void
_xnp_window_action_checkbox_gcallback (GtkAction* action,
                                       gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_checkbox ((XnpWindow*) self);
#line 575 "window.c"
}

static void
_xnp_window_action_next_note_gcallback (GtkAction* action,
                                        gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_next_note ((XnpWindow*) self);
#line 584 "window.c"
}

static void
_xnp_window_action_prev_note_gcallback (GtkAction* action,
                                        gpointer self)
{
#line 66 "../lib/window.vala"
	xnp_window_action_prev_note ((XnpWindow*) self);
#line 593 "window.c"
}

static void
xnp_window_remove_tab_bindings (XnpWindow* self,
                                GType t)
{
	GObjectClass* klass = NULL;
	GTypeClass* _tmp0_;
	GtkBindingSet* _tmp1_;
	GtkBindingSet* _tmp2_;
#line 225 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 226 "../lib/window.vala"
	_tmp0_ = g_type_class_ref (t);
#line 226 "../lib/window.vala"
	klass = (GObjectClass*) _tmp0_;
#line 227 "../lib/window.vala"
	_tmp1_ = gtk_binding_set_by_class ((gpointer) klass);
#line 227 "../lib/window.vala"
	gtk_binding_entry_remove (_tmp1_, GDK_KEY_Tab, GDK_CONTROL_MASK);
#line 229 "../lib/window.vala"
	_tmp2_ = gtk_binding_set_by_class ((gpointer) klass);
#line 229 "../lib/window.vala"
	gtk_binding_entry_remove (_tmp2_, GDK_KEY_Tab, GDK_CONTROL_MASK | GDK_SHIFT_MASK);
#line 225 "../lib/window.vala"
	_g_type_class_unref0 (klass);
#line 620 "window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 234 "../lib/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 628 "window.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 234 "../lib/window.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 234 "../lib/window.vala"
	return _data9_;
#line 638 "window.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 234 "../lib/window.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 648 "window.c"
		XnpWindow* self;
#line 234 "../lib/window.vala"
		self = _data9_->self;
#line 234 "../lib/window.vala"
		_g_object_unref0 (_data9_->menu_evbox);
#line 234 "../lib/window.vala"
		_g_object_unref0 (_data9_->app);
#line 234 "../lib/window.vala"
		_g_object_unref0 (self);
#line 234 "../lib/window.vala"
		g_slice_free (Block9Data, _data9_);
#line 660 "window.c"
	}
}

static gboolean
__lambda30_ (Block9Data* _data9_)
{
	XnpWindow* self;
	GtkImage* _tmp0_;
	GdkWindow* _tmp1_;
	gboolean result;
#line 294 "../lib/window.vala"
	self = _data9_->self;
#line 295 "../lib/window.vala"
	_tmp0_ = self->priv->menu_image;
#line 295 "../lib/window.vala"
	gtk_image_set_from_icon_name (_tmp0_, "org.xfce.notes.menu-active", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 296 "../lib/window.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) _data9_->menu_evbox);
#line 296 "../lib/window.vala"
	gdk_window_invalidate_rect (_tmp1_, NULL, FALSE);
#line 297 "../lib/window.vala"
	result = FALSE;
#line 297 "../lib/window.vala"
	return result;
#line 685 "window.c"
}

static gboolean
___lambda30__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                            GdkEventCrossing* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda30_ (self);
#line 294 "../lib/window.vala"
	return result;
#line 697 "window.c"
}

static gboolean
__lambda31_ (Block9Data* _data9_)
{
	XnpWindow* self;
	GtkImage* _tmp0_;
	GdkWindow* _tmp1_;
	gboolean result;
#line 299 "../lib/window.vala"
	self = _data9_->self;
#line 300 "../lib/window.vala"
	_tmp0_ = self->priv->menu_image;
#line 300 "../lib/window.vala"
	gtk_image_set_from_icon_name (_tmp0_, "org.xfce.notes.menu", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 301 "../lib/window.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) _data9_->menu_evbox);
#line 301 "../lib/window.vala"
	gdk_window_invalidate_rect (_tmp1_, NULL, FALSE);
#line 302 "../lib/window.vala"
	result = FALSE;
#line 302 "../lib/window.vala"
	return result;
#line 721 "window.c"
}

static gboolean
___lambda31__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                            GdkEventCrossing* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda31_ (self);
#line 299 "../lib/window.vala"
	return result;
#line 733 "window.c"
}

static gboolean
_xnp_window_menu_evbox_pressed_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                 GdkEventButton* event,
                                                                 gpointer self)
{
	gboolean result;
	result = xnp_window_menu_evbox_pressed_cb ((XnpWindow*) self, _sender, event);
#line 348 "../lib/window.vala"
	return result;
#line 745 "window.c"
}

static void
_xnp_window_action_prev_note_xnp_icon_button_clicked (XnpIconButton* _sender,
                                                      gpointer self)
{
#line 349 "../lib/window.vala"
	xnp_window_action_prev_note ((XnpWindow*) self);
#line 754 "window.c"
}

static void
_xnp_window_action_next_note_xnp_icon_button_clicked (XnpIconButton* _sender,
                                                      gpointer self)
{
#line 350 "../lib/window.vala"
	xnp_window_action_next_note ((XnpWindow*) self);
#line 763 "window.c"
}

static void
__lambda32_ (XnpWindow* self)
{
#line 351 "../lib/window.vala"
	xnp_window_hide (self);
#line 771 "window.c"
}

static void
___lambda32__xnp_icon_button_clicked (XnpIconButton* _sender,
                                      gpointer self)
{
#line 351 "../lib/window.vala"
	__lambda32_ ((XnpWindow*) self);
#line 780 "window.c"
}

static gboolean
__lambda33_ (XnpWindow* self)
{
	gboolean result;
#line 356 "../lib/window.vala"
	xnp_window_hide (self);
#line 357 "../lib/window.vala"
	result = TRUE;
#line 357 "../lib/window.vala"
	return result;
#line 793 "window.c"
}

static gboolean
___lambda33__gtk_widget_delete_event (GtkWidget* _sender,
                                      GdkEventAny* event,
                                      gpointer self)
{
	gboolean result;
	result = __lambda33_ ((XnpWindow*) self);
#line 354 "../lib/window.vala"
	return result;
#line 805 "window.c"
}

static void
__lambda34_ (XnpWindow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 360 "../lib/window.vala"
	g_object_get ((GtkWindow*) self, "is-active", &_tmp0_, NULL);
#line 360 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 360 "../lib/window.vala"
	if (_tmp1_) {
#line 819 "window.c"
		GtkImage* _tmp2_;
		XnpTitleBarButton* _tmp3_;
		GtkNotebook* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 361 "../lib/window.vala"
		_tmp2_ = self->priv->menu_image;
#line 361 "../lib/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
#line 362 "../lib/window.vala"
		_tmp3_ = self->priv->close_button;
#line 362 "../lib/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, TRUE);
#line 363 "../lib/window.vala"
		_tmp4_ = self->priv->notebook;
#line 363 "../lib/window.vala"
		g_object_get (_tmp4_, "page", &_tmp5_, NULL);
#line 363 "../lib/window.vala"
		_tmp6_ = _tmp5_;
#line 363 "../lib/window.vala"
		xnp_window_update_navigation_sensitivity (self, _tmp6_);
#line 841 "window.c"
	} else {
		GtkImage* _tmp7_;
		XnpTitleBarButton* _tmp8_;
		XnpTitleBarButton* _tmp9_;
		XnpTitleBarButton* _tmp10_;
#line 365 "../lib/window.vala"
		_tmp7_ = self->priv->menu_image;
#line 365 "../lib/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 366 "../lib/window.vala"
		_tmp8_ = self->priv->left_arrow_button;
#line 366 "../lib/window.vala"
		xnp_icon_button_set_enabled ((XnpIconButton*) _tmp8_, FALSE);
#line 367 "../lib/window.vala"
		_tmp9_ = self->priv->right_arrow_button;
#line 367 "../lib/window.vala"
		xnp_icon_button_set_enabled ((XnpIconButton*) _tmp9_, FALSE);
#line 368 "../lib/window.vala"
		_tmp10_ = self->priv->close_button;
#line 368 "../lib/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 369 "../lib/window.vala"
		xnp_window_save_current_note (self);
#line 865 "window.c"
	}
}

static void
___lambda34__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 359 "../lib/window.vala"
	__lambda34_ ((XnpWindow*) self);
#line 876 "window.c"
}

static gboolean
_xnp_window_window_leaved_cb_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                            GdkEventCrossing* event,
                                                            gpointer self)
{
	gboolean result;
	result = xnp_window_window_leaved_cb ((XnpWindow*) self, event);
#line 372 "../lib/window.vala"
	return result;
#line 888 "window.c"
}

static gboolean
_xnp_window_window_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                             GdkEventMotion* event,
                                                             gpointer self)
{
	gboolean result;
	result = xnp_window_window_motion_cb ((XnpWindow*) self, event);
#line 373 "../lib/window.vala"
	return result;
#line 900 "window.c"
}

static gboolean
_xnp_window_window_pressed_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                             GdkEventButton* event,
                                                             gpointer self)
{
	gboolean result;
	result = xnp_window_window_pressed_cb ((XnpWindow*) self, event);
#line 374 "../lib/window.vala"
	return result;
#line 912 "window.c"
}

static gboolean
_xnp_window_window_state_cb_gtk_widget_window_state_event (GtkWidget* _sender,
                                                           GdkEventWindowState* event,
                                                           gpointer self)
{
	gboolean result;
	result = xnp_window_window_state_cb ((XnpWindow*) self, event);
#line 375 "../lib/window.vala"
	return result;
#line 924 "window.c"
}

static gboolean
_xnp_window_title_evbox_pressed_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                  GdkEventButton* event,
                                                                  gpointer self)
{
	gboolean result;
	result = xnp_window_title_evbox_pressed_cb ((XnpWindow*) self, _sender, event);
#line 376 "../lib/window.vala"
	return result;
#line 936 "window.c"
}

static gboolean
_xnp_window_title_evbox_scrolled_cb_gtk_widget_scroll_event (GtkWidget* _sender,
                                                             GdkEventScroll* event,
                                                             gpointer self)
{
	gboolean result;
	result = xnp_window_title_evbox_scrolled_cb ((XnpWindow*) self, _sender, event);
#line 377 "../lib/window.vala"
	return result;
#line 948 "window.c"
}

static gboolean
_xnp_window_notebook_tab_scroll_cb_gtk_widget_scroll_event (GtkWidget* _sender,
                                                            GdkEventScroll* event,
                                                            gpointer self)
{
	gboolean result;
	result = xnp_window_notebook_tab_scroll_cb ((XnpWindow*) self, event);
#line 378 "../lib/window.vala"
	return result;
#line 960 "window.c"
}

static void
__lambda35_ (Block9Data* _data9_,
             GtkNotebook* n,
             GtkWidget* c,
             guint p)
{
	XnpWindow* self;
	GtkNotebook* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 380 "../lib/window.vala"
	self = _data9_->self;
#line 380 "../lib/window.vala"
	g_return_if_fail (n != NULL);
#line 380 "../lib/window.vala"
	g_return_if_fail (c != NULL);
#line 381 "../lib/window.vala"
	if (!_data9_->app->external_event) {
#line 981 "window.c"
		GtkNotebook* _tmp0_;
#line 382 "../lib/window.vala"
		_tmp0_ = self->priv->notebook;
#line 382 "../lib/window.vala"
		g_object_set (_tmp0_, "page", (gint) p, NULL);
#line 987 "window.c"
	}
#line 383 "../lib/window.vala"
	_tmp1_ = self->priv->notebook;
#line 383 "../lib/window.vala"
	g_object_get (_tmp1_, "page", &_tmp2_, NULL);
#line 383 "../lib/window.vala"
	_tmp3_ = _tmp2_;
#line 383 "../lib/window.vala"
	xnp_window_update_navigation_sensitivity (self, _tmp3_);
#line 997 "window.c"
}

static void
___lambda35__gtk_notebook_page_added (GtkNotebook* _sender,
                                      GtkWidget* child,
                                      guint page_num,
                                      gpointer self)
{
#line 380 "../lib/window.vala"
	__lambda35_ (self, _sender, child, page_num);
#line 1008 "window.c"
}

static void
__lambda36_ (XnpWindow* self,
             GtkNotebook* n,
             GtkWidget* c,
             guint p)
{
#line 385 "../lib/window.vala"
	g_return_if_fail (n != NULL);
#line 385 "../lib/window.vala"
	g_return_if_fail (c != NULL);
#line 386 "../lib/window.vala"
	xnp_window_update_navigation_sensitivity (self, (gint) p);
#line 1023 "window.c"
}

static void
___lambda36__gtk_notebook_page_removed (GtkNotebook* _sender,
                                        GtkWidget* child,
                                        guint page_num,
                                        gpointer self)
{
#line 385 "../lib/window.vala"
	__lambda36_ ((XnpWindow*) self, _sender, child, page_num);
#line 1034 "window.c"
}

static void
__lambda37_ (XnpWindow* self,
             GtkNotebook* n,
             GtkWidget* c,
             guint p)
{
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 388 "../lib/window.vala"
	g_return_if_fail (n != NULL);
#line 388 "../lib/window.vala"
	g_return_if_fail (c != NULL);
#line 389 "../lib/window.vala"
	xnp_window_save_current_note (self);
#line 390 "../lib/window.vala"
	_tmp0_ = xnp_window_get_note (self, (gint) p);
#line 390 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 390 "../lib/window.vala"
	_tmp2_ = xnp_note_get_name (_tmp1_);
#line 390 "../lib/window.vala"
	_tmp3_ = _tmp2_;
#line 390 "../lib/window.vala"
	xnp_window_update_title (self, _tmp3_);
#line 390 "../lib/window.vala"
	_g_object_unref0 (_tmp1_);
#line 391 "../lib/window.vala"
	xnp_window_update_navigation_sensitivity (self, (gint) p);
#line 1067 "window.c"
}

static void
___lambda37__gtk_notebook_switch_page (GtkNotebook* _sender,
                                       GtkWidget* page,
                                       guint page_num,
                                       gpointer self)
{
#line 388 "../lib/window.vala"
	__lambda37_ ((XnpWindow*) self, _sender, page, page_num);
#line 1078 "window.c"
}

static void
__lambda38_ (XnpWindow* self)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
	GtkLabel* _tmp8_;
#line 395 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 395 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 395 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 395 "../lib/window.vala"
	current_note = _tmp2_;
#line 396 "../lib/window.vala"
	_tmp3_ = current_note;
#line 396 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 1102 "window.c"
		XnpNote* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 397 "../lib/window.vala"
		_tmp4_ = current_note;
#line 397 "../lib/window.vala"
		_tmp5_ = xnp_note_get_name (_tmp4_);
#line 397 "../lib/window.vala"
		_tmp6_ = _tmp5_;
#line 397 "../lib/window.vala"
		xnp_window_update_title (self, _tmp6_);
#line 1114 "window.c"
	} else {
		const gchar* _tmp7_;
#line 399 "../lib/window.vala"
		_tmp7_ = self->priv->_name;
#line 399 "../lib/window.vala"
		gtk_window_set_title ((GtkWindow*) self, _tmp7_);
#line 1121 "window.c"
	}
#line 401 "../lib/window.vala"
	_tmp8_ = self->priv->title_label;
#line 401 "../lib/window.vala"
	if (gtk_widget_get_mapped ((GtkWidget*) _tmp8_)) {
#line 1127 "window.c"
		GtkLabel* _tmp9_;
		GdkWindow* _tmp10_;
#line 402 "../lib/window.vala"
		_tmp9_ = self->priv->title_label;
#line 402 "../lib/window.vala"
		_tmp10_ = gtk_widget_get_window ((GtkWidget*) _tmp9_);
#line 402 "../lib/window.vala"
		gdk_window_invalidate_rect (_tmp10_, NULL, FALSE);
#line 1136 "window.c"
	}
#line 394 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 1140 "window.c"
}

static void
___lambda38__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 394 "../lib/window.vala"
	__lambda38_ ((XnpWindow*) self);
#line 1150 "window.c"
}

static void
__lambda39_ (XnpWindow* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 406 "../lib/window.vala"
	_tmp0_ = self->priv->title_label;
#line 406 "../lib/window.vala"
	_tmp1_ = gtk_window_get_title ((GtkWindow*) self);
#line 406 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 406 "../lib/window.vala"
	_tmp3_ = g_markup_printf_escaped ("<b>%s</b>", _tmp2_);
#line 406 "../lib/window.vala"
	_tmp4_ = _tmp3_;
#line 406 "../lib/window.vala"
	gtk_label_set_markup (_tmp0_, _tmp4_);
#line 406 "../lib/window.vala"
	_g_free0 (_tmp4_);
#line 1175 "window.c"
}

static void
___lambda39__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 405 "../lib/window.vala"
	__lambda39_ ((XnpWindow*) self);
#line 1185 "window.c"
}

static gboolean
__lambda40_ (XnpWindow* self,
             GdkDragContext* c,
             gint x,
             gint y,
             guint t)
{
	GtkNotebook* src_notebook = NULL;
	GtkWidget* _tmp0_;
	GtkNotebook* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkNotebook* _tmp3_;
	XnpWindow* src_win = NULL;
	GtkNotebook* _tmp6_;
	GtkWidget* _tmp7_;
	XnpWindow* _tmp8_;
	XnpWindow* _tmp9_;
	XnpWindow* _tmp10_;
	XnpNote* _tmp11_;
	XnpNote* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean result;
#line 408 "../lib/window.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 409 "../lib/window.vala"
	_tmp0_ = gtk_drag_get_source_widget (c);
#line 409 "../lib/window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_notebook_get_type ()) ? ((GtkNotebook*) _tmp0_) : NULL);
#line 409 "../lib/window.vala"
	src_notebook = _tmp1_;
#line 410 "../lib/window.vala"
	_tmp3_ = src_notebook;
#line 410 "../lib/window.vala"
	if (_tmp3_ == NULL) {
#line 410 "../lib/window.vala"
		_tmp2_ = TRUE;
#line 1224 "window.c"
	} else {
		GtkNotebook* _tmp4_;
		GtkNotebook* _tmp5_;
#line 410 "../lib/window.vala"
		_tmp4_ = src_notebook;
#line 410 "../lib/window.vala"
		_tmp5_ = self->priv->notebook;
#line 410 "../lib/window.vala"
		_tmp2_ = _tmp4_ == _tmp5_;
#line 1234 "window.c"
	}
#line 410 "../lib/window.vala"
	if (_tmp2_) {
#line 411 "../lib/window.vala"
		result = FALSE;
#line 411 "../lib/window.vala"
		_g_object_unref0 (src_notebook);
#line 411 "../lib/window.vala"
		return result;
#line 1244 "window.c"
	}
#line 412 "../lib/window.vala"
	_tmp6_ = src_notebook;
#line 412 "../lib/window.vala"
	_tmp7_ = gtk_widget_get_toplevel ((GtkWidget*) _tmp6_);
#line 412 "../lib/window.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, XNP_TYPE_WINDOW, XnpWindow));
#line 412 "../lib/window.vala"
	src_win = _tmp8_;
#line 413 "../lib/window.vala"
	_tmp9_ = src_win;
#line 413 "../lib/window.vala"
	_tmp10_ = src_win;
#line 413 "../lib/window.vala"
	_tmp11_ = xnp_window_get_current_note (_tmp10_);
#line 413 "../lib/window.vala"
	_tmp12_ = _tmp11_;
#line 413 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_NOTE_MOVED_SIGNAL], 0, _tmp9_, _tmp12_, &_tmp13_);
#line 413 "../lib/window.vala"
	if (_tmp13_) {
#line 414 "../lib/window.vala"
		result = FALSE;
#line 414 "../lib/window.vala"
		_g_object_unref0 (src_win);
#line 414 "../lib/window.vala"
		_g_object_unref0 (src_notebook);
#line 414 "../lib/window.vala"
		return result;
#line 1274 "window.c"
	}
#line 415 "../lib/window.vala"
	gtk_drag_finish (c, FALSE, FALSE, (guint32) t);
#line 416 "../lib/window.vala"
	result = TRUE;
#line 416 "../lib/window.vala"
	_g_object_unref0 (src_win);
#line 416 "../lib/window.vala"
	_g_object_unref0 (src_notebook);
#line 416 "../lib/window.vala"
	return result;
#line 1286 "window.c"
}

static gboolean
___lambda40__gtk_widget_drag_drop (GtkWidget* _sender,
                                   GdkDragContext* context,
                                   gint x,
                                   gint y,
                                   guint time_,
                                   gpointer self)
{
	gboolean result;
	result = __lambda40_ ((XnpWindow*) self, context, x, y, time_);
#line 408 "../lib/window.vala"
	return result;
#line 1301 "window.c"
}

static void
__lambda41_ (XnpWindow* self,
             GdkDragContext* c)
{
	GtkNotebook* src_notebook = NULL;
	GtkWidget* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkNotebook* _tmp2_;
	XnpWindow* src_win = NULL;
	GtkNotebook* _tmp3_;
	GtkWidget* _tmp4_;
	XnpWindow* _tmp5_;
	XnpWindow* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 418 "../lib/window.vala"
	g_return_if_fail (c != NULL);
#line 419 "../lib/window.vala"
	_tmp0_ = gtk_drag_get_source_widget (c);
#line 419 "../lib/window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_notebook_get_type ()) ? ((GtkNotebook*) _tmp0_) : NULL);
#line 419 "../lib/window.vala"
	src_notebook = _tmp1_;
#line 420 "../lib/window.vala"
	_tmp2_ = src_notebook;
#line 420 "../lib/window.vala"
	if (_tmp2_ == NULL) {
#line 421 "../lib/window.vala"
		_g_object_unref0 (src_notebook);
#line 421 "../lib/window.vala"
		return;
#line 1335 "window.c"
	}
#line 422 "../lib/window.vala"
	_tmp3_ = src_notebook;
#line 422 "../lib/window.vala"
	_tmp4_ = gtk_widget_get_toplevel ((GtkWidget*) _tmp3_);
#line 422 "../lib/window.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, XNP_TYPE_WINDOW, XnpWindow));
#line 422 "../lib/window.vala"
	src_win = _tmp5_;
#line 423 "../lib/window.vala"
	_tmp6_ = src_win;
#line 423 "../lib/window.vala"
	_tmp7_ = xnp_window_get_n_pages (_tmp6_);
#line 423 "../lib/window.vala"
	_tmp8_ = _tmp7_;
#line 423 "../lib/window.vala"
	if (_tmp8_ == 0) {
#line 1353 "window.c"
		XnpWindow* _tmp9_;
#line 424 "../lib/window.vala"
		_tmp9_ = src_win;
#line 424 "../lib/window.vala"
		g_signal_emit (_tmp9_, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "delete");
#line 1359 "window.c"
	}
#line 418 "../lib/window.vala"
	_g_object_unref0 (src_win);
#line 418 "../lib/window.vala"
	_g_object_unref0 (src_notebook);
#line 1365 "window.c"
}

static void
___lambda41__gtk_widget_drag_data_received (GtkWidget* _sender,
                                            GdkDragContext* context,
                                            gint x,
                                            gint y,
                                            GtkSelectionData* selection_data,
                                            guint info,
                                            guint time_,
                                            gpointer self)
{
#line 418 "../lib/window.vala"
	__lambda41_ ((XnpWindow*) self, context);
#line 1380 "window.c"
}

XnpWindow*
xnp_window_construct (GType object_type,
                      XnpApplication* app)
{
	XnpWindow * self = NULL;
	Block9Data* _data9_;
	XnpApplication* _tmp0_;
	XnpApplication* _tmp1_;
	GtkActionGroup* _tmp2_;
	GtkActionGroup* _tmp3_;
	GtkUIManager* _tmp4_;
	GtkUIManager* _tmp5_;
	GtkActionGroup* _tmp6_;
	GtkMenu* _tmp16_;
	GtkMenu* _tmp17_;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp18_;
	GtkRcStyle* style = NULL;
	GtkRcStyle* _tmp19_;
	GtkRcStyle* _tmp20_;
	GtkBox* vbox_frame = NULL;
	GtkBox* _tmp21_;
	GtkBox* title_box = NULL;
	GtkBox* _tmp22_;
	GtkEventBox* _tmp23_;
	GtkImage* _tmp24_;
	GtkImage* _tmp25_;
	GtkEventBox* title_evbox = NULL;
	GtkEventBox* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	XnpTitleBarButton* _tmp36_;
	XnpTitleBarButton* _tmp37_;
	XnpTitleBarButton* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	XnpTitleBarButton* _tmp41_;
	XnpTitleBarButton* _tmp42_;
	XnpTitleBarButton* _tmp43_;
	XnpTitleBarButton* _tmp44_;
	XnpTitleBarButton* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	XnpTitleBarButton* _tmp48_;
	XnpTitleBarButton* _tmp49_;
	XnpTitleBarButton* _tmp50_;
	XnpTitleBarButton* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	XnpTitleBarButton* _tmp56_;
	GtkBox* _tmp57_;
	GtkBox* _tmp58_;
	GtkBox* _tmp59_;
	GtkNotebook* _tmp60_;
	GtkNotebook* _tmp61_;
	GtkNotebook* _tmp62_;
	GtkNotebook* _tmp63_;
	GtkNotebook* _tmp64_;
	GtkNotebook* _tmp65_;
	GtkNotebook* _tmp66_;
	GtkNotebook* _tmp67_;
	GtkNotebook* _tmp68_;
	GtkBox* _tmp69_;
	GtkNotebook* _tmp70_;
	XnpTitleBarButton* _tmp71_;
	XnpTitleBarButton* _tmp72_;
	XnpTitleBarButton* _tmp73_;
	XnpTitleBarButton* _tmp74_;
	XnpTitleBarButton* _tmp75_;
	GtkNotebook* _tmp76_;
	GtkNotebook* _tmp77_;
	GtkNotebook* _tmp78_;
	GtkNotebook* _tmp79_;
	GtkNotebook* _tmp80_;
	GtkNotebook* _tmp81_;
	GError* _inner_error0_ = NULL;
#line 234 "../lib/window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 234 "../lib/window.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 234 "../lib/window.vala"
	_data9_->_ref_count_ = 1;
#line 234 "../lib/window.vala"
	_tmp0_ = _g_object_ref0 (app);
#line 234 "../lib/window.vala"
	_g_object_unref0 (_data9_->app);
#line 234 "../lib/window.vala"
	_data9_->app = _tmp0_;
#line 234 "../lib/window.vala"
	self = (XnpWindow*) g_object_new (object_type, NULL);
#line 234 "../lib/window.vala"
	_data9_->self = g_object_ref (self);
#line 235 "../lib/window.vala"
	_tmp1_ = _g_object_ref0 (_data9_->app);
#line 235 "../lib/window.vala"
	_g_object_unref0 (self->priv->app);
#line 235 "../lib/window.vala"
	self->priv->app = _tmp1_;
#line 238 "../lib/window.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) (GDK_POINTER_MOTION_MASK | GDK_BUTTON_PRESS_MASK));
#line 241 "../lib/window.vala"
	_tmp2_ = gtk_action_group_new ("XNP");
#line 241 "../lib/window.vala"
	_g_object_unref0 (self->priv->action_group);
#line 241 "../lib/window.vala"
	self->priv->action_group = _tmp2_;
#line 242 "../lib/window.vala"
	_tmp3_ = self->priv->action_group;
#line 242 "../lib/window.vala"
	gtk_action_group_add_actions (_tmp3_, XNP_WINDOW_action_entries, (guint) G_N_ELEMENTS (XNP_WINDOW_action_entries), self);
#line 244 "../lib/window.vala"
	_tmp4_ = gtk_ui_manager_new ();
#line 244 "../lib/window.vala"
	_g_object_unref0 (self->priv->ui);
#line 244 "../lib/window.vala"
	self->priv->ui = _tmp4_;
#line 245 "../lib/window.vala"
	_tmp5_ = self->priv->ui;
#line 245 "../lib/window.vala"
	_tmp6_ = self->priv->action_group;
#line 245 "../lib/window.vala"
	gtk_ui_manager_insert_action_group (_tmp5_, _tmp6_, 0);
#line 1514 "window.c"
	{
		GtkUIManager* _tmp7_;
		GtkUIManager* _tmp8_;
		GtkAccelGroup* _tmp9_;
#line 247 "../lib/window.vala"
		_tmp7_ = self->priv->ui;
#line 247 "../lib/window.vala"
		gtk_ui_manager_add_ui_from_string (_tmp7_, XNP_WINDOW_ui_string, (gssize) -1, &_inner_error0_);
#line 247 "../lib/window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1525 "window.c"
			goto __catch0_g_error;
		}
#line 248 "../lib/window.vala"
		_tmp8_ = self->priv->ui;
#line 248 "../lib/window.vala"
		_tmp9_ = gtk_ui_manager_get_accel_group (_tmp8_);
#line 248 "../lib/window.vala"
		gtk_window_add_accel_group ((GtkWindow*) self, _tmp9_);
#line 250 "../lib/window.vala"
		if (!xnp_window_tab_hotkeys_bound) {
#line 1536 "window.c"
			GObjectClass* _tmp10_;
			GtkBindingSet* _tmp11_;
			GObjectClass* _tmp12_;
			GtkBindingSet* _tmp13_;
#line 251 "../lib/window.vala"
			xnp_window_remove_tab_bindings (self, gtk_text_view_get_type ());
#line 252 "../lib/window.vala"
			xnp_window_remove_tab_bindings (self, gtk_notebook_get_type ());
#line 253 "../lib/window.vala"
			xnp_window_remove_tab_bindings (self, gtk_scrolled_window_get_type ());
#line 254 "../lib/window.vala"
			_tmp10_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 254 "../lib/window.vala"
			_tmp11_ = gtk_binding_set_by_class ((gpointer) _tmp10_);
#line 254 "../lib/window.vala"
			gtk_binding_entry_add_signal (_tmp11_, GDK_KEY_Tab, GDK_CONTROL_MASK, "action-cycle-forward", (guint) 0, NULL);
#line 257 "../lib/window.vala"
			_tmp12_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 257 "../lib/window.vala"
			_tmp13_ = gtk_binding_set_by_class ((gpointer) _tmp12_);
#line 257 "../lib/window.vala"
			gtk_binding_entry_add_signal (_tmp13_, GDK_KEY_Tab, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "action-cycle-backward", (guint) 0, NULL);
#line 260 "../lib/window.vala"
			xnp_window_tab_hotkeys_bound = TRUE;
#line 1561 "window.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 246 "../lib/window.vala"
		e = _inner_error0_;
#line 246 "../lib/window.vala"
		_inner_error0_ = NULL;
#line 264 "../lib/window.vala"
		_tmp14_ = e;
#line 264 "../lib/window.vala"
		_tmp15_ = _tmp14_->message;
#line 264 "../lib/window.vala"
		g_warning ("window.vala:264: %s", _tmp15_);
#line 246 "../lib/window.vala"
		_g_error_free0 (e);
#line 1582 "window.c"
	}
	__finally0:
#line 246 "../lib/window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "../lib/window.vala"
		block9_data_unref (_data9_);
#line 246 "../lib/window.vala"
		_data9_ = NULL;
#line 246 "../lib/window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 246 "../lib/window.vala"
		g_clear_error (&_inner_error0_);
#line 246 "../lib/window.vala"
		return NULL;
#line 1597 "window.c"
	}
#line 268 "../lib/window.vala"
	_tmp16_ = xnp_window_build_menu (self);
#line 268 "../lib/window.vala"
	_g_object_unref0 (self->priv->menu);
#line 268 "../lib/window.vala"
	self->priv->menu = _tmp16_;
#line 269 "../lib/window.vala"
	_tmp17_ = self->priv->menu;
#line 269 "../lib/window.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp17_);
#line 272 "../lib/window.vala"
	_tmp18_ = (GtkFrame*) gtk_frame_new (NULL);
#line 272 "../lib/window.vala"
	g_object_ref_sink (_tmp18_);
#line 272 "../lib/window.vala"
	frame = _tmp18_;
#line 273 "../lib/window.vala"
	gtk_frame_set_shadow_type (frame, GTK_SHADOW_NONE);
#line 274 "../lib/window.vala"
	_tmp19_ = gtk_widget_get_modifier_style ((GtkWidget*) frame);
#line 274 "../lib/window.vala"
	_tmp20_ = _g_object_ref0 (_tmp19_);
#line 274 "../lib/window.vala"
	style = _tmp20_;
#line 275 "../lib/window.vala"
	style->xthickness = 1;
#line 276 "../lib/window.vala"
	style->ythickness = 3;
#line 277 "../lib/window.vala"
	gtk_widget_modify_style ((GtkWidget*) frame, style);
#line 278 "../lib/window.vala"
	gtk_widget_show ((GtkWidget*) frame);
#line 279 "../lib/window.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) frame);
#line 280 "../lib/window.vala"
	_tmp21_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 280 "../lib/window.vala"
	g_object_ref_sink (_tmp21_);
#line 280 "../lib/window.vala"
	vbox_frame = _tmp21_;
#line 282 "../lib/window.vala"
	gtk_box_set_spacing (vbox_frame, 1);
#line 283 "../lib/window.vala"
	gtk_widget_show ((GtkWidget*) vbox_frame);
#line 284 "../lib/window.vala"
	gtk_container_add ((GtkContainer*) frame, (GtkWidget*) vbox_frame);
#line 287 "../lib/window.vala"
	_tmp22_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 287 "../lib/window.vala"
	g_object_ref_sink (_tmp22_);
#line 287 "../lib/window.vala"
	title_box = _tmp22_;
#line 288 "../lib/window.vala"
	gtk_widget_set_name ((GtkWidget*) title_box, "titlebar");
#line 289 "../lib/window.vala"
	_tmp23_ = (GtkEventBox*) gtk_event_box_new ();
#line 289 "../lib/window.vala"
	g_object_ref_sink (_tmp23_);
#line 289 "../lib/window.vala"
	_data9_->menu_evbox = _tmp23_;
#line 290 "../lib/window.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _data9_->menu_evbox, _ ("Menu"));
#line 291 "../lib/window.vala"
	gtk_event_box_set_visible_window (_data9_->menu_evbox, FALSE);
#line 292 "../lib/window.vala"
	_tmp24_ = (GtkImage*) gtk_image_new_from_icon_name ("org.xfce.notes.menu", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 292 "../lib/window.vala"
	g_object_ref_sink (_tmp24_);
#line 292 "../lib/window.vala"
	_g_object_unref0 (self->priv->menu_image);
#line 292 "../lib/window.vala"
	self->priv->menu_image = _tmp24_;
#line 293 "../lib/window.vala"
	_tmp25_ = self->priv->menu_image;
#line 293 "../lib/window.vala"
	gtk_container_add ((GtkContainer*) _data9_->menu_evbox, (GtkWidget*) _tmp25_);
#line 294 "../lib/window.vala"
	g_signal_connect_data ((GtkWidget*) _data9_->menu_evbox, "enter-notify-event", (GCallback) ___lambda30__gtk_widget_enter_notify_event, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 299 "../lib/window.vala"
	g_signal_connect_data ((GtkWidget*) _data9_->menu_evbox, "leave-notify-event", (GCallback) ___lambda31__gtk_widget_leave_notify_event, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 304 "../lib/window.vala"
	gtk_box_pack_start (title_box, (GtkWidget*) _data9_->menu_evbox, FALSE, FALSE, (guint) 2);
#line 305 "../lib/window.vala"
	_tmp26_ = (GtkEventBox*) gtk_event_box_new ();
#line 305 "../lib/window.vala"
	g_object_ref_sink (_tmp26_);
#line 305 "../lib/window.vala"
	title_evbox = _tmp26_;
#line 306 "../lib/window.vala"
	gtk_widget_add_events ((GtkWidget*) title_evbox, (gint) GDK_SCROLL_MASK);
#line 307 "../lib/window.vala"
	gtk_event_box_set_visible_window (title_evbox, FALSE);
#line 308 "../lib/window.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (NULL);
#line 308 "../lib/window.vala"
	g_object_ref_sink (_tmp27_);
#line 308 "../lib/window.vala"
	_g_object_unref0 (self->priv->title_label);
#line 308 "../lib/window.vala"
	self->priv->title_label = _tmp27_;
#line 309 "../lib/window.vala"
	_tmp28_ = self->priv->title_label;
#line 309 "../lib/window.vala"
	_tmp29_ = gtk_window_get_title ((GtkWindow*) self);
#line 309 "../lib/window.vala"
	_tmp30_ = _tmp29_;
#line 309 "../lib/window.vala"
	_tmp31_ = g_markup_printf_escaped ("<b>%s</b>", _tmp30_);
#line 309 "../lib/window.vala"
	_tmp32_ = _tmp31_;
#line 309 "../lib/window.vala"
	gtk_label_set_markup (_tmp28_, _tmp32_);
#line 309 "../lib/window.vala"
	_g_free0 (_tmp32_);
#line 310 "../lib/window.vala"
	_tmp33_ = self->priv->title_label;
#line 310 "../lib/window.vala"
	gtk_label_set_ellipsize (_tmp33_, PANGO_ELLIPSIZE_END);
#line 311 "../lib/window.vala"
	_tmp34_ = self->priv->title_label;
#line 311 "../lib/window.vala"
	gtk_label_set_xalign (_tmp34_, (gfloat) 0.0);
#line 312 "../lib/window.vala"
	_tmp35_ = self->priv->title_label;
#line 312 "../lib/window.vala"
	gtk_container_add ((GtkContainer*) title_evbox, (GtkWidget*) _tmp35_);
#line 313 "../lib/window.vala"
	gtk_box_pack_start (title_box, (GtkWidget*) title_evbox, TRUE, TRUE, (guint) 6);
#line 314 "../lib/window.vala"
	_tmp36_ = xnp_title_bar_button_new (XNP_TITLE_BAR_BUTTON_TYPE_LEFT_ARROW);
#line 314 "../lib/window.vala"
	g_object_ref_sink (_tmp36_);
#line 314 "../lib/window.vala"
	_g_object_unref0 (self->priv->left_arrow_button);
#line 314 "../lib/window.vala"
	self->priv->left_arrow_button = _tmp36_;
#line 315 "../lib/window.vala"
	_tmp37_ = self->priv->left_arrow_button;
#line 315 "../lib/window.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp37_, (gint) GDK_SCROLL_MASK);
#line 316 "../lib/window.vala"
	_tmp38_ = self->priv->left_arrow_button;
#line 316 "../lib/window.vala"
	_tmp39_ = gtk_accelerator_get_label (GDK_KEY_Page_Up, GDK_CONTROL_MASK);
#line 316 "../lib/window.vala"
	_tmp40_ = _tmp39_;
#line 316 "../lib/window.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp38_, _tmp40_);
#line 316 "../lib/window.vala"
	_g_free0 (_tmp40_);
#line 317 "../lib/window.vala"
	_tmp41_ = self->priv->left_arrow_button;
#line 317 "../lib/window.vala"
	xnp_icon_button_set_enabled ((XnpIconButton*) _tmp41_, FALSE);
#line 318 "../lib/window.vala"
	_tmp42_ = self->priv->left_arrow_button;
#line 318 "../lib/window.vala"
	gtk_box_pack_start (title_box, (GtkWidget*) _tmp42_, FALSE, FALSE, (guint) 2);
#line 319 "../lib/window.vala"
	_tmp43_ = xnp_title_bar_button_new (XNP_TITLE_BAR_BUTTON_TYPE_RIGHT_ARROW);
#line 319 "../lib/window.vala"
	g_object_ref_sink (_tmp43_);
#line 319 "../lib/window.vala"
	_g_object_unref0 (self->priv->right_arrow_button);
#line 319 "../lib/window.vala"
	self->priv->right_arrow_button = _tmp43_;
#line 320 "../lib/window.vala"
	_tmp44_ = self->priv->right_arrow_button;
#line 320 "../lib/window.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp44_, (gint) GDK_SCROLL_MASK);
#line 321 "../lib/window.vala"
	_tmp45_ = self->priv->right_arrow_button;
#line 321 "../lib/window.vala"
	_tmp46_ = gtk_accelerator_get_label (GDK_KEY_Page_Down, GDK_CONTROL_MASK);
#line 321 "../lib/window.vala"
	_tmp47_ = _tmp46_;
#line 321 "../lib/window.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp45_, _tmp47_);
#line 321 "../lib/window.vala"
	_g_free0 (_tmp47_);
#line 322 "../lib/window.vala"
	_tmp48_ = self->priv->right_arrow_button;
#line 322 "../lib/window.vala"
	xnp_icon_button_set_enabled ((XnpIconButton*) _tmp48_, FALSE);
#line 323 "../lib/window.vala"
	_tmp49_ = self->priv->right_arrow_button;
#line 323 "../lib/window.vala"
	gtk_box_pack_start (title_box, (GtkWidget*) _tmp49_, FALSE, FALSE, (guint) 2);
#line 324 "../lib/window.vala"
	_tmp50_ = xnp_title_bar_button_new (XNP_TITLE_BAR_BUTTON_TYPE_CLOSE);
#line 324 "../lib/window.vala"
	g_object_ref_sink (_tmp50_);
#line 324 "../lib/window.vala"
	_g_object_unref0 (self->priv->close_button);
#line 324 "../lib/window.vala"
	self->priv->close_button = _tmp50_;
#line 325 "../lib/window.vala"
	_tmp51_ = self->priv->close_button;
#line 325 "../lib/window.vala"
	_tmp52_ = gtk_accelerator_get_label (GDK_KEY_Escape, 0);
#line 325 "../lib/window.vala"
	_tmp53_ = _tmp52_;
#line 325 "../lib/window.vala"
	_tmp54_ = g_strdup_printf (_ ("Hide (%s)"), _tmp53_);
#line 325 "../lib/window.vala"
	_tmp55_ = _tmp54_;
#line 325 "../lib/window.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp51_, _tmp55_);
#line 325 "../lib/window.vala"
	_g_free0 (_tmp55_);
#line 325 "../lib/window.vala"
	_g_free0 (_tmp53_);
#line 326 "../lib/window.vala"
	_tmp56_ = self->priv->close_button;
#line 326 "../lib/window.vala"
	gtk_box_pack_start (title_box, (GtkWidget*) _tmp56_, FALSE, FALSE, (guint) 2);
#line 327 "../lib/window.vala"
	gtk_widget_show_all ((GtkWidget*) title_box);
#line 328 "../lib/window.vala"
	gtk_box_pack_start (vbox_frame, (GtkWidget*) title_box, FALSE, FALSE, (guint) 0);
#line 331 "../lib/window.vala"
	_tmp57_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 331 "../lib/window.vala"
	g_object_ref_sink (_tmp57_);
#line 331 "../lib/window.vala"
	_g_object_unref0 (self->priv->content_box);
#line 331 "../lib/window.vala"
	self->priv->content_box = _tmp57_;
#line 332 "../lib/window.vala"
	_tmp58_ = self->priv->content_box;
#line 332 "../lib/window.vala"
	gtk_widget_show ((GtkWidget*) _tmp58_);
#line 333 "../lib/window.vala"
	_tmp59_ = self->priv->content_box;
#line 333 "../lib/window.vala"
	gtk_box_pack_start (vbox_frame, (GtkWidget*) _tmp59_, TRUE, TRUE, (guint) 0);
#line 336 "../lib/window.vala"
	_tmp60_ = (GtkNotebook*) gtk_notebook_new ();
#line 336 "../lib/window.vala"
	g_object_ref_sink (_tmp60_);
#line 336 "../lib/window.vala"
	_g_object_unref0 (self->priv->notebook);
#line 336 "../lib/window.vala"
	self->priv->notebook = _tmp60_;
#line 337 "../lib/window.vala"
	_tmp61_ = self->priv->notebook;
#line 337 "../lib/window.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp61_, (gint) GDK_SCROLL_MASK);
#line 338 "../lib/window.vala"
	_tmp62_ = self->priv->notebook;
#line 338 "../lib/window.vala"
	gtk_widget_set_name ((GtkWidget*) _tmp62_, "notes-notebook");
#line 339 "../lib/window.vala"
	_tmp63_ = self->priv->notebook;
#line 339 "../lib/window.vala"
	gtk_notebook_set_group_name (_tmp63_, "notes");
#line 340 "../lib/window.vala"
	_tmp64_ = self->priv->notebook;
#line 340 "../lib/window.vala"
	gtk_notebook_set_show_border (_tmp64_, TRUE);
#line 341 "../lib/window.vala"
	_tmp65_ = self->priv->notebook;
#line 341 "../lib/window.vala"
	gtk_notebook_set_show_tabs (_tmp65_, FALSE);
#line 342 "../lib/window.vala"
	_tmp66_ = self->priv->notebook;
#line 342 "../lib/window.vala"
	gtk_notebook_set_tab_pos (_tmp66_, GTK_POS_TOP);
#line 343 "../lib/window.vala"
	_tmp67_ = self->priv->notebook;
#line 343 "../lib/window.vala"
	gtk_notebook_set_scrollable (_tmp67_, TRUE);
#line 344 "../lib/window.vala"
	_tmp68_ = self->priv->notebook;
#line 344 "../lib/window.vala"
	gtk_widget_show ((GtkWidget*) _tmp68_);
#line 345 "../lib/window.vala"
	_tmp69_ = self->priv->content_box;
#line 345 "../lib/window.vala"
	_tmp70_ = self->priv->notebook;
#line 345 "../lib/window.vala"
	gtk_box_pack_start (_tmp69_, (GtkWidget*) _tmp70_, TRUE, TRUE, (guint) 0);
#line 348 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) _data9_->menu_evbox, "button-press-event", (GCallback) _xnp_window_menu_evbox_pressed_cb_gtk_widget_button_press_event, self, 0);
#line 349 "../lib/window.vala"
	_tmp71_ = self->priv->left_arrow_button;
#line 349 "../lib/window.vala"
	g_signal_connect_object ((XnpIconButton*) _tmp71_, "clicked", (GCallback) _xnp_window_action_prev_note_xnp_icon_button_clicked, self, 0);
#line 350 "../lib/window.vala"
	_tmp72_ = self->priv->right_arrow_button;
#line 350 "../lib/window.vala"
	g_signal_connect_object ((XnpIconButton*) _tmp72_, "clicked", (GCallback) _xnp_window_action_next_note_xnp_icon_button_clicked, self, 0);
#line 351 "../lib/window.vala"
	_tmp73_ = self->priv->close_button;
#line 351 "../lib/window.vala"
	g_signal_connect_object ((XnpIconButton*) _tmp73_, "clicked", (GCallback) ___lambda32__xnp_icon_button_clicked, self, 0);
#line 354 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) ___lambda33__gtk_widget_delete_event, self, 0);
#line 359 "../lib/window.vala"
	g_signal_connect_object ((GObject*) self, "notify::is-active", (GCallback) ___lambda34__g_object_notify, self, 0);
#line 372 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) _xnp_window_window_leaved_cb_gtk_widget_leave_notify_event, self, 0);
#line 373 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _xnp_window_window_motion_cb_gtk_widget_motion_notify_event, self, 0);
#line 374 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) _xnp_window_window_pressed_cb_gtk_widget_button_press_event, self, 0);
#line 375 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "window-state-event", (GCallback) _xnp_window_window_state_cb_gtk_widget_window_state_event, self, 0);
#line 376 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) title_evbox, "button-press-event", (GCallback) _xnp_window_title_evbox_pressed_cb_gtk_widget_button_press_event, self, 0);
#line 377 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) title_evbox, "scroll-event", (GCallback) _xnp_window_title_evbox_scrolled_cb_gtk_widget_scroll_event, self, 0);
#line 378 "../lib/window.vala"
	_tmp74_ = self->priv->left_arrow_button;
#line 378 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp74_, "scroll-event", (GCallback) _xnp_window_notebook_tab_scroll_cb_gtk_widget_scroll_event, self, 0);
#line 379 "../lib/window.vala"
	_tmp75_ = self->priv->right_arrow_button;
#line 379 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp75_, "scroll-event", (GCallback) _xnp_window_notebook_tab_scroll_cb_gtk_widget_scroll_event, self, 0);
#line 380 "../lib/window.vala"
	_tmp76_ = self->priv->notebook;
#line 380 "../lib/window.vala"
	g_signal_connect_data (_tmp76_, "page-added", (GCallback) ___lambda35__gtk_notebook_page_added, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 385 "../lib/window.vala"
	_tmp77_ = self->priv->notebook;
#line 385 "../lib/window.vala"
	g_signal_connect_object (_tmp77_, "page-removed", (GCallback) ___lambda36__gtk_notebook_page_removed, self, 0);
#line 388 "../lib/window.vala"
	_tmp78_ = self->priv->notebook;
#line 388 "../lib/window.vala"
	g_signal_connect_object (_tmp78_, "switch-page", (GCallback) ___lambda37__gtk_notebook_switch_page, self, 0);
#line 393 "../lib/window.vala"
	_tmp79_ = self->priv->notebook;
#line 393 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp79_, "scroll-event", (GCallback) _xnp_window_notebook_tab_scroll_cb_gtk_widget_scroll_event, self, 0);
#line 394 "../lib/window.vala"
	g_signal_connect_object ((GObject*) self, "notify::name", (GCallback) ___lambda38__g_object_notify, self, 0);
#line 405 "../lib/window.vala"
	g_signal_connect_object ((GObject*) self, "notify::title", (GCallback) ___lambda39__g_object_notify, self, 0);
#line 408 "../lib/window.vala"
	_tmp80_ = self->priv->notebook;
#line 408 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp80_, "drag-drop", (GCallback) ___lambda40__gtk_widget_drag_drop, self, 0);
#line 418 "../lib/window.vala"
	_tmp81_ = self->priv->notebook;
#line 418 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp81_, "drag-data-received", (GCallback) ___lambda41__gtk_widget_drag_data_received, self, G_CONNECT_AFTER);
#line 234 "../lib/window.vala"
	_g_object_unref0 (title_evbox);
#line 234 "../lib/window.vala"
	_g_object_unref0 (title_box);
#line 234 "../lib/window.vala"
	_g_object_unref0 (vbox_frame);
#line 234 "../lib/window.vala"
	_g_object_unref0 (style);
#line 234 "../lib/window.vala"
	_g_object_unref0 (frame);
#line 234 "../lib/window.vala"
	block9_data_unref (_data9_);
#line 234 "../lib/window.vala"
	_data9_ = NULL;
#line 234 "../lib/window.vala"
	return self;
#line 1963 "window.c"
}

XnpWindow*
xnp_window_new (XnpApplication* app)
{
#line 234 "../lib/window.vala"
	return xnp_window_construct (XNP_TYPE_WINDOW, app);
#line 1971 "window.c"
}

/**
 * hide:
 *
 * Save position before hidding.
 */
void
xnp_window_hide (XnpWindow* self)
{
	gint winx = 0;
	gint winy = 0;
	XnpWindow* new_focus = NULL;
	XnpApplication* _tmp0_;
	XnpWindow* _tmp1_;
	XnpWindow* _tmp2_;
	XnpWindow* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	XnpWindow* _tmp6_;
	gboolean _tmp13_;
	gboolean _tmp14_;
#line 440 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 442 "../lib/window.vala"
	_tmp0_ = self->priv->app;
#line 442 "../lib/window.vala"
	_tmp1_ = xnp_application_get_next_focus (_tmp0_);
#line 442 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 442 "../lib/window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 442 "../lib/window.vala"
	new_focus = _tmp3_;
#line 443 "../lib/window.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp4_, &_tmp5_);
#line 443 "../lib/window.vala"
	winx = _tmp4_;
#line 443 "../lib/window.vala"
	winy = _tmp5_;
#line 444 "../lib/window.vala"
	_tmp6_ = new_focus;
#line 444 "../lib/window.vala"
	if (_tmp6_ != NULL) {
#line 2016 "window.c"
		XnpWindow* _tmp7_;
		XnpWindow* _tmp8_;
		XnpWindow* _tmp9_;
		XnpApplication* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 445 "../lib/window.vala"
		_tmp7_ = new_focus;
#line 445 "../lib/window.vala"
		gtk_window_set_skip_taskbar_hint ((GtkWindow*) _tmp7_, FALSE);
#line 446 "../lib/window.vala"
		_tmp8_ = new_focus;
#line 446 "../lib/window.vala"
		gtk_window_present ((GtkWindow*) _tmp8_);
#line 447 "../lib/window.vala"
		GTK_WIDGET_CLASS (xnp_window_parent_class)->hide ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 448 "../lib/window.vala"
		_tmp9_ = new_focus;
#line 448 "../lib/window.vala"
		_tmp10_ = self->priv->app;
#line 448 "../lib/window.vala"
		_tmp11_ = xnp_application_get_skip_taskbar_hint (_tmp10_);
#line 448 "../lib/window.vala"
		_tmp12_ = _tmp11_;
#line 448 "../lib/window.vala"
		gtk_window_set_skip_taskbar_hint ((GtkWindow*) _tmp9_, _tmp12_);
#line 2043 "window.c"
	} else {
#line 450 "../lib/window.vala"
		GTK_WIDGET_CLASS (xnp_window_parent_class)->hide ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 2047 "window.c"
	}
#line 452 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "hide");
#line 453 "../lib/window.vala"
	gtk_window_deiconify ((GtkWindow*) self);
#line 454 "../lib/window.vala"
	xnp_window_unshade (self);
#line 455 "../lib/window.vala"
	gtk_window_move ((GtkWindow*) self, winx, winy);
#line 456 "../lib/window.vala"
	_tmp13_ = xnp_window_get_above (self);
#line 456 "../lib/window.vala"
	_tmp14_ = _tmp13_;
#line 456 "../lib/window.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, _tmp14_);
#line 440 "../lib/window.vala"
	_g_object_unref0 (new_focus);
#line 2065 "window.c"
}

/**
 * window_leaved_cb:
 *
 * Reset the mouse cursor.
 */
static gboolean
xnp_window_window_leaved_cb (XnpWindow* self,
                             GdkEventCrossing* event)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean outside = FALSE;
	GdkWindow* _tmp6_;
	gboolean result;
#line 464 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 464 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 466 "../lib/window.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 466 "../lib/window.vala"
	allocation = _tmp0_;
#line 467 "../lib/window.vala"
	if (event->x <= ((gdouble) 0)) {
#line 467 "../lib/window.vala"
		_tmp3_ = TRUE;
#line 2097 "window.c"
	} else {
		GtkAllocation _tmp4_;
#line 467 "../lib/window.vala"
		_tmp4_ = allocation;
#line 467 "../lib/window.vala"
		_tmp3_ = event->x >= ((gdouble) _tmp4_.width);
#line 2104 "window.c"
	}
#line 467 "../lib/window.vala"
	if (_tmp3_) {
#line 467 "../lib/window.vala"
		_tmp2_ = TRUE;
#line 2110 "window.c"
	} else {
#line 468 "../lib/window.vala"
		_tmp2_ = event->y <= ((gdouble) 0);
#line 2114 "window.c"
	}
#line 467 "../lib/window.vala"
	if (_tmp2_) {
#line 467 "../lib/window.vala"
		_tmp1_ = TRUE;
#line 2120 "window.c"
	} else {
		GtkAllocation _tmp5_;
#line 468 "../lib/window.vala"
		_tmp5_ = allocation;
#line 468 "../lib/window.vala"
		_tmp1_ = event->y >= ((gdouble) _tmp5_.height);
#line 2127 "window.c"
	}
#line 467 "../lib/window.vala"
	outside = _tmp1_;
#line 469 "../lib/window.vala"
	if (!outside) {
#line 469 "../lib/window.vala"
		result = TRUE;
#line 469 "../lib/window.vala"
		return result;
#line 2137 "window.c"
	}
#line 470 "../lib/window.vala"
	_tmp6_ = gtk_widget_get_window ((GtkWidget*) self);
#line 470 "../lib/window.vala"
	gdk_window_set_cursor (_tmp6_, NULL);
#line 471 "../lib/window.vala"
	result = TRUE;
#line 471 "../lib/window.vala"
	return result;
#line 2147 "window.c"
}

/**
 * window_motion_cb:
 *
 * Update mouse cursor.
 */
static gboolean
xnp_window_window_motion_cb (XnpWindow* self,
                             GdkEventMotion* event)
{
	GtkAllocation allocation = {0};
	GdkCursor* cursor = NULL;
	void* widget = NULL;
	GdkWindow* _tmp0_;
	void* _tmp1_ = NULL;
	void* _tmp2_;
	GtkAllocation _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	GtkNotebook* _tmp30_;
	gboolean _tmp31_ = FALSE;
	GdkWindow* _tmp32_;
	GdkCursor* _tmp33_;
	gboolean result;
#line 479 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 479 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 484 "../lib/window.vala"
	_tmp0_ = event->window;
#line 484 "../lib/window.vala"
	gdk_window_get_user_data (_tmp0_, &_tmp1_);
#line 484 "../lib/window.vala"
	widget = _tmp1_;
#line 485 "../lib/window.vala"
	_tmp2_ = widget;
#line 485 "../lib/window.vala"
	if (_tmp2_ != self) {
#line 2188 "window.c"
		GdkWindow* _tmp3_;
#line 486 "../lib/window.vala"
		_tmp3_ = gtk_widget_get_window ((GtkWidget*) self);
#line 486 "../lib/window.vala"
		gdk_window_set_cursor (_tmp3_, NULL);
#line 487 "../lib/window.vala"
		result = FALSE;
#line 487 "../lib/window.vala"
		_g_object_unref0 (cursor);
#line 487 "../lib/window.vala"
		return result;
#line 2200 "window.c"
	}
#line 490 "../lib/window.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp4_);
#line 490 "../lib/window.vala"
	allocation = _tmp4_;
#line 492 "../lib/window.vala"
	if (event->x > ((gdouble) 4)) {
#line 492 "../lib/window.vala"
		_tmp7_ = event->y > ((gdouble) 4);
#line 2210 "window.c"
	} else {
#line 492 "../lib/window.vala"
		_tmp7_ = FALSE;
#line 2214 "window.c"
	}
#line 492 "../lib/window.vala"
	if (_tmp7_) {
#line 2218 "window.c"
		GtkAllocation _tmp8_;
#line 493 "../lib/window.vala"
		_tmp8_ = allocation;
#line 493 "../lib/window.vala"
		_tmp6_ = event->x < ((gdouble) (_tmp8_.width - 4));
#line 2224 "window.c"
	} else {
#line 492 "../lib/window.vala"
		_tmp6_ = FALSE;
#line 2228 "window.c"
	}
#line 492 "../lib/window.vala"
	if (_tmp6_) {
#line 2232 "window.c"
		GtkAllocation _tmp9_;
#line 494 "../lib/window.vala"
		_tmp9_ = allocation;
#line 494 "../lib/window.vala"
		_tmp5_ = event->y < ((gdouble) (_tmp9_.height - 4));
#line 2238 "window.c"
	} else {
#line 492 "../lib/window.vala"
		_tmp5_ = FALSE;
#line 2242 "window.c"
	}
#line 492 "../lib/window.vala"
	if (_tmp5_) {
#line 2246 "window.c"
		GdkWindow* _tmp10_;
#line 495 "../lib/window.vala"
		_tmp10_ = gtk_widget_get_window ((GtkWidget*) self);
#line 495 "../lib/window.vala"
		gdk_window_set_cursor (_tmp10_, NULL);
#line 496 "../lib/window.vala"
		result = FALSE;
#line 496 "../lib/window.vala"
		_g_object_unref0 (cursor);
#line 496 "../lib/window.vala"
		return result;
#line 2258 "window.c"
	}
#line 500 "../lib/window.vala"
	if (event->y <= ((gdouble) self->priv->CORNER_MARGIN)) {
#line 502 "../lib/window.vala"
		if (event->x <= ((gdouble) self->priv->CORNER_MARGIN)) {
#line 2264 "window.c"
			GdkCursor* _tmp11_;
			GdkCursor* _tmp12_;
#line 503 "../lib/window.vala"
			_tmp11_ = self->priv->CURSOR_TOP_LC;
#line 503 "../lib/window.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 503 "../lib/window.vala"
			_g_object_unref0 (cursor);
#line 503 "../lib/window.vala"
			cursor = _tmp12_;
#line 2275 "window.c"
		} else {
			GtkAllocation _tmp13_;
#line 505 "../lib/window.vala"
			_tmp13_ = allocation;
#line 505 "../lib/window.vala"
			if (event->x >= ((gdouble) (_tmp13_.width - self->priv->CORNER_MARGIN))) {
#line 2282 "window.c"
				GdkCursor* _tmp14_;
				GdkCursor* _tmp15_;
#line 506 "../lib/window.vala"
				_tmp14_ = self->priv->CURSOR_TOP_RC;
#line 506 "../lib/window.vala"
				_tmp15_ = _g_object_ref0 (_tmp14_);
#line 506 "../lib/window.vala"
				_g_object_unref0 (cursor);
#line 506 "../lib/window.vala"
				cursor = _tmp15_;
#line 2293 "window.c"
			} else {
				GdkCursor* _tmp16_;
				GdkCursor* _tmp17_;
#line 508 "../lib/window.vala"
				_tmp16_ = self->priv->CURSOR_TOP;
#line 508 "../lib/window.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 508 "../lib/window.vala"
				_g_object_unref0 (cursor);
#line 508 "../lib/window.vala"
				cursor = _tmp17_;
#line 2305 "window.c"
			}
		}
	} else {
		GtkAllocation _tmp18_;
#line 511 "../lib/window.vala"
		_tmp18_ = allocation;
#line 511 "../lib/window.vala"
		if (event->y > ((gdouble) (_tmp18_.height - self->priv->CORNER_MARGIN))) {
#line 513 "../lib/window.vala"
			if (event->x <= ((gdouble) self->priv->CORNER_MARGIN)) {
#line 2316 "window.c"
				GdkCursor* _tmp19_;
				GdkCursor* _tmp20_;
#line 514 "../lib/window.vala"
				_tmp19_ = self->priv->CURSOR_BOTTOM_LC;
#line 514 "../lib/window.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 514 "../lib/window.vala"
				_g_object_unref0 (cursor);
#line 514 "../lib/window.vala"
				cursor = _tmp20_;
#line 2327 "window.c"
			} else {
				GtkAllocation _tmp21_;
#line 516 "../lib/window.vala"
				_tmp21_ = allocation;
#line 516 "../lib/window.vala"
				if (event->x >= ((gdouble) (_tmp21_.width - self->priv->CORNER_MARGIN))) {
#line 2334 "window.c"
					GdkCursor* _tmp22_;
					GdkCursor* _tmp23_;
#line 517 "../lib/window.vala"
					_tmp22_ = self->priv->CURSOR_BOTTOM_RC;
#line 517 "../lib/window.vala"
					_tmp23_ = _g_object_ref0 (_tmp22_);
#line 517 "../lib/window.vala"
					_g_object_unref0 (cursor);
#line 517 "../lib/window.vala"
					cursor = _tmp23_;
#line 2345 "window.c"
				} else {
					GdkCursor* _tmp24_;
					GdkCursor* _tmp25_;
#line 519 "../lib/window.vala"
					_tmp24_ = self->priv->CURSOR_BOTTOM;
#line 519 "../lib/window.vala"
					_tmp25_ = _g_object_ref0 (_tmp24_);
#line 519 "../lib/window.vala"
					_g_object_unref0 (cursor);
#line 519 "../lib/window.vala"
					cursor = _tmp25_;
#line 2357 "window.c"
				}
			}
		} else {
#line 522 "../lib/window.vala"
			if (event->x <= ((gdouble) self->priv->CORNER_MARGIN)) {
#line 2363 "window.c"
				GdkCursor* _tmp26_;
				GdkCursor* _tmp27_;
#line 523 "../lib/window.vala"
				_tmp26_ = self->priv->CURSOR_LEFT;
#line 523 "../lib/window.vala"
				_tmp27_ = _g_object_ref0 (_tmp26_);
#line 523 "../lib/window.vala"
				_g_object_unref0 (cursor);
#line 523 "../lib/window.vala"
				cursor = _tmp27_;
#line 2374 "window.c"
			} else {
				GdkCursor* _tmp28_;
				GdkCursor* _tmp29_;
#line 526 "../lib/window.vala"
				_tmp28_ = self->priv->CURSOR_RIGHT;
#line 526 "../lib/window.vala"
				_tmp29_ = _g_object_ref0 (_tmp28_);
#line 526 "../lib/window.vala"
				_g_object_unref0 (cursor);
#line 526 "../lib/window.vala"
				cursor = _tmp29_;
#line 2386 "window.c"
			}
		}
	}
#line 528 "../lib/window.vala"
	_tmp30_ = self->priv->notebook;
#line 528 "../lib/window.vala"
	g_signal_emit_by_name ((GtkWidget*) _tmp30_, "motion-notify-event", event, &_tmp31_);
#line 529 "../lib/window.vala"
	_tmp32_ = gtk_widget_get_window ((GtkWidget*) self);
#line 529 "../lib/window.vala"
	_tmp33_ = cursor;
#line 529 "../lib/window.vala"
	gdk_window_set_cursor (_tmp32_, _tmp33_);
#line 530 "../lib/window.vala"
	result = TRUE;
#line 530 "../lib/window.vala"
	_g_object_unref0 (cursor);
#line 530 "../lib/window.vala"
	return result;
#line 2406 "window.c"
}

/**
 * window_pressed_cb:
 *
 * Start a window resize depending on mouse pointer location.
 */
static gboolean
xnp_window_window_pressed_cb (XnpWindow* self,
                              GdkEventButton* event)
{
	GdkCursor* cursor = NULL;
	GdkWindow* _tmp0_;
	GdkCursor* _tmp1_;
	GdkCursor* _tmp2_;
	GdkWindowEdge edge = 0;
	GdkCursor* _tmp3_;
	GdkCursor* _tmp4_;
	gboolean result;
#line 538 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 538 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 539 "../lib/window.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 539 "../lib/window.vala"
	_tmp1_ = gdk_window_get_cursor (_tmp0_);
#line 539 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 539 "../lib/window.vala"
	cursor = _tmp2_;
#line 542 "../lib/window.vala"
	_tmp3_ = cursor;
#line 542 "../lib/window.vala"
	_tmp4_ = self->priv->CURSOR_TOP;
#line 542 "../lib/window.vala"
	if (_tmp3_ == _tmp4_) {
#line 543 "../lib/window.vala"
		edge = GDK_WINDOW_EDGE_NORTH;
#line 2446 "window.c"
	} else {
		GdkCursor* _tmp5_;
		GdkCursor* _tmp6_;
#line 544 "../lib/window.vala"
		_tmp5_ = cursor;
#line 544 "../lib/window.vala"
		_tmp6_ = self->priv->CURSOR_BOTTOM;
#line 544 "../lib/window.vala"
		if (_tmp5_ == _tmp6_) {
#line 545 "../lib/window.vala"
			edge = GDK_WINDOW_EDGE_SOUTH;
#line 2458 "window.c"
		} else {
			GdkCursor* _tmp7_;
			GdkCursor* _tmp8_;
#line 546 "../lib/window.vala"
			_tmp7_ = cursor;
#line 546 "../lib/window.vala"
			_tmp8_ = self->priv->CURSOR_LEFT;
#line 546 "../lib/window.vala"
			if (_tmp7_ == _tmp8_) {
#line 547 "../lib/window.vala"
				edge = GDK_WINDOW_EDGE_WEST;
#line 2470 "window.c"
			} else {
				GdkCursor* _tmp9_;
				GdkCursor* _tmp10_;
#line 548 "../lib/window.vala"
				_tmp9_ = cursor;
#line 548 "../lib/window.vala"
				_tmp10_ = self->priv->CURSOR_RIGHT;
#line 548 "../lib/window.vala"
				if (_tmp9_ == _tmp10_) {
#line 549 "../lib/window.vala"
					edge = GDK_WINDOW_EDGE_EAST;
#line 2482 "window.c"
				} else {
					GdkCursor* _tmp11_;
					GdkCursor* _tmp12_;
#line 550 "../lib/window.vala"
					_tmp11_ = cursor;
#line 550 "../lib/window.vala"
					_tmp12_ = self->priv->CURSOR_TOP_LC;
#line 550 "../lib/window.vala"
					if (_tmp11_ == _tmp12_) {
#line 551 "../lib/window.vala"
						edge = GDK_WINDOW_EDGE_NORTH_WEST;
#line 2494 "window.c"
					} else {
						GdkCursor* _tmp13_;
						GdkCursor* _tmp14_;
#line 552 "../lib/window.vala"
						_tmp13_ = cursor;
#line 552 "../lib/window.vala"
						_tmp14_ = self->priv->CURSOR_TOP_RC;
#line 552 "../lib/window.vala"
						if (_tmp13_ == _tmp14_) {
#line 553 "../lib/window.vala"
							edge = GDK_WINDOW_EDGE_NORTH_EAST;
#line 2506 "window.c"
						} else {
							GdkCursor* _tmp15_;
							GdkCursor* _tmp16_;
#line 554 "../lib/window.vala"
							_tmp15_ = cursor;
#line 554 "../lib/window.vala"
							_tmp16_ = self->priv->CURSOR_BOTTOM_LC;
#line 554 "../lib/window.vala"
							if (_tmp15_ == _tmp16_) {
#line 555 "../lib/window.vala"
								edge = GDK_WINDOW_EDGE_SOUTH_WEST;
#line 2518 "window.c"
							} else {
								GdkCursor* _tmp17_;
								GdkCursor* _tmp18_;
#line 556 "../lib/window.vala"
								_tmp17_ = cursor;
#line 556 "../lib/window.vala"
								_tmp18_ = self->priv->CURSOR_BOTTOM_RC;
#line 556 "../lib/window.vala"
								if (_tmp17_ == _tmp18_) {
#line 557 "../lib/window.vala"
									edge = GDK_WINDOW_EDGE_SOUTH_EAST;
#line 2530 "window.c"
								} else {
#line 559 "../lib/window.vala"
									result = FALSE;
#line 559 "../lib/window.vala"
									_g_object_unref0 (cursor);
#line 559 "../lib/window.vala"
									return result;
#line 2538 "window.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 561 "../lib/window.vala"
	gtk_window_begin_resize_drag ((GtkWindow*) self, edge, (gint) event->button, (gint) event->x_root, (gint) event->y_root, event->time);
#line 564 "../lib/window.vala"
	result = TRUE;
#line 564 "../lib/window.vala"
	_g_object_unref0 (cursor);
#line 564 "../lib/window.vala"
	return result;
#line 2555 "window.c"
}

/**
 * window_state_cb:
 *
 * Watch window manager actions always on top and sticky
 * window.
 */
static gboolean
xnp_window_window_state_cb (XnpWindow* self,
                            GdkEventWindowState* event)
{
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 573 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 573 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 574 "../lib/window.vala"
	if ((gboolean) (event->changed_mask & GDK_WINDOW_STATE_ABOVE)) {
#line 2576 "window.c"
		GtkCheckMenuItem* _tmp0_;
#line 577 "../lib/window.vala"
		_tmp0_ = self->priv->mi_above;
#line 577 "../lib/window.vala"
		gtk_check_menu_item_set_active (_tmp0_, (gboolean) (event->new_window_state & GDK_WINDOW_STATE_ABOVE));
#line 2582 "window.c"
	}
#line 579 "../lib/window.vala"
	if ((gboolean) (event->changed_mask & GDK_WINDOW_STATE_STICKY)) {
#line 579 "../lib/window.vala"
		_tmp1_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 2588 "window.c"
	} else {
#line 579 "../lib/window.vala"
		_tmp1_ = FALSE;
#line 2592 "window.c"
	}
#line 579 "../lib/window.vala"
	if (_tmp1_) {
#line 580 "../lib/window.vala"
		xnp_window_set_sticky (self, (gboolean) ((event->new_window_state & GDK_WINDOW_STATE_STICKY) != 0));
#line 2598 "window.c"
	}
#line 582 "../lib/window.vala"
	result = FALSE;
#line 582 "../lib/window.vala"
	return result;
#line 2604 "window.c"
}

/**
 * title_evbox_pressed_cb:
 *
 * Raise/lower the window and popup window menu.
 */
static gboolean
xnp_window_title_evbox_pressed_cb (XnpWindow* self,
                                   GtkWidget* widget,
                                   GdkEventButton* event)
{
	GdkWindow* _tmp0_;
	GdkCursor* _tmp1_;
	gboolean result;
#line 590 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 590 "../lib/window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 590 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 591 "../lib/window.vala"
	if (event->type != GDK_BUTTON_PRESS) {
#line 592 "../lib/window.vala"
		result = FALSE;
#line 592 "../lib/window.vala"
		return result;
#line 2632 "window.c"
	}
#line 593 "../lib/window.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 593 "../lib/window.vala"
	_tmp1_ = gdk_window_get_cursor (_tmp0_);
#line 593 "../lib/window.vala"
	if (_tmp1_ != NULL) {
#line 594 "../lib/window.vala"
		result = FALSE;
#line 594 "../lib/window.vala"
		return result;
#line 2644 "window.c"
	}
#line 595 "../lib/window.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 2648 "window.c"
		GdkWindow* _tmp2_;
		gint winx = 0;
		gint winy = 0;
		gint curx = 0;
		gint cury = 0;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 596 "../lib/window.vala"
		_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 596 "../lib/window.vala"
		gdk_window_show (_tmp2_);
#line 598 "../lib/window.vala"
		gtk_window_get_position ((GtkWindow*) self, &_tmp3_, &_tmp4_);
#line 598 "../lib/window.vala"
		winx = _tmp3_;
#line 598 "../lib/window.vala"
		winy = _tmp4_;
#line 599 "../lib/window.vala"
		gtk_widget_get_pointer ((GtkWidget*) self, &_tmp5_, &_tmp6_);
#line 599 "../lib/window.vala"
		curx = _tmp5_;
#line 599 "../lib/window.vala"
		cury = _tmp6_;
#line 600 "../lib/window.vala"
		winx += curx;
#line 601 "../lib/window.vala"
		winy += cury;
#line 602 "../lib/window.vala"
		gtk_window_begin_move_drag ((GtkWindow*) self, 1, winx, winy, gtk_get_current_event_time ());
#line 2680 "window.c"
	} else {
#line 604 "../lib/window.vala"
		if (event->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 2684 "window.c"
			GdkWindow* _tmp7_;
#line 605 "../lib/window.vala"
			_tmp7_ = gtk_widget_get_window ((GtkWidget*) self);
#line 605 "../lib/window.vala"
			gdk_window_lower (_tmp7_);
#line 2690 "window.c"
		} else {
#line 607 "../lib/window.vala"
			if (event->button == ((guint) GDK_BUTTON_SECONDARY)) {
#line 2694 "window.c"
				GtkMenu* _tmp8_;
#line 608 "../lib/window.vala"
				_tmp8_ = self->priv->menu;
#line 608 "../lib/window.vala"
				gtk_menu_popup (_tmp8_, NULL, NULL, NULL, NULL, (guint) 0, gtk_get_current_event_time ());
#line 2700 "window.c"
			}
		}
	}
#line 610 "../lib/window.vala"
	result = FALSE;
#line 610 "../lib/window.vala"
	return result;
#line 2708 "window.c"
}

/**
 * title_evbox_scrolled_cb:
 *
 * Shade/unshade the window and set transparency by holding ALT.
 */
static gboolean
xnp_window_title_evbox_scrolled_cb (XnpWindow* self,
                                    GtkWidget* widget,
                                    GdkEventScroll* event)
{
	gboolean result;
#line 618 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 618 "../lib/window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 618 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 619 "../lib/window.vala"
	if ((gboolean) (event->state & GDK_MOD1_MASK)) {
#line 620 "../lib/window.vala"
		if (event->direction == GDK_SCROLL_UP) {
#line 2732 "window.c"
			gdouble _tmp0_;
			gdouble _tmp1_;
#line 621 "../lib/window.vala"
			_tmp0_ = gtk_widget_get_opacity ((GtkWidget*) self);
#line 621 "../lib/window.vala"
			_tmp1_ = _tmp0_;
#line 621 "../lib/window.vala"
			gtk_widget_set_opacity ((GtkWidget*) self, _tmp1_ + 0.1);
#line 2741 "window.c"
		} else {
#line 622 "../lib/window.vala"
			if (event->direction == GDK_SCROLL_DOWN) {
#line 2745 "window.c"
				gdouble _tmp2_;
				gdouble _tmp3_;
#line 623 "../lib/window.vala"
				_tmp2_ = gtk_widget_get_opacity ((GtkWidget*) self);
#line 623 "../lib/window.vala"
				_tmp3_ = _tmp2_;
#line 623 "../lib/window.vala"
				if ((_tmp3_ - 0.1) >= 0.1) {
#line 2754 "window.c"
					gdouble _tmp4_;
					gdouble _tmp5_;
#line 624 "../lib/window.vala"
					_tmp4_ = gtk_widget_get_opacity ((GtkWidget*) self);
#line 624 "../lib/window.vala"
					_tmp5_ = _tmp4_;
#line 624 "../lib/window.vala"
					gtk_widget_set_opacity ((GtkWidget*) self, _tmp5_ - 0.1);
#line 2763 "window.c"
				}
			}
		}
	} else {
#line 628 "../lib/window.vala"
		if (event->direction == GDK_SCROLL_UP) {
#line 629 "../lib/window.vala"
			xnp_window_shade (self);
#line 2772 "window.c"
		} else {
#line 631 "../lib/window.vala"
			if (event->direction == GDK_SCROLL_DOWN) {
#line 632 "../lib/window.vala"
				xnp_window_unshade (self);
#line 2778 "window.c"
			}
		}
	}
#line 635 "../lib/window.vala"
	result = FALSE;
#line 635 "../lib/window.vala"
	return result;
#line 2786 "window.c"
}

/**
 * notebook_tab_scroll_cb:
 *
 * Switch tabs with mouse scroll wheel.
 */
static gboolean
xnp_window_notebook_tab_scroll_cb (XnpWindow* self,
                                   GdkEventScroll* event)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
	GtkWidget* event_widget = NULL;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	GtkWidget* _tmp8_;
	gboolean result;
#line 643 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 643 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 644 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 644 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 644 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 644 "../lib/window.vala"
	current_note = _tmp2_;
#line 646 "../lib/window.vala"
	_tmp3_ = current_note;
#line 646 "../lib/window.vala"
	if (_tmp3_ == NULL) {
#line 647 "../lib/window.vala"
		result = FALSE;
#line 647 "../lib/window.vala"
		_g_object_unref0 (current_note);
#line 647 "../lib/window.vala"
		return result;
#line 2832 "window.c"
	}
#line 649 "../lib/window.vala"
	_tmp4_ = gtk_get_event_widget ((GdkEvent*) event);
#line 649 "../lib/window.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 649 "../lib/window.vala"
	event_widget = _tmp5_;
#line 652 "../lib/window.vala"
	_tmp8_ = event_widget;
#line 652 "../lib/window.vala"
	if (_tmp8_ == NULL) {
#line 652 "../lib/window.vala"
		_tmp7_ = TRUE;
#line 2846 "window.c"
	} else {
		GtkWidget* _tmp9_;
		XnpNote* _tmp10_;
#line 653 "../lib/window.vala"
		_tmp9_ = event_widget;
#line 653 "../lib/window.vala"
		_tmp10_ = current_note;
#line 653 "../lib/window.vala"
		_tmp7_ = _tmp9_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget);
#line 2856 "window.c"
	}
#line 652 "../lib/window.vala"
	if (_tmp7_) {
#line 652 "../lib/window.vala"
		_tmp6_ = TRUE;
#line 2862 "window.c"
	} else {
		GtkWidget* _tmp11_;
		XnpNote* _tmp12_;
#line 654 "../lib/window.vala"
		_tmp11_ = event_widget;
#line 654 "../lib/window.vala"
		_tmp12_ = current_note;
#line 654 "../lib/window.vala"
		_tmp6_ = gtk_widget_is_ancestor (_tmp11_, (GtkWidget*) _tmp12_);
#line 2872 "window.c"
	}
#line 652 "../lib/window.vala"
	if (_tmp6_) {
#line 655 "../lib/window.vala"
		result = FALSE;
#line 655 "../lib/window.vala"
		_g_object_unref0 (event_widget);
#line 655 "../lib/window.vala"
		_g_object_unref0 (current_note);
#line 655 "../lib/window.vala"
		return result;
#line 2884 "window.c"
	}
#line 658 "../lib/window.vala"
	if ((event->state & gtk_accelerator_get_default_mod_mask ()) != 0) {
#line 659 "../lib/window.vala"
		result = FALSE;
#line 659 "../lib/window.vala"
		_g_object_unref0 (event_widget);
#line 659 "../lib/window.vala"
		_g_object_unref0 (current_note);
#line 659 "../lib/window.vala"
		return result;
#line 2896 "window.c"
	}
#line 661 "../lib/window.vala"
	switch (event->direction) {
#line 661 "../lib/window.vala"
		case GDK_SCROLL_RIGHT:
#line 661 "../lib/window.vala"
		case GDK_SCROLL_DOWN:
#line 2904 "window.c"
		{
			GtkNotebook* _tmp13_;
#line 664 "../lib/window.vala"
			_tmp13_ = self->priv->notebook;
#line 664 "../lib/window.vala"
			gtk_notebook_next_page (_tmp13_);
#line 665 "../lib/window.vala"
			break;
#line 2913 "window.c"
		}
#line 661 "../lib/window.vala"
		case GDK_SCROLL_LEFT:
#line 661 "../lib/window.vala"
		case GDK_SCROLL_UP:
#line 2919 "window.c"
		{
			GtkNotebook* _tmp14_;
#line 668 "../lib/window.vala"
			_tmp14_ = self->priv->notebook;
#line 668 "../lib/window.vala"
			gtk_notebook_prev_page (_tmp14_);
#line 669 "../lib/window.vala"
			break;
#line 2928 "window.c"
		}
		default:
		{
#line 671 "../lib/window.vala"
			result = FALSE;
#line 671 "../lib/window.vala"
			_g_object_unref0 (event_widget);
#line 671 "../lib/window.vala"
			_g_object_unref0 (current_note);
#line 671 "../lib/window.vala"
			return result;
#line 2940 "window.c"
		}
	}
#line 674 "../lib/window.vala"
	result = TRUE;
#line 674 "../lib/window.vala"
	_g_object_unref0 (event_widget);
#line 674 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 674 "../lib/window.vala"
	return result;
#line 2951 "window.c"
}

/**
 * note_notify_name_cb:
 *
 */
static void
xnp_window_note_notify_name_cb (XnpWindow* self,
                                GObject* object,
                                GParamSpec* pspec)
{
	XnpNote* note = NULL;
	XnpNote* _tmp0_;
	GtkEventBox* tab_evbox = NULL;
	XnpNote* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkLabel* label = NULL;
	GtkEventBox* _tmp3_;
	GtkWidget* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	XnpNote* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	XnpNote* _tmp10_;
	XnpNote* _tmp11_;
	XnpNote* _tmp12_;
#line 681 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 681 "../lib/window.vala"
	g_return_if_fail (object != NULL);
#line 682 "../lib/window.vala"
	_tmp0_ = _g_object_ref0 (XNP_IS_NOTE (object) ? ((XnpNote*) object) : NULL);
#line 682 "../lib/window.vala"
	note = _tmp0_;
#line 683 "../lib/window.vala"
	_tmp1_ = note;
#line 683 "../lib/window.vala"
	_tmp2_ = xnp_window_get_tab_evbox (self, _tmp1_);
#line 683 "../lib/window.vala"
	tab_evbox = _tmp2_;
#line 684 "../lib/window.vala"
	_tmp3_ = tab_evbox;
#line 684 "../lib/window.vala"
	_tmp4_ = gtk_bin_get_child ((GtkBin*) _tmp3_);
#line 684 "../lib/window.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp4_) : NULL);
#line 684 "../lib/window.vala"
	label = _tmp5_;
#line 685 "../lib/window.vala"
	_tmp6_ = label;
#line 685 "../lib/window.vala"
	_tmp7_ = note;
#line 685 "../lib/window.vala"
	_tmp8_ = xnp_note_get_name (_tmp7_);
#line 685 "../lib/window.vala"
	_tmp9_ = _tmp8_;
#line 685 "../lib/window.vala"
	gtk_label_set_text (_tmp6_, _tmp9_);
#line 686 "../lib/window.vala"
	_xnp_window_notebook_update_tabs_angle (self);
#line 687 "../lib/window.vala"
	_tmp10_ = note;
#line 687 "../lib/window.vala"
	_tmp11_ = xnp_window_get_current_note (self);
#line 687 "../lib/window.vala"
	_tmp12_ = _tmp11_;
#line 687 "../lib/window.vala"
	if (_tmp10_ == _tmp12_) {
#line 3021 "window.c"
		XnpNote* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 688 "../lib/window.vala"
		_tmp13_ = note;
#line 688 "../lib/window.vala"
		_tmp14_ = xnp_note_get_name (_tmp13_);
#line 688 "../lib/window.vala"
		_tmp15_ = _tmp14_;
#line 688 "../lib/window.vala"
		xnp_window_update_title (self, _tmp15_);
#line 3033 "window.c"
	}
#line 681 "../lib/window.vala"
	_g_object_unref0 (label);
#line 681 "../lib/window.vala"
	_g_object_unref0 (tab_evbox);
#line 681 "../lib/window.vala"
	_g_object_unref0 (note);
#line 3041 "window.c"
}

/**
 * tab_evbox_pressed_cb:
 *
 * Handle mouse click events on notebook tabs.
 */
static gboolean
xnp_window_tab_evbox_pressed_cb (XnpWindow* self,
                                 GdkEventButton* event,
                                 XnpNote* note)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 696 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 696 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 696 "../lib/window.vala"
	g_return_val_if_fail (note != NULL, FALSE);
#line 697 "../lib/window.vala"
	if (event->type == GDK_DOUBLE_BUTTON_PRESS) {
#line 697 "../lib/window.vala"
		_tmp0_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
#line 3066 "window.c"
	} else {
#line 697 "../lib/window.vala"
		_tmp0_ = FALSE;
#line 3070 "window.c"
	}
#line 697 "../lib/window.vala"
	if (_tmp0_) {
#line 698 "../lib/window.vala"
		xnp_window_action_rename_note (self);
#line 3076 "window.c"
	} else {
#line 699 "../lib/window.vala"
		if (event->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 3080 "window.c"
			GtkNotebook* _tmp1_;
			GtkNotebook* _tmp2_;
#line 700 "../lib/window.vala"
			_tmp1_ = self->priv->notebook;
#line 700 "../lib/window.vala"
			_tmp2_ = self->priv->notebook;
#line 700 "../lib/window.vala"
			g_object_set (_tmp1_, "page", gtk_notebook_page_num (_tmp2_, (GtkWidget*) note), NULL);
#line 701 "../lib/window.vala"
			xnp_window_delete_current_note (self);
#line 3091 "window.c"
		} else {
#line 704 "../lib/window.vala"
			result = FALSE;
#line 704 "../lib/window.vala"
			return result;
#line 3097 "window.c"
		}
	}
#line 706 "../lib/window.vala"
	result = TRUE;
#line 706 "../lib/window.vala"
	return result;
#line 3104 "window.c"
}

static void
xnp_window_action_new_window (XnpWindow* self)
{
#line 713 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 714 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "create-new-window");
#line 3114 "window.c"
}

static void
xnp_window_action_delete_window (XnpWindow* self)
{
#line 717 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 718 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "delete");
#line 3124 "window.c"
}

static void
xnp_window_action_rename_window (XnpWindow* self)
{
#line 721 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 722 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "rename");
#line 3134 "window.c"
}

static void
xnp_window_action_new_note (XnpWindow* self)
{
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
#line 725 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 726 "../lib/window.vala"
	_tmp0_ = xnp_window_insert_note (self, NULL);
#line 726 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 726 "../lib/window.vala"
	_g_object_unref0 (_tmp1_);
#line 3150 "window.c"
}

static void
xnp_window_action_delete_note (XnpWindow* self)
{
#line 729 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 730 "../lib/window.vala"
	xnp_window_delete_current_note (self);
#line 3160 "window.c"
}

static void
xnp_window_action_rename_note (XnpWindow* self)
{
#line 733 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 734 "../lib/window.vala"
	xnp_window_rename_current_note (self);
#line 3170 "window.c"
}

static void
xnp_window_action_undo (XnpWindow* self)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
#line 737 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 738 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 738 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 738 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 738 "../lib/window.vala"
	current_note = _tmp2_;
#line 739 "../lib/window.vala"
	_tmp3_ = current_note;
#line 739 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 3195 "window.c"
		XnpNote* _tmp4_;
		XnpHypertextView* _tmp5_;
#line 740 "../lib/window.vala"
		_tmp4_ = current_note;
#line 740 "../lib/window.vala"
		_tmp5_ = _tmp4_->text_view;
#line 740 "../lib/window.vala"
		xnp_hypertext_view_undo (_tmp5_);
#line 3204 "window.c"
	}
#line 737 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 3208 "window.c"
}

static void
xnp_window_action_redo (XnpWindow* self)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
#line 743 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 744 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 744 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 744 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 744 "../lib/window.vala"
	current_note = _tmp2_;
#line 745 "../lib/window.vala"
	_tmp3_ = current_note;
#line 745 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 3233 "window.c"
		XnpNote* _tmp4_;
		XnpHypertextView* _tmp5_;
#line 746 "../lib/window.vala"
		_tmp4_ = current_note;
#line 746 "../lib/window.vala"
		_tmp5_ = _tmp4_->text_view;
#line 746 "../lib/window.vala"
		xnp_hypertext_view_redo (_tmp5_);
#line 3242 "window.c"
	}
#line 743 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 3246 "window.c"
}

static void
xnp_window_action_bold (XnpWindow* self)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
#line 749 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 750 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 750 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 750 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 750 "../lib/window.vala"
	current_note = _tmp2_;
#line 751 "../lib/window.vala"
	_tmp3_ = current_note;
#line 751 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 3271 "window.c"
		XnpNote* _tmp4_;
		XnpHypertextView* _tmp5_;
#line 752 "../lib/window.vala"
		_tmp4_ = current_note;
#line 752 "../lib/window.vala"
		_tmp5_ = _tmp4_->text_view;
#line 752 "../lib/window.vala"
		xnp_hypertext_view_toggle_tag (_tmp5_, "b");
#line 3280 "window.c"
	}
#line 749 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 3284 "window.c"
}

static void
xnp_window_action_italic (XnpWindow* self)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
#line 755 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 756 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 756 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 756 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 756 "../lib/window.vala"
	current_note = _tmp2_;
#line 757 "../lib/window.vala"
	_tmp3_ = current_note;
#line 757 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 3309 "window.c"
		XnpNote* _tmp4_;
		XnpHypertextView* _tmp5_;
#line 758 "../lib/window.vala"
		_tmp4_ = current_note;
#line 758 "../lib/window.vala"
		_tmp5_ = _tmp4_->text_view;
#line 758 "../lib/window.vala"
		xnp_hypertext_view_toggle_tag (_tmp5_, "i");
#line 3318 "window.c"
	}
#line 755 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 3322 "window.c"
}

static void
xnp_window_action_strikethrough (XnpWindow* self)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
#line 761 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 762 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 762 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 762 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 762 "../lib/window.vala"
	current_note = _tmp2_;
#line 763 "../lib/window.vala"
	_tmp3_ = current_note;
#line 763 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 3347 "window.c"
		XnpNote* _tmp4_;
		XnpHypertextView* _tmp5_;
#line 764 "../lib/window.vala"
		_tmp4_ = current_note;
#line 764 "../lib/window.vala"
		_tmp5_ = _tmp4_->text_view;
#line 764 "../lib/window.vala"
		xnp_hypertext_view_toggle_tag (_tmp5_, "s");
#line 3356 "window.c"
	}
#line 761 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 3360 "window.c"
}

static void
xnp_window_action_underline (XnpWindow* self)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
#line 767 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 768 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 768 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 768 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 768 "../lib/window.vala"
	current_note = _tmp2_;
#line 769 "../lib/window.vala"
	_tmp3_ = current_note;
#line 769 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 3385 "window.c"
		XnpNote* _tmp4_;
		XnpHypertextView* _tmp5_;
#line 770 "../lib/window.vala"
		_tmp4_ = current_note;
#line 770 "../lib/window.vala"
		_tmp5_ = _tmp4_->text_view;
#line 770 "../lib/window.vala"
		xnp_hypertext_view_toggle_tag (_tmp5_, "u");
#line 3394 "window.c"
	}
#line 767 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 3398 "window.c"
}

static void
xnp_window_action_checkbox (XnpWindow* self)
{
	XnpNote* current_note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
#line 773 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 774 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 774 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 774 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 774 "../lib/window.vala"
	current_note = _tmp2_;
#line 775 "../lib/window.vala"
	_tmp3_ = current_note;
#line 775 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 3423 "window.c"
		XnpNote* _tmp4_;
		XnpHypertextView* _tmp5_;
#line 776 "../lib/window.vala"
		_tmp4_ = current_note;
#line 776 "../lib/window.vala"
		_tmp5_ = _tmp4_->text_view;
#line 776 "../lib/window.vala"
		xnp_hypertext_view_insert_checkbox (_tmp5_, FALSE);
#line 3432 "window.c"
	}
#line 773 "../lib/window.vala"
	_g_object_unref0 (current_note);
#line 3436 "window.c"
}

static void
xnp_window_action_next_note (XnpWindow* self)
{
	GtkNotebook* _tmp0_;
#line 779 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 780 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 780 "../lib/window.vala"
	gtk_notebook_next_page (_tmp0_);
#line 3449 "window.c"
}

static void
xnp_window_action_prev_note (XnpWindow* self)
{
	GtkNotebook* _tmp0_;
#line 783 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 784 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 784 "../lib/window.vala"
	gtk_notebook_prev_page (_tmp0_);
#line 3462 "window.c"
}

/**
 * menu_evbox_pressed_cb:
 *
 * Popup the window menu.
 */
static void
_xnp_window_menu_position_gtk_menu_position_func (GtkMenu* menu,
                                                  gint* x,
                                                  gint* y,
                                                  gboolean* push_in,
                                                  gpointer self)
{
#line 797 "../lib/window.vala"
	xnp_window_menu_position ((XnpWindow*) self, menu, x, y, push_in);
#line 797 "../lib/window.vala"
	g_object_unref (self);
#line 3481 "window.c"
}

static gboolean
xnp_window_menu_evbox_pressed_cb (XnpWindow* self,
                                  GtkWidget* widget,
                                  GdkEventButton* event)
{
	GtkMenu* _tmp0_;
	gboolean result;
#line 796 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 796 "../lib/window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 796 "../lib/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 797 "../lib/window.vala"
	_tmp0_ = self->priv->menu;
#line 797 "../lib/window.vala"
	gtk_menu_popup (_tmp0_, NULL, NULL, _xnp_window_menu_position_gtk_menu_position_func, g_object_ref (self), (guint) 0, gtk_get_current_event_time ());
#line 798 "../lib/window.vala"
	result = FALSE;
#line 798 "../lib/window.vala"
	return result;
#line 3505 "window.c"
}

/**
 * menu_position:
 *
 * Menu position function for the window menu.
 */
static void
xnp_window_menu_position (XnpWindow* self,
                          GtkMenu* menu,
                          gint* x,
                          gint* y,
                          gboolean* push_in)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
	gint winx = 0;
	gint winy = 0;
	gint width = 0;
	gint height = 0;
	GtkRequisition requisition = {0};
	GtkAllocation allocation = {0};
	GdkWindow* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	GtkRequisition _tmp5_ = {0};
	GdkWindow* _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	GtkBox* _tmp9_;
	GtkAllocation _tmp10_ = {0};
	GtkAllocation _tmp11_;
	GtkRequisition _tmp12_;
	GtkRequisition _tmp15_;
#line 806 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 806 "../lib/window.vala"
	g_return_if_fail (menu != NULL);
#line 811 "../lib/window.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 811 "../lib/window.vala"
	gdk_window_get_geometry (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 811 "../lib/window.vala"
	winx = _tmp1_;
#line 811 "../lib/window.vala"
	winy = _tmp2_;
#line 811 "../lib/window.vala"
	width = _tmp3_;
#line 811 "../lib/window.vala"
	height = _tmp4_;
#line 812 "../lib/window.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) menu, &_tmp5_, NULL);
#line 812 "../lib/window.vala"
	requisition = _tmp5_;
#line 813 "../lib/window.vala"
	_tmp6_ = gtk_widget_get_window ((GtkWidget*) self);
#line 813 "../lib/window.vala"
	gdk_window_get_origin (_tmp6_, &_tmp7_, &_tmp8_);
#line 813 "../lib/window.vala"
	_vala_x = _tmp7_;
#line 813 "../lib/window.vala"
	_vala_y = _tmp8_;
#line 814 "../lib/window.vala"
	_vala_push_in = FALSE;
#line 816 "../lib/window.vala"
	_tmp9_ = self->priv->content_box;
#line 816 "../lib/window.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp9_, &_tmp10_);
#line 816 "../lib/window.vala"
	allocation = _tmp10_;
#line 818 "../lib/window.vala"
	_tmp11_ = allocation;
#line 818 "../lib/window.vala"
	_tmp12_ = requisition;
#line 818 "../lib/window.vala"
	if (((_vala_y + _tmp11_.y) + _tmp12_.height) > gdk_screen_height ()) {
#line 3585 "window.c"
		GtkRequisition _tmp13_;
#line 820 "../lib/window.vala"
		_tmp13_ = requisition;
#line 820 "../lib/window.vala"
		_vala_y = _vala_y - _tmp13_.height;
#line 3591 "window.c"
	} else {
		GtkAllocation _tmp14_;
#line 824 "../lib/window.vala"
		_tmp14_ = allocation;
#line 824 "../lib/window.vala"
		_vala_y = _vala_y + _tmp14_.y;
#line 3598 "window.c"
	}
#line 826 "../lib/window.vala"
	_tmp15_ = requisition;
#line 826 "../lib/window.vala"
	if ((_vala_x + _tmp15_.width) > gdk_screen_width ()) {
#line 3604 "window.c"
		gint menu_width = 0;
		gint _tmp16_ = 0;
		GtkAllocation _tmp17_;
#line 829 "../lib/window.vala"
		gtk_widget_get_preferred_width ((GtkWidget*) menu, &_tmp16_, NULL);
#line 829 "../lib/window.vala"
		menu_width = _tmp16_;
#line 830 "../lib/window.vala"
		_tmp17_ = allocation;
#line 830 "../lib/window.vala"
		_vala_x = (_vala_x - menu_width) + _tmp17_.y;
#line 3616 "window.c"
	}
#line 806 "../lib/window.vala"
	if (x) {
#line 806 "../lib/window.vala"
		*x = _vala_x;
#line 3622 "window.c"
	}
#line 806 "../lib/window.vala"
	if (y) {
#line 806 "../lib/window.vala"
		*y = _vala_y;
#line 3628 "window.c"
	}
#line 806 "../lib/window.vala"
	if (push_in) {
#line 806 "../lib/window.vala"
		*push_in = _vala_push_in;
#line 3634 "window.c"
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 840 "../lib/window.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 840 "../lib/window.vala"
	return _data10_;
#line 3645 "window.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 840 "../lib/window.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 3655 "window.c"
		XnpWindow* self;
#line 840 "../lib/window.vala"
		self = _data10_->self;
#line 840 "../lib/window.vala"
		_g_object_unref0 (self);
#line 840 "../lib/window.vala"
		g_slice_free (Block10Data, _data10_);
#line 3663 "window.c"
	}
}

static void
__lambda24_ (Block10Data* _data10_)
{
	XnpWindow* self;
#line 847 "../lib/window.vala"
	self = _data10_->self;
#line 847 "../lib/window.vala"
	_data10_->callback (_data10_->callback_target);
#line 3675 "window.c"
}

static void
___lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 847 "../lib/window.vala"
	__lambda24_ (self);
#line 3684 "window.c"
}

static void
xnp_window_menu_add_icon_item (XnpWindow* self,
                               GtkMenu* menu,
                               const gchar* text,
                               const gchar* icon,
                               const gchar* accel,
                               XnpWindowCallback callback,
                               gpointer callback_target)
{
	Block10Data* _data10_;
	GtkImageMenuItem* mi = NULL;
	GtkImageMenuItem* _tmp0_;
	GtkImage* image = NULL;
	GtkImage* _tmp1_;
	GtkImageMenuItem* _tmp2_;
	GtkImage* _tmp3_;
	GtkImageMenuItem* _tmp8_;
	GtkImageMenuItem* _tmp9_;
#line 840 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 840 "../lib/window.vala"
	g_return_if_fail (menu != NULL);
#line 840 "../lib/window.vala"
	g_return_if_fail (text != NULL);
#line 840 "../lib/window.vala"
	g_return_if_fail (icon != NULL);
#line 840 "../lib/window.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 840 "../lib/window.vala"
	_data10_->_ref_count_ = 1;
#line 840 "../lib/window.vala"
	_data10_->self = g_object_ref (self);
#line 840 "../lib/window.vala"
	_data10_->callback = callback;
#line 840 "../lib/window.vala"
	_data10_->callback_target = callback_target;
#line 841 "../lib/window.vala"
	_tmp0_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_mnemonic (text);
#line 841 "../lib/window.vala"
	g_object_ref_sink (_tmp0_);
#line 841 "../lib/window.vala"
	mi = _tmp0_;
#line 842 "../lib/window.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (icon, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 842 "../lib/window.vala"
	g_object_ref_sink (_tmp1_);
#line 842 "../lib/window.vala"
	image = _tmp1_;
#line 843 "../lib/window.vala"
	_tmp2_ = mi;
#line 843 "../lib/window.vala"
	_tmp3_ = image;
#line 843 "../lib/window.vala"
	gtk_image_menu_item_set_image (_tmp2_, (GtkWidget*) _tmp3_);
#line 844 "../lib/window.vala"
	if (accel != NULL) {
#line 3743 "window.c"
		GtkImageMenuItem* _tmp4_;
		GtkActionGroup* _tmp5_;
		GtkAction* _tmp6_;
		const gchar* _tmp7_;
#line 845 "../lib/window.vala"
		_tmp4_ = mi;
#line 845 "../lib/window.vala"
		_tmp5_ = self->priv->action_group;
#line 845 "../lib/window.vala"
		_tmp6_ = gtk_action_group_get_action (_tmp5_, accel);
#line 845 "../lib/window.vala"
		_tmp7_ = gtk_action_get_accel_path (_tmp6_);
#line 845 "../lib/window.vala"
		gtk_menu_item_set_accel_path ((GtkMenuItem*) _tmp4_, _tmp7_);
#line 3758 "window.c"
	}
#line 847 "../lib/window.vala"
	_tmp8_ = mi;
#line 847 "../lib/window.vala"
	g_signal_connect_data ((GtkMenuItem*) _tmp8_, "activate", (GCallback) ___lambda24__gtk_menu_item_activate, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 848 "../lib/window.vala"
	_tmp9_ = mi;
#line 848 "../lib/window.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp9_) : NULL, -1);
#line 840 "../lib/window.vala"
	_g_object_unref0 (image);
#line 840 "../lib/window.vala"
	_g_object_unref0 (mi);
#line 840 "../lib/window.vala"
	block10_data_unref (_data10_);
#line 840 "../lib/window.vala"
	_data10_ = NULL;
#line 3776 "window.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 851 "../lib/window.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 851 "../lib/window.vala"
	return _data11_;
#line 3786 "window.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 851 "../lib/window.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 3796 "window.c"
		XnpWindow* self;
#line 851 "../lib/window.vala"
		self = _data11_->self;
#line 851 "../lib/window.vala"
		_g_object_unref0 (self);
#line 851 "../lib/window.vala"
		g_slice_free (Block11Data, _data11_);
#line 3804 "window.c"
	}
}

static void
__lambda25_ (Block11Data* _data11_)
{
	XnpWindow* self;
#line 854 "../lib/window.vala"
	self = _data11_->self;
#line 854 "../lib/window.vala"
	_data11_->callback (_data11_->callback_target);
#line 3816 "window.c"
}

static void
___lambda25__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                          gpointer self)
{
#line 854 "../lib/window.vala"
	__lambda25_ (self);
#line 3825 "window.c"
}

static GtkCheckMenuItem*
xnp_window_menu_add_check_item (XnpWindow* self,
                                GtkMenu* menu,
                                const gchar* text,
                                gboolean active,
                                XnpWindowCallback callback,
                                gpointer callback_target)
{
	Block11Data* _data11_;
	GtkCheckMenuItem* mi = NULL;
	GtkCheckMenuItem* _tmp0_;
	GtkCheckMenuItem* result;
#line 851 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 851 "../lib/window.vala"
	g_return_val_if_fail (menu != NULL, NULL);
#line 851 "../lib/window.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 851 "../lib/window.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 851 "../lib/window.vala"
	_data11_->_ref_count_ = 1;
#line 851 "../lib/window.vala"
	_data11_->self = g_object_ref (self);
#line 851 "../lib/window.vala"
	_data11_->callback = callback;
#line 851 "../lib/window.vala"
	_data11_->callback_target = callback_target;
#line 852 "../lib/window.vala"
	_tmp0_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (text);
#line 852 "../lib/window.vala"
	g_object_ref_sink (_tmp0_);
#line 852 "../lib/window.vala"
	mi = _tmp0_;
#line 853 "../lib/window.vala"
	gtk_check_menu_item_set_active (mi, active);
#line 854 "../lib/window.vala"
	g_signal_connect_data (mi, "toggled", (GCallback) ___lambda25__gtk_check_menu_item_toggled, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 855 "../lib/window.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, G_TYPE_CHECK_INSTANCE_TYPE (mi, gtk_widget_get_type ()) ? ((GtkWidget*) mi) : NULL, -1);
#line 856 "../lib/window.vala"
	result = mi;
#line 856 "../lib/window.vala"
	block11_data_unref (_data11_);
#line 856 "../lib/window.vala"
	_data11_ = NULL;
#line 856 "../lib/window.vala"
	return result;
#line 3876 "window.c"
}

static void
xnp_window_menu_add_separator (XnpWindow* self,
                               GtkMenu* menu)
{
	GtkSeparatorMenuItem* mi = NULL;
	GtkSeparatorMenuItem* _tmp0_;
#line 859 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 859 "../lib/window.vala"
	g_return_if_fail (menu != NULL);
#line 860 "../lib/window.vala"
	_tmp0_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 860 "../lib/window.vala"
	g_object_ref_sink (_tmp0_);
#line 860 "../lib/window.vala"
	mi = _tmp0_;
#line 861 "../lib/window.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, G_TYPE_CHECK_INSTANCE_TYPE (mi, gtk_widget_get_type ()) ? ((GtkWidget*) mi) : NULL, -1);
#line 859 "../lib/window.vala"
	_g_object_unref0 (mi);
#line 3899 "window.c"
}

/**
 * build_menu:
 *
 * Build the window menu.
 */
static void
_xnp_window_update_menu_go_gtk_widget_show (GtkWidget* _sender,
                                            gpointer self)
{
#line 879 "../lib/window.vala"
	xnp_window_update_menu_go ((XnpWindow*) self, _sender);
#line 3913 "window.c"
}

static void
_xnp_window_action_new_note_xnp_window_callback (gpointer self)
{
#line 884 "../lib/window.vala"
	xnp_window_action_new_note ((XnpWindow*) self);
#line 3921 "window.c"
}

static void
_xnp_window_action_delete_note_xnp_window_callback (gpointer self)
{
#line 885 "../lib/window.vala"
	xnp_window_action_delete_note ((XnpWindow*) self);
#line 3929 "window.c"
}

static void
_xnp_window_action_rename_note_xnp_window_callback (gpointer self)
{
#line 886 "../lib/window.vala"
	xnp_window_action_rename_note ((XnpWindow*) self);
#line 3937 "window.c"
}

static void
__lambda26_ (XnpWindow* self)
{
	GtkCheckMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 890 "../lib/window.vala"
	_tmp0_ = self->priv->mi_above;
#line 890 "../lib/window.vala"
	_tmp1_ = gtk_check_menu_item_get_active (_tmp0_);
#line 890 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 890 "../lib/window.vala"
	xnp_window_set_above (self, _tmp2_);
#line 3954 "window.c"
}

static void
___lambda26__xnp_window_callback (gpointer self)
{
#line 890 "../lib/window.vala"
	__lambda26_ ((XnpWindow*) self);
#line 3962 "window.c"
}

static void
__lambda27_ (XnpWindow* self)
{
	GtkCheckMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 891 "../lib/window.vala"
	_tmp0_ = self->priv->mi_sticky;
#line 891 "../lib/window.vala"
	_tmp1_ = gtk_check_menu_item_get_active (_tmp0_);
#line 891 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 891 "../lib/window.vala"
	xnp_window_set_sticky (self, _tmp2_);
#line 3979 "window.c"
}

static void
___lambda27__xnp_window_callback (gpointer self)
{
#line 891 "../lib/window.vala"
	__lambda27_ ((XnpWindow*) self);
#line 3987 "window.c"
}

static void
__lambda28_ (XnpWindow* self)
{
#line 895 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "properties");
#line 3995 "window.c"
}

static void
___lambda28__xnp_window_callback (gpointer self)
{
#line 895 "../lib/window.vala"
	__lambda28_ ((XnpWindow*) self);
#line 4003 "window.c"
}

static void
__lambda29_ (XnpWindow* self)
{
#line 896 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "about");
#line 4011 "window.c"
}

static void
___lambda29__xnp_window_callback (gpointer self)
{
#line 896 "../lib/window.vala"
	__lambda29_ ((XnpWindow*) self);
#line 4019 "window.c"
}

static GtkMenu*
xnp_window_build_menu (XnpWindow* self)
{
	GtkMenu* menu = NULL;
	GtkMenu* _tmp0_;
	GtkUIManager* _tmp1_;
	GtkAccelGroup* _tmp2_;
	GtkMenuItem* mi = NULL;
	GtkMenuItem* _tmp3_;
	GtkMenu* menu_go = NULL;
	GtkMenu* _tmp4_;
	GtkUIManager* _tmp5_;
	GtkAccelGroup* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GtkCheckMenuItem* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GtkCheckMenuItem* _tmp12_;
	GtkMenu* result;
#line 869 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 870 "../lib/window.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 870 "../lib/window.vala"
	g_object_ref_sink (_tmp0_);
#line 870 "../lib/window.vala"
	menu = _tmp0_;
#line 871 "../lib/window.vala"
	_tmp1_ = self->priv->ui;
#line 871 "../lib/window.vala"
	_tmp2_ = gtk_ui_manager_get_accel_group (_tmp1_);
#line 871 "../lib/window.vala"
	gtk_menu_set_accel_group (menu, _tmp2_);
#line 873 "../lib/window.vala"
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Groups"));
#line 873 "../lib/window.vala"
	g_object_ref_sink (_tmp3_);
#line 873 "../lib/window.vala"
	mi = _tmp3_;
#line 874 "../lib/window.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, G_TYPE_CHECK_INSTANCE_TYPE (mi, gtk_widget_get_type ()) ? ((GtkWidget*) mi) : NULL, -1);
#line 877 "../lib/window.vala"
	_tmp4_ = (GtkMenu*) gtk_menu_new ();
#line 877 "../lib/window.vala"
	g_object_ref_sink (_tmp4_);
#line 877 "../lib/window.vala"
	menu_go = _tmp4_;
#line 878 "../lib/window.vala"
	_tmp5_ = self->priv->ui;
#line 878 "../lib/window.vala"
	_tmp6_ = gtk_ui_manager_get_accel_group (_tmp5_);
#line 878 "../lib/window.vala"
	gtk_menu_set_accel_group (menu_go, _tmp6_);
#line 879 "../lib/window.vala"
	g_signal_connect_object ((GtkWidget*) menu_go, "show", (GCallback) _xnp_window_update_menu_go_gtk_widget_show, self, 0);
#line 880 "../lib/window.vala"
	gtk_menu_item_set_submenu (mi, menu_go);
#line 883 "../lib/window.vala"
	xnp_window_menu_add_separator (self, menu);
#line 884 "../lib/window.vala"
	xnp_window_menu_add_icon_item (self, menu, _ ("_New"), "gtk-new", "new-note", _xnp_window_action_new_note_xnp_window_callback, self);
#line 885 "../lib/window.vala"
	xnp_window_menu_add_icon_item (self, menu, _ ("_Delete"), "gtk-delete", "delete-note", _xnp_window_action_delete_note_xnp_window_callback, self);
#line 886 "../lib/window.vala"
	xnp_window_menu_add_icon_item (self, menu, _ ("_Rename"), "gtk-edit", "rename-note", _xnp_window_action_rename_note_xnp_window_callback, self);
#line 889 "../lib/window.vala"
	xnp_window_menu_add_separator (self, menu);
#line 890 "../lib/window.vala"
	_tmp7_ = xnp_window_get_above (self);
#line 890 "../lib/window.vala"
	_tmp8_ = _tmp7_;
#line 890 "../lib/window.vala"
	_tmp9_ = xnp_window_menu_add_check_item (self, menu, _ ("Always on top"), _tmp8_, ___lambda26__xnp_window_callback, self);
#line 890 "../lib/window.vala"
	_g_object_unref0 (self->priv->mi_above);
#line 890 "../lib/window.vala"
	self->priv->mi_above = _tmp9_;
#line 891 "../lib/window.vala"
	_tmp10_ = xnp_window_get_sticky (self);
#line 891 "../lib/window.vala"
	_tmp11_ = _tmp10_;
#line 891 "../lib/window.vala"
	_tmp12_ = xnp_window_menu_add_check_item (self, menu, _ ("Sticky window"), _tmp11_, ___lambda27__xnp_window_callback, self);
#line 891 "../lib/window.vala"
	_g_object_unref0 (self->priv->mi_sticky);
#line 891 "../lib/window.vala"
	self->priv->mi_sticky = _tmp12_;
#line 894 "../lib/window.vala"
	xnp_window_menu_add_separator (self, menu);
#line 895 "../lib/window.vala"
	xnp_window_menu_add_icon_item (self, menu, _ ("_Properties"), "gtk-properties", NULL, ___lambda28__xnp_window_callback, self);
#line 896 "../lib/window.vala"
	xnp_window_menu_add_icon_item (self, menu, _ ("_About"), "gtk-about", NULL, ___lambda29__xnp_window_callback, self);
#line 898 "../lib/window.vala"
	result = menu;
#line 898 "../lib/window.vala"
	_g_object_unref0 (menu_go);
#line 898 "../lib/window.vala"
	_g_object_unref0 (mi);
#line 898 "../lib/window.vala"
	return result;
#line 4124 "window.c"
}

/**
 * update_menu_go:
 *
 * Update the menu Go when it is shown.
 */
static void
__lambda21_ (XnpWindow* self,
             GtkWidget* w)
{
#line 911 "../lib/window.vala"
	g_return_if_fail (w != NULL);
#line 912 "../lib/window.vala"
	gtk_widget_destroy (w);
#line 4140 "window.c"
}

static void
___lambda21__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 911 "../lib/window.vala"
	__lambda21_ ((XnpWindow*) self, widget);
#line 4149 "window.c"
}

static void
________lambda22_ (XnpWindow* self,
                   GtkMenuItem* i)
{
	GtkNotebook* _tmp0_;
	gconstpointer _tmp1_;
#line 932 "../lib/window.vala"
	g_return_if_fail (i != NULL);
#line 933 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 933 "../lib/window.vala"
	_tmp1_ = g_object_get_data ((GObject*) i, "page");
#line 933 "../lib/window.vala"
	g_object_set (_tmp0_, "page", (gint) ((gintptr) _tmp1_), NULL);
#line 4166 "window.c"
}

static void
_________lambda22__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self)
{
#line 932 "../lib/window.vala"
	________lambda22_ ((XnpWindow*) self, _sender);
#line 4175 "window.c"
}

static void
_____lambda23_ (XnpWindow* self,
                GtkMenuItem* i)
{
	XnpWindow* w = NULL;
	gconstpointer _tmp0_;
	XnpWindow* _tmp1_;
#line 943 "../lib/window.vala"
	g_return_if_fail (i != NULL);
#line 944 "../lib/window.vala"
	_tmp0_ = g_object_get_data ((GObject*) i, "window");
#line 944 "../lib/window.vala"
	_tmp1_ = _g_object_ref0 ((XnpWindow*) _tmp0_);
#line 944 "../lib/window.vala"
	w = _tmp1_;
#line 945 "../lib/window.vala"
	gtk_window_present ((GtkWindow*) w);
#line 943 "../lib/window.vala"
	_g_object_unref0 (w);
#line 4197 "window.c"
}

static void
______lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 943 "../lib/window.vala"
	_____lambda23_ ((XnpWindow*) self, _sender);
#line 4206 "window.c"
}

static void
_xnp_window_action_rename_window_xnp_window_callback (gpointer self)
{
#line 953 "../lib/window.vala"
	xnp_window_action_rename_window ((XnpWindow*) self);
#line 4214 "window.c"
}

static void
_xnp_window_action_delete_window_xnp_window_callback (gpointer self)
{
#line 954 "../lib/window.vala"
	xnp_window_action_delete_window ((XnpWindow*) self);
#line 4222 "window.c"
}

static void
_xnp_window_action_new_window_xnp_window_callback (gpointer self)
{
#line 955 "../lib/window.vala"
	xnp_window_action_new_window ((XnpWindow*) self);
#line 4230 "window.c"
}

static void
xnp_window_update_menu_go (XnpWindow* self,
                           GtkWidget* widget)
{
	GtkMenu* menu = NULL;
	GtkMenu* _tmp0_;
	GtkMenuItem* mi = NULL;
	GtkImage* image = NULL;
	GtkMenu* _tmp1_;
	XnpApplication* _tmp2_;
	GSList* _tmp3_;
	GtkMenu* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenu* _tmp46_;
	GtkMenu* _tmp47_;
#line 906 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 906 "../lib/window.vala"
	g_return_if_fail (widget != NULL);
#line 907 "../lib/window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_menu_get_type ()) ? ((GtkMenu*) widget) : NULL);
#line 907 "../lib/window.vala"
	menu = _tmp0_;
#line 911 "../lib/window.vala"
	_tmp1_ = menu;
#line 911 "../lib/window.vala"
	gtk_container_foreach ((GtkContainer*) _tmp1_, ___lambda21__gtk_callback, self);
#line 915 "../lib/window.vala"
	_tmp2_ = self->priv->app;
#line 915 "../lib/window.vala"
	_tmp3_ = xnp_application_get_window_list (_tmp2_);
#line 4264 "window.c"
	{
		GSList* win_collection = NULL;
		GSList* win_it = NULL;
#line 915 "../lib/window.vala"
		win_collection = _tmp3_;
#line 915 "../lib/window.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 4272 "window.c"
			XnpWindow* _tmp4_;
			XnpWindow* win = NULL;
#line 915 "../lib/window.vala"
			_tmp4_ = _g_object_ref0 ((XnpWindow*) win_it->data);
#line 915 "../lib/window.vala"
			win = _tmp4_;
#line 4279 "window.c"
			{
				XnpWindow* _tmp5_;
#line 916 "../lib/window.vala"
				_tmp5_ = win;
#line 916 "../lib/window.vala"
				if (_tmp5_ == self) {
#line 4286 "window.c"
					XnpWindow* _tmp6_;
					const gchar* _tmp7_;
					GtkMenuItem* _tmp8_;
					GtkMenuItem* _tmp9_;
					GtkMenu* _tmp10_;
					GtkMenuItem* _tmp11_;
					XnpNote* current_note = NULL;
					XnpNote* _tmp12_;
					XnpNote* _tmp13_;
					XnpNote* _tmp14_;
					gint n_pages = 0;
					gint _tmp15_;
					gint _tmp16_;
					GtkMenu* _tmp34_;
#line 917 "../lib/window.vala"
					_tmp6_ = win;
#line 917 "../lib/window.vala"
					_tmp7_ = _tmp6_->priv->_name;
#line 917 "../lib/window.vala"
					_tmp8_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp7_);
#line 917 "../lib/window.vala"
					g_object_ref_sink (_tmp8_);
#line 917 "../lib/window.vala"
					_g_object_unref0 (mi);
#line 917 "../lib/window.vala"
					mi = _tmp8_;
#line 918 "../lib/window.vala"
					_tmp9_ = mi;
#line 918 "../lib/window.vala"
					gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 919 "../lib/window.vala"
					_tmp10_ = menu;
#line 919 "../lib/window.vala"
					_tmp11_ = mi;
#line 919 "../lib/window.vala"
					gtk_menu_shell_insert ((GtkMenuShell*) _tmp10_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp11_) : NULL, -1);
#line 921 "../lib/window.vala"
					_tmp12_ = xnp_window_get_current_note (self);
#line 921 "../lib/window.vala"
					_tmp13_ = _tmp12_;
#line 921 "../lib/window.vala"
					_tmp14_ = _g_object_ref0 (_tmp13_);
#line 921 "../lib/window.vala"
					current_note = _tmp14_;
#line 922 "../lib/window.vala"
					_tmp15_ = xnp_window_get_n_pages (self);
#line 922 "../lib/window.vala"
					_tmp16_ = _tmp15_;
#line 922 "../lib/window.vala"
					n_pages = _tmp16_;
#line 4337 "window.c"
					{
						gint p = 0;
#line 924 "../lib/window.vala"
						p = 0;
#line 4342 "window.c"
						{
							gboolean _tmp17_ = FALSE;
#line 924 "../lib/window.vala"
							_tmp17_ = TRUE;
#line 924 "../lib/window.vala"
							while (TRUE) {
#line 4349 "window.c"
								XnpNote* note = NULL;
								XnpNote* _tmp19_;
								XnpNote* _tmp20_;
								const gchar* _tmp21_;
								const gchar* _tmp22_;
								GtkImageMenuItem* _tmp23_;
								XnpNote* _tmp24_;
								XnpNote* _tmp25_;
								GtkMenuItem* _tmp29_;
								void* _tmp30_;
								GtkMenuItem* _tmp31_;
								GtkMenu* _tmp32_;
								GtkMenuItem* _tmp33_;
#line 924 "../lib/window.vala"
								if (!_tmp17_) {
#line 4365 "window.c"
									gint _tmp18_;
#line 924 "../lib/window.vala"
									_tmp18_ = p;
#line 924 "../lib/window.vala"
									p = _tmp18_ + 1;
#line 4371 "window.c"
								}
#line 924 "../lib/window.vala"
								_tmp17_ = FALSE;
#line 924 "../lib/window.vala"
								if (!(p < n_pages)) {
#line 924 "../lib/window.vala"
									break;
#line 4379 "window.c"
								}
#line 925 "../lib/window.vala"
								_tmp19_ = xnp_window_get_note (self, p);
#line 925 "../lib/window.vala"
								note = _tmp19_;
#line 926 "../lib/window.vala"
								_tmp20_ = note;
#line 926 "../lib/window.vala"
								_tmp21_ = xnp_note_get_name (_tmp20_);
#line 926 "../lib/window.vala"
								_tmp22_ = _tmp21_;
#line 926 "../lib/window.vala"
								_tmp23_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_label (_tmp22_);
#line 926 "../lib/window.vala"
								g_object_ref_sink (_tmp23_);
#line 926 "../lib/window.vala"
								_g_object_unref0 (mi);
#line 926 "../lib/window.vala"
								mi = (GtkMenuItem*) _tmp23_;
#line 927 "../lib/window.vala"
								_tmp24_ = note;
#line 927 "../lib/window.vala"
								_tmp25_ = current_note;
#line 927 "../lib/window.vala"
								if (_tmp24_ == _tmp25_) {
#line 4405 "window.c"
									GtkImage* _tmp26_;
									GtkMenuItem* _tmp27_;
									GtkImage* _tmp28_;
#line 928 "../lib/window.vala"
									_tmp26_ = (GtkImage*) gtk_image_new_from_icon_name ("gtk-go-forward", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 928 "../lib/window.vala"
									g_object_ref_sink (_tmp26_);
#line 928 "../lib/window.vala"
									_g_object_unref0 (image);
#line 928 "../lib/window.vala"
									image = _tmp26_;
#line 929 "../lib/window.vala"
									_tmp27_ = mi;
#line 929 "../lib/window.vala"
									_tmp28_ = image;
#line 929 "../lib/window.vala"
									gtk_image_menu_item_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_image_menu_item_get_type (), GtkImageMenuItem), (GtkWidget*) _tmp28_);
#line 4423 "window.c"
								}
#line 931 "../lib/window.vala"
								_tmp29_ = mi;
#line 931 "../lib/window.vala"
								_tmp30_ = GINT_TO_POINTER (p);
#line 931 "../lib/window.vala"
								g_object_set_data_full ((GObject*) _tmp29_, "page", _tmp30_, NULL);
#line 932 "../lib/window.vala"
								_tmp31_ = mi;
#line 932 "../lib/window.vala"
								g_signal_connect_object (_tmp31_, "activate", (GCallback) _________lambda22__gtk_menu_item_activate, self, 0);
#line 935 "../lib/window.vala"
								_tmp32_ = menu;
#line 935 "../lib/window.vala"
								_tmp33_ = mi;
#line 935 "../lib/window.vala"
								gtk_menu_shell_insert ((GtkMenuShell*) _tmp32_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp33_) : NULL, -1);
#line 924 "../lib/window.vala"
								_g_object_unref0 (note);
#line 4443 "window.c"
							}
						}
					}
#line 938 "../lib/window.vala"
					_tmp34_ = menu;
#line 938 "../lib/window.vala"
					xnp_window_menu_add_separator (self, _tmp34_);
#line 916 "../lib/window.vala"
					_g_object_unref0 (current_note);
#line 4453 "window.c"
				} else {
					XnpWindow* _tmp35_;
					const gchar* _tmp36_;
					GtkMenuItem* _tmp37_;
					GtkMenuItem* _tmp38_;
					XnpWindow* _tmp39_;
					GtkMenuItem* _tmp40_;
					GtkMenu* _tmp41_;
					GtkMenuItem* _tmp42_;
					GtkMenu* _tmp43_;
#line 941 "../lib/window.vala"
					_tmp35_ = win;
#line 941 "../lib/window.vala"
					_tmp36_ = _tmp35_->priv->_name;
#line 941 "../lib/window.vala"
					_tmp37_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp36_);
#line 941 "../lib/window.vala"
					g_object_ref_sink (_tmp37_);
#line 941 "../lib/window.vala"
					_g_object_unref0 (mi);
#line 941 "../lib/window.vala"
					mi = _tmp37_;
#line 942 "../lib/window.vala"
					_tmp38_ = mi;
#line 942 "../lib/window.vala"
					_tmp39_ = win;
#line 942 "../lib/window.vala"
					g_object_set_data_full ((GObject*) _tmp38_, "window", (void*) _tmp39_, NULL);
#line 943 "../lib/window.vala"
					_tmp40_ = mi;
#line 943 "../lib/window.vala"
					g_signal_connect_object (_tmp40_, "activate", (GCallback) ______lambda23__gtk_menu_item_activate, self, 0);
#line 947 "../lib/window.vala"
					_tmp41_ = menu;
#line 947 "../lib/window.vala"
					_tmp42_ = mi;
#line 947 "../lib/window.vala"
					gtk_menu_shell_insert ((GtkMenuShell*) _tmp41_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp42_) : NULL, -1);
#line 949 "../lib/window.vala"
					_tmp43_ = menu;
#line 949 "../lib/window.vala"
					xnp_window_menu_add_separator (self, _tmp43_);
#line 4496 "window.c"
				}
#line 915 "../lib/window.vala"
				_g_object_unref0 (win);
#line 4500 "window.c"
			}
		}
	}
#line 953 "../lib/window.vala"
	_tmp44_ = menu;
#line 953 "../lib/window.vala"
	xnp_window_menu_add_icon_item (self, _tmp44_, _ ("_Rename group"), "gtk-edit", "rename-window", _xnp_window_action_rename_window_xnp_window_callback, self);
#line 954 "../lib/window.vala"
	_tmp45_ = menu;
#line 954 "../lib/window.vala"
	xnp_window_menu_add_icon_item (self, _tmp45_, _ ("_Delete group"), "gtk-remove", "delete-window", _xnp_window_action_delete_window_xnp_window_callback, self);
#line 955 "../lib/window.vala"
	_tmp46_ = menu;
#line 955 "../lib/window.vala"
	xnp_window_menu_add_icon_item (self, _tmp46_, _ ("_Add a new group"), "gtk-add", "new-window", _xnp_window_action_new_window_xnp_window_callback, self);
#line 957 "../lib/window.vala"
	_tmp47_ = menu;
#line 957 "../lib/window.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp47_);
#line 906 "../lib/window.vala"
	_g_object_unref0 (image);
#line 906 "../lib/window.vala"
	_g_object_unref0 (mi);
#line 906 "../lib/window.vala"
	_g_object_unref0 (menu);
#line 4526 "window.c"
}

/**
 * get_geometry:
 *
 * Returns the X,Y position and width/height.
 */
void
xnp_window_get_geometry (XnpWindow* self,
                         gint* winx,
                         gint* winy,
                         gint* width,
                         gint* height)
{
	gint _vala_winx = 0;
	gint _vala_winy = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	GtkBox* _tmp0_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
#line 965 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 967 "../lib/window.vala"
	_tmp0_ = self->priv->content_box;
#line 967 "../lib/window.vala"
	if (!gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 4554 "window.c"
		gint _tmp1_ = 0;
#line 968 "../lib/window.vala"
		gtk_window_get_size ((GtkWindow*) self, &_tmp1_, NULL);
#line 968 "../lib/window.vala"
		self->priv->width = _tmp1_;
#line 4560 "window.c"
	} else {
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 971 "../lib/window.vala"
		gtk_window_get_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 971 "../lib/window.vala"
		self->priv->width = _tmp2_;
#line 971 "../lib/window.vala"
		self->priv->height = _tmp3_;
#line 4570 "window.c"
	}
#line 973 "../lib/window.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp4_, &_tmp5_);
#line 973 "../lib/window.vala"
	_vala_winx = _tmp4_;
#line 973 "../lib/window.vala"
	_vala_winy = _tmp5_;
#line 974 "../lib/window.vala"
	_vala_width = self->priv->width;
#line 975 "../lib/window.vala"
	_vala_height = self->priv->height;
#line 965 "../lib/window.vala"
	if (winx) {
#line 965 "../lib/window.vala"
		*winx = _vala_winx;
#line 4586 "window.c"
	}
#line 965 "../lib/window.vala"
	if (winy) {
#line 965 "../lib/window.vala"
		*winy = _vala_winy;
#line 4592 "window.c"
	}
#line 965 "../lib/window.vala"
	if (width) {
#line 965 "../lib/window.vala"
		*width = _vala_width;
#line 4598 "window.c"
	}
#line 965 "../lib/window.vala"
	if (height) {
#line 965 "../lib/window.vala"
		*height = _vala_height;
#line 4604 "window.c"
	}
}

/**
 * compare_func:
 *
 * Compare function for the window name to use with GLib.CompareFunc delegates.
 */
gint
xnp_window_compare_func (XnpWindow* self,
                         XnpWindow* win2)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint result;
#line 983 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 983 "../lib/window.vala"
	g_return_val_if_fail (win2 != NULL, 0);
#line 984 "../lib/window.vala"
	_tmp0_ = self->priv->_name;
#line 984 "../lib/window.vala"
	_tmp1_ = win2->priv->_name;
#line 984 "../lib/window.vala"
	result = g_utf8_collate (_tmp0_, _tmp1_);
#line 984 "../lib/window.vala"
	return result;
#line 4632 "window.c"
}

/**
 * get_current_page:
 *
 * Get the current page in the notebook.
 */
gint
xnp_window_get_current_page (XnpWindow* self)
{
	GtkNotebook* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 992 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 993 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 993 "../lib/window.vala"
	g_object_get (_tmp0_, "page", &_tmp1_, NULL);
#line 993 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 993 "../lib/window.vala"
	result = _tmp2_;
#line 993 "../lib/window.vala"
	return result;
#line 4659 "window.c"
}

/**
 * set_current_page:
 *
 * Set the current page in the notebook.
 */
void
xnp_window_set_current_page (XnpWindow* self,
                             gint page)
{
	GtkNotebook* _tmp0_;
#line 1001 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1002 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 1002 "../lib/window.vala"
	g_object_set (_tmp0_, "page", page, NULL);
#line 4678 "window.c"
}

/**
 * shade:
 *
 * Shade the window (roll up) to show only the title bar.
 */
static void
xnp_window_shade (XnpWindow* self)
{
	GtkBox* _tmp0_;
#line 1014 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1015 "../lib/window.vala"
	_tmp0_ = self->priv->content_box;
#line 1015 "../lib/window.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 4696 "window.c"
		GtkBox* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 1016 "../lib/window.vala"
		_tmp1_ = self->priv->content_box;
#line 1016 "../lib/window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1017 "../lib/window.vala"
		gtk_window_get_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 1017 "../lib/window.vala"
		self->priv->width = _tmp2_;
#line 1017 "../lib/window.vala"
		self->priv->height = _tmp3_;
#line 1018 "../lib/window.vala"
		gtk_window_resize ((GtkWindow*) self, self->priv->width, 1);
#line 4712 "window.c"
	}
}

/**
 * unshade:
 *
 * Unshade the window (roll down).
 */
static void
xnp_window_unshade (XnpWindow* self)
{
	GtkBox* _tmp0_;
#line 1027 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1028 "../lib/window.vala"
	_tmp0_ = self->priv->content_box;
#line 1028 "../lib/window.vala"
	if (!gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 4731 "window.c"
		GtkBox* _tmp1_;
		gint _tmp2_ = 0;
#line 1029 "../lib/window.vala"
		_tmp1_ = self->priv->content_box;
#line 1029 "../lib/window.vala"
		gtk_widget_show ((GtkWidget*) _tmp1_);
#line 1030 "../lib/window.vala"
		gtk_window_get_size ((GtkWindow*) self, &_tmp2_, NULL);
#line 1030 "../lib/window.vala"
		self->priv->width = _tmp2_;
#line 1031 "../lib/window.vala"
		gtk_window_resize ((GtkWindow*) self, self->priv->width, self->priv->height);
#line 4744 "window.c"
	}
}

/**
 * update_title:
 *
 * Updates the window title.
 */
static void
xnp_window_update_title (XnpWindow* self,
                         const gchar* note_name)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 1040 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1040 "../lib/window.vala"
	g_return_if_fail (note_name != NULL);
#line 1041 "../lib/window.vala"
	_tmp0_ = self->priv->_name;
#line 1041 "../lib/window.vala"
	_tmp1_ = g_strconcat (_tmp0_, " - ", NULL);
#line 1041 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 1041 "../lib/window.vala"
	_tmp3_ = g_strconcat (_tmp2_, note_name, NULL);
#line 1041 "../lib/window.vala"
	_tmp4_ = _tmp3_;
#line 1041 "../lib/window.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp4_);
#line 1041 "../lib/window.vala"
	_g_free0 (_tmp4_);
#line 1041 "../lib/window.vala"
	_g_free0 (_tmp2_);
#line 4782 "window.c"
}

/**
 * update_navigation_sensitivity:
 *
 * Update the goleft/right sensitivities.
 */
static void
xnp_window_update_navigation_sensitivity (XnpWindow* self,
                                          gint page_num)
{
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 1049 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1050 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 1050 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1050 "../lib/window.vala"
	n_pages = _tmp1_;
#line 1051 "../lib/window.vala"
	if (n_pages <= 1) {
#line 4807 "window.c"
		XnpTitleBarButton* _tmp2_;
		XnpTitleBarButton* _tmp3_;
#line 1052 "../lib/window.vala"
		_tmp2_ = self->priv->left_arrow_button;
#line 1052 "../lib/window.vala"
		xnp_icon_button_set_enabled ((XnpIconButton*) _tmp2_, FALSE);
#line 1053 "../lib/window.vala"
		_tmp3_ = self->priv->right_arrow_button;
#line 1053 "../lib/window.vala"
		xnp_icon_button_set_enabled ((XnpIconButton*) _tmp3_, FALSE);
#line 4818 "window.c"
	} else {
		XnpTitleBarButton* _tmp4_;
		XnpTitleBarButton* _tmp5_;
#line 1056 "../lib/window.vala"
		_tmp4_ = self->priv->left_arrow_button;
#line 1056 "../lib/window.vala"
		xnp_icon_button_set_enabled ((XnpIconButton*) _tmp4_, page_num > 0);
#line 1057 "../lib/window.vala"
		_tmp5_ = self->priv->right_arrow_button;
#line 1057 "../lib/window.vala"
		xnp_icon_button_set_enabled ((XnpIconButton*) _tmp5_, (page_num + 1) < n_pages);
#line 4830 "window.c"
	}
}

/**
 * popup_error:
 *
 * Show a pop-up error message.
 */
void
xnp_window_popup_error (XnpWindow* self,
                        const gchar* message)
{
	GtkMessageDialog* error_dialog = NULL;
	GtkMessageDialog* _tmp0_;
	const gchar* _tmp1_;
#line 1066 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1066 "../lib/window.vala"
	g_return_if_fail (message != NULL);
#line 1067 "../lib/window.vala"
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", message);
#line 1067 "../lib/window.vala"
	g_object_ref_sink (_tmp0_);
#line 1067 "../lib/window.vala"
	error_dialog = _tmp0_;
#line 1069 "../lib/window.vala"
	gtk_window_set_icon_name ((GtkWindow*) error_dialog, "gtk-dialog-error");
#line 1070 "../lib/window.vala"
	_tmp1_ = self->priv->_name;
#line 1070 "../lib/window.vala"
	gtk_window_set_title ((GtkWindow*) error_dialog, _tmp1_);
#line 1071 "../lib/window.vala"
	gtk_dialog_run ((GtkDialog*) error_dialog);
#line 1072 "../lib/window.vala"
	xnp_window_dialog_destroy (self, (GtkDialog*) error_dialog);
#line 1066 "../lib/window.vala"
	_g_object_unref0 (error_dialog);
#line 4868 "window.c"
}

/**
 * dialog_hide:
 *
 * Hide dialog window and stay focused.
 */
void
xnp_window_dialog_hide (XnpWindow* self,
                        GtkDialog* dialog)
{
	XnpApplication* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1080 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1080 "../lib/window.vala"
	g_return_if_fail (dialog != NULL);
#line 1081 "../lib/window.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, FALSE);
#line 1082 "../lib/window.vala"
	gtk_widget_hide ((GtkWidget*) dialog);
#line 1083 "../lib/window.vala"
	_tmp0_ = self->priv->app;
#line 1083 "../lib/window.vala"
	_tmp1_ = xnp_application_get_skip_taskbar_hint (_tmp0_);
#line 1083 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 1083 "../lib/window.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, _tmp2_);
#line 4899 "window.c"
}

/**
 * dialog_destroy:
 *
 * Destroy dialog window and stay focused.
 */
void
xnp_window_dialog_destroy (XnpWindow* self,
                           GtkDialog* dialog)
{
	XnpApplication* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1092 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1092 "../lib/window.vala"
	g_return_if_fail (dialog != NULL);
#line 1093 "../lib/window.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, FALSE);
#line 1094 "../lib/window.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 1095 "../lib/window.vala"
	_tmp0_ = self->priv->app;
#line 1095 "../lib/window.vala"
	_tmp1_ = xnp_application_get_skip_taskbar_hint (_tmp0_);
#line 1095 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 1095 "../lib/window.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, _tmp2_);
#line 4930 "window.c"
}

/**
 * get_note:
 *
 * Get note from page.
 */
static XnpNote*
xnp_window_get_note (XnpWindow* self,
                     gint p)
{
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* result;
#line 1107 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1108 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 1108 "../lib/window.vala"
	_tmp1_ = gtk_notebook_get_nth_page (_tmp0_, p);
#line 1108 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, XNP_TYPE_NOTE, XnpNote));
#line 1108 "../lib/window.vala"
	result = _tmp2_;
#line 1108 "../lib/window.vala"
	return result;
#line 4958 "window.c"
}

/**
 * rename_note:
 *
 * Rename note.
 */
void
xnp_window_rename_note (XnpWindow* self,
                        const gchar* note_name,
                        const gchar* new_name)
{
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 1116 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1116 "../lib/window.vala"
	g_return_if_fail (note_name != NULL);
#line 1116 "../lib/window.vala"
	g_return_if_fail (new_name != NULL);
#line 1117 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 1117 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1117 "../lib/window.vala"
	n_pages = _tmp1_;
#line 4986 "window.c"
	{
		gint p = 0;
#line 1118 "../lib/window.vala"
		p = 0;
#line 4991 "window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1118 "../lib/window.vala"
			_tmp2_ = TRUE;
#line 1118 "../lib/window.vala"
			while (TRUE) {
#line 4998 "window.c"
				XnpNote* note = NULL;
				XnpNote* _tmp4_;
				XnpNote* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1118 "../lib/window.vala"
				if (!_tmp2_) {
#line 5006 "window.c"
					gint _tmp3_;
#line 1118 "../lib/window.vala"
					_tmp3_ = p;
#line 1118 "../lib/window.vala"
					p = _tmp3_ + 1;
#line 5012 "window.c"
				}
#line 1118 "../lib/window.vala"
				_tmp2_ = FALSE;
#line 1118 "../lib/window.vala"
				if (!(p < n_pages)) {
#line 1118 "../lib/window.vala"
					break;
#line 5020 "window.c"
				}
#line 1119 "../lib/window.vala"
				_tmp4_ = xnp_window_get_note (self, p);
#line 1119 "../lib/window.vala"
				note = _tmp4_;
#line 1120 "../lib/window.vala"
				_tmp5_ = note;
#line 1120 "../lib/window.vala"
				_tmp6_ = xnp_note_get_name (_tmp5_);
#line 1120 "../lib/window.vala"
				_tmp7_ = _tmp6_;
#line 1120 "../lib/window.vala"
				if (g_strcmp0 (_tmp7_, note_name) == 0) {
#line 5034 "window.c"
					XnpNote* _tmp8_;
#line 1121 "../lib/window.vala"
					_tmp8_ = note;
#line 1121 "../lib/window.vala"
					xnp_note_set_name (_tmp8_, new_name);
#line 1122 "../lib/window.vala"
					_g_object_unref0 (note);
#line 1122 "../lib/window.vala"
					break;
#line 5044 "window.c"
				}
#line 1118 "../lib/window.vala"
				_g_object_unref0 (note);
#line 5048 "window.c"
			}
		}
	}
}

/**
 * insert_note:
 *
 * Create a new note and insert it inside the notebook after
 * the current position or after the last note in case of
 * external event.
 */
XnpNote*
xnp_window_insert_note (XnpWindow* self,
                        const gchar* name)
{
	gchar* note_name = NULL;
	gchar* _tmp0_;
	XnpNote* note = NULL;
	const gchar* _tmp10_;
	XnpNote* _tmp11_;
	XnpNote* _tmp12_;
	XnpNote* _tmp13_;
	XnpNote* _tmp14_;
	GtkEventBox* tab_evbox = NULL;
	GtkEventBox* _tmp15_;
	GtkEventBox* _tmp16_;
	GtkLabel* label = NULL;
	const gchar* _tmp17_;
	GtkLabel* _tmp18_;
	GtkEventBox* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	XnpNote* _tmp22_;
	GtkEventBox* _tmp23_;
	gint _tmp24_ = 0;
	XnpApplication* _tmp25_;
	gint pos = 0;
	GtkNotebook* _tmp31_;
	XnpNote* _tmp32_;
	GtkEventBox* _tmp33_;
	GtkNotebook* _tmp34_;
	XnpNote* _tmp35_;
	GtkNotebook* _tmp36_;
	XnpNote* _tmp37_;
	XnpNote* result;
#line 1134 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1135 "../lib/window.vala"
	_tmp0_ = g_strdup ("");
#line 1135 "../lib/window.vala"
	note_name = _tmp0_;
#line 1137 "../lib/window.vala"
	if (name == NULL) {
#line 5103 "window.c"
		gint len = 0;
		gint _tmp1_;
		gint _tmp2_;
#line 1138 "../lib/window.vala"
		_tmp1_ = xnp_window_get_n_pages (self);
#line 1138 "../lib/window.vala"
		_tmp2_ = _tmp1_;
#line 1138 "../lib/window.vala"
		len = _tmp2_;
#line 5113 "window.c"
		{
			gint i = 0;
#line 1139 "../lib/window.vala"
			i = 1;
#line 5118 "window.c"
			{
				gboolean _tmp3_ = FALSE;
#line 1139 "../lib/window.vala"
				_tmp3_ = TRUE;
#line 1139 "../lib/window.vala"
				while (TRUE) {
#line 5125 "window.c"
					gchar* _tmp5_;
					gboolean _tmp6_ = FALSE;
					const gchar* _tmp7_;
#line 1139 "../lib/window.vala"
					if (!_tmp3_) {
#line 5131 "window.c"
						gint _tmp4_;
#line 1139 "../lib/window.vala"
						_tmp4_ = i;
#line 1139 "../lib/window.vala"
						i = _tmp4_ + 1;
#line 5137 "window.c"
					}
#line 1139 "../lib/window.vala"
					_tmp3_ = FALSE;
#line 1139 "../lib/window.vala"
					if (!(i <= (len + 1))) {
#line 1139 "../lib/window.vala"
						break;
#line 5145 "window.c"
					}
#line 1140 "../lib/window.vala"
					_tmp5_ = g_strdup_printf (_ ("Note %d"), i);
#line 1140 "../lib/window.vala"
					_g_free0 (note_name);
#line 1140 "../lib/window.vala"
					note_name = _tmp5_;
#line 1141 "../lib/window.vala"
					_tmp7_ = note_name;
#line 1141 "../lib/window.vala"
					if (!xnp_window_note_name_exists (self, _tmp7_)) {
#line 5157 "window.c"
						const gchar* _tmp8_;
#line 1141 "../lib/window.vala"
						_tmp8_ = note_name;
#line 1141 "../lib/window.vala"
						_tmp6_ = !xnp_window_note_file_exists (self, _tmp8_);
#line 5163 "window.c"
					} else {
#line 1141 "../lib/window.vala"
						_tmp6_ = FALSE;
#line 5167 "window.c"
					}
#line 1141 "../lib/window.vala"
					if (_tmp6_) {
#line 1142 "../lib/window.vala"
						break;
#line 5173 "window.c"
					}
				}
			}
		}
	} else {
		gchar* _tmp9_;
#line 1146 "../lib/window.vala"
		_tmp9_ = g_strdup (name);
#line 1146 "../lib/window.vala"
		_g_free0 (note_name);
#line 1146 "../lib/window.vala"
		note_name = _tmp9_;
#line 5186 "window.c"
	}
#line 1149 "../lib/window.vala"
	_tmp10_ = note_name;
#line 1149 "../lib/window.vala"
	_tmp11_ = xnp_note_new (_tmp10_);
#line 1149 "../lib/window.vala"
	g_object_ref_sink (_tmp11_);
#line 1149 "../lib/window.vala"
	note = _tmp11_;
#line 1150 "../lib/window.vala"
	_tmp12_ = note;
#line 1150 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_NOTE_INSERTED_SIGNAL], 0, _tmp12_);
#line 1151 "../lib/window.vala"
	_tmp13_ = note;
#line 1151 "../lib/window.vala"
	if (!_tmp13_->backed) {
#line 1152 "../lib/window.vala"
		result = note;
#line 1152 "../lib/window.vala"
		_g_free0 (note_name);
#line 1152 "../lib/window.vala"
		return result;
#line 5210 "window.c"
	}
#line 1155 "../lib/window.vala"
	_tmp14_ = note;
#line 1155 "../lib/window.vala"
	gtk_widget_show ((GtkWidget*) _tmp14_);
#line 1156 "../lib/window.vala"
	_tmp15_ = (GtkEventBox*) gtk_event_box_new ();
#line 1156 "../lib/window.vala"
	g_object_ref_sink (_tmp15_);
#line 1156 "../lib/window.vala"
	tab_evbox = _tmp15_;
#line 1157 "../lib/window.vala"
	_tmp16_ = tab_evbox;
#line 1157 "../lib/window.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp16_, (gint) (GDK_POINTER_MOTION_MASK | GDK_SCROLL_MASK));
#line 1158 "../lib/window.vala"
	_tmp17_ = note_name;
#line 1158 "../lib/window.vala"
	_tmp18_ = (GtkLabel*) gtk_label_new (_tmp17_);
#line 1158 "../lib/window.vala"
	g_object_ref_sink (_tmp18_);
#line 1158 "../lib/window.vala"
	label = _tmp18_;
#line 1159 "../lib/window.vala"
	_tmp19_ = tab_evbox;
#line 1159 "../lib/window.vala"
	_tmp20_ = label;
#line 1159 "../lib/window.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 1160 "../lib/window.vala"
	_tmp21_ = label;
#line 1160 "../lib/window.vala"
	gtk_widget_show ((GtkWidget*) _tmp21_);
#line 1161 "../lib/window.vala"
	_tmp22_ = note;
#line 1161 "../lib/window.vala"
	_tmp23_ = tab_evbox;
#line 1161 "../lib/window.vala"
	xnp_window_connect_note_signals (self, _tmp22_, _tmp23_);
#line 1162 "../lib/window.vala"
	_tmp25_ = self->priv->app;
#line 1162 "../lib/window.vala"
	if (_tmp25_->external_event) {
#line 5254 "window.c"
		gint _tmp26_;
		gint _tmp27_;
#line 1162 "../lib/window.vala"
		_tmp26_ = xnp_window_get_n_pages (self);
#line 1162 "../lib/window.vala"
		_tmp27_ = _tmp26_;
#line 1162 "../lib/window.vala"
		_tmp24_ = _tmp27_;
#line 5263 "window.c"
	} else {
		GtkNotebook* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 1162 "../lib/window.vala"
		_tmp28_ = self->priv->notebook;
#line 1162 "../lib/window.vala"
		g_object_get (_tmp28_, "page", &_tmp29_, NULL);
#line 1162 "../lib/window.vala"
		_tmp30_ = _tmp29_;
#line 1162 "../lib/window.vala"
		_tmp24_ = _tmp30_ + 1;
#line 5276 "window.c"
	}
#line 1162 "../lib/window.vala"
	pos = _tmp24_;
#line 1163 "../lib/window.vala"
	_tmp31_ = self->priv->notebook;
#line 1163 "../lib/window.vala"
	_tmp32_ = note;
#line 1163 "../lib/window.vala"
	_tmp33_ = tab_evbox;
#line 1163 "../lib/window.vala"
	gtk_notebook_insert_page (_tmp31_, (GtkWidget*) _tmp32_, (GtkWidget*) _tmp33_, pos);
#line 1164 "../lib/window.vala"
	_tmp34_ = self->priv->notebook;
#line 1164 "../lib/window.vala"
	_tmp35_ = note;
#line 1164 "../lib/window.vala"
	gtk_notebook_set_tab_reorderable (_tmp34_, (GtkWidget*) _tmp35_, TRUE);
#line 1165 "../lib/window.vala"
	_tmp36_ = self->priv->notebook;
#line 1165 "../lib/window.vala"
	_tmp37_ = note;
#line 1165 "../lib/window.vala"
	gtk_notebook_set_tab_detachable (_tmp36_, (GtkWidget*) _tmp37_, TRUE);
#line 1166 "../lib/window.vala"
	_xnp_window_notebook_update_tabs_angle (self);
#line 1167 "../lib/window.vala"
	result = note;
#line 1167 "../lib/window.vala"
	_g_object_unref0 (label);
#line 1167 "../lib/window.vala"
	_g_object_unref0 (tab_evbox);
#line 1167 "../lib/window.vala"
	_g_free0 (note_name);
#line 1167 "../lib/window.vala"
	return result;
#line 5312 "window.c"
}

/**
 * connect_note_signals:
 *
 * Connect note signals.
 */
static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 1175 "../lib/window.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 1175 "../lib/window.vala"
	return _data12_;
#line 5327 "window.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 1175 "../lib/window.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 5337 "window.c"
		XnpWindow* self;
#line 1175 "../lib/window.vala"
		self = _data12_->self;
#line 1175 "../lib/window.vala"
		_g_object_unref0 (_data12_->note);
#line 1175 "../lib/window.vala"
		_g_object_unref0 (self);
#line 1175 "../lib/window.vala"
		g_slice_free (Block12Data, _data12_);
#line 5347 "window.c"
	}
}

static void
_xnp_window_note_notify_name_cb_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 1176 "../lib/window.vala"
	xnp_window_note_notify_name_cb ((XnpWindow*) self, _sender, pspec);
#line 5358 "window.c"
}

static void
__lambda19_ (XnpWindow* self,
             XnpNote* note)
{
#line 1177 "../lib/window.vala"
	g_return_if_fail (note != NULL);
#line 1178 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_SAVE_DATA_SIGNAL], 0, note);
#line 5369 "window.c"
}

static void
___lambda19__xnp_note_save_data (XnpNote* _sender,
                                 gpointer self)
{
#line 1177 "../lib/window.vala"
	__lambda19_ ((XnpWindow*) self, _sender);
#line 5378 "window.c"
}

static gboolean
__lambda20_ (Block12Data* _data12_,
             GdkEventButton* e)
{
	XnpWindow* self;
	gboolean result;
#line 1180 "../lib/window.vala"
	self = _data12_->self;
#line 1180 "../lib/window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 1181 "../lib/window.vala"
	result = xnp_window_tab_evbox_pressed_cb (self, e, _data12_->note);
#line 1181 "../lib/window.vala"
	return result;
#line 5395 "window.c"
}

static gboolean
___lambda20__gtk_widget_button_press_event (GtkWidget* _sender,
                                            GdkEventButton* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda20_ (self, event);
#line 1180 "../lib/window.vala"
	return result;
#line 5407 "window.c"
}

void
xnp_window_connect_note_signals (XnpWindow* self,
                                 XnpNote* note,
                                 GtkEventBox* tab_evbox)
{
	Block12Data* _data12_;
	XnpNote* _tmp0_;
	gulong _tmp1_;
	gulong _tmp2_;
#line 1175 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1175 "../lib/window.vala"
	g_return_if_fail (note != NULL);
#line 1175 "../lib/window.vala"
	g_return_if_fail (tab_evbox != NULL);
#line 1175 "../lib/window.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 1175 "../lib/window.vala"
	_data12_->_ref_count_ = 1;
#line 1175 "../lib/window.vala"
	_data12_->self = g_object_ref (self);
#line 1175 "../lib/window.vala"
	_tmp0_ = _g_object_ref0 (note);
#line 1175 "../lib/window.vala"
	_g_object_unref0 (_data12_->note);
#line 1175 "../lib/window.vala"
	_data12_->note = _tmp0_;
#line 1176 "../lib/window.vala"
	g_signal_connect_object ((GObject*) _data12_->note, "notify::name", (GCallback) _xnp_window_note_notify_name_cb_g_object_notify, self, 0);
#line 1177 "../lib/window.vala"
	_tmp1_ = g_signal_connect_object (_data12_->note, "save-data", (GCallback) ___lambda19__xnp_note_save_data, self, 0);
#line 1177 "../lib/window.vala"
	_data12_->note->save_handler_id = _tmp1_;
#line 1180 "../lib/window.vala"
	_tmp2_ = g_signal_connect_data ((GtkWidget*) tab_evbox, "button-press-event", (GCallback) ___lambda20__gtk_widget_button_press_event, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 1180 "../lib/window.vala"
	_data12_->note->tab_handler_id = _tmp2_;
#line 1175 "../lib/window.vala"
	block12_data_unref (_data12_);
#line 1175 "../lib/window.vala"
	_data12_ = NULL;
#line 5451 "window.c"
}

/**
 * disconnect_note_signals:
 *
 * Disconnect note signals.
 */
void
xnp_window_disconnect_note_signals (XnpWindow* self,
                                    XnpNote* note,
                                    GtkEventBox* tab_evbox)
{
	guint _tmp0_;
	GQuark _tmp1_;
#line 1190 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1190 "../lib/window.vala"
	g_return_if_fail (note != NULL);
#line 1190 "../lib/window.vala"
	g_return_if_fail (tab_evbox != NULL);
#line 1191 "../lib/window.vala"
	g_signal_parse_name ("notify::name", G_TYPE_OBJECT, &_tmp0_, &_tmp1_, TRUE);
#line 1191 "../lib/window.vala"
	g_signal_handlers_disconnect_matched ((GObject*) note, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, _tmp1_, NULL, (GCallback) _xnp_window_note_notify_name_cb_g_object_notify, self);
#line 1192 "../lib/window.vala"
	g_signal_handler_disconnect ((GObject*) tab_evbox, note->tab_handler_id);
#line 1193 "../lib/window.vala"
	g_signal_handler_disconnect ((GObject*) note, note->save_handler_id);
#line 5480 "window.c"
}

/**
 * move_note:
 *
 * Moves the note named @note_name to position @page.
 */
void
xnp_window_move_note (XnpWindow* self,
                      const gchar* note_name,
                      gint page)
{
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 1201 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1201 "../lib/window.vala"
	g_return_if_fail (note_name != NULL);
#line 1202 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 1202 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1202 "../lib/window.vala"
	n_pages = _tmp1_;
#line 5506 "window.c"
	{
		gint p = 0;
#line 1203 "../lib/window.vala"
		p = 0;
#line 5511 "window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1203 "../lib/window.vala"
			_tmp2_ = TRUE;
#line 1203 "../lib/window.vala"
			while (TRUE) {
#line 5518 "window.c"
				XnpNote* note = NULL;
				XnpNote* _tmp4_;
				XnpNote* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1203 "../lib/window.vala"
				if (!_tmp2_) {
#line 5526 "window.c"
					gint _tmp3_;
#line 1203 "../lib/window.vala"
					_tmp3_ = p;
#line 1203 "../lib/window.vala"
					p = _tmp3_ + 1;
#line 5532 "window.c"
				}
#line 1203 "../lib/window.vala"
				_tmp2_ = FALSE;
#line 1203 "../lib/window.vala"
				if (!(p < n_pages)) {
#line 1203 "../lib/window.vala"
					break;
#line 5540 "window.c"
				}
#line 1204 "../lib/window.vala"
				_tmp4_ = xnp_window_get_note (self, p);
#line 1204 "../lib/window.vala"
				note = _tmp4_;
#line 1205 "../lib/window.vala"
				_tmp5_ = note;
#line 1205 "../lib/window.vala"
				_tmp6_ = xnp_note_get_name (_tmp5_);
#line 1205 "../lib/window.vala"
				_tmp7_ = _tmp6_;
#line 1205 "../lib/window.vala"
				if (g_strcmp0 (_tmp7_, note_name) == 0) {
#line 5554 "window.c"
					GtkNotebook* _tmp8_;
					XnpNote* _tmp9_;
#line 1206 "../lib/window.vala"
					_tmp8_ = self->priv->notebook;
#line 1206 "../lib/window.vala"
					_tmp9_ = note;
#line 1206 "../lib/window.vala"
					gtk_notebook_reorder_child (_tmp8_, (GtkWidget*) _tmp9_, page);
#line 1207 "../lib/window.vala"
					xnp_window_update_navigation_sensitivity (self, page);
#line 1208 "../lib/window.vala"
					_g_object_unref0 (note);
#line 1208 "../lib/window.vala"
					break;
#line 5569 "window.c"
				}
#line 1203 "../lib/window.vala"
				_g_object_unref0 (note);
#line 5573 "window.c"
			}
		}
	}
}

/**
 * get_note_names:
 *
 * Returns a string list of the note names in the order they are currently displayed
 * in the notebook.
 */
static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1223 "../lib/window.vala"
	if ((*length) == (*size)) {
#line 1223 "../lib/window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1223 "../lib/window.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5597 "window.c"
	}
#line 1223 "../lib/window.vala"
	(*array)[(*length)++] = value;
#line 1223 "../lib/window.vala"
	(*array)[*length] = NULL;
#line 5603 "window.c"
}

gchar**
xnp_window_get_note_names (XnpWindow* self,
                           gint* result_length1)
{
	gchar** note_names = NULL;
	gint note_names_length1;
	gint _note_names_size_;
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** result;
#line 1219 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1220 "../lib/window.vala"
	note_names = NULL;
#line 1220 "../lib/window.vala"
	note_names_length1 = 0;
#line 1220 "../lib/window.vala"
	_note_names_size_ = note_names_length1;
#line 1221 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 1221 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1221 "../lib/window.vala"
	n_pages = _tmp1_;
#line 5633 "window.c"
	{
		gint p = 0;
#line 1222 "../lib/window.vala"
		p = 0;
#line 5638 "window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1222 "../lib/window.vala"
			_tmp2_ = TRUE;
#line 1222 "../lib/window.vala"
			while (TRUE) {
#line 5645 "window.c"
				XnpNote* _tmp4_;
				XnpNote* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
#line 1222 "../lib/window.vala"
				if (!_tmp2_) {
#line 5653 "window.c"
					gint _tmp3_;
#line 1222 "../lib/window.vala"
					_tmp3_ = p;
#line 1222 "../lib/window.vala"
					p = _tmp3_ + 1;
#line 5659 "window.c"
				}
#line 1222 "../lib/window.vala"
				_tmp2_ = FALSE;
#line 1222 "../lib/window.vala"
				if (!(p < n_pages)) {
#line 1222 "../lib/window.vala"
					break;
#line 5667 "window.c"
				}
#line 1223 "../lib/window.vala"
				_tmp4_ = xnp_window_get_note (self, p);
#line 1223 "../lib/window.vala"
				_tmp5_ = _tmp4_;
#line 1223 "../lib/window.vala"
				_tmp6_ = xnp_note_get_name (_tmp5_);
#line 1223 "../lib/window.vala"
				_tmp7_ = _tmp6_;
#line 1223 "../lib/window.vala"
				_tmp8_ = g_strdup (_tmp7_);
#line 1223 "../lib/window.vala"
				_vala_array_add8 (&note_names, &note_names_length1, &_note_names_size_, _tmp8_);
#line 1223 "../lib/window.vala"
				_g_object_unref0 (_tmp5_);
#line 5683 "window.c"
			}
		}
	}
#line 1225 "../lib/window.vala"
	_tmp9_ = note_names;
#line 1225 "../lib/window.vala"
	_tmp9__length1 = note_names_length1;
#line 1225 "../lib/window.vala"
	if (result_length1) {
#line 1225 "../lib/window.vala"
		*result_length1 = _tmp9__length1;
#line 5695 "window.c"
	}
#line 1225 "../lib/window.vala"
	result = _tmp9_;
#line 1225 "../lib/window.vala"
	return result;
#line 5701 "window.c"
}

/**
 * get_tab_evbox:
 *
 * Get tab event box for note.
 */
GtkEventBox*
xnp_window_get_tab_evbox (XnpWindow* self,
                          XnpNote* note)
{
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkEventBox* result;
#line 1233 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1233 "../lib/window.vala"
	g_return_val_if_fail (note != NULL, NULL);
#line 1234 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 1234 "../lib/window.vala"
	_tmp1_ = gtk_notebook_get_tab_label (_tmp0_, (GtkWidget*) note);
#line 1234 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_event_box_get_type ()) ? ((GtkEventBox*) _tmp1_) : NULL);
#line 1234 "../lib/window.vala"
	result = _tmp2_;
#line 1234 "../lib/window.vala"
	return result;
#line 5731 "window.c"
}

/**
 * delete_current_note:
 *
 * Delete the current note.
 */
void
xnp_window_delete_current_note (XnpWindow* self)
{
	XnpNote* note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	gint page = 0;
	GtkNotebook* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	XnpNote* _tmp6_;
	XnpNote* _tmp9_;
	XnpHypertextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	XnpNote* _tmp26_;
	XnpNote* _tmp27_;
	GtkNotebook* _tmp28_;
	GtkNotebook* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	XnpNote* _tmp32_;
	gboolean _tmp33_ = FALSE;
	GtkNotebook* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	gint _tmp42_;
	gint _tmp43_;
#line 1242 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1243 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 1243 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1243 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1243 "../lib/window.vala"
	note = _tmp2_;
#line 1244 "../lib/window.vala"
	_tmp3_ = self->priv->notebook;
#line 1244 "../lib/window.vala"
	g_object_get (_tmp3_, "page", &_tmp4_, NULL);
#line 1244 "../lib/window.vala"
	_tmp5_ = _tmp4_;
#line 1244 "../lib/window.vala"
	page = _tmp5_;
#line 1246 "../lib/window.vala"
	_tmp6_ = note;
#line 1246 "../lib/window.vala"
	if (_tmp6_ == NULL) {
#line 5790 "window.c"
		gint _tmp7_;
		gint _tmp8_;
#line 1247 "../lib/window.vala"
		_tmp7_ = xnp_window_get_n_pages (self);
#line 1247 "../lib/window.vala"
		_tmp8_ = _tmp7_;
#line 1247 "../lib/window.vala"
		if (_tmp8_ == 0) {
#line 1248 "../lib/window.vala"
			g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "delete");
#line 5801 "window.c"
		}
#line 1249 "../lib/window.vala"
		_g_object_unref0 (note);
#line 1249 "../lib/window.vala"
		return;
#line 5807 "window.c"
	}
#line 1252 "../lib/window.vala"
	_tmp9_ = note;
#line 1252 "../lib/window.vala"
	_tmp10_ = _tmp9_->text_view;
#line 1252 "../lib/window.vala"
	_tmp11_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp10_);
#line 1252 "../lib/window.vala"
	_tmp12_ = _tmp11_;
#line 1252 "../lib/window.vala"
	if (gtk_text_buffer_get_char_count (_tmp12_) > 0) {
#line 5819 "window.c"
		GtkMessageDialog* dialog = NULL;
		GtkMessageDialog* _tmp13_;
		GtkMessageDialog* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		XnpNote* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GtkMessageDialog* _tmp23_;
		gint res = 0;
		GtkMessageDialog* _tmp24_;
		GtkMessageDialog* _tmp25_;
#line 1253 "../lib/window.vala"
		_tmp13_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, "%s", _ ("Are you sure you want to delete this note?"));
#line 1253 "../lib/window.vala"
		g_object_ref_sink (_tmp13_);
#line 1253 "../lib/window.vala"
		dialog = _tmp13_;
#line 1255 "../lib/window.vala"
		_tmp14_ = dialog;
#line 1255 "../lib/window.vala"
		_tmp15_ = self->priv->_name;
#line 1255 "../lib/window.vala"
		_tmp16_ = g_strconcat (_tmp15_, " - ", NULL);
#line 1255 "../lib/window.vala"
		_tmp17_ = _tmp16_;
#line 1255 "../lib/window.vala"
		_tmp18_ = note;
#line 1255 "../lib/window.vala"
		_tmp19_ = xnp_note_get_name (_tmp18_);
#line 1255 "../lib/window.vala"
		_tmp20_ = _tmp19_;
#line 1255 "../lib/window.vala"
		_tmp21_ = g_strconcat (_tmp17_, _tmp20_, NULL);
#line 1255 "../lib/window.vala"
		_tmp22_ = _tmp21_;
#line 1255 "../lib/window.vala"
		gtk_window_set_title ((GtkWindow*) _tmp14_, _tmp22_);
#line 1255 "../lib/window.vala"
		_g_free0 (_tmp22_);
#line 1255 "../lib/window.vala"
		_g_free0 (_tmp17_);
#line 1256 "../lib/window.vala"
		_tmp23_ = dialog;
#line 1256 "../lib/window.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp23_, "gtk-delete");
#line 1257 "../lib/window.vala"
		_tmp24_ = dialog;
#line 1257 "../lib/window.vala"
		res = gtk_dialog_run ((GtkDialog*) _tmp24_);
#line 1258 "../lib/window.vala"
		_tmp25_ = dialog;
#line 1258 "../lib/window.vala"
		xnp_window_dialog_destroy (self, (GtkDialog*) _tmp25_);
#line 1259 "../lib/window.vala"
		if (res != ((gint) GTK_RESPONSE_YES)) {
#line 1260 "../lib/window.vala"
			_g_object_unref0 (dialog);
#line 1260 "../lib/window.vala"
			_g_object_unref0 (note);
#line 1260 "../lib/window.vala"
			return;
#line 5885 "window.c"
		}
#line 1252 "../lib/window.vala"
		_g_object_unref0 (dialog);
#line 5889 "window.c"
	}
#line 1263 "../lib/window.vala"
	_tmp26_ = note;
#line 1263 "../lib/window.vala"
	g_signal_emit (self, xnp_window_signals[XNP_WINDOW_NOTE_DELETED_SIGNAL], 0, _tmp26_);
#line 1264 "../lib/window.vala"
	_tmp27_ = note;
#line 1264 "../lib/window.vala"
	if (_tmp27_->backed) {
#line 1265 "../lib/window.vala"
		_g_object_unref0 (note);
#line 1265 "../lib/window.vala"
		return;
#line 5903 "window.c"
	}
#line 1267 "../lib/window.vala"
	_tmp28_ = self->priv->notebook;
#line 1267 "../lib/window.vala"
	_tmp29_ = self->priv->notebook;
#line 1267 "../lib/window.vala"
	g_object_get (_tmp29_, "page", &_tmp30_, NULL);
#line 1267 "../lib/window.vala"
	_tmp31_ = _tmp30_;
#line 1267 "../lib/window.vala"
	gtk_notebook_remove_page (_tmp28_, _tmp31_);
#line 1268 "../lib/window.vala"
	_tmp32_ = note;
#line 1268 "../lib/window.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp32_);
#line 1270 "../lib/window.vala"
	_tmp34_ = self->priv->notebook;
#line 1270 "../lib/window.vala"
	g_object_get (_tmp34_, "page", &_tmp35_, NULL);
#line 1270 "../lib/window.vala"
	_tmp36_ = _tmp35_;
#line 1270 "../lib/window.vala"
	if (_tmp36_ > 0) {
#line 5927 "window.c"
		gint _tmp37_;
		gint _tmp38_;
#line 1270 "../lib/window.vala"
		_tmp37_ = xnp_window_get_n_pages (self);
#line 1270 "../lib/window.vala"
		_tmp38_ = _tmp37_;
#line 1270 "../lib/window.vala"
		_tmp33_ = page != _tmp38_;
#line 5936 "window.c"
	} else {
#line 1270 "../lib/window.vala"
		_tmp33_ = FALSE;
#line 5940 "window.c"
	}
#line 1270 "../lib/window.vala"
	if (_tmp33_) {
#line 5944 "window.c"
		GtkNotebook* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
#line 1271 "../lib/window.vala"
		_tmp39_ = self->priv->notebook;
#line 1271 "../lib/window.vala"
		g_object_get (_tmp39_, "page", &_tmp40_, NULL);
#line 1271 "../lib/window.vala"
		_tmp41_ = _tmp40_;
#line 1271 "../lib/window.vala"
		g_object_set (_tmp39_, "page", _tmp41_ - 1, NULL);
#line 5956 "window.c"
	}
#line 1273 "../lib/window.vala"
	_tmp42_ = xnp_window_get_n_pages (self);
#line 1273 "../lib/window.vala"
	_tmp43_ = _tmp42_;
#line 1273 "../lib/window.vala"
	if (_tmp43_ == 0) {
#line 1274 "../lib/window.vala"
		g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "delete");
#line 5966 "window.c"
	}
#line 1242 "../lib/window.vala"
	_g_object_unref0 (note);
#line 5970 "window.c"
}

/**
 * externally_removed:
 *
 * Handle external file deletion event
 */
void
xnp_window_externally_removed (XnpWindow* self,
                               const gchar* note_name)
{
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 1282 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1282 "../lib/window.vala"
	g_return_if_fail (note_name != NULL);
#line 1283 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 1283 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1283 "../lib/window.vala"
	n_pages = _tmp1_;
#line 5995 "window.c"
	{
		gint p = 0;
#line 1284 "../lib/window.vala"
		p = 0;
#line 6000 "window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1284 "../lib/window.vala"
			_tmp2_ = TRUE;
#line 1284 "../lib/window.vala"
			while (TRUE) {
#line 6007 "window.c"
				XnpNote* note = NULL;
				XnpNote* _tmp4_;
				XnpNote* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1284 "../lib/window.vala"
				if (!_tmp2_) {
#line 6015 "window.c"
					gint _tmp3_;
#line 1284 "../lib/window.vala"
					_tmp3_ = p;
#line 1284 "../lib/window.vala"
					p = _tmp3_ + 1;
#line 6021 "window.c"
				}
#line 1284 "../lib/window.vala"
				_tmp2_ = FALSE;
#line 1284 "../lib/window.vala"
				if (!(p < n_pages)) {
#line 1284 "../lib/window.vala"
					break;
#line 6029 "window.c"
				}
#line 1285 "../lib/window.vala"
				_tmp4_ = xnp_window_get_note (self, p);
#line 1285 "../lib/window.vala"
				note = _tmp4_;
#line 1286 "../lib/window.vala"
				_tmp5_ = note;
#line 1286 "../lib/window.vala"
				_tmp6_ = xnp_note_get_name (_tmp5_);
#line 1286 "../lib/window.vala"
				_tmp7_ = _tmp6_;
#line 1286 "../lib/window.vala"
				if (g_strcmp0 (_tmp7_, note_name) == 0) {
#line 6043 "window.c"
					gboolean current_page = FALSE;
					GtkNotebook* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					GtkNotebook* _tmp11_;
					XnpNote* _tmp12_;
					gboolean _tmp13_ = FALSE;
					gboolean _tmp14_ = FALSE;
					gint _tmp23_;
					gint _tmp24_;
#line 1287 "../lib/window.vala"
					_tmp8_ = self->priv->notebook;
#line 1287 "../lib/window.vala"
					g_object_get (_tmp8_, "page", &_tmp9_, NULL);
#line 1287 "../lib/window.vala"
					_tmp10_ = _tmp9_;
#line 1287 "../lib/window.vala"
					current_page = _tmp10_ == p;
#line 1289 "../lib/window.vala"
					_tmp11_ = self->priv->notebook;
#line 1289 "../lib/window.vala"
					gtk_notebook_remove_page (_tmp11_, p);
#line 1290 "../lib/window.vala"
					_tmp12_ = note;
#line 1290 "../lib/window.vala"
					gtk_widget_destroy ((GtkWidget*) _tmp12_);
#line 1292 "../lib/window.vala"
					if (current_page) {
#line 6072 "window.c"
						GtkNotebook* _tmp15_;
						gint _tmp16_;
						gint _tmp17_;
#line 1292 "../lib/window.vala"
						_tmp15_ = self->priv->notebook;
#line 1292 "../lib/window.vala"
						g_object_get (_tmp15_, "page", &_tmp16_, NULL);
#line 1292 "../lib/window.vala"
						_tmp17_ = _tmp16_;
#line 1292 "../lib/window.vala"
						_tmp14_ = _tmp17_ > 0;
#line 6084 "window.c"
					} else {
#line 1292 "../lib/window.vala"
						_tmp14_ = FALSE;
#line 6088 "window.c"
					}
#line 1292 "../lib/window.vala"
					if (_tmp14_) {
#line 6092 "window.c"
						gint _tmp18_;
						gint _tmp19_;
#line 1292 "../lib/window.vala"
						_tmp18_ = xnp_window_get_n_pages (self);
#line 1292 "../lib/window.vala"
						_tmp19_ = _tmp18_;
#line 1292 "../lib/window.vala"
						_tmp13_ = p != _tmp19_;
#line 6101 "window.c"
					} else {
#line 1292 "../lib/window.vala"
						_tmp13_ = FALSE;
#line 6105 "window.c"
					}
#line 1292 "../lib/window.vala"
					if (_tmp13_) {
#line 6109 "window.c"
						GtkNotebook* _tmp20_;
						gint _tmp21_;
						gint _tmp22_;
#line 1293 "../lib/window.vala"
						_tmp20_ = self->priv->notebook;
#line 1293 "../lib/window.vala"
						g_object_get (_tmp20_, "page", &_tmp21_, NULL);
#line 1293 "../lib/window.vala"
						_tmp22_ = _tmp21_;
#line 1293 "../lib/window.vala"
						g_object_set (_tmp20_, "page", _tmp22_ - 1, NULL);
#line 6121 "window.c"
					}
#line 1295 "../lib/window.vala"
					_tmp23_ = xnp_window_get_n_pages (self);
#line 1295 "../lib/window.vala"
					_tmp24_ = _tmp23_;
#line 1295 "../lib/window.vala"
					if (_tmp24_ == 0) {
#line 1296 "../lib/window.vala"
						g_signal_emit (self, xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL], 0, "delete");
#line 6131 "window.c"
					}
#line 1298 "../lib/window.vala"
					_g_object_unref0 (note);
#line 1298 "../lib/window.vala"
					break;
#line 6137 "window.c"
				}
#line 1284 "../lib/window.vala"
				_g_object_unref0 (note);
#line 6141 "window.c"
			}
		}
	}
}

/**
 * rename_current_note:
 *
 * Rename the current note.
 */
void
xnp_window_rename_current_note (XnpWindow* self)
{
	XnpNote* note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
	GtkDialog* dialog = NULL;
	GtkWidget* _tmp4_;
	GtkDialog* _tmp5_;
	GtkBox* content_area = NULL;
	GtkDialog* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkDialog* _tmp9_;
	GtkDialog* _tmp10_;
	GtkDialog* _tmp11_;
	GtkDialog* _tmp12_;
	GtkBox* _tmp13_;
	GtkEntry* entry = NULL;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	XnpNote* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GtkEntry* _tmp19_;
	GtkBox* _tmp20_;
	GtkEntry* _tmp21_;
	GtkBox* _tmp22_;
	gint res = 0;
	GtkDialog* _tmp23_;
	GtkDialog* _tmp24_;
	gboolean _tmp25_ = FALSE;
	GtkDialog* _tmp45_;
#line 1308 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1309 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 1309 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1309 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1309 "../lib/window.vala"
	note = _tmp2_;
#line 1310 "../lib/window.vala"
	_tmp3_ = note;
#line 1310 "../lib/window.vala"
	if (_tmp3_ == NULL) {
#line 1311 "../lib/window.vala"
		_g_object_unref0 (note);
#line 1311 "../lib/window.vala"
		return;
#line 6205 "window.c"
	}
#line 1313 "../lib/window.vala"
	_tmp4_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 1313 "../lib/window.vala"
	_tmp5_ = (GtkDialog*) gtk_dialog_new_with_buttons (_ ("Rename note"), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_window_get_type (), GtkWindow), GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, "gtk-cancel", GTK_RESPONSE_CANCEL, "gtk-ok", GTK_RESPONSE_OK, NULL);
#line 1313 "../lib/window.vala"
	g_object_ref_sink (_tmp5_);
#line 1313 "../lib/window.vala"
	dialog = _tmp5_;
#line 1316 "../lib/window.vala"
	_tmp6_ = dialog;
#line 1316 "../lib/window.vala"
	_tmp7_ = gtk_dialog_get_content_area (_tmp6_);
#line 1316 "../lib/window.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_box_get_type (), GtkBox));
#line 1316 "../lib/window.vala"
	content_area = _tmp8_;
#line 1317 "../lib/window.vala"
	_tmp9_ = dialog;
#line 1317 "../lib/window.vala"
	gtk_dialog_set_default_response (_tmp9_, (gint) GTK_RESPONSE_OK);
#line 1318 "../lib/window.vala"
	_tmp10_ = dialog;
#line 1318 "../lib/window.vala"
	gtk_window_set_resizable ((GtkWindow*) _tmp10_, FALSE);
#line 1319 "../lib/window.vala"
	_tmp11_ = dialog;
#line 1319 "../lib/window.vala"
	gtk_window_set_icon_name ((GtkWindow*) _tmp11_, "gtk-edit");
#line 1320 "../lib/window.vala"
	_tmp12_ = dialog;
#line 1320 "../lib/window.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp12_, (guint) 4);
#line 1321 "../lib/window.vala"
	_tmp13_ = content_area;
#line 1321 "../lib/window.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp13_, (guint) 6);
#line 1323 "../lib/window.vala"
	_tmp14_ = (GtkEntry*) gtk_entry_new ();
#line 1323 "../lib/window.vala"
	g_object_ref_sink (_tmp14_);
#line 1323 "../lib/window.vala"
	entry = _tmp14_;
#line 1324 "../lib/window.vala"
	_tmp15_ = entry;
#line 1324 "../lib/window.vala"
	_tmp16_ = note;
#line 1324 "../lib/window.vala"
	_tmp17_ = xnp_note_get_name (_tmp16_);
#line 1324 "../lib/window.vala"
	_tmp18_ = _tmp17_;
#line 1324 "../lib/window.vala"
	gtk_entry_set_text (_tmp15_, _tmp18_);
#line 1325 "../lib/window.vala"
	_tmp19_ = entry;
#line 1325 "../lib/window.vala"
	gtk_entry_set_activates_default (_tmp19_, TRUE);
#line 1326 "../lib/window.vala"
	_tmp20_ = content_area;
#line 1326 "../lib/window.vala"
	_tmp21_ = entry;
#line 1326 "../lib/window.vala"
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 1327 "../lib/window.vala"
	_tmp22_ = content_area;
#line 1327 "../lib/window.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp22_);
#line 1329 "../lib/window.vala"
	_tmp23_ = dialog;
#line 1329 "../lib/window.vala"
	res = gtk_dialog_run (_tmp23_);
#line 1330 "../lib/window.vala"
	_tmp24_ = dialog;
#line 1330 "../lib/window.vala"
	xnp_window_dialog_hide (self, _tmp24_);
#line 1331 "../lib/window.vala"
	if (res == ((gint) GTK_RESPONSE_OK)) {
#line 6283 "window.c"
		GtkEntry* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		XnpNote* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
#line 1331 "../lib/window.vala"
		_tmp26_ = entry;
#line 1331 "../lib/window.vala"
		_tmp27_ = gtk_entry_get_text (_tmp26_);
#line 1331 "../lib/window.vala"
		_tmp28_ = _tmp27_;
#line 1331 "../lib/window.vala"
		_tmp29_ = note;
#line 1331 "../lib/window.vala"
		_tmp30_ = xnp_note_get_name (_tmp29_);
#line 1331 "../lib/window.vala"
		_tmp31_ = _tmp30_;
#line 1331 "../lib/window.vala"
		_tmp25_ = g_strcmp0 (_tmp28_, _tmp31_) != 0;
#line 6304 "window.c"
	} else {
#line 1331 "../lib/window.vala"
		_tmp25_ = FALSE;
#line 6308 "window.c"
	}
#line 1331 "../lib/window.vala"
	if (_tmp25_) {
#line 6312 "window.c"
		gchar* name = NULL;
		GtkEntry* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		const gchar* _tmp36_;
#line 1332 "../lib/window.vala"
		_tmp32_ = entry;
#line 1332 "../lib/window.vala"
		_tmp33_ = gtk_entry_get_text (_tmp32_);
#line 1332 "../lib/window.vala"
		_tmp34_ = _tmp33_;
#line 1332 "../lib/window.vala"
		_tmp35_ = g_strdup (_tmp34_);
#line 1332 "../lib/window.vala"
		name = _tmp35_;
#line 1333 "../lib/window.vala"
		_tmp36_ = name;
#line 1333 "../lib/window.vala"
		if (xnp_window_note_name_exists (self, _tmp36_)) {
#line 6333 "window.c"
			GtkMessageDialog* error_dialog = NULL;
			const gchar* _tmp37_;
			GtkMessageDialog* _tmp38_;
			GtkMessageDialog* _tmp39_;
			GtkMessageDialog* _tmp40_;
			GtkMessageDialog* _tmp41_;
			GtkMessageDialog* _tmp42_;
#line 1334 "../lib/window.vala"
			_tmp37_ = name;
#line 1334 "../lib/window.vala"
			_tmp38_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, _ ("The name %s is already in use"), _tmp37_);
#line 1334 "../lib/window.vala"
			g_object_ref_sink (_tmp38_);
#line 1334 "../lib/window.vala"
			error_dialog = _tmp38_;
#line 1336 "../lib/window.vala"
			_tmp39_ = error_dialog;
#line 1336 "../lib/window.vala"
			gtk_window_set_icon_name ((GtkWindow*) _tmp39_, "gtk-dialog-error");
#line 1337 "../lib/window.vala"
			_tmp40_ = error_dialog;
#line 1337 "../lib/window.vala"
			gtk_window_set_title ((GtkWindow*) _tmp40_, _ ("Error"));
#line 1338 "../lib/window.vala"
			_tmp41_ = error_dialog;
#line 1338 "../lib/window.vala"
			gtk_dialog_run ((GtkDialog*) _tmp41_);
#line 1339 "../lib/window.vala"
			_tmp42_ = error_dialog;
#line 1339 "../lib/window.vala"
			xnp_window_dialog_destroy (self, (GtkDialog*) _tmp42_);
#line 1333 "../lib/window.vala"
			_g_object_unref0 (error_dialog);
#line 6367 "window.c"
		} else {
			XnpNote* _tmp43_;
			const gchar* _tmp44_;
#line 1342 "../lib/window.vala"
			_tmp43_ = note;
#line 1342 "../lib/window.vala"
			_tmp44_ = name;
#line 1342 "../lib/window.vala"
			g_signal_emit (self, xnp_window_signals[XNP_WINDOW_NOTE_RENAMED_SIGNAL], 0, _tmp43_, _tmp44_);
#line 6377 "window.c"
		}
#line 1331 "../lib/window.vala"
		_g_free0 (name);
#line 6381 "window.c"
	}
#line 1345 "../lib/window.vala"
	_tmp45_ = dialog;
#line 1345 "../lib/window.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp45_);
#line 1308 "../lib/window.vala"
	_g_object_unref0 (entry);
#line 1308 "../lib/window.vala"
	_g_object_unref0 (content_area);
#line 1308 "../lib/window.vala"
	_g_object_unref0 (dialog);
#line 1308 "../lib/window.vala"
	_g_object_unref0 (note);
#line 6395 "window.c"
}

/**
  * find_note_by_name:
  *
  * Return note with given name or null not found.
  */
XnpNote*
xnp_window_find_note_by_name (XnpWindow* self,
                              const gchar* name)
{
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
	XnpNote* result;
#line 1353 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1353 "../lib/window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1354 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 1354 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1354 "../lib/window.vala"
	n_pages = _tmp1_;
#line 6421 "window.c"
	{
		gint p = 0;
#line 1355 "../lib/window.vala"
		p = 0;
#line 6426 "window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1355 "../lib/window.vala"
			_tmp2_ = TRUE;
#line 1355 "../lib/window.vala"
			while (TRUE) {
#line 6433 "window.c"
				XnpNote* note = NULL;
				XnpNote* _tmp4_;
				XnpNote* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1355 "../lib/window.vala"
				if (!_tmp2_) {
#line 6441 "window.c"
					gint _tmp3_;
#line 1355 "../lib/window.vala"
					_tmp3_ = p;
#line 1355 "../lib/window.vala"
					p = _tmp3_ + 1;
#line 6447 "window.c"
				}
#line 1355 "../lib/window.vala"
				_tmp2_ = FALSE;
#line 1355 "../lib/window.vala"
				if (!(p < n_pages)) {
#line 1355 "../lib/window.vala"
					break;
#line 6455 "window.c"
				}
#line 1356 "../lib/window.vala"
				_tmp4_ = xnp_window_get_note (self, p);
#line 1356 "../lib/window.vala"
				note = _tmp4_;
#line 1357 "../lib/window.vala"
				_tmp5_ = note;
#line 1357 "../lib/window.vala"
				_tmp6_ = xnp_note_get_name (_tmp5_);
#line 1357 "../lib/window.vala"
				_tmp7_ = _tmp6_;
#line 1357 "../lib/window.vala"
				if (g_strcmp0 (_tmp7_, name) == 0) {
#line 1358 "../lib/window.vala"
					result = note;
#line 1358 "../lib/window.vala"
					return result;
#line 6473 "window.c"
				}
#line 1355 "../lib/window.vala"
				_g_object_unref0 (note);
#line 6477 "window.c"
			}
		}
	}
#line 1361 "../lib/window.vala"
	result = NULL;
#line 1361 "../lib/window.vala"
	return result;
#line 6485 "window.c"
}

/**
 * note_name_exists:
 *
 * Verify if the given name already exists in the notebook.
 */
gboolean
xnp_window_note_name_exists (XnpWindow* self,
                             const gchar* name)
{
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 1369 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1369 "../lib/window.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 1370 "../lib/window.vala"
	_tmp0_ = xnp_window_find_note_by_name (self, name);
#line 1370 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1370 "../lib/window.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 1370 "../lib/window.vala"
	_g_object_unref0 (_tmp1_);
#line 1370 "../lib/window.vala"
	result = _tmp2_;
#line 1370 "../lib/window.vala"
	return result;
#line 6517 "window.c"
}

/**
 * note_file_exists:
 *
 * Verify if the file with given name exists in the notes directory.
 */
gboolean
xnp_window_note_file_exists (XnpWindow* self,
                             const gchar* file_name)
{
	gchar* path = NULL;
	XnpApplication* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean result;
#line 1378 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1378 "../lib/window.vala"
	g_return_val_if_fail (file_name != NULL, FALSE);
#line 1379 "../lib/window.vala"
	_tmp0_ = self->priv->app;
#line 1379 "../lib/window.vala"
	_tmp1_ = xnp_application_get_notes_path (_tmp0_);
#line 1379 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 1379 "../lib/window.vala"
	_tmp3_ = self->priv->_name;
#line 1379 "../lib/window.vala"
	_tmp4_ = g_file_new_build_filename (_tmp2_, _tmp3_, file_name, NULL);
#line 1379 "../lib/window.vala"
	_tmp5_ = _tmp4_;
#line 1379 "../lib/window.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 1379 "../lib/window.vala"
	_tmp7_ = _tmp6_;
#line 1379 "../lib/window.vala"
	_g_object_unref0 (_tmp5_);
#line 1379 "../lib/window.vala"
	path = _tmp7_;
#line 1380 "../lib/window.vala"
	result = xnp_file_utils_path_exists (path);
#line 1380 "../lib/window.vala"
	_g_free0 (path);
#line 1380 "../lib/window.vala"
	return result;
#line 6569 "window.c"
}

/**
 * save_notes:
 *
 * Save notes.
 */
void
xnp_window_save_notes (XnpWindow* self)
{
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 1388 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1389 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 1389 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1389 "../lib/window.vala"
	n_pages = _tmp1_;
#line 6591 "window.c"
	{
		gint p = 0;
#line 1390 "../lib/window.vala"
		p = 0;
#line 6596 "window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1390 "../lib/window.vala"
			_tmp2_ = TRUE;
#line 1390 "../lib/window.vala"
			while (TRUE) {
#line 6603 "window.c"
				XnpNote* _tmp4_;
				XnpNote* _tmp5_;
#line 1390 "../lib/window.vala"
				if (!_tmp2_) {
#line 6608 "window.c"
					gint _tmp3_;
#line 1390 "../lib/window.vala"
					_tmp3_ = p;
#line 1390 "../lib/window.vala"
					p = _tmp3_ + 1;
#line 6614 "window.c"
				}
#line 1390 "../lib/window.vala"
				_tmp2_ = FALSE;
#line 1390 "../lib/window.vala"
				if (!(p < n_pages)) {
#line 1390 "../lib/window.vala"
					break;
#line 6622 "window.c"
				}
#line 1391 "../lib/window.vala"
				_tmp4_ = xnp_window_get_note (self, p);
#line 1391 "../lib/window.vala"
				_tmp5_ = _tmp4_;
#line 1391 "../lib/window.vala"
				xnp_note_save (_tmp5_);
#line 1391 "../lib/window.vala"
				_g_object_unref0 (_tmp5_);
#line 6632 "window.c"
			}
		}
	}
}

static void
xnp_window_save_current_note (XnpWindow* self)
{
	XnpNote* note = NULL;
	XnpNote* _tmp0_;
	XnpNote* _tmp1_;
	XnpNote* _tmp2_;
	XnpNote* _tmp3_;
#line 1395 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1396 "../lib/window.vala"
	_tmp0_ = xnp_window_get_current_note (self);
#line 1396 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1396 "../lib/window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1396 "../lib/window.vala"
	note = _tmp2_;
#line 1397 "../lib/window.vala"
	_tmp3_ = note;
#line 1397 "../lib/window.vala"
	if (_tmp3_ != NULL) {
#line 6660 "window.c"
		XnpNote* _tmp4_;
#line 1398 "../lib/window.vala"
		_tmp4_ = note;
#line 1398 "../lib/window.vala"
		xnp_note_save (_tmp4_);
#line 6666 "window.c"
	}
#line 1395 "../lib/window.vala"
	_g_object_unref0 (note);
#line 6670 "window.c"
}

/**
 * _notebook_update_tabs_angle:
 *
 * Set the angle of each label in the tab.
 */
static void
_xnp_window_notebook_update_tabs_angle (XnpWindow* self)
{
	gint angle = 0;
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 1406 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 1407 "../lib/window.vala"
	angle = 0;
#line 1408 "../lib/window.vala"
	if (self->priv->_tabs_position == 2) {
#line 1409 "../lib/window.vala"
		angle = 270;
#line 6693 "window.c"
	} else {
#line 1410 "../lib/window.vala"
		if (self->priv->_tabs_position == 4) {
#line 1411 "../lib/window.vala"
			angle = 90;
#line 6699 "window.c"
		}
	}
#line 1413 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 1413 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 1413 "../lib/window.vala"
	n_pages = _tmp1_;
#line 6708 "window.c"
	{
		gint i = 0;
#line 1414 "../lib/window.vala"
		i = 0;
#line 6713 "window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1414 "../lib/window.vala"
			_tmp2_ = TRUE;
#line 1414 "../lib/window.vala"
			while (TRUE) {
#line 6720 "window.c"
				GtkEventBox* tab_evbox = NULL;
				XnpNote* _tmp4_;
				XnpNote* _tmp5_;
				GtkEventBox* _tmp6_;
				GtkEventBox* _tmp7_;
				GtkEventBox* _tmp8_;
				GtkLabel* label = NULL;
				GtkEventBox* _tmp9_;
				GtkWidget* _tmp10_;
				GtkLabel* _tmp11_;
				GtkLabel* _tmp12_;
#line 1414 "../lib/window.vala"
				if (!_tmp2_) {
#line 6734 "window.c"
					gint _tmp3_;
#line 1414 "../lib/window.vala"
					_tmp3_ = i;
#line 1414 "../lib/window.vala"
					i = _tmp3_ + 1;
#line 6740 "window.c"
				}
#line 1414 "../lib/window.vala"
				_tmp2_ = FALSE;
#line 1414 "../lib/window.vala"
				if (!(i < n_pages)) {
#line 1414 "../lib/window.vala"
					break;
#line 6748 "window.c"
				}
#line 1415 "../lib/window.vala"
				_tmp4_ = xnp_window_get_note (self, i);
#line 1415 "../lib/window.vala"
				_tmp5_ = _tmp4_;
#line 1415 "../lib/window.vala"
				_tmp6_ = xnp_window_get_tab_evbox (self, _tmp5_);
#line 1415 "../lib/window.vala"
				_tmp7_ = _tmp6_;
#line 1415 "../lib/window.vala"
				_g_object_unref0 (_tmp5_);
#line 1415 "../lib/window.vala"
				tab_evbox = _tmp7_;
#line 1416 "../lib/window.vala"
				_tmp8_ = tab_evbox;
#line 1416 "../lib/window.vala"
				if (_tmp8_ == NULL) {
#line 1417 "../lib/window.vala"
					_g_object_unref0 (tab_evbox);
#line 1417 "../lib/window.vala"
					continue;
#line 6770 "window.c"
				}
#line 1418 "../lib/window.vala"
				_tmp9_ = tab_evbox;
#line 1418 "../lib/window.vala"
				_tmp10_ = gtk_bin_get_child ((GtkBin*) _tmp9_);
#line 1418 "../lib/window.vala"
				_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp10_) : NULL);
#line 1418 "../lib/window.vala"
				label = _tmp11_;
#line 1419 "../lib/window.vala"
				_tmp12_ = label;
#line 1419 "../lib/window.vala"
				if (_tmp12_ != NULL) {
#line 6784 "window.c"
					GtkLabel* _tmp13_;
#line 1420 "../lib/window.vala"
					_tmp13_ = label;
#line 1420 "../lib/window.vala"
					gtk_label_set_angle (_tmp13_, (gdouble) angle);
#line 6790 "window.c"
				}
#line 1414 "../lib/window.vala"
				_g_object_unref0 (label);
#line 1414 "../lib/window.vala"
				_g_object_unref0 (tab_evbox);
#line 6796 "window.c"
			}
		}
	}
}

const gchar*
xnp_window_get_name (XnpWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 95 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../lib/window.vala"
	_tmp0_ = self->priv->_name;
#line 95 "../lib/window.vala"
	result = _tmp0_;
#line 95 "../lib/window.vala"
	return result;
#line 6815 "window.c"
}

void
xnp_window_set_name (XnpWindow* self,
                     const gchar* value)
{
	gchar* old_value;
#line 95 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 95 "../lib/window.vala"
	old_value = xnp_window_get_name (self);
#line 95 "../lib/window.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6829 "window.c"
		gchar* _tmp0_;
#line 95 "../lib/window.vala"
		_tmp0_ = g_strdup (value);
#line 95 "../lib/window.vala"
		_g_free0 (self->priv->_name);
#line 95 "../lib/window.vala"
		self->priv->_name = _tmp0_;
#line 95 "../lib/window.vala"
		g_object_notify_by_pspec ((GObject *) self, xnp_window_properties[XNP_WINDOW_NAME_PROPERTY]);
#line 6839 "window.c"
	}
}

XnpNote*
xnp_window_get_current_note (XnpWindow* self)
{
	XnpNote* result;
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkWidget* _tmp4_;
#line 98 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 99 "../lib/window.vala"
	_tmp1_ = self->priv->notebook;
#line 99 "../lib/window.vala"
	g_object_get (_tmp1_, "page", &_tmp2_, NULL);
#line 99 "../lib/window.vala"
	_tmp3_ = _tmp2_;
#line 99 "../lib/window.vala"
	_tmp4_ = gtk_notebook_get_nth_page (_tmp0_, _tmp3_);
#line 99 "../lib/window.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, XNP_TYPE_NOTE, XnpNote);
#line 99 "../lib/window.vala"
	return result;
#line 6868 "window.c"
}

gint
xnp_window_get_n_pages (XnpWindow* self)
{
	gint result;
	GtkNotebook* _tmp0_;
#line 104 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 105 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 105 "../lib/window.vala"
	result = gtk_notebook_get_n_pages (_tmp0_);
#line 105 "../lib/window.vala"
	return result;
#line 6884 "window.c"
}

gboolean
xnp_window_get_empty (XnpWindow* self)
{
	gboolean result;
	gint n_pages = 0;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 110 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "../lib/window.vala"
	_tmp0_ = xnp_window_get_n_pages (self);
#line 111 "../lib/window.vala"
	_tmp1_ = _tmp0_;
#line 111 "../lib/window.vala"
	n_pages = _tmp1_;
#line 112 "../lib/window.vala"
	if (n_pages == 1) {
#line 6905 "window.c"
		XnpNote* _tmp3_;
		XnpNote* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 112 "../lib/window.vala"
		_tmp3_ = xnp_window_get_note (self, 0);
#line 112 "../lib/window.vala"
		_tmp4_ = _tmp3_;
#line 112 "../lib/window.vala"
		_tmp5_ = xnp_note_get_text (_tmp4_);
#line 112 "../lib/window.vala"
		_tmp6_ = _tmp5_;
#line 112 "../lib/window.vala"
		_tmp7_ = _tmp6_;
#line 112 "../lib/window.vala"
		_tmp2_ = g_strcmp0 (_tmp7_, "") == 0;
#line 112 "../lib/window.vala"
		_g_free0 (_tmp7_);
#line 112 "../lib/window.vala"
		_g_object_unref0 (_tmp4_);
#line 6927 "window.c"
	} else {
#line 112 "../lib/window.vala"
		_tmp2_ = n_pages == 0;
#line 6931 "window.c"
	}
#line 112 "../lib/window.vala"
	result = _tmp2_;
#line 112 "../lib/window.vala"
	return result;
#line 6937 "window.c"
}

gboolean
xnp_window_get_show_tabs (XnpWindow* self)
{
	gboolean result;
	GtkNotebook* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 117 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 118 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 118 "../lib/window.vala"
	_tmp1_ = gtk_notebook_get_show_tabs (_tmp0_);
#line 118 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 118 "../lib/window.vala"
	result = _tmp2_;
#line 118 "../lib/window.vala"
	return result;
#line 6959 "window.c"
}

void
xnp_window_set_show_tabs (XnpWindow* self,
                          gboolean value)
{
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 120 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 121 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 121 "../lib/window.vala"
	gtk_notebook_set_show_tabs (_tmp0_, value);
#line 122 "../lib/window.vala"
	_tmp1_ = self->priv->notebook;
#line 122 "../lib/window.vala"
	_tmp2_ = gtk_notebook_get_show_tabs (_tmp1_);
#line 122 "../lib/window.vala"
	_tmp3_ = _tmp2_;
#line 122 "../lib/window.vala"
	if (_tmp3_) {
#line 6984 "window.c"
		XnpTitleBarButton* _tmp4_;
		XnpTitleBarButton* _tmp5_;
#line 123 "../lib/window.vala"
		_tmp4_ = self->priv->left_arrow_button;
#line 123 "../lib/window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 124 "../lib/window.vala"
		_tmp5_ = self->priv->right_arrow_button;
#line 124 "../lib/window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 6995 "window.c"
	} else {
		XnpTitleBarButton* _tmp6_;
		XnpTitleBarButton* _tmp7_;
#line 126 "../lib/window.vala"
		_tmp6_ = self->priv->left_arrow_button;
#line 126 "../lib/window.vala"
		gtk_widget_show ((GtkWidget*) _tmp6_);
#line 127 "../lib/window.vala"
		_tmp7_ = self->priv->right_arrow_button;
#line 127 "../lib/window.vala"
		gtk_widget_show ((GtkWidget*) _tmp7_);
#line 7007 "window.c"
	}
#line 120 "../lib/window.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_window_properties[XNP_WINDOW_SHOW_TABS_PROPERTY]);
#line 7011 "window.c"
}

gint
xnp_window_get_tabs_position (XnpWindow* self)
{
	gint result;
#line 134 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 135 "../lib/window.vala"
	result = self->priv->_tabs_position;
#line 135 "../lib/window.vala"
	return result;
#line 7024 "window.c"
}

void
xnp_window_set_tabs_position (XnpWindow* self,
                              gint value)
{
#line 137 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 138 "../lib/window.vala"
	self->priv->_tabs_position = value;
#line 139 "../lib/window.vala"
	if (self->priv->_tabs_position == 0) {
#line 140 "../lib/window.vala"
		xnp_window_set_show_tabs (self, FALSE);
#line 7039 "window.c"
	} else {
#line 142 "../lib/window.vala"
		xnp_window_set_show_tabs (self, TRUE);
#line 143 "../lib/window.vala"
		_xnp_window_notebook_update_tabs_angle (self);
#line 144 "../lib/window.vala"
		if (self->priv->_tabs_position == 1) {
#line 7047 "window.c"
			GtkNotebook* _tmp0_;
#line 145 "../lib/window.vala"
			_tmp0_ = self->priv->notebook;
#line 145 "../lib/window.vala"
			gtk_notebook_set_tab_pos (_tmp0_, GTK_POS_TOP);
#line 7053 "window.c"
		} else {
#line 146 "../lib/window.vala"
			if (self->priv->_tabs_position == 2) {
#line 7057 "window.c"
				GtkNotebook* _tmp1_;
#line 147 "../lib/window.vala"
				_tmp1_ = self->priv->notebook;
#line 147 "../lib/window.vala"
				gtk_notebook_set_tab_pos (_tmp1_, GTK_POS_RIGHT);
#line 7063 "window.c"
			} else {
#line 148 "../lib/window.vala"
				if (self->priv->_tabs_position == 3) {
#line 7067 "window.c"
					GtkNotebook* _tmp2_;
#line 149 "../lib/window.vala"
					_tmp2_ = self->priv->notebook;
#line 149 "../lib/window.vala"
					gtk_notebook_set_tab_pos (_tmp2_, GTK_POS_BOTTOM);
#line 7073 "window.c"
				} else {
#line 150 "../lib/window.vala"
					if (self->priv->_tabs_position == 4) {
#line 7077 "window.c"
						GtkNotebook* _tmp3_;
#line 151 "../lib/window.vala"
						_tmp3_ = self->priv->notebook;
#line 151 "../lib/window.vala"
						gtk_notebook_set_tab_pos (_tmp3_, GTK_POS_LEFT);
#line 7083 "window.c"
					} else {
#line 153 "../lib/window.vala"
						xnp_window_set_show_tabs (self, FALSE);
#line 154 "../lib/window.vala"
						g_warning ("window.vala:154: Bad value for tabs-position");
#line 7089 "window.c"
					}
				}
			}
		}
	}
#line 137 "../lib/window.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_window_properties[XNP_WINDOW_TABS_POSITION_PROPERTY]);
#line 7097 "window.c"
}

gboolean
xnp_window_get_above (XnpWindow* self)
{
	gboolean result;
#line 162 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../lib/window.vala"
	result = self->priv->_above;
#line 163 "../lib/window.vala"
	return result;
#line 7110 "window.c"
}

void
xnp_window_set_above (XnpWindow* self,
                      gboolean value)
{
#line 165 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 166 "../lib/window.vala"
	self->priv->_above = value;
#line 167 "../lib/window.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, value);
#line 165 "../lib/window.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_window_properties[XNP_WINDOW_ABOVE_PROPERTY]);
#line 7125 "window.c"
}

gboolean
xnp_window_get_sticky (XnpWindow* self)
{
	gboolean result;
#line 173 "../lib/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 174 "../lib/window.vala"
	result = self->priv->_sticky;
#line 174 "../lib/window.vala"
	return result;
#line 7138 "window.c"
}

void
xnp_window_set_sticky (XnpWindow* self,
                       gboolean value)
{
	GtkCheckMenuItem* _tmp0_;
#line 176 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 177 "../lib/window.vala"
	self->priv->_sticky = value;
#line 178 "../lib/window.vala"
	if (value == TRUE) {
#line 179 "../lib/window.vala"
		gtk_window_stick ((GtkWindow*) self);
#line 7154 "window.c"
	} else {
#line 181 "../lib/window.vala"
		gtk_window_unstick ((GtkWindow*) self);
#line 7158 "window.c"
	}
#line 182 "../lib/window.vala"
	_tmp0_ = self->priv->mi_sticky;
#line 182 "../lib/window.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_check_menu_item_get_type ())) {
#line 7164 "window.c"
		GtkCheckMenuItem* _tmp1_;
#line 183 "../lib/window.vala"
		_tmp1_ = self->priv->mi_sticky;
#line 183 "../lib/window.vala"
		gtk_check_menu_item_set_active (_tmp1_, self->priv->_sticky);
#line 7170 "window.c"
	}
#line 176 "../lib/window.vala"
	g_object_notify_by_pspec ((GObject *) self, xnp_window_properties[XNP_WINDOW_STICKY_PROPERTY]);
#line 7174 "window.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 25 "../lib/window.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "../lib/window.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "../lib/window.vala"
		data1 = closure->data;
#line 25 "../lib/window.vala"
		data2 = param_values->data[0].v_pointer;
#line 7199 "window.c"
	} else {
#line 25 "../lib/window.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "../lib/window.vala"
		data2 = closure->data;
#line 7205 "window.c"
	}
#line 25 "../lib/window.vala"
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 25 "../lib/window.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 7211 "window.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__OBJECT_OBJECT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 25 "../lib/window.vala"
	g_return_if_fail (return_value != NULL);
#line 25 "../lib/window.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "../lib/window.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "../lib/window.vala"
		data1 = closure->data;
#line 25 "../lib/window.vala"
		data2 = param_values->data[0].v_pointer;
#line 7239 "window.c"
	} else {
#line 25 "../lib/window.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "../lib/window.vala"
		data2 = closure->data;
#line 7245 "window.c"
	}
#line 25 "../lib/window.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 25 "../lib/window.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 25 "../lib/window.vala"
	g_value_set_boolean (return_value, v_return);
#line 7253 "window.c"
}

static void
xnp_window_real_action_cycle_forward (XnpWindow* self)
{
	GtkNotebook* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 195 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 196 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 196 "../lib/window.vala"
	g_object_get (_tmp0_, "page", &_tmp1_, NULL);
#line 196 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 196 "../lib/window.vala"
	_tmp3_ = xnp_window_get_n_pages (self);
#line 196 "../lib/window.vala"
	_tmp4_ = _tmp3_;
#line 196 "../lib/window.vala"
	if (_tmp2_ == (_tmp4_ - 1)) {
#line 7278 "window.c"
		GtkNotebook* _tmp5_;
#line 197 "../lib/window.vala"
		_tmp5_ = self->priv->notebook;
#line 197 "../lib/window.vala"
		g_object_set (_tmp5_, "page", 0, NULL);
#line 7284 "window.c"
	} else {
		GtkNotebook* _tmp6_;
#line 199 "../lib/window.vala"
		_tmp6_ = self->priv->notebook;
#line 199 "../lib/window.vala"
		gtk_notebook_next_page (_tmp6_);
#line 7291 "window.c"
	}
}

static void
xnp_window_real_action_cycle_backward (XnpWindow* self)
{
	GtkNotebook* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 203 "../lib/window.vala"
	g_return_if_fail (self != NULL);
#line 204 "../lib/window.vala"
	_tmp0_ = self->priv->notebook;
#line 204 "../lib/window.vala"
	g_object_get (_tmp0_, "page", &_tmp1_, NULL);
#line 204 "../lib/window.vala"
	_tmp2_ = _tmp1_;
#line 204 "../lib/window.vala"
	if (_tmp2_ == 0) {
#line 7311 "window.c"
		GtkNotebook* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 205 "../lib/window.vala"
		_tmp3_ = self->priv->notebook;
#line 205 "../lib/window.vala"
		_tmp4_ = xnp_window_get_n_pages (self);
#line 205 "../lib/window.vala"
		_tmp5_ = _tmp4_;
#line 205 "../lib/window.vala"
		g_object_set (_tmp3_, "page", _tmp5_ - 1, NULL);
#line 7323 "window.c"
	} else {
		GtkNotebook* _tmp6_;
#line 207 "../lib/window.vala"
		_tmp6_ = self->priv->notebook;
#line 207 "../lib/window.vala"
		gtk_notebook_prev_page (_tmp6_);
#line 7330 "window.c"
	}
}

static GObject *
xnp_window_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	XnpWindow * self;
#line 210 "../lib/window.vala"
	parent_class = G_OBJECT_CLASS (xnp_window_parent_class);
#line 210 "../lib/window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 210 "../lib/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_WINDOW, XnpWindow);
#line 211 "../lib/window.vala"
	gtk_widget_set_name (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "notes-window");
#line 212 "../lib/window.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("Notes"));
#line 213 "../lib/window.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 214 "../lib/window.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
#line 215 "../lib/window.vala"
	g_object_set ((GtkWindow*) self, "default-height", 380, NULL);
#line 216 "../lib/window.vala"
	g_object_set ((GtkWindow*) self, "default-width", 300, NULL);
#line 217 "../lib/window.vala"
	gtk_window_set_decorated ((GtkWindow*) self, FALSE);
#line 218 "../lib/window.vala"
	gtk_window_set_icon_name ((GtkWindow*) self, "org.xfce.notes");
#line 219 "../lib/window.vala"
	xnp_window_set_sticky (self, TRUE);
#line 220 "../lib/window.vala"
	gtk_widget_set_opacity ((GtkWidget*) self, 0.9);
#line 210 "../lib/window.vala"
	return obj;
#line 7370 "window.c"
}

static void
xnp_window_class_init (XnpWindowClass * klass,
                       gpointer klass_data)
{
#line 25 "../lib/window.vala"
	xnp_window_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/window.vala"
	g_type_class_adjust_private_offset (klass, &XnpWindow_private_offset);
#line 25 "../lib/window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_xnp_window_get_property;
#line 25 "../lib/window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_xnp_window_set_property;
#line 25 "../lib/window.vala"
	G_OBJECT_CLASS (klass)->constructor = xnp_window_constructor;
#line 25 "../lib/window.vala"
	G_OBJECT_CLASS (klass)->finalize = xnp_window_finalize;
#line 25 "../lib/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_WINDOW_NAME_PROPERTY, xnp_window_properties[XNP_WINDOW_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_WINDOW_CURRENT_NOTE_PROPERTY, xnp_window_properties[XNP_WINDOW_CURRENT_NOTE_PROPERTY] = g_param_spec_object ("current-note", "current-note", "current-note", XNP_TYPE_NOTE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../lib/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_WINDOW_N_PAGES_PROPERTY, xnp_window_properties[XNP_WINDOW_N_PAGES_PROPERTY] = g_param_spec_int ("n-pages", "n-pages", "n-pages", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../lib/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_WINDOW_EMPTY_PROPERTY, xnp_window_properties[XNP_WINDOW_EMPTY_PROPERTY] = g_param_spec_boolean ("empty", "empty", "empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../lib/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_WINDOW_SHOW_TABS_PROPERTY, xnp_window_properties[XNP_WINDOW_SHOW_TABS_PROPERTY] = g_param_spec_boolean ("show-tabs", "show-tabs", "show-tabs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_WINDOW_TABS_POSITION_PROPERTY, xnp_window_properties[XNP_WINDOW_TABS_POSITION_PROPERTY] = g_param_spec_int ("tabs-position", "tabs-position", "tabs-position", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_WINDOW_ABOVE_PROPERTY, xnp_window_properties[XNP_WINDOW_ABOVE_PROPERTY] = g_param_spec_boolean ("above", "above", "above", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_WINDOW_STICKY_PROPERTY, xnp_window_properties[XNP_WINDOW_STICKY_PROPERTY] = g_param_spec_boolean ("sticky", "sticky", "sticky", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/window.vala"
	xnp_window_signals[XNP_WINDOW_ACTION_SIGNAL] = g_signal_new ("action", XNP_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 25 "../lib/window.vala"
	xnp_window_signals[XNP_WINDOW_SAVE_DATA_SIGNAL] = g_signal_new ("save-data", XNP_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, XNP_TYPE_NOTE);
#line 25 "../lib/window.vala"
	xnp_window_signals[XNP_WINDOW_NOTE_INSERTED_SIGNAL] = g_signal_new ("note-inserted", XNP_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, XNP_TYPE_NOTE);
#line 25 "../lib/window.vala"
	xnp_window_signals[XNP_WINDOW_NOTE_DELETED_SIGNAL] = g_signal_new ("note-deleted", XNP_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, XNP_TYPE_NOTE);
#line 25 "../lib/window.vala"
	xnp_window_signals[XNP_WINDOW_NOTE_RENAMED_SIGNAL] = g_signal_new ("note-renamed", XNP_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, XNP_TYPE_NOTE, G_TYPE_STRING);
#line 25 "../lib/window.vala"
	xnp_window_signals[XNP_WINDOW_NOTE_MOVED_SIGNAL] = g_signal_new ("note-moved", XNP_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT_OBJECT, G_TYPE_BOOLEAN, 2, XNP_TYPE_WINDOW, XNP_TYPE_NOTE);
#line 25 "../lib/window.vala"
	xnp_window_signals[XNP_WINDOW_ACTION_CYCLE_FORWARD_SIGNAL] = g_signal_new_class_handler ("action-cycle-forward", XNP_TYPE_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, (GCallback) xnp_window_real_action_cycle_forward, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 25 "../lib/window.vala"
	xnp_window_signals[XNP_WINDOW_ACTION_CYCLE_BACKWARD_SIGNAL] = g_signal_new_class_handler ("action-cycle-backward", XNP_TYPE_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, (GCallback) xnp_window_real_action_cycle_backward, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 7421 "window.c"
}

static void
xnp_window_instance_init (XnpWindow * self,
                          gpointer klass)
{
	GdkDisplay* _tmp0_;
	GdkCursor* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkCursor* _tmp7_;
	GdkDisplay* _tmp8_;
	GdkCursor* _tmp9_;
	GdkDisplay* _tmp10_;
	GdkCursor* _tmp11_;
	GdkDisplay* _tmp12_;
	GdkCursor* _tmp13_;
	GdkDisplay* _tmp14_;
	GdkCursor* _tmp15_;
	gchar* _tmp16_;
#line 25 "../lib/window.vala"
	self->priv = xnp_window_get_instance_private (self);
#line 85 "../lib/window.vala"
	self->priv->CORNER_MARGIN = 20;
#line 86 "../lib/window.vala"
	_tmp0_ = gdk_display_get_default ();
#line 86 "../lib/window.vala"
	_tmp1_ = gdk_cursor_new_for_display (_tmp0_, GDK_TOP_LEFT_CORNER);
#line 86 "../lib/window.vala"
	self->priv->CURSOR_TOP_LC = _tmp1_;
#line 87 "../lib/window.vala"
	_tmp2_ = gdk_display_get_default ();
#line 87 "../lib/window.vala"
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_TOP_SIDE);
#line 87 "../lib/window.vala"
	self->priv->CURSOR_TOP = _tmp3_;
#line 88 "../lib/window.vala"
	_tmp4_ = gdk_display_get_default ();
#line 88 "../lib/window.vala"
	_tmp5_ = gdk_cursor_new_for_display (_tmp4_, GDK_TOP_RIGHT_CORNER);
#line 88 "../lib/window.vala"
	self->priv->CURSOR_TOP_RC = _tmp5_;
#line 89 "../lib/window.vala"
	_tmp6_ = gdk_display_get_default ();
#line 89 "../lib/window.vala"
	_tmp7_ = gdk_cursor_new_for_display (_tmp6_, GDK_RIGHT_SIDE);
#line 89 "../lib/window.vala"
	self->priv->CURSOR_RIGHT = _tmp7_;
#line 90 "../lib/window.vala"
	_tmp8_ = gdk_display_get_default ();
#line 90 "../lib/window.vala"
	_tmp9_ = gdk_cursor_new_for_display (_tmp8_, GDK_LEFT_SIDE);
#line 90 "../lib/window.vala"
	self->priv->CURSOR_LEFT = _tmp9_;
#line 91 "../lib/window.vala"
	_tmp10_ = gdk_display_get_default ();
#line 91 "../lib/window.vala"
	_tmp11_ = gdk_cursor_new_for_display (_tmp10_, GDK_BOTTOM_RIGHT_CORNER);
#line 91 "../lib/window.vala"
	self->priv->CURSOR_BOTTOM_RC = _tmp11_;
#line 92 "../lib/window.vala"
	_tmp12_ = gdk_display_get_default ();
#line 92 "../lib/window.vala"
	_tmp13_ = gdk_cursor_new_for_display (_tmp12_, GDK_BOTTOM_SIDE);
#line 92 "../lib/window.vala"
	self->priv->CURSOR_BOTTOM = _tmp13_;
#line 93 "../lib/window.vala"
	_tmp14_ = gdk_display_get_default ();
#line 93 "../lib/window.vala"
	_tmp15_ = gdk_cursor_new_for_display (_tmp14_, GDK_BOTTOM_LEFT_CORNER);
#line 93 "../lib/window.vala"
	self->priv->CURSOR_BOTTOM_LC = _tmp15_;
#line 95 "../lib/window.vala"
	_tmp16_ = g_strdup (_ ("Notes"));
#line 95 "../lib/window.vala"
	self->priv->_name = _tmp16_;
#line 7501 "window.c"
}

static void
xnp_window_finalize (GObject * obj)
{
	XnpWindow * self;
#line 25 "../lib/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_WINDOW, XnpWindow);
#line 27 "../lib/window.vala"
	_g_object_unref0 (self->monitor);
#line 29 "../lib/window.vala"
	_g_object_unref0 (self->priv->app);
#line 32 "../lib/window.vala"
	_g_object_unref0 (self->priv->menu);
#line 33 "../lib/window.vala"
	_g_object_unref0 (self->priv->mi_above);
#line 34 "../lib/window.vala"
	_g_object_unref0 (self->priv->mi_sticky);
#line 35 "../lib/window.vala"
	_g_object_unref0 (self->priv->menu_image);
#line 36 "../lib/window.vala"
	_g_object_unref0 (self->priv->title_label);
#line 37 "../lib/window.vala"
	_g_object_unref0 (self->priv->left_arrow_button);
#line 38 "../lib/window.vala"
	_g_object_unref0 (self->priv->right_arrow_button);
#line 39 "../lib/window.vala"
	_g_object_unref0 (self->priv->close_button);
#line 40 "../lib/window.vala"
	_g_object_unref0 (self->priv->content_box);
#line 41 "../lib/window.vala"
	_g_object_unref0 (self->priv->notebook);
#line 43 "../lib/window.vala"
	_g_object_unref0 (self->priv->ui);
#line 65 "../lib/window.vala"
	_g_object_unref0 (self->priv->action_group);
#line 86 "../lib/window.vala"
	_g_object_unref0 (self->priv->CURSOR_TOP_LC);
#line 87 "../lib/window.vala"
	_g_object_unref0 (self->priv->CURSOR_TOP);
#line 88 "../lib/window.vala"
	_g_object_unref0 (self->priv->CURSOR_TOP_RC);
#line 89 "../lib/window.vala"
	_g_object_unref0 (self->priv->CURSOR_RIGHT);
#line 90 "../lib/window.vala"
	_g_object_unref0 (self->priv->CURSOR_LEFT);
#line 91 "../lib/window.vala"
	_g_object_unref0 (self->priv->CURSOR_BOTTOM_RC);
#line 92 "../lib/window.vala"
	_g_object_unref0 (self->priv->CURSOR_BOTTOM);
#line 93 "../lib/window.vala"
	_g_object_unref0 (self->priv->CURSOR_BOTTOM_LC);
#line 95 "../lib/window.vala"
	_g_free0 (self->priv->_name);
#line 25 "../lib/window.vala"
	G_OBJECT_CLASS (xnp_window_parent_class)->finalize (obj);
#line 7558 "window.c"
}

static GType
xnp_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (XnpWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnp_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnpWindow), 0, (GInstanceInitFunc) xnp_window_instance_init, NULL };
	GType xnp_window_type_id;
	xnp_window_type_id = g_type_register_static (gtk_window_get_type (), "XnpWindow", &g_define_type_info, 0);
	XnpWindow_private_offset = g_type_add_instance_private (xnp_window_type_id, sizeof (XnpWindowPrivate));
	return xnp_window_type_id;
}

GType
xnp_window_get_type (void)
{
	static volatile gsize xnp_window_type_id__once = 0;
	if (g_once_init_enter (&xnp_window_type_id__once)) {
		GType xnp_window_type_id;
		xnp_window_type_id = xnp_window_get_type_once ();
		g_once_init_leave (&xnp_window_type_id__once, xnp_window_type_id);
	}
	return xnp_window_type_id__once;
}

static void
_vala_xnp_window_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	XnpWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_WINDOW, XnpWindow);
#line 25 "../lib/window.vala"
	switch (property_id) {
#line 25 "../lib/window.vala"
		case XNP_WINDOW_NAME_PROPERTY:
#line 25 "../lib/window.vala"
		g_value_set_string (value, xnp_window_get_name (self));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_CURRENT_NOTE_PROPERTY:
#line 25 "../lib/window.vala"
		g_value_set_object (value, xnp_window_get_current_note (self));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_N_PAGES_PROPERTY:
#line 25 "../lib/window.vala"
		g_value_set_int (value, xnp_window_get_n_pages (self));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_EMPTY_PROPERTY:
#line 25 "../lib/window.vala"
		g_value_set_boolean (value, xnp_window_get_empty (self));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_SHOW_TABS_PROPERTY:
#line 25 "../lib/window.vala"
		g_value_set_boolean (value, xnp_window_get_show_tabs (self));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_TABS_POSITION_PROPERTY:
#line 25 "../lib/window.vala"
		g_value_set_int (value, xnp_window_get_tabs_position (self));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_ABOVE_PROPERTY:
#line 25 "../lib/window.vala"
		g_value_set_boolean (value, xnp_window_get_above (self));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_STICKY_PROPERTY:
#line 25 "../lib/window.vala"
		g_value_set_boolean (value, xnp_window_get_sticky (self));
#line 25 "../lib/window.vala"
		break;
#line 7641 "window.c"
		default:
#line 25 "../lib/window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/window.vala"
		break;
#line 7647 "window.c"
	}
}

static void
_vala_xnp_window_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	XnpWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_WINDOW, XnpWindow);
#line 25 "../lib/window.vala"
	switch (property_id) {
#line 25 "../lib/window.vala"
		case XNP_WINDOW_NAME_PROPERTY:
#line 25 "../lib/window.vala"
		xnp_window_set_name (self, g_value_get_string (value));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_SHOW_TABS_PROPERTY:
#line 25 "../lib/window.vala"
		xnp_window_set_show_tabs (self, g_value_get_boolean (value));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_TABS_POSITION_PROPERTY:
#line 25 "../lib/window.vala"
		xnp_window_set_tabs_position (self, g_value_get_int (value));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_ABOVE_PROPERTY:
#line 25 "../lib/window.vala"
		xnp_window_set_above (self, g_value_get_boolean (value));
#line 25 "../lib/window.vala"
		break;
#line 25 "../lib/window.vala"
		case XNP_WINDOW_STICKY_PROPERTY:
#line 25 "../lib/window.vala"
		xnp_window_set_sticky (self, g_value_get_boolean (value));
#line 25 "../lib/window.vala"
		break;
#line 7691 "window.c"
		default:
#line 25 "../lib/window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/window.vala"
		break;
#line 7697 "window.c"
	}
}

